//////////////////////////////////////////////////////////////////////////////
// Utility Functions
//
//    This file declares utility functions used by the skeleton accelerant.
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Prototypes ////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Calculate Storage Bits Per Pixel
//    Utility function to calculate the number of storage bits per pixel
// given a colour space.
uint32 CalcStorageBPP(uint32 cs);

//////////////////////////////////////////////////////////////////////////////
// Calculate Color Depth Bits Per Pixel
//    Utility function to calculate the number of color depth bits per pixel
// given a colour space.
//    NOTE: We're ignoring alpha bits for the moment.
uint32 CalcColorDepth(uint32 cs);

//////////////////////////////////////////////////////////////////////////////
// Name of Colour Space
//    Utility function to provide a name string for the given colour space.
// This string is a pointer to an entry in a static array.
char *NameOfSpace(uint32 cs);

//////////////////////////////////////////////////////////////////////////////
// Count RAM
//    This function determines the amount of usable memory in the specified
// aperture, by writing to the apetrure and reading back in a pattern
// designed to detect most types of aliasing and artifacting.
uint32 CountMemory(void *Aperture, uint32 ApertureSize);


//////////////////////////////////////////////////////////////////////////////
// This Is The End Of The File ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
