//////////////////////////////////////////////////////////////////////////////
// Accelerant Info
//
//    This header contains a type definition and an extern declaration for
// the structure used to hold information that is local to an accelerant
// instance.
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Typedefs //////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

typedef struct
{
  // General.

  int fd; // File descriptor of the kernel driver, for ioctl calls.
  SHARED_INFO *si; // SHARED_INFO structure containing information about this card.


  // Predefined graphics mode table.

  uint32 mode_count;          // Number of predefined graphics modes defined.
  area_id predefined_mode_list_area;   // Area ID for the list of predefined modes.
  display_mode *predefined_mode_list;  // List of predefined modes.
} ACCELERANT_INFO;


//////////////////////////////////////////////////////////////////////////////
// Extern Declarations ///////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// The ACCELERANT_INFO structure used by this accelerant instance.

extern ACCELERANT_INFO ai;


// Pointer to the SHARED_INFO structure for the driver. Extracted for
// convenience.

extern SHARED_INFO *si;


//////////////////////////////////////////////////////////////////////////////
// This Is The End Of The File ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
