//////////////////////////////////////////////////////////////////////////////
// DPMS - Power management routines.
//    These functions alter the power state of the graphics card.
//
//////////////////////////////////////////////////////////////////////////////
//    NOTE: This is just a set of skeleton routines that tells the caller
// that we don't support power management (or rather that we do, but for only
// one power management state).
//
//    HACK - Give definitions of the power management modes here.
//
//    NOTE: I've *seen* proper definitions of what each of these modes is
// supposed to do. However, they seem to have vanished into the Abyss.
// Ideally they'd be posted somewhere in this file for the benefit of anyone
// implementing proper power management.


//////////////////////////////////////////////////////////////////////////////
// Prototypes ////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// DPMS Capabilities
//    This returns a bit vector indicating which power management modes we
// support. Constants are B_DPMS_ON, B_DPMS_STAND_BY, B_DPMS_SUSPEND, and
// B_DPMS_OFF.
uint32 DPMS_Capabilities(void);

//////////////////////////////////////////////////////////////////////////////
// DPMS Mode
//    This reads the current power management mode.
uint32 DPMS_Mode(void);

//////////////////////////////////////////////////////////////////////////////
// Set DPMS Mode
//    This sets the current power management mode.
status_t SetDPMS_Mode(uint32 dpms_flags);


//////////////////////////////////////////////////////////////////////////////
// This Is The End Of The File ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
