/************************************************************************
*                                                                       *
*               INTEL CORPORATION PROPRIETARY INFORMATION               *
*                                                                       *
*    This listing is supplied under the terms of a license agreement    *
*      with INTEL Corporation and may not be copied nor disclosed       *
*        except in accordance with the terms of that agreement.         *
*                                                                       *
*************************************************************************
*                                                                       *
*               Copyright (C) 1994-1997 Intel Corp.                     *
*                         All Rights Reserved.                          *
*                                                                       *
************************************************************************/
/*
 * This file is automatically generated. Do not hand-modify!
 *
 * This file contains tables supporting CLUT8. Tables include:
 *
 *    PalTable         : The palette
 *    [S]ICDY          : For Y dithering and clamping
 *    DitherTable      : For UV dithering
 *    [S]Truncate[VU]  : Maps 8 bit chroma to 5 bits
 *
 * These tables are used in CF_CLUT8, PT_[FIXED|CONFIG] mode
 *
 * Using segmented random traversal of UV points
 */

/*
 * Parameters:
 *    Y ranges from 38 to 218 in steps of 15 (13 points)
 *    Each Y point has 15 UV points
 */

#include "datatype.h"

#define PC_NOCOLLAPSE 0x04

#pragma data_seg(".sdata")	/* following is data shared among instances */

I32 CP_EntryCount = 195;

unsigned char CP_PalTable[4*236] = {
   25,  25,  25, PC_NOCOLLAPSE,   /* YVU=( 38,128,128) */
   43,  43,  43, PC_NOCOLLAPSE,   /* YVU=( 53,128,128) */
   60,  60,  60, PC_NOCOLLAPSE,   /* YVU=( 68,128,128) */
   77,  77,  77, PC_NOCOLLAPSE,   /* YVU=( 83,128,128) */
   95,  95,  95, PC_NOCOLLAPSE,   /* YVU=( 98,128,128) */
  112, 112, 112, PC_NOCOLLAPSE,   /* YVU=(113,128,128) */
  130, 130, 130, PC_NOCOLLAPSE,   /* YVU=(128,128,128) */
  147, 147, 147, PC_NOCOLLAPSE,   /* YVU=(143,128,128) */
  165, 165, 165, PC_NOCOLLAPSE,   /* YVU=(158,128,128) */
  182, 182, 182, PC_NOCOLLAPSE,   /* YVU=(173,128,128) */
  200, 200, 200, PC_NOCOLLAPSE,   /* YVU=(188,128,128) */
  217, 217, 217, PC_NOCOLLAPSE,   /* YVU=(203,128,128) */
  235, 235, 235, PC_NOCOLLAPSE,   /* YVU=(218,128,128) */
    0,  51,  25, PC_NOCOLLAPSE,   /* YVU=( 38, 96,128) */
    0,  69,  43, PC_NOCOLLAPSE,   /* YVU=( 53, 96,128) */
    9,  86,  60, PC_NOCOLLAPSE,   /* YVU=( 68, 96,128) */
   26, 104,  77, PC_NOCOLLAPSE,   /* YVU=( 83, 96,128) */
   44, 121,  95, PC_NOCOLLAPSE,   /* YVU=( 98, 96,128) */
   61, 138, 112, PC_NOCOLLAPSE,   /* YVU=(113, 96,128) */
   79, 156, 130, PC_NOCOLLAPSE,   /* YVU=(128, 96,128) */
   96, 173, 147, PC_NOCOLLAPSE,   /* YVU=(143, 96,128) */
  114, 191, 165, PC_NOCOLLAPSE,   /* YVU=(158, 96,128) */
  131, 208, 182, PC_NOCOLLAPSE,   /* YVU=(173, 96,128) */
  149, 226, 200, PC_NOCOLLAPSE,   /* YVU=(188, 96,128) */
  166, 243, 217, PC_NOCOLLAPSE,   /* YVU=(203, 96,128) */
  184, 255, 235, PC_NOCOLLAPSE,   /* YVU=(218, 96,128) */
   25,  38,   0, PC_NOCOLLAPSE,   /* YVU=( 38,128, 96) */
   43,  55,   0, PC_NOCOLLAPSE,   /* YVU=( 53,128, 96) */
   60,  73,   0, PC_NOCOLLAPSE,   /* YVU=( 68,128, 96) */
   78,  90,  13, PC_NOCOLLAPSE,   /* YVU=( 83,128, 96) */
   95, 107,  30, PC_NOCOLLAPSE,   /* YVU=( 98,128, 96) */
  112, 125,  48, PC_NOCOLLAPSE,   /* YVU=(113,128, 96) */
  130, 142,  65, PC_NOCOLLAPSE,   /* YVU=(128,128, 96) */
  147, 160,  83, PC_NOCOLLAPSE,   /* YVU=(143,128, 96) */
  165, 177, 100, PC_NOCOLLAPSE,   /* YVU=(158,128, 96) */
  182, 195, 118, PC_NOCOLLAPSE,   /* YVU=(173,128, 96) */
  200, 212, 135, PC_NOCOLLAPSE,   /* YVU=(188,128, 96) */
  217, 230, 153, PC_NOCOLLAPSE,   /* YVU=(203,128, 96) */
  235, 247, 170, PC_NOCOLLAPSE,   /* YVU=(218,128, 96) */
   76,   0,  25, PC_NOCOLLAPSE,   /* YVU=( 38,160,128) */
   94,  17,  43, PC_NOCOLLAPSE,   /* YVU=( 53,160,128) */
  111,  34,  60, PC_NOCOLLAPSE,   /* YVU=( 68,160,128) */
  129,  51,  78, PC_NOCOLLAPSE,   /* YVU=( 83,160,128) */
  146,  69,  95, PC_NOCOLLAPSE,   /* YVU=( 98,160,128) */
  163,  86, 112, PC_NOCOLLAPSE,   /* YVU=(113,160,128) */
  181, 104, 130, PC_NOCOLLAPSE,   /* YVU=(128,160,128) */
  198, 121, 147, PC_NOCOLLAPSE,   /* YVU=(143,160,128) */
  216, 139, 165, PC_NOCOLLAPSE,   /* YVU=(158,160,128) */
  233, 156, 182, PC_NOCOLLAPSE,   /* YVU=(173,160,128) */
  251, 174, 200, PC_NOCOLLAPSE,   /* YVU=(188,160,128) */
  255, 191, 217, PC_NOCOLLAPSE,   /* YVU=(203,160,128) */
  255, 209, 235, PC_NOCOLLAPSE,   /* YVU=(218,160,128) */
   25,  13,  90, PC_NOCOLLAPSE,   /* YVU=( 38,128,160) */
   43,  30, 107, PC_NOCOLLAPSE,   /* YVU=( 53,128,160) */
   60,  48, 125, PC_NOCOLLAPSE,   /* YVU=( 68,128,160) */
   77,  65, 142, PC_NOCOLLAPSE,   /* YVU=( 83,128,160) */
   95,  82, 159, PC_NOCOLLAPSE,   /* YVU=( 98,128,160) */
  112, 100, 177, PC_NOCOLLAPSE,   /* YVU=(113,128,160) */
  130, 117, 194, PC_NOCOLLAPSE,   /* YVU=(128,128,160) */
  147, 135, 212, PC_NOCOLLAPSE,   /* YVU=(143,128,160) */
  165, 152, 229, PC_NOCOLLAPSE,   /* YVU=(158,128,160) */
  182, 170, 247, PC_NOCOLLAPSE,   /* YVU=(173,128,160) */
  200, 187, 255, PC_NOCOLLAPSE,   /* YVU=(188,128,160) */
  217, 205, 255, PC_NOCOLLAPSE,   /* YVU=(203,128,160) */
  235, 222, 255, PC_NOCOLLAPSE,   /* YVU=(218,128,160) */
    0,  64,   0, PC_NOCOLLAPSE,   /* YVU=( 38, 96, 96) */
    0,  81,   0, PC_NOCOLLAPSE,   /* YVU=( 53, 96, 96) */
    9,  99,   0, PC_NOCOLLAPSE,   /* YVU=( 68, 96, 96) */
   26, 116,  13, PC_NOCOLLAPSE,   /* YVU=( 83, 96, 96) */
   44, 133,  30, PC_NOCOLLAPSE,   /* YVU=( 98, 96, 96) */
   61, 151,  48, PC_NOCOLLAPSE,   /* YVU=(113, 96, 96) */
   79, 168,  65, PC_NOCOLLAPSE,   /* YVU=(128, 96, 96) */
   96, 186,  83, PC_NOCOLLAPSE,   /* YVU=(143, 96, 96) */
  114, 203, 100, PC_NOCOLLAPSE,   /* YVU=(158, 96, 96) */
  131, 221, 118, PC_NOCOLLAPSE,   /* YVU=(173, 96, 96) */
  149, 238, 135, PC_NOCOLLAPSE,   /* YVU=(188, 96, 96) */
  166, 255, 153, PC_NOCOLLAPSE,   /* YVU=(203, 96, 96) */
  184, 255, 170, PC_NOCOLLAPSE,   /* YVU=(218, 96, 96) */
    0,  39,  90, PC_NOCOLLAPSE,   /* YVU=( 38, 96,160) */
    0,  56, 107, PC_NOCOLLAPSE,   /* YVU=( 53, 96,160) */
    9,  74, 125, PC_NOCOLLAPSE,   /* YVU=( 68, 96,160) */
   26,  91, 142, PC_NOCOLLAPSE,   /* YVU=( 83, 96,160) */
   44, 108, 159, PC_NOCOLLAPSE,   /* YVU=( 98, 96,160) */
   61, 126, 177, PC_NOCOLLAPSE,   /* YVU=(113, 96,160) */
   79, 143, 194, PC_NOCOLLAPSE,   /* YVU=(128, 96,160) */
   96, 161, 212, PC_NOCOLLAPSE,   /* YVU=(143, 96,160) */
  114, 178, 229, PC_NOCOLLAPSE,   /* YVU=(158, 96,160) */
  131, 196, 247, PC_NOCOLLAPSE,   /* YVU=(173, 96,160) */
  149, 213, 255, PC_NOCOLLAPSE,   /* YVU=(188, 96,160) */
  166, 231, 255, PC_NOCOLLAPSE,   /* YVU=(203, 96,160) */
  184, 248, 255, PC_NOCOLLAPSE,   /* YVU=(218, 96,160) */
   76,   0,  90, PC_NOCOLLAPSE,   /* YVU=( 38,160,160) */
   94,   4, 107, PC_NOCOLLAPSE,   /* YVU=( 53,160,160) */
  111,  22, 125, PC_NOCOLLAPSE,   /* YVU=( 68,160,160) */
  129,  39, 142, PC_NOCOLLAPSE,   /* YVU=( 83,160,160) */
  146,  56, 160, PC_NOCOLLAPSE,   /* YVU=( 98,160,160) */
  163,  74, 177, PC_NOCOLLAPSE,   /* YVU=(113,160,160) */
  181,  91, 194, PC_NOCOLLAPSE,   /* YVU=(128,160,160) */
  198, 109, 212, PC_NOCOLLAPSE,   /* YVU=(143,160,160) */
  216, 126, 229, PC_NOCOLLAPSE,   /* YVU=(158,160,160) */
  233, 144, 247, PC_NOCOLLAPSE,   /* YVU=(173,160,160) */
  251, 161, 255, PC_NOCOLLAPSE,   /* YVU=(188,160,160) */
  255, 179, 255, PC_NOCOLLAPSE,   /* YVU=(203,160,160) */
  255, 196, 255, PC_NOCOLLAPSE,   /* YVU=(218,160,160) */
   76,  12,   0, PC_NOCOLLAPSE,   /* YVU=( 38,160, 96) */
   94,  29,   0, PC_NOCOLLAPSE,   /* YVU=( 53,160, 96) */
  111,  47,   0, PC_NOCOLLAPSE,   /* YVU=( 68,160, 96) */
  129,  64,  13, PC_NOCOLLAPSE,   /* YVU=( 83,160, 96) */
  146,  81,  30, PC_NOCOLLAPSE,   /* YVU=( 98,160, 96) */
  164,  99,  48, PC_NOCOLLAPSE,   /* YVU=(113,160, 96) */
  181, 116,  65, PC_NOCOLLAPSE,   /* YVU=(128,160, 96) */
  198, 134,  83, PC_NOCOLLAPSE,   /* YVU=(143,160, 96) */
  216, 151, 100, PC_NOCOLLAPSE,   /* YVU=(158,160, 96) */
  233, 169, 118, PC_NOCOLLAPSE,   /* YVU=(173,160, 96) */
  251, 186, 135, PC_NOCOLLAPSE,   /* YVU=(188,160, 96) */
  255, 204, 153, PC_NOCOLLAPSE,   /* YVU=(203,160, 96) */
  255, 221, 170, PC_NOCOLLAPSE,   /* YVU=(218,160, 96) */
   25,  50,   0, PC_NOCOLLAPSE,   /* YVU=( 38,128, 64) */
   43,  68,   0, PC_NOCOLLAPSE,   /* YVU=( 53,128, 64) */
   60,  85,   0, PC_NOCOLLAPSE,   /* YVU=( 68,128, 64) */
   78, 103,   0, PC_NOCOLLAPSE,   /* YVU=( 83,128, 64) */
   95, 120,   0, PC_NOCOLLAPSE,   /* YVU=( 98,128, 64) */
  112, 137,   0, PC_NOCOLLAPSE,   /* YVU=(113,128, 64) */
  130, 155,   1, PC_NOCOLLAPSE,   /* YVU=(128,128, 64) */
  147, 172,  18, PC_NOCOLLAPSE,   /* YVU=(143,128, 64) */
  165, 190,  36, PC_NOCOLLAPSE,   /* YVU=(158,128, 64) */
  182, 207,  53, PC_NOCOLLAPSE,   /* YVU=(173,128, 64) */
  200, 225,  71, PC_NOCOLLAPSE,   /* YVU=(188,128, 64) */
  217, 242,  88, PC_NOCOLLAPSE,   /* YVU=(203,128, 64) */
  235, 255, 106, PC_NOCOLLAPSE,   /* YVU=(218,128, 64) */
  127,   0,  25, PC_NOCOLLAPSE,   /* YVU=( 38,192,128) */
  145,   0,  43, PC_NOCOLLAPSE,   /* YVU=( 53,192,128) */
  162,   8,  60, PC_NOCOLLAPSE,   /* YVU=( 68,192,128) */
  180,  25,  78, PC_NOCOLLAPSE,   /* YVU=( 83,192,128) */
  197,  43,  95, PC_NOCOLLAPSE,   /* YVU=( 98,192,128) */
  215,  60, 112, PC_NOCOLLAPSE,   /* YVU=(113,192,128) */
  232,  78, 130, PC_NOCOLLAPSE,   /* YVU=(128,192,128) */
  249,  95, 147, PC_NOCOLLAPSE,   /* YVU=(143,192,128) */
  255, 113, 165, PC_NOCOLLAPSE,   /* YVU=(158,192,128) */
  255, 130, 182, PC_NOCOLLAPSE,   /* YVU=(173,192,128) */
  255, 148, 200, PC_NOCOLLAPSE,   /* YVU=(188,192,128) */
  255, 165, 217, PC_NOCOLLAPSE,   /* YVU=(203,192,128) */
  255, 183, 235, PC_NOCOLLAPSE,   /* YVU=(218,192,128) */
    0,  77,  25, PC_NOCOLLAPSE,   /* YVU=( 38, 64,128) */
    0,  95,  43, PC_NOCOLLAPSE,   /* YVU=( 53, 64,128) */
    0, 112,  60, PC_NOCOLLAPSE,   /* YVU=( 68, 64,128) */
    0, 130,  77, PC_NOCOLLAPSE,   /* YVU=( 83, 64,128) */
    0, 147,  95, PC_NOCOLLAPSE,   /* YVU=( 98, 64,128) */
   10, 164, 112, PC_NOCOLLAPSE,   /* YVU=(113, 64,128) */
   28, 182, 130, PC_NOCOLLAPSE,   /* YVU=(128, 64,128) */
   45, 199, 147, PC_NOCOLLAPSE,   /* YVU=(143, 64,128) */
   63, 217, 165, PC_NOCOLLAPSE,   /* YVU=(158, 64,128) */
   80, 234, 182, PC_NOCOLLAPSE,   /* YVU=(173, 64,128) */
   98, 252, 200, PC_NOCOLLAPSE,   /* YVU=(188, 64,128) */
  115, 255, 217, PC_NOCOLLAPSE,   /* YVU=(203, 64,128) */
  132, 255, 235, PC_NOCOLLAPSE,   /* YVU=(218, 64,128) */
   25,   0, 154, PC_NOCOLLAPSE,   /* YVU=( 38,128,192) */
   43,  18, 172, PC_NOCOLLAPSE,   /* YVU=( 53,128,192) */
   60,  35, 189, PC_NOCOLLAPSE,   /* YVU=( 68,128,192) */
   77,  52, 207, PC_NOCOLLAPSE,   /* YVU=( 83,128,192) */
   95,  70, 224, PC_NOCOLLAPSE,   /* YVU=( 98,128,192) */
  112,  87, 241, PC_NOCOLLAPSE,   /* YVU=(113,128,192) */
  130, 105, 255, PC_NOCOLLAPSE,   /* YVU=(128,128,192) */
  147, 122, 255, PC_NOCOLLAPSE,   /* YVU=(143,128,192) */
  165, 140, 255, PC_NOCOLLAPSE,   /* YVU=(158,128,192) */
  182, 157, 255, PC_NOCOLLAPSE,   /* YVU=(173,128,192) */
  200, 175, 255, PC_NOCOLLAPSE,   /* YVU=(188,128,192) */
  217, 192, 255, PC_NOCOLLAPSE,   /* YVU=(203,128,192) */
  235, 210, 255, PC_NOCOLLAPSE,   /* YVU=(218,128,192) */
   76,  24,   0, PC_NOCOLLAPSE,   /* YVU=( 38,160, 64) */
   94,  42,   0, PC_NOCOLLAPSE,   /* YVU=( 53,160, 64) */
  111,  59,   0, PC_NOCOLLAPSE,   /* YVU=( 68,160, 64) */
  129,  76,   0, PC_NOCOLLAPSE,   /* YVU=( 83,160, 64) */
  146,  94,   0, PC_NOCOLLAPSE,   /* YVU=( 98,160, 64) */
  164, 111,   0, PC_NOCOLLAPSE,   /* YVU=(113,160, 64) */
  181, 129,   1, PC_NOCOLLAPSE,   /* YVU=(128,160, 64) */
  198, 146,  18, PC_NOCOLLAPSE,   /* YVU=(143,160, 64) */
  216, 164,  36, PC_NOCOLLAPSE,   /* YVU=(158,160, 64) */
  233, 181,  53, PC_NOCOLLAPSE,   /* YVU=(173,160, 64) */
  251, 199,  71, PC_NOCOLLAPSE,   /* YVU=(188,160, 64) */
  255, 216,  88, PC_NOCOLLAPSE,   /* YVU=(203,160, 64) */
  255, 234, 106, PC_NOCOLLAPSE,   /* YVU=(218,160, 64) */
  127,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 38,192, 96) */
  145,   3,   0, PC_NOCOLLAPSE,   /* YVU=( 53,192, 96) */
  162,  21,   0, PC_NOCOLLAPSE,   /* YVU=( 68,192, 96) */
  180,  38,  13, PC_NOCOLLAPSE,   /* YVU=( 83,192, 96) */
  197,  55,  30, PC_NOCOLLAPSE,   /* YVU=( 98,192, 96) */
  215,  73,  48, PC_NOCOLLAPSE,   /* YVU=(113,192, 96) */
  232,  90,  65, PC_NOCOLLAPSE,   /* YVU=(128,192, 96) */
  250, 108,  83, PC_NOCOLLAPSE,   /* YVU=(143,192, 96) */
  255, 125, 100, PC_NOCOLLAPSE,   /* YVU=(158,192, 96) */
  255, 143, 118, PC_NOCOLLAPSE,   /* YVU=(173,192, 96) */
  255, 160, 135, PC_NOCOLLAPSE,   /* YVU=(188,192, 96) */
  255, 178, 153, PC_NOCOLLAPSE,   /* YVU=(203,192, 96) */
  255, 195, 170, PC_NOCOLLAPSE,   /* YVU=(218,192, 96) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
}; /* PalTable */

unsigned char CP_ICDY[1024] = {
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
}; /* ICDY */

unsigned char CP_SICDY[1024] = {
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
}; /* SICDY */

unsigned long CP_DitherTable[] = {	/*  U, V */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  0, 0 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  0, 1 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  0, 2 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  0, 3 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  0, 4 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  0, 5 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  0, 6 */
0x7f7f4b4b, 0x4b7f4b4b, 0x4b4b7f7f, 0x4b4b4b7f,   /*  0, 7 */
0x7f7f4b4b, 0x4b7f4b4b, 0x4b4b7f7f, 0x4b4b4b7f,   /*  0, 8 */
0x7f7f7f4b, 0x4b7f4b7f, 0x7f4b7f7f, 0x4b7f4b7f,   /*  0, 9 */
0x7f7f7f4b, 0x4b7f4b7f, 0x7f4b7f7f, 0x4b7f4b7f,   /*  0,10 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  0,11 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  0,12 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  0,13 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  0,14 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  0,15 */
0x7f7f7f7f, 0x7f7f7f7f, 0x7f7f7f7f, 0x7f7f7f7f,   /*  0,16 */
0xb37f7f7f, 0x7f7f7f7f, 0x7f7fb37f, 0x7f7f7f7f,   /*  0,17 */
0xb37f7f7f, 0x7f7f7fb3, 0x7f7fb37f, 0x7fb37f7f,   /*  0,18 */
0xb3b37f7f, 0x7f7f7fb3, 0x7f7fb3b3, 0x7fb37f7f,   /*  0,19 */
0xb3b37f7f, 0x7fb37fb3, 0x7f7fb3b3, 0x7fb37fb3,   /*  0,20 */
0xb3b37fb3, 0x7fb37fb3, 0x7fb3b3b3, 0x7fb37fb3,   /*  0,21 */
0xb3b37fb3, 0xb3b37fb3, 0x7fb3b3b3, 0x7fb3b3b3,   /*  0,22 */
0xb3b3b3b3, 0xb3b37fb3, 0xb3b3b3b3, 0x7fb3b3b3,   /*  0,23 */
0xb3b3b3b3, 0xb3b3b3b3, 0xb3b3b3b3, 0xb3b3b3b3,   /*  0,24 */
0xb3b3b3b3, 0xb3b3b3b3, 0xb3b3b3b3, 0xb3b3b3b3,   /*  0,25 */
0xb3b3b3b3, 0xb3b3b3b3, 0xb3b3b3b3, 0xb3b3b3b3,   /*  0,26 */
0xb3b3b3b3, 0xb3b3b3c0, 0xb3b3b3b3, 0xb3c0b3b3,   /*  0,27 */
0xb3b3b3b3, 0xb3b3b3c0, 0xb3b3b3b3, 0xb3c0b3b3,   /*  0,28 */
0xb3b3b3b3, 0xb3b3b3c0, 0xb3b3b3b3, 0xb3c0b3b3,   /*  0,29 */
0xb3b3b3b3, 0xb3b3b3c0, 0xb3b3b3b3, 0xb3c0b3b3,   /*  0,30 */
0xb3c0b3c0, 0xb3b3b3c0, 0xb3c0b3c0, 0xb3c0b3b3,   /*  0,31 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  1, 0 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  1, 1 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  1, 2 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  1, 3 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  1, 4 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  1, 5 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  1, 6 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  1, 7 */
0x7f7f4b4b, 0x4b7f4b4b, 0x4b4b7f7f, 0x4b4b4b7f,   /*  1, 8 */
0x7f7f4b4b, 0x4b7f4b4b, 0x4b4b7f7f, 0x4b4b4b7f,   /*  1, 9 */
0x7f7f7f4b, 0x4b7f4b7f, 0x7f4b7f7f, 0x4b7f4b7f,   /*  1,10 */
0x7f7f7f4b, 0x4b7f4b7f, 0x7f4b7f7f, 0x4b7f4b7f,   /*  1,11 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  1,12 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  1,13 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  1,14 */
0x7f7f7f7f, 0x7f7f4b7f, 0x7f7f7f7f, 0x4b7f7f7f,   /*  1,15 */
0x7f7f7f7f, 0x7f7f247f, 0x7f7f7f7f, 0x247f7f7f,   /*  1,16 */
0xb37f7f7f, 0x7f7f247f, 0x7f7fb37f, 0x247f7f7f,   /*  1,17 */
0xb37f7f7f, 0x7f7f24b3, 0x7f7fb37f, 0x24b37f7f,   /*  1,18 */
0xb3b37f7f, 0x7f7f24b3, 0x7f7fb3b3, 0x24b37f7f,   /*  1,19 */
0xb3b37f7f, 0x7fb324b3, 0x7f7fb3b3, 0x24b37fb3,   /*  1,20 */
0xb3b37fb3, 0x7fb324b3, 0x7fb3b3b3, 0x24b37fb3,   /*  1,21 */
0xb3b37fb3, 0xb3b324b3, 0x7fb3b3b3, 0x24b3b3b3,   /*  1,22 */
0xb3b3b3b3, 0xb3b324b3, 0xb3b3b3b3, 0x24b3b3b3,   /*  1,23 */
0xb3b3b3b3, 0xb3b372b3, 0xb3b3b3b3, 0x72b3b3b3,   /*  1,24 */
0xb3b3b3b3, 0xb3b372b3, 0xb3b3b3b3, 0x72b3b3b3,   /*  1,25 */
0xb3b3b3b3, 0xb3b372b3, 0xb3b3b3b3, 0x72b3b3b3,   /*  1,26 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  1,27 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  1,28 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  1,29 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  1,30 */
0xb3c0b3c0, 0xb3b372c0, 0xb3c0b3c0, 0x72c0b3b3,   /*  1,31 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  2, 0 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  2, 1 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  2, 2 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  2, 3 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  2, 4 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  2, 5 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  2, 6 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  2, 7 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  2, 8 */
0x7f7f4b4b, 0x4b7f4b4b, 0x4b4b7f7f, 0x4b4b4b7f,   /*  2, 9 */
0x7f7f4b4b, 0x4b7f4b24, 0x4b4b7f7f, 0x4b244b7f,   /*  2,10 */
0x7f7f7f4b, 0x4b7f4b24, 0x7f4b7f7f, 0x4b244b7f,   /*  2,11 */
0x7f7f7f4b, 0x4b7f4b24, 0x7f4b7f7f, 0x4b244b7f,   /*  2,12 */
0x7f7f7f7f, 0x7f7f4b24, 0x7f7f7f7f, 0x4b247f7f,   /*  2,13 */
0x7f7f7f7f, 0x7f7f4b24, 0x7f7f7f7f, 0x4b247f7f,   /*  2,14 */
0x7f7f7f7f, 0x7f7f4b24, 0x7f7f7f7f, 0x4b247f7f,   /*  2,15 */
0x7f7f7f7f, 0x7f7f2424, 0x7f7f7f7f, 0x24247f7f,   /*  2,16 */
0xb37f7f7f, 0x7f7f2424, 0x7f7fb37f, 0x24247f7f,   /*  2,17 */
0xb37f7f7f, 0x7f7f2472, 0x7f7fb37f, 0x24727f7f,   /*  2,18 */
0xb3b37f7f, 0x7f7f2472, 0x7f7fb3b3, 0x24727f7f,   /*  2,19 */
0xb3b37f7f, 0x7fb32472, 0x7f7fb3b3, 0x24727fb3,   /*  2,20 */
0xb3b37fb3, 0x7fb32472, 0x7fb3b3b3, 0x24727fb3,   /*  2,21 */
0xb3b37fb3, 0xb3b32472, 0x7fb3b3b3, 0x2472b3b3,   /*  2,22 */
0xb3b3b3b3, 0xb3b32472, 0xb3b3b3b3, 0x2472b3b3,   /*  2,23 */
0xb3b3b3b3, 0xb3b37272, 0xb3b3b3b3, 0x7272b3b3,   /*  2,24 */
0xb3b3b3b3, 0xb3b37272, 0xb3b3b3b3, 0x7272b3b3,   /*  2,25 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  2,26 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  2,27 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  2,28 */
0xb3b3b3b3, 0xb3b372c0, 0xb3b3b3b3, 0x72c0b3b3,   /*  2,29 */
0xb3c0b3c0, 0xb3b372c0, 0xb3c0b3c0, 0x72c0b3b3,   /*  2,30 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  2,31 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  3, 0 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  3, 1 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  3, 2 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  3, 3 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  3, 4 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  3, 5 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  3, 6 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  3, 7 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  3, 8 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  3, 9 */
0x7f7f4b4b, 0x4b7f4b24, 0x4b4b7f7f, 0x4b244b7f,   /*  3,10 */
0x7f7f4b4b, 0x4b7f4b24, 0x4b4b7f7f, 0x4b244b7f,   /*  3,11 */
0x7f7f7f4b, 0x4b7f4b24, 0x7f4b7f7f, 0x4b244b7f,   /*  3,12 */
0x7f7f7f24, 0x4b7f4b24, 0x7f247f7f, 0x4b244b7f,   /*  3,13 */
0x7f7f7f24, 0x7f7f4b24, 0x7f247f7f, 0x4b247f7f,   /*  3,14 */
0x7f7f7f24, 0x7f7f4b24, 0x7f247f7f, 0x4b247f7f,   /*  3,15 */
0x7f7f7f24, 0x7f7f2424, 0x7f247f7f, 0x24247f7f,   /*  3,16 */
0xb37f7f24, 0x7f7f2424, 0x7f24b37f, 0x24247f7f,   /*  3,17 */
0xb37f7f24, 0x7f7f2472, 0x7f24b37f, 0x24727f7f,   /*  3,18 */
0xb3b37f24, 0x7f7f2472, 0x7f24b3b3, 0x24727f7f,   /*  3,19 */
0xb3b37f24, 0x7fb32472, 0x7f24b3b3, 0x24727fb3,   /*  3,20 */
0xb3b37f72, 0x7fb32472, 0x7f72b3b3, 0x24727fb3,   /*  3,21 */
0xb3b37f72, 0xb3b32472, 0x7f72b3b3, 0x2472b3b3,   /*  3,22 */
0xb3b3b372, 0xb3b32472, 0xb372b3b3, 0x2472b3b3,   /*  3,23 */
0xb3b3b372, 0xb3b37272, 0xb372b3b3, 0x7272b3b3,   /*  3,24 */
0xb3b3b372, 0xb3b37272, 0xb372b3b3, 0x7272b3b3,   /*  3,25 */
0xb3b3b372, 0xb3b372c0, 0xb372b3b3, 0x72c0b3b3,   /*  3,26 */
0xb3b3b372, 0xb3b372c0, 0xb372b3b3, 0x72c0b3b3,   /*  3,27 */
0xb3b3b372, 0xb3b372c0, 0xb372b3b3, 0x72c0b3b3,   /*  3,28 */
0xb3c0b3c0, 0xb3b372c0, 0xb3c0b3c0, 0x72c0b3b3,   /*  3,29 */
0xc0c0b3c0, 0xb3b372c0, 0xb3c0c0c0, 0x72c0b3b3,   /*  3,30 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  3,31 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  4, 0 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  4, 1 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  4, 2 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  4, 3 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  4, 4 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  4, 5 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  4, 6 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  4, 7 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  4, 8 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  4, 9 */
0x7f4b4b4b, 0x4b4b4b24, 0x4b4b7f4b, 0x4b244b4b,   /*  4,10 */
0x7f7f4b4b, 0x4b7f4b24, 0x4b4b7f7f, 0x4b244b7f,   /*  4,11 */
0x7f7f4b4b, 0x4b7f4b24, 0x4b4b7f7f, 0x4b244b7f,   /*  4,12 */
0x7f7f7f24, 0x4b7f4b24, 0x7f247f7f, 0x4b244b7f,   /*  4,13 */
0x7f7f7f24, 0x247f4b24, 0x7f247f7f, 0x4b24247f,   /*  4,14 */
0x7f7f7f24, 0x247f4b24, 0x7f247f7f, 0x4b24247f,   /*  4,15 */
0x7f7f7f24, 0x247f2424, 0x7f247f7f, 0x2424247f,   /*  4,16 */
0xb37f7f24, 0x247f2424, 0x7f24b37f, 0x2424247f,   /*  4,17 */
0xb37f7f24, 0x247f2472, 0x7f24b37f, 0x2472247f,   /*  4,18 */
0xb3b37f24, 0x247f2472, 0x7f24b3b3, 0x2472247f,   /*  4,19 */
0xb3b37f24, 0x24b32472, 0x7f24b3b3, 0x247224b3,   /*  4,20 */
0xb3b37f72, 0x24b32472, 0x7f72b3b3, 0x247224b3,   /*  4,21 */
0xb3b37f72, 0x72b32472, 0x7f72b3b3, 0x247272b3,   /*  4,22 */
0xb3b3b372, 0x72b32472, 0xb372b3b3, 0x247272b3,   /*  4,23 */
0xb3b3b372, 0x72b37272, 0xb372b3b3, 0x727272b3,   /*  4,24 */
0xb3b3b372, 0x72b37272, 0xb372b3b3, 0x727272b3,   /*  4,25 */
0xb3b3b372, 0x72b372c0, 0xb372b3b3, 0x72c072b3,   /*  4,26 */
0xb3b3b372, 0x72b372c0, 0xb372b3b3, 0x72c072b3,   /*  4,27 */
0xb3c0b372, 0x72b372c0, 0xb372b3c0, 0x72c072b3,   /*  4,28 */
0xc0c0b3c0, 0x72c072c0, 0xb3c0c0c0, 0x72c072c0,   /*  4,29 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  4,30 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  4,31 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  5, 0 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  5, 1 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  5, 2 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  5, 3 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  5, 4 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  5, 5 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  5, 6 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  5, 7 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  5, 8 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  5, 9 */
0x7f4b4b4b, 0x4b4b4b24, 0x4b4b7f4b, 0x4b244b4b,   /*  5,10 */
0x7f244b4b, 0x4b4b4b24, 0x4b4b7f24, 0x4b244b4b,   /*  5,11 */
0x7f244b4b, 0x4b7f4b24, 0x4b4b7f24, 0x4b244b7f,   /*  5,12 */
0x7f244b24, 0x4b7f4b24, 0x4b247f24, 0x4b244b7f,   /*  5,13 */
0x7f247f24, 0x247f4b24, 0x7f247f24, 0x4b24247f,   /*  5,14 */
0x7f247f24, 0x247f4b24, 0x7f247f24, 0x4b24247f,   /*  5,15 */
0x7f247f24, 0x247f2424, 0x7f247f24, 0x2424247f,   /*  5,16 */
0xb3247f24, 0x247f2424, 0x7f24b324, 0x2424247f,   /*  5,17 */
0xb3247f24, 0x247f2472, 0x7f24b324, 0x2472247f,   /*  5,18 */
0xb3727f24, 0x247f2472, 0x7f24b372, 0x2472247f,   /*  5,19 */
0xb3727f24, 0x24b32472, 0x7f24b372, 0x247224b3,   /*  5,20 */
0xb3727f72, 0x24b32472, 0x7f72b372, 0x247224b3,   /*  5,21 */
0xb3727f72, 0x72b32472, 0x7f72b372, 0x247272b3,   /*  5,22 */
0xb372b372, 0x72b32472, 0xb372b372, 0x247272b3,   /*  5,23 */
0xb372b372, 0x72b37272, 0xb372b372, 0x727272b3,   /*  5,24 */
0xb372b372, 0x72b37272, 0xb372b372, 0x727272b3,   /*  5,25 */
0xb372b372, 0x72b372c0, 0xb372b372, 0x72c072b3,   /*  5,26 */
0xc0c0b372, 0x72b372c0, 0xb372c0c0, 0x72c072b3,   /*  5,27 */
0xc0c0b372, 0x72b372c0, 0xb372c0c0, 0x72c072b3,   /*  5,28 */
0xc0c0b3c0, 0x72c072c0, 0xb3c0c0c0, 0x72c072c0,   /*  5,29 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  5,30 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  5,31 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  6, 0 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  6, 1 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  6, 2 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  6, 3 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  6, 4 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  6, 5 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  6, 6 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  6, 7 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  6, 8 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  6, 9 */
0x7f4b4b4b, 0x4b4b4b24, 0x4b4b7f4b, 0x4b244b4b,   /*  6,10 */
0x7f244b4b, 0x4b4b4b24, 0x4b4b7f24, 0x4b244b4b,   /*  6,11 */
0x7f244b4b, 0x4b244b24, 0x4b4b7f24, 0x4b244b24,   /*  6,12 */
0x7f244b24, 0x4b244b24, 0x4b247f24, 0x4b244b24,   /*  6,13 */
0x7f244b24, 0x24244b24, 0x4b247f24, 0x4b242424,   /*  6,14 */
0x7f247f24, 0x24244b24, 0x7f247f24, 0x4b242424,   /*  6,15 */
0x7f247f24, 0x24242424, 0x7f247f24, 0x24242424,   /*  6,16 */
0xb3247f24, 0x24242424, 0x7f24b324, 0x24242424,   /*  6,17 */
0xb3247f24, 0x24242472, 0x7f24b324, 0x24722424,   /*  6,18 */
0xb3727f24, 0x24242472, 0x7f24b372, 0x24722424,   /*  6,19 */
0xb3727f24, 0x24722472, 0x7f24b372, 0x24722472,   /*  6,20 */
0xb3727f72, 0x24722472, 0x7f72b372, 0x24722472,   /*  6,21 */
0xb3727f72, 0x72722472, 0x7f72b372, 0x24727272,   /*  6,22 */
0xb372b372, 0x72722472, 0xb372b372, 0x24727272,   /*  6,23 */
0xb372b372, 0x72727272, 0xb372b372, 0x72727272,   /*  6,24 */
0xb372b372, 0x72727272, 0xb372b372, 0x72727272,   /*  6,25 */
0xb372b372, 0x727272c0, 0xb372b372, 0x72c07272,   /*  6,26 */
0xc0c0b372, 0x727272c0, 0xb372c0c0, 0x72c07272,   /*  6,27 */
0xc0c0b372, 0x72c072c0, 0xb372c0c0, 0x72c072c0,   /*  6,28 */
0xc0c0b3c0, 0x72c072c0, 0xb3c0c0c0, 0x72c072c0,   /*  6,29 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  6,30 */
0xc0c0b3c0, 0xc0c072c0, 0xb3c0c0c0, 0x72c0c0c0,   /*  6,31 */
0x4b4b4b99, 0x994b994b, 0x4b994b4b, 0x994b994b,   /*  7, 0 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  7, 1 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  7, 2 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  7, 3 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  7, 4 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  7, 5 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  7, 6 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  7, 7 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  7, 8 */
0x7f4b4b4b, 0x4b4b4b4b, 0x4b4b7f4b, 0x4b4b4b4b,   /*  7, 9 */
0x7f4b4b4b, 0x4b4b4b24, 0x4b4b7f4b, 0x4b244b4b,   /*  7,10 */
0x7f244b4b, 0x4b4b4b24, 0x4b4b7f24, 0x4b244b4b,   /*  7,11 */
0x7f244b4b, 0x4b244b24, 0x4b4b7f24, 0x4b244b24,   /*  7,12 */
0x7f244b24, 0x4b244b24, 0x4b247f24, 0x4b244b24,   /*  7,13 */
0x7f244b24, 0x24244b24, 0x4b247f24, 0x4b242424,   /*  7,14 */
0x7f242424, 0x24244b24, 0x24247f24, 0x4b242424,   /*  7,15 */
0x7f242424, 0x24242424, 0x24247f24, 0x24242424,   /*  7,16 */
0xb3242424, 0x24242424, 0x2424b324, 0x24242424,   /*  7,17 */
0xb3242424, 0x24242472, 0x2424b324, 0x24722424,   /*  7,18 */
0xb3722424, 0x24242472, 0x2424b372, 0x24722424,   /*  7,19 */
0xb3722424, 0x24722472, 0x2424b372, 0x24722472,   /*  7,20 */
0xb3722472, 0x24722472, 0x2472b372, 0x24722472,   /*  7,21 */
0xb3722472, 0x72722472, 0x2472b372, 0x24727272,   /*  7,22 */
0xb3727272, 0x72722472, 0x7272b372, 0x24727272,   /*  7,23 */
0xb3727272, 0x72727272, 0x7272b372, 0x72727272,   /*  7,24 */
0xb3727272, 0x72727272, 0x7272b372, 0x72727272,   /*  7,25 */
0xc0727272, 0x727272c0, 0x7272c072, 0x72c07272,   /*  7,26 */
0xc0c07272, 0x727272c0, 0x7272c0c0, 0x72c07272,   /*  7,27 */
0xc0c07272, 0x72c072c0, 0x7272c0c0, 0x72c072c0,   /*  7,28 */
0xc0c072c0, 0x72c072c0, 0x72c0c0c0, 0x72c072c0,   /*  7,29 */
0xc0c072c0, 0xc0c072c0, 0x72c0c0c0, 0x72c0c0c0,   /*  7,30 */
0xc0c0c0c0, 0xc0c072c0, 0xc0c0c0c0, 0x72c0c0c0,   /*  7,31 */
0x4b4b4b99, 0x994b994b, 0x4b994b4b, 0x994b994b,   /*  8, 0 */
0x4b4b4b99, 0x994b994b, 0x4b994b4b, 0x994b994b,   /*  8, 1 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  8, 2 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  8, 3 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  8, 4 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  8, 5 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  8, 6 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  8, 7 */
0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b, 0x4b4b4b4b,   /*  8, 8 */
0x244b4b4b, 0x4b4b4b4b, 0x4b4b244b, 0x4b4b4b4b,   /*  8, 9 */
0x244b4b4b, 0x4b4b4b24, 0x4b4b244b, 0x4b244b4b,   /*  8,10 */
0x24244b4b, 0x4b4b4b24, 0x4b4b2424, 0x4b244b4b,   /*  8,11 */
0x24244b4b, 0x4b244b24, 0x4b4b2424, 0x4b244b24,   /*  8,12 */
0x24244b24, 0x4b244b24, 0x4b242424, 0x4b244b24,   /*  8,13 */
0x24244b24, 0x24244b24, 0x4b242424, 0x4b242424,   /*  8,14 */
0x24242424, 0x24244b24, 0x24242424, 0x4b242424,   /*  8,15 */
0x24242424, 0x24242424, 0x24242424, 0x24242424,   /*  8,16 */
0x72242424, 0x24242424, 0x24247224, 0x24242424,   /*  8,17 */
0x72242424, 0x24242472, 0x24247224, 0x24722424,   /*  8,18 */
0x72722424, 0x24242472, 0x24247272, 0x24722424,   /*  8,19 */
0x72722424, 0x24722472, 0x24247272, 0x24722472,   /*  8,20 */
0x72722472, 0x24722472, 0x24727272, 0x24722472,   /*  8,21 */
0x72722472, 0x72722472, 0x24727272, 0x24727272,   /*  8,22 */
0x72727272, 0x72722472, 0x72727272, 0x24727272,   /*  8,23 */
0x72727272, 0x72727272, 0x72727272, 0x72727272,   /*  8,24 */
0xc0727272, 0x72727272, 0x7272c072, 0x72727272,   /*  8,25 */
0xc0727272, 0x727272c0, 0x7272c072, 0x72c07272,   /*  8,26 */
0xc0c07272, 0x727272c0, 0x7272c0c0, 0x72c07272,   /*  8,27 */
0xc0c07272, 0x72c072c0, 0x7272c0c0, 0x72c072c0,   /*  8,28 */
0xc0c072c0, 0x72c072c0, 0x72c0c0c0, 0x72c072c0,   /*  8,29 */
0xc0c072c0, 0xc0c072c0, 0x72c0c0c0, 0x72c0c0c0,   /*  8,30 */
0xc0c0c0c0, 0xc0c072c0, 0xc0c0c0c0, 0x72c0c0c0,   /*  8,31 */
0x4b4b9999, 0x994b9999, 0x99994b4b, 0x9999994b,   /*  9, 0 */
0x4b4b4b99, 0x994b994b, 0x4b994b4b, 0x994b994b,   /*  9, 1 */
0x4b4b4b99, 0x994b994b, 0x4b994b4b, 0x994b994b,   /*  9, 2 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  9, 3 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  9, 4 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  9, 5 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  9, 6 */
0x4b4b4b4b, 0x4b4b994b, 0x4b4b4b4b, 0x994b4b4b,   /*  9, 7 */
0x4b4b4b4b, 0x4b4b174b, 0x4b4b4b4b, 0x174b4b4b,   /*  9, 8 */
0x244b4b4b, 0x4b4b174b, 0x4b4b244b, 0x174b4b4b,   /*  9, 9 */
0x244b4b4b, 0x4b4b1724, 0x4b4b244b, 0x17244b4b,   /*  9,10 */
0x24244b4b, 0x4b4b1724, 0x4b4b2424, 0x17244b4b,   /*  9,11 */
0x24244b4b, 0x4b241724, 0x4b4b2424, 0x17244b24,   /*  9,12 */
0x24244b24, 0x4b241724, 0x4b242424, 0x17244b24,   /*  9,13 */
0x24244b24, 0x24241724, 0x4b242424, 0x17242424,   /*  9,14 */
0x24242424, 0x24241724, 0x24242424, 0x17242424,   /*  9,15 */
0x24242424, 0x24240a24, 0x24242424, 0x0a242424,   /*  9,16 */
0x72242424, 0x24240a24, 0x24247224, 0x0a242424,   /*  9,17 */
0x72242424, 0x24240a72, 0x24247224, 0x0a722424,   /*  9,18 */
0x72722424, 0x24240a72, 0x24247272, 0x0a722424,   /*  9,19 */
0x72722424, 0x24720a72, 0x24247272, 0x0a722472,   /*  9,20 */
0x72722472, 0x24720a72, 0x24727272, 0x0a722472,   /*  9,21 */
0x72722472, 0x72720a72, 0x24727272, 0x0a727272,   /*  9,22 */
0x72727272, 0x72720a72, 0x72727272, 0x0a727272,   /*  9,23 */
0x72727272, 0x72723172, 0x72727272, 0x31727272,   /*  9,24 */
0xc0727272, 0x72723172, 0x7272c072, 0x31727272,   /*  9,25 */
0xc0727272, 0x727231c0, 0x7272c072, 0x31c07272,   /*  9,26 */
0xc0c07272, 0x727231c0, 0x7272c0c0, 0x31c07272,   /*  9,27 */
0xc0c07272, 0x72c031c0, 0x7272c0c0, 0x31c072c0,   /*  9,28 */
0xc0c072c0, 0x72c031c0, 0x72c0c0c0, 0x31c072c0,   /*  9,29 */
0xc0c072c0, 0xc0c031c0, 0x72c0c0c0, 0x31c0c0c0,   /*  9,30 */
0xc0c0c0c0, 0xc0c031c0, 0xc0c0c0c0, 0x31c0c0c0,   /*  9,31 */
0x4b4b9999, 0x994b9999, 0x99994b4b, 0x9999994b,   /* 10, 0 */
0x4b4b9999, 0x994b9999, 0x99994b4b, 0x9999994b,   /* 10, 1 */
0x4b4b4b99, 0x994b9917, 0x4b994b4b, 0x9917994b,   /* 10, 2 */
0x4b4b4b99, 0x994b9917, 0x4b994b4b, 0x9917994b,   /* 10, 3 */
0x4b4b4b4b, 0x4b4b9917, 0x4b4b4b4b, 0x99174b4b,   /* 10, 4 */
0x4b4b4b4b, 0x4b4b9917, 0x4b4b4b4b, 0x99174b4b,   /* 10, 5 */
0x4b4b4b4b, 0x4b4b9917, 0x4b4b4b4b, 0x99174b4b,   /* 10, 6 */
0x4b4b4b4b, 0x4b4b9917, 0x4b4b4b4b, 0x99174b4b,   /* 10, 7 */
0x4b4b4b4b, 0x4b4b1717, 0x4b4b4b4b, 0x17174b4b,   /* 10, 8 */
0x244b4b4b, 0x4b4b1717, 0x4b4b244b, 0x17174b4b,   /* 10, 9 */
0x244b4b4b, 0x4b4b170a, 0x4b4b244b, 0x170a4b4b,   /* 10,10 */
0x24244b4b, 0x4b4b170a, 0x4b4b2424, 0x170a4b4b,   /* 10,11 */
0x24244b4b, 0x4b24170a, 0x4b4b2424, 0x170a4b24,   /* 10,12 */
0x24244b24, 0x4b24170a, 0x4b242424, 0x170a4b24,   /* 10,13 */
0x24244b24, 0x2424170a, 0x4b242424, 0x170a2424,   /* 10,14 */
0x24242424, 0x2424170a, 0x24242424, 0x170a2424,   /* 10,15 */
0x24242424, 0x24240a0a, 0x24242424, 0x0a0a2424,   /* 10,16 */
0x72242424, 0x24240a0a, 0x24247224, 0x0a0a2424,   /* 10,17 */
0x72242424, 0x24240a31, 0x24247224, 0x0a312424,   /* 10,18 */
0x72722424, 0x24240a31, 0x24247272, 0x0a312424,   /* 10,19 */
0x72722424, 0x24720a31, 0x24247272, 0x0a312472,   /* 10,20 */
0x72722472, 0x24720a31, 0x24727272, 0x0a312472,   /* 10,21 */
0x72722472, 0x72720a31, 0x24727272, 0x0a317272,   /* 10,22 */
0x72727272, 0x72720a31, 0x72727272, 0x0a317272,   /* 10,23 */
0x72727272, 0x72723131, 0x72727272, 0x31317272,   /* 10,24 */
0xc0727272, 0x72723131, 0x7272c072, 0x31317272,   /* 10,25 */
0xc0727272, 0x7272318c, 0x7272c072, 0x318c7272,   /* 10,26 */
0xc0c07272, 0x7272318c, 0x7272c0c0, 0x318c7272,   /* 10,27 */
0xc0c07272, 0x72c0318c, 0x7272c0c0, 0x318c72c0,   /* 10,28 */
0xc0c072c0, 0x72c0318c, 0x72c0c0c0, 0x318c72c0,   /* 10,29 */
0xc0c072c0, 0xc0c0318c, 0x72c0c0c0, 0x318cc0c0,   /* 10,30 */
0xc0c0c0c0, 0xc0c0318c, 0xc0c0c0c0, 0x318cc0c0,   /* 10,31 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 11, 0 */
0x4b4b9999, 0x994b9999, 0x99994b4b, 0x9999994b,   /* 11, 1 */
0x4b4b9999, 0x994b9917, 0x99994b4b, 0x9917994b,   /* 11, 2 */
0x4b4b4b99, 0x994b9917, 0x4b994b4b, 0x9917994b,   /* 11, 3 */
0x4b4b4b99, 0x994b9917, 0x4b994b4b, 0x9917994b,   /* 11, 4 */
0x4b4b4b17, 0x4b4b9917, 0x4b174b4b, 0x99174b4b,   /* 11, 5 */
0x4b4b4b17, 0x4b4b9917, 0x4b174b4b, 0x99174b4b,   /* 11, 6 */
0x4b4b4b17, 0x4b4b9917, 0x4b174b4b, 0x99174b4b,   /* 11, 7 */
0x4b4b4b17, 0x4b4b1717, 0x4b174b4b, 0x17174b4b,   /* 11, 8 */
0x244b4b17, 0x4b4b1717, 0x4b17244b, 0x17174b4b,   /* 11, 9 */
0x244b4b17, 0x4b4b170a, 0x4b17244b, 0x170a4b4b,   /* 11,10 */
0x24244b17, 0x4b4b170a, 0x4b172424, 0x170a4b4b,   /* 11,11 */
0x24244b17, 0x4b24170a, 0x4b172424, 0x170a4b24,   /* 11,12 */
0x24244b0a, 0x4b24170a, 0x4b0a2424, 0x170a4b24,   /* 11,13 */
0x24244b0a, 0x2424170a, 0x4b0a2424, 0x170a2424,   /* 11,14 */
0x2424240a, 0x2424170a, 0x240a2424, 0x170a2424,   /* 11,15 */
0x2424240a, 0x24240a0a, 0x240a2424, 0x0a0a2424,   /* 11,16 */
0x7224240a, 0x24240a0a, 0x240a7224, 0x0a0a2424,   /* 11,17 */
0x7224240a, 0x24240a31, 0x240a7224, 0x0a312424,   /* 11,18 */
0x7272240a, 0x24240a31, 0x240a7272, 0x0a312424,   /* 11,19 */
0x7272240a, 0x24720a31, 0x240a7272, 0x0a312472,   /* 11,20 */
0x72722431, 0x24720a31, 0x24317272, 0x0a312472,   /* 11,21 */
0x72722431, 0x72720a31, 0x24317272, 0x0a317272,   /* 11,22 */
0x72727231, 0x72720a31, 0x72317272, 0x0a317272,   /* 11,23 */
0x72727231, 0x72723131, 0x72317272, 0x31317272,   /* 11,24 */
0xc0727231, 0x72723131, 0x7231c072, 0x31317272,   /* 11,25 */
0xc0727231, 0x7272318c, 0x7231c072, 0x318c7272,   /* 11,26 */
0xc0c07231, 0x7272318c, 0x7231c0c0, 0x318c7272,   /* 11,27 */
0xc0c07231, 0x72c0318c, 0x7231c0c0, 0x318c72c0,   /* 11,28 */
0xc0c0728c, 0x72c0318c, 0x728cc0c0, 0x318c72c0,   /* 11,29 */
0xc0c0728c, 0xc0c0318c, 0x728cc0c0, 0x318cc0c0,   /* 11,30 */
0xc0c0c08c, 0xc0c0318c, 0xc08cc0c0, 0x318cc0c0,   /* 11,31 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 12, 0 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 12, 1 */
0x4b4b9999, 0x994b9917, 0x99994b4b, 0x9917994b,   /* 12, 2 */
0x4b4b9999, 0x994b9917, 0x99994b4b, 0x9917994b,   /* 12, 3 */
0x4b4b4b99, 0x994b9917, 0x4b994b4b, 0x9917994b,   /* 12, 4 */
0x4b4b4b17, 0x994b9917, 0x4b174b4b, 0x9917994b,   /* 12, 5 */
0x4b4b4b17, 0x174b9917, 0x4b174b4b, 0x9917174b,   /* 12, 6 */
0x4b4b4b17, 0x174b9917, 0x4b174b4b, 0x9917174b,   /* 12, 7 */
0x4b4b4b17, 0x174b1717, 0x4b174b4b, 0x1717174b,   /* 12, 8 */
0x244b4b17, 0x174b1717, 0x4b17244b, 0x1717174b,   /* 12, 9 */
0x244b4b17, 0x174b170a, 0x4b17244b, 0x170a174b,   /* 12,10 */
0x24244b17, 0x174b170a, 0x4b172424, 0x170a174b,   /* 12,11 */
0x24244b17, 0x1724170a, 0x4b172424, 0x170a1724,   /* 12,12 */
0x24244b0a, 0x1724170a, 0x4b0a2424, 0x170a1724,   /* 12,13 */
0x24244b0a, 0x0a24170a, 0x4b0a2424, 0x170a0a24,   /* 12,14 */
0x2424240a, 0x0a24170a, 0x240a2424, 0x170a0a24,   /* 12,15 */
0x2424240a, 0x0a240a0a, 0x240a2424, 0x0a0a0a24,   /* 12,16 */
0x7224240a, 0x0a240a0a, 0x240a7224, 0x0a0a0a24,   /* 12,17 */
0x7224240a, 0x0a240a31, 0x240a7224, 0x0a310a24,   /* 12,18 */
0x7272240a, 0x0a240a31, 0x240a7272, 0x0a310a24,   /* 12,19 */
0x7272240a, 0x0a720a31, 0x240a7272, 0x0a310a72,   /* 12,20 */
0x72722431, 0x0a720a31, 0x24317272, 0x0a310a72,   /* 12,21 */
0x72722431, 0x31720a31, 0x24317272, 0x0a313172,   /* 12,22 */
0x72727231, 0x31720a31, 0x72317272, 0x0a313172,   /* 12,23 */
0x72727231, 0x31723131, 0x72317272, 0x31313172,   /* 12,24 */
0xc0727231, 0x31723131, 0x7231c072, 0x31313172,   /* 12,25 */
0xc0727231, 0x3172318c, 0x7231c072, 0x318c3172,   /* 12,26 */
0xc0c07231, 0x3172318c, 0x7231c0c0, 0x318c3172,   /* 12,27 */
0xc0c07231, 0x31c0318c, 0x7231c0c0, 0x318c31c0,   /* 12,28 */
0xc0c0728c, 0x31c0318c, 0x728cc0c0, 0x318c31c0,   /* 12,29 */
0xc0c0728c, 0x8cc0318c, 0x728cc0c0, 0x318c8cc0,   /* 12,30 */
0xc0c0c08c, 0x8cc0318c, 0xc08cc0c0, 0x318c8cc0,   /* 12,31 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 13, 0 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 13, 1 */
0x4b999999, 0x99999917, 0x99994b99, 0x99179999,   /* 13, 2 */
0x4b179999, 0x994b9917, 0x99994b17, 0x9917994b,   /* 13, 3 */
0x4b179999, 0x994b9917, 0x99994b17, 0x9917994b,   /* 13, 4 */
0x4b174b17, 0x994b9917, 0x4b174b17, 0x9917994b,   /* 13, 5 */
0x4b174b17, 0x174b9917, 0x4b174b17, 0x9917174b,   /* 13, 6 */
0x4b174b17, 0x174b9917, 0x4b174b17, 0x9917174b,   /* 13, 7 */
0x4b174b17, 0x174b1717, 0x4b174b17, 0x1717174b,   /* 13, 8 */
0x24174b17, 0x174b1717, 0x4b172417, 0x1717174b,   /* 13, 9 */
0x24174b17, 0x174b170a, 0x4b172417, 0x170a174b,   /* 13,10 */
0x240a4b17, 0x174b170a, 0x4b17240a, 0x170a174b,   /* 13,11 */
0x240a4b17, 0x1724170a, 0x4b17240a, 0x170a1724,   /* 13,12 */
0x240a4b0a, 0x1724170a, 0x4b0a240a, 0x170a1724,   /* 13,13 */
0x240a4b0a, 0x0a24170a, 0x4b0a240a, 0x170a0a24,   /* 13,14 */
0x240a240a, 0x0a24170a, 0x240a240a, 0x170a0a24,   /* 13,15 */
0x240a240a, 0x0a240a0a, 0x240a240a, 0x0a0a0a24,   /* 13,16 */
0x720a240a, 0x0a240a0a, 0x240a720a, 0x0a0a0a24,   /* 13,17 */
0x720a240a, 0x0a240a31, 0x240a720a, 0x0a310a24,   /* 13,18 */
0x7231240a, 0x0a240a31, 0x240a7231, 0x0a310a24,   /* 13,19 */
0x7231240a, 0x0a720a31, 0x240a7231, 0x0a310a72,   /* 13,20 */
0x72312431, 0x0a720a31, 0x24317231, 0x0a310a72,   /* 13,21 */
0x72312431, 0x31720a31, 0x24317231, 0x0a313172,   /* 13,22 */
0x72317231, 0x31720a31, 0x72317231, 0x0a313172,   /* 13,23 */
0x72317231, 0x31723131, 0x72317231, 0x31313172,   /* 13,24 */
0xc0317231, 0x31723131, 0x7231c031, 0x31313172,   /* 13,25 */
0xc0317231, 0x3172318c, 0x7231c031, 0x318c3172,   /* 13,26 */
0xc08c7231, 0x3172318c, 0x7231c08c, 0x318c3172,   /* 13,27 */
0xc08c7231, 0x31c0318c, 0x7231c08c, 0x318c31c0,   /* 13,28 */
0xc08c728c, 0x31c0318c, 0x728cc08c, 0x318c31c0,   /* 13,29 */
0xc08c728c, 0x8cc0318c, 0x728cc08c, 0x318c8cc0,   /* 13,30 */
0xc08cc08c, 0x8cc0318c, 0xc08cc08c, 0x318c8cc0,   /* 13,31 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 14, 0 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 14, 1 */
0x4b999999, 0x99999917, 0x99994b99, 0x99179999,   /* 14, 2 */
0x4b179999, 0x99999917, 0x99994b17, 0x99179999,   /* 14, 3 */
0x4b179999, 0x99179917, 0x99994b17, 0x99179917,   /* 14, 4 */
0x4b179917, 0x99179917, 0x99174b17, 0x99179917,   /* 14, 5 */
0x4b174b17, 0x17179917, 0x4b174b17, 0x99171717,   /* 14, 6 */
0x4b174b17, 0x17179917, 0x4b174b17, 0x99171717,   /* 14, 7 */
0x4b174b17, 0x17171717, 0x4b174b17, 0x17171717,   /* 14, 8 */
0x24174b17, 0x17171717, 0x4b172417, 0x17171717,   /* 14, 9 */
0x24174b17, 0x1717170a, 0x4b172417, 0x170a1717,   /* 14,10 */
0x240a4b17, 0x1717170a, 0x4b17240a, 0x170a1717,   /* 14,11 */
0x240a4b17, 0x170a170a, 0x4b17240a, 0x170a170a,   /* 14,12 */
0x240a4b0a, 0x170a170a, 0x4b0a240a, 0x170a170a,   /* 14,13 */
0x240a4b0a, 0x0a0a170a, 0x4b0a240a, 0x170a0a0a,   /* 14,14 */
0x240a240a, 0x0a0a170a, 0x240a240a, 0x170a0a0a,   /* 14,15 */
0x240a240a, 0x0a0a0a0a, 0x240a240a, 0x0a0a0a0a,   /* 14,16 */
0x720a240a, 0x0a0a0a0a, 0x240a720a, 0x0a0a0a0a,   /* 14,17 */
0x720a240a, 0x0a0a0a31, 0x240a720a, 0x0a310a0a,   /* 14,18 */
0x7231240a, 0x0a0a0a31, 0x240a7231, 0x0a310a0a,   /* 14,19 */
0x7231240a, 0x0a310a31, 0x240a7231, 0x0a310a31,   /* 14,20 */
0x72312431, 0x0a310a31, 0x24317231, 0x0a310a31,   /* 14,21 */
0x72312431, 0x31310a31, 0x24317231, 0x0a313131,   /* 14,22 */
0x72317231, 0x31310a31, 0x72317231, 0x0a313131,   /* 14,23 */
0x72317231, 0x31313131, 0x72317231, 0x31313131,   /* 14,24 */
0xc0317231, 0x31313131, 0x7231c031, 0x31313131,   /* 14,25 */
0xc0317231, 0x3131318c, 0x7231c031, 0x318c3131,   /* 14,26 */
0xc08c7231, 0x3131318c, 0x7231c08c, 0x318c3131,   /* 14,27 */
0xc08c7231, 0x318c318c, 0x7231c08c, 0x318c318c,   /* 14,28 */
0xc08c728c, 0x318c318c, 0x728cc08c, 0x318c318c,   /* 14,29 */
0xc08c728c, 0x8c8c318c, 0x728cc08c, 0x318c8c8c,   /* 14,30 */
0xc08cc08c, 0x8c8c318c, 0xc08cc08c, 0x318c8c8c,   /* 14,31 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 15, 0 */
0x4b999999, 0x99999999, 0x99994b99, 0x99999999,   /* 15, 1 */
0x4b999999, 0x99999917, 0x99994b99, 0x99179999,   /* 15, 2 */
0x4b179999, 0x99999917, 0x99994b17, 0x99179999,   /* 15, 3 */
0x4b179999, 0x99179917, 0x99994b17, 0x99179917,   /* 15, 4 */
0x4b179917, 0x99179917, 0x99174b17, 0x99179917,   /* 15, 5 */
0x4b179917, 0x17179917, 0x99174b17, 0x99171717,   /* 15, 6 */
0x4b171717, 0x17179917, 0x17174b17, 0x99171717,   /* 15, 7 */
0x4b171717, 0x17171717, 0x17174b17, 0x17171717,   /* 15, 8 */
0x24171717, 0x17171717, 0x17172417, 0x17171717,   /* 15, 9 */
0x24171717, 0x1717170a, 0x17172417, 0x170a1717,   /* 15,10 */
0x240a1717, 0x1717170a, 0x1717240a, 0x170a1717,   /* 15,11 */
0x240a1717, 0x170a170a, 0x1717240a, 0x170a170a,   /* 15,12 */
0x240a170a, 0x170a170a, 0x170a240a, 0x170a170a,   /* 15,13 */
0x240a170a, 0x0a0a170a, 0x170a240a, 0x170a0a0a,   /* 15,14 */
0x240a0a0a, 0x0a0a170a, 0x0a0a240a, 0x170a0a0a,   /* 15,15 */
0x240a0a0a, 0x0a0a0a0a, 0x0a0a240a, 0x0a0a0a0a,   /* 15,16 */
0x720a0a0a, 0x0a0a0a0a, 0x0a0a720a, 0x0a0a0a0a,   /* 15,17 */
0x720a0a0a, 0x0a0a0a31, 0x0a0a720a, 0x0a310a0a,   /* 15,18 */
0x72310a0a, 0x0a0a0a31, 0x0a0a7231, 0x0a310a0a,   /* 15,19 */
0x72310a0a, 0x0a310a31, 0x0a0a7231, 0x0a310a31,   /* 15,20 */
0x72310a31, 0x0a310a31, 0x0a317231, 0x0a310a31,   /* 15,21 */
0x72310a31, 0x31310a31, 0x0a317231, 0x0a313131,   /* 15,22 */
0x72313131, 0x31310a31, 0x31317231, 0x0a313131,   /* 15,23 */
0x72313131, 0x31313131, 0x31317231, 0x31313131,   /* 15,24 */
0xc0313131, 0x31313131, 0x3131c031, 0x31313131,   /* 15,25 */
0xc0313131, 0x3131318c, 0x3131c031, 0x318c3131,   /* 15,26 */
0xc08c3131, 0x3131318c, 0x3131c08c, 0x318c3131,   /* 15,27 */
0xc08c3131, 0x318c318c, 0x3131c08c, 0x318c318c,   /* 15,28 */
0xc08c318c, 0x318c318c, 0x318cc08c, 0x318c318c,   /* 15,29 */
0xc08c318c, 0x8c8c318c, 0x318cc08c, 0x318c8c8c,   /* 15,30 */
0xc08c8c8c, 0x8c8c318c, 0x8c8cc08c, 0x318c8c8c,   /* 15,31 */
0x99999999, 0x99999999, 0x99999999, 0x99999999,   /* 16, 0 */
0x17999999, 0x99999999, 0x99991799, 0x99999999,   /* 16, 1 */
0x17999999, 0x99999917, 0x99991799, 0x99179999,   /* 16, 2 */
0x17179999, 0x99999917, 0x99991717, 0x99179999,   /* 16, 3 */
0x17179999, 0x99179917, 0x99991717, 0x99179917,   /* 16, 4 */
0x17179917, 0x99179917, 0x99171717, 0x99179917,   /* 16, 5 */
0x17179917, 0x17179917, 0x99171717, 0x99171717,   /* 16, 6 */
0x17171717, 0x17179917, 0x17171717, 0x99171717,   /* 16, 7 */
0x17171717, 0x17171717, 0x17171717, 0x17171717,   /* 16, 8 */
0x0a171717, 0x17171717, 0x17170a17, 0x17171717,   /* 16, 9 */
0x0a171717, 0x1717170a, 0x17170a17, 0x170a1717,   /* 16,10 */
0x0a0a1717, 0x1717170a, 0x17170a0a, 0x170a1717,   /* 16,11 */
0x0a0a1717, 0x170a170a, 0x17170a0a, 0x170a170a,   /* 16,12 */
0x0a0a170a, 0x170a170a, 0x170a0a0a, 0x170a170a,   /* 16,13 */
0x0a0a170a, 0x0a0a170a, 0x170a0a0a, 0x170a0a0a,   /* 16,14 */
0x0a0a0a0a, 0x0a0a170a, 0x0a0a0a0a, 0x170a0a0a,   /* 16,15 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /* 16,16 */
0x310a0a0a, 0x0a0a0a0a, 0x0a0a310a, 0x0a0a0a0a,   /* 16,17 */
0x310a0a0a, 0x0a0a0a31, 0x0a0a310a, 0x0a310a0a,   /* 16,18 */
0x31310a0a, 0x0a0a0a31, 0x0a0a3131, 0x0a310a0a,   /* 16,19 */
0x31310a0a, 0x0a310a31, 0x0a0a3131, 0x0a310a31,   /* 16,20 */
0x31310a31, 0x0a310a31, 0x0a313131, 0x0a310a31,   /* 16,21 */
0x31310a31, 0x31310a31, 0x0a313131, 0x0a313131,   /* 16,22 */
0x31313131, 0x31310a31, 0x31313131, 0x0a313131,   /* 16,23 */
0x31313131, 0x31313131, 0x31313131, 0x31313131,   /* 16,24 */
0x8c313131, 0x31313131, 0x31318c31, 0x31313131,   /* 16,25 */
0x8c313131, 0x3131318c, 0x31318c31, 0x318c3131,   /* 16,26 */
0x8c8c3131, 0x3131318c, 0x31318c8c, 0x318c3131,   /* 16,27 */
0x8c8c3131, 0x318c318c, 0x31318c8c, 0x318c318c,   /* 16,28 */
0x8c8c318c, 0x318c318c, 0x318c8c8c, 0x318c318c,   /* 16,29 */
0x8c8c318c, 0x8c8c318c, 0x318c8c8c, 0x318c8c8c,   /* 16,30 */
0x8c8c8c8c, 0x8c8c318c, 0x8c8c8c8c, 0x318c8c8c,   /* 16,31 */
0x99999999, 0x99999999, 0x99999999, 0x99999999,   /* 17, 0 */
0x17999999, 0x99999999, 0x99991799, 0x99999999,   /* 17, 1 */
0x17999999, 0x99999917, 0x99991799, 0x99179999,   /* 17, 2 */
0x17179999, 0x99999917, 0x99991717, 0x99179999,   /* 17, 3 */
0x17179999, 0x99179917, 0x99991717, 0x99179917,   /* 17, 4 */
0x17179917, 0x99179917, 0x99171717, 0x99179917,   /* 17, 5 */
0x17179917, 0x17179917, 0x99171717, 0x99171717,   /* 17, 6 */
0x17171717, 0x17175817, 0x17171717, 0x58171717,   /* 17, 7 */
0x17171717, 0x17175817, 0x17171717, 0x58171717,   /* 17, 8 */
0x0a171717, 0x17175817, 0x17170a17, 0x58171717,   /* 17, 9 */
0x0a171717, 0x1717580a, 0x17170a17, 0x580a1717,   /* 17,10 */
0x0a0a1717, 0x1717580a, 0x17170a0a, 0x580a1717,   /* 17,11 */
0x0a0a1717, 0x170a580a, 0x17170a0a, 0x580a170a,   /* 17,12 */
0x0a0a170a, 0x170a580a, 0x170a0a0a, 0x580a170a,   /* 17,13 */
0x0a0a170a, 0x0a0a580a, 0x170a0a0a, 0x580a0a0a,   /* 17,14 */
0x0a0a0a0a, 0x0a0a580a, 0x0a0a0a0a, 0x580a0a0a,   /* 17,15 */
0x0a0a0a0a, 0x0a0a3e0a, 0x0a0a0a0a, 0x3e0a0a0a,   /* 17,16 */
0x310a0a0a, 0x0a0a3e0a, 0x0a0a310a, 0x3e0a0a0a,   /* 17,17 */
0x310a0a0a, 0x0a0a3e31, 0x0a0a310a, 0x3e310a0a,   /* 17,18 */
0x31310a0a, 0x0a0a3e31, 0x0a0a3131, 0x3e310a0a,   /* 17,19 */
0x31310a0a, 0x0a313e31, 0x0a0a3131, 0x3e310a31,   /* 17,20 */
0x31310a31, 0x0a313e31, 0x0a313131, 0x3e310a31,   /* 17,21 */
0x31310a31, 0x31313e31, 0x0a313131, 0x3e313131,   /* 17,22 */
0x31313131, 0x31313e31, 0x31313131, 0x3e313131,   /* 17,23 */
0x31313131, 0x31316531, 0x31313131, 0x65313131,   /* 17,24 */
0x8c313131, 0x31316531, 0x31318c31, 0x65313131,   /* 17,25 */
0x8c313131, 0x3131658c, 0x31318c31, 0x658c3131,   /* 17,26 */
0x8c8c3131, 0x3131658c, 0x31318c8c, 0x658c3131,   /* 17,27 */
0x8c8c3131, 0x318c658c, 0x31318c8c, 0x658c318c,   /* 17,28 */
0x8c8c318c, 0x318c658c, 0x318c8c8c, 0x658c318c,   /* 17,29 */
0x8c8c318c, 0x8c8c658c, 0x318c8c8c, 0x658c8c8c,   /* 17,30 */
0x8c8c8c8c, 0x8c8c658c, 0x8c8c8c8c, 0x658c8c8c,   /* 17,31 */
0x99999999, 0x99999999, 0x99999999, 0x99999999,   /* 18, 0 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 18, 1 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 18, 2 */
0x17179999, 0x99999958, 0x99991717, 0x99589999,   /* 18, 3 */
0x17179999, 0x99179958, 0x99991717, 0x99589917,   /* 18, 4 */
0x17179917, 0x99179958, 0x99171717, 0x99589917,   /* 18, 5 */
0x17179917, 0x17175858, 0x99171717, 0x58581717,   /* 18, 6 */
0x17171717, 0x17175858, 0x17171717, 0x58581717,   /* 18, 7 */
0x17171717, 0x17175858, 0x17171717, 0x58581717,   /* 18, 8 */
0x0a171717, 0x17175858, 0x17170a17, 0x58581717,   /* 18, 9 */
0x0a171717, 0x1717583e, 0x17170a17, 0x583e1717,   /* 18,10 */
0x0a0a1717, 0x1717583e, 0x17170a0a, 0x583e1717,   /* 18,11 */
0x0a0a1717, 0x170a583e, 0x17170a0a, 0x583e170a,   /* 18,12 */
0x0a0a170a, 0x170a583e, 0x170a0a0a, 0x583e170a,   /* 18,13 */
0x0a0a170a, 0x0a0a583e, 0x170a0a0a, 0x583e0a0a,   /* 18,14 */
0x0a0a0a0a, 0x0a0a583e, 0x0a0a0a0a, 0x583e0a0a,   /* 18,15 */
0x0a0a0a0a, 0x0a0a3e3e, 0x0a0a0a0a, 0x3e3e0a0a,   /* 18,16 */
0x310a0a0a, 0x0a0a3e3e, 0x0a0a310a, 0x3e3e0a0a,   /* 18,17 */
0x310a0a0a, 0x0a0a3e65, 0x0a0a310a, 0x3e650a0a,   /* 18,18 */
0x31310a0a, 0x0a0a3e65, 0x0a0a3131, 0x3e650a0a,   /* 18,19 */
0x31310a0a, 0x0a313e65, 0x0a0a3131, 0x3e650a31,   /* 18,20 */
0x31310a31, 0x0a313e65, 0x0a313131, 0x3e650a31,   /* 18,21 */
0x31310a31, 0x31313e65, 0x0a313131, 0x3e653131,   /* 18,22 */
0x31313131, 0x31313e65, 0x31313131, 0x3e653131,   /* 18,23 */
0x31313131, 0x31316565, 0x31313131, 0x65653131,   /* 18,24 */
0x8c313131, 0x31316565, 0x31318c31, 0x65653131,   /* 18,25 */
0x8c313131, 0x31316565, 0x31318c31, 0x65653131,   /* 18,26 */
0x8c8c3131, 0x3131658c, 0x31318c8c, 0x658c3131,   /* 18,27 */
0x8c8c3131, 0x318c658c, 0x31318c8c, 0x658c318c,   /* 18,28 */
0x8c8c318c, 0x318c658c, 0x318c8c8c, 0x658c318c,   /* 18,29 */
0x8c8c318c, 0x8c8c658c, 0x318c8c8c, 0x658c8c8c,   /* 18,30 */
0x8c8c8c8c, 0x8c8c658c, 0x8c8c8c8c, 0x658c8c8c,   /* 18,31 */
0x99999999, 0x99999958, 0x99999999, 0x99589999,   /* 19, 0 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 19, 1 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 19, 2 */
0x17179999, 0x99999958, 0x99991717, 0x99589999,   /* 19, 3 */
0x17179958, 0x99179958, 0x99581717, 0x99589917,   /* 19, 4 */
0x17179958, 0x99175858, 0x99581717, 0x58589917,   /* 19, 5 */
0x17179958, 0x17175858, 0x99581717, 0x58581717,   /* 19, 6 */
0x17171758, 0x17175858, 0x17581717, 0x58581717,   /* 19, 7 */
0x17171758, 0x17175858, 0x17581717, 0x58581717,   /* 19, 8 */
0x0a171758, 0x17175858, 0x17580a17, 0x58581717,   /* 19, 9 */
0x0a171758, 0x1717583e, 0x17580a17, 0x583e1717,   /* 19,10 */
0x0a0a1758, 0x1717583e, 0x17580a0a, 0x583e1717,   /* 19,11 */
0x0a0a1758, 0x170a583e, 0x17580a0a, 0x583e170a,   /* 19,12 */
0x0a0a173e, 0x170a583e, 0x173e0a0a, 0x583e170a,   /* 19,13 */
0x0a0a173e, 0x0a0a583e, 0x173e0a0a, 0x583e0a0a,   /* 19,14 */
0x0a0a0a3e, 0x0a0a583e, 0x0a3e0a0a, 0x583e0a0a,   /* 19,15 */
0x0a0a0a3e, 0x0a0a3e3e, 0x0a3e0a0a, 0x3e3e0a0a,   /* 19,16 */
0x310a0a3e, 0x0a0a3e3e, 0x0a3e310a, 0x3e3e0a0a,   /* 19,17 */
0x310a0a3e, 0x0a0a3e65, 0x0a3e310a, 0x3e650a0a,   /* 19,18 */
0x31310a3e, 0x0a0a3e65, 0x0a3e3131, 0x3e650a0a,   /* 19,19 */
0x31310a3e, 0x0a313e65, 0x0a3e3131, 0x3e650a31,   /* 19,20 */
0x31310a65, 0x0a313e65, 0x0a653131, 0x3e650a31,   /* 19,21 */
0x31310a65, 0x31313e65, 0x0a653131, 0x3e653131,   /* 19,22 */
0x31313165, 0x31313e65, 0x31653131, 0x3e653131,   /* 19,23 */
0x31313165, 0x31316565, 0x31653131, 0x65653131,   /* 19,24 */
0x8c313165, 0x31316565, 0x31658c31, 0x65653131,   /* 19,25 */
0x8c313165, 0x31316565, 0x31658c31, 0x65653131,   /* 19,26 */
0x8c8c3165, 0x31316565, 0x31658c8c, 0x65653131,   /* 19,27 */
0x8c8c3165, 0x318c658c, 0x31658c8c, 0x658c318c,   /* 19,28 */
0x8c8c3165, 0x318c658c, 0x31658c8c, 0x658c318c,   /* 19,29 */
0x8c8c318c, 0x8c8c658c, 0x318c8c8c, 0x658c8c8c,   /* 19,30 */
0x8c8c8c8c, 0x8c8c658c, 0x8c8c8c8c, 0x658c8c8c,   /* 19,31 */
0x99999999, 0x99999958, 0x99999999, 0x99589999,   /* 20, 0 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 20, 1 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 20, 2 */
0x17179958, 0x99999958, 0x99581717, 0x99589999,   /* 20, 3 */
0x17179958, 0x99175858, 0x99581717, 0x58589917,   /* 20, 4 */
0x17179958, 0x58175858, 0x99581717, 0x58585817,   /* 20, 5 */
0x17179958, 0x58175858, 0x99581717, 0x58585817,   /* 20, 6 */
0x17171758, 0x58175858, 0x17581717, 0x58585817,   /* 20, 7 */
0x17171758, 0x58175858, 0x17581717, 0x58585817,   /* 20, 8 */
0x0a171758, 0x58175858, 0x17580a17, 0x58585817,   /* 20, 9 */
0x0a171758, 0x5817583e, 0x17580a17, 0x583e5817,   /* 20,10 */
0x0a0a1758, 0x5817583e, 0x17580a0a, 0x583e5817,   /* 20,11 */
0x0a0a1758, 0x580a583e, 0x17580a0a, 0x583e580a,   /* 20,12 */
0x0a0a173e, 0x580a583e, 0x173e0a0a, 0x583e580a,   /* 20,13 */
0x0a0a173e, 0x3e0a583e, 0x173e0a0a, 0x583e3e0a,   /* 20,14 */
0x0a0a0a3e, 0x3e0a583e, 0x0a3e0a0a, 0x583e3e0a,   /* 20,15 */
0x0a0a0a3e, 0x3e0a3e3e, 0x0a3e0a0a, 0x3e3e3e0a,   /* 20,16 */
0x310a0a3e, 0x3e0a3e3e, 0x0a3e310a, 0x3e3e3e0a,   /* 20,17 */
0x310a0a3e, 0x3e0a3e65, 0x0a3e310a, 0x3e653e0a,   /* 20,18 */
0x31310a3e, 0x3e0a3e65, 0x0a3e3131, 0x3e653e0a,   /* 20,19 */
0x31310a3e, 0x3e313e65, 0x0a3e3131, 0x3e653e31,   /* 20,20 */
0x31310a65, 0x3e313e65, 0x0a653131, 0x3e653e31,   /* 20,21 */
0x31310a65, 0x65313e65, 0x0a653131, 0x3e656531,   /* 20,22 */
0x31313165, 0x65313e65, 0x31653131, 0x3e656531,   /* 20,23 */
0x31313165, 0x65316565, 0x31653131, 0x65656531,   /* 20,24 */
0x8c313165, 0x65316565, 0x31658c31, 0x65656531,   /* 20,25 */
0x8c313165, 0x65316565, 0x31658c31, 0x65656531,   /* 20,26 */
0x8c8c3165, 0x65316565, 0x31658c8c, 0x65656531,   /* 20,27 */
0x8c8c3165, 0x658c6565, 0x31658c8c, 0x6565658c,   /* 20,28 */
0x8c8c3165, 0x658c658c, 0x31658c8c, 0x658c658c,   /* 20,29 */
0x8c8c3165, 0x658c658c, 0x31658c8c, 0x658c658c,   /* 20,30 */
0x8c8c8c8c, 0x8c8c658c, 0x8c8c8c8c, 0x658c8c8c,   /* 20,31 */
0x99999999, 0x99999958, 0x99999999, 0x99589999,   /* 21, 0 */
0x17999999, 0x99999958, 0x99991799, 0x99589999,   /* 21, 1 */
0x17589958, 0x99999958, 0x99581758, 0x99589999,   /* 21, 2 */
0x17589958, 0x99995858, 0x99581758, 0x58589999,   /* 21, 3 */
0x17589958, 0x58175858, 0x99581758, 0x58585817,   /* 21, 4 */
0x17589958, 0x58175858, 0x99581758, 0x58585817,   /* 21, 5 */
0x17589958, 0x58175858, 0x99581758, 0x58585817,   /* 21, 6 */
0x17581758, 0x58175858, 0x17581758, 0x58585817,   /* 21, 7 */
0x17581758, 0x58175858, 0x17581758, 0x58585817,   /* 21, 8 */
0x0a581758, 0x58175858, 0x17580a58, 0x58585817,   /* 21, 9 */
0x0a581758, 0x5817583e, 0x17580a58, 0x583e5817,   /* 21,10 */
0x0a3e1758, 0x5817583e, 0x17580a3e, 0x583e5817,   /* 21,11 */
0x0a3e1758, 0x580a583e, 0x17580a3e, 0x583e580a,   /* 21,12 */
0x0a3e173e, 0x580a583e, 0x173e0a3e, 0x583e580a,   /* 21,13 */
0x0a3e173e, 0x3e0a583e, 0x173e0a3e, 0x583e3e0a,   /* 21,14 */
0x0a3e0a3e, 0x3e0a583e, 0x0a3e0a3e, 0x583e3e0a,   /* 21,15 */
0x0a3e0a3e, 0x3e0a3e3e, 0x0a3e0a3e, 0x3e3e3e0a,   /* 21,16 */
0x313e0a3e, 0x3e0a3e3e, 0x0a3e313e, 0x3e3e3e0a,   /* 21,17 */
0x313e0a3e, 0x3e0a3e65, 0x0a3e313e, 0x3e653e0a,   /* 21,18 */
0x31650a3e, 0x3e0a3e65, 0x0a3e3165, 0x3e653e0a,   /* 21,19 */
0x31650a3e, 0x3e313e65, 0x0a3e3165, 0x3e653e31,   /* 21,20 */
0x31650a65, 0x3e313e65, 0x0a653165, 0x3e653e31,   /* 21,21 */
0x31650a65, 0x65313e65, 0x0a653165, 0x3e656531,   /* 21,22 */
0x31653165, 0x65313e65, 0x31653165, 0x3e656531,   /* 21,23 */
0x31653165, 0x65316565, 0x31653165, 0x65656531,   /* 21,24 */
0x8c653165, 0x65316565, 0x31658c65, 0x65656531,   /* 21,25 */
0x8c653165, 0x65316565, 0x31658c65, 0x65656531,   /* 21,26 */
0x8c653165, 0x65316565, 0x31658c65, 0x65656531,   /* 21,27 */
0x8c8c3165, 0x658c6565, 0x31658c8c, 0x6565658c,   /* 21,28 */
0x8c8c3165, 0x658c6565, 0x31658c8c, 0x6565658c,   /* 21,29 */
0x8c8c3165, 0x658c658c, 0x31658c8c, 0x658c658c,   /* 21,30 */
0x8c8c8c65, 0x658c658c, 0x8c658c8c, 0x658c658c,   /* 21,31 */
0x99999999, 0x99999958, 0x99999999, 0x99589999,   /* 22, 0 */
0x17589958, 0x99999958, 0x99581758, 0x99589999,   /* 22, 1 */
0x17589958, 0x99995858, 0x99581758, 0x58589999,   /* 22, 2 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 22, 3 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 22, 4 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 22, 5 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 22, 6 */
0x17581758, 0x58585858, 0x17581758, 0x58585858,   /* 22, 7 */
0x17581758, 0x58585858, 0x17581758, 0x58585858,   /* 22, 8 */
0x0a581758, 0x58585858, 0x17580a58, 0x58585858,   /* 22, 9 */
0x0a581758, 0x5858583e, 0x17580a58, 0x583e5858,   /* 22,10 */
0x0a3e1758, 0x5858583e, 0x17580a3e, 0x583e5858,   /* 22,11 */
0x0a3e1758, 0x583e583e, 0x17580a3e, 0x583e583e,   /* 22,12 */
0x0a3e173e, 0x583e583e, 0x173e0a3e, 0x583e583e,   /* 22,13 */
0x0a3e173e, 0x3e3e583e, 0x173e0a3e, 0x583e3e3e,   /* 22,14 */
0x0a3e0a3e, 0x3e3e583e, 0x0a3e0a3e, 0x583e3e3e,   /* 22,15 */
0x0a3e0a3e, 0x3e3e3e3e, 0x0a3e0a3e, 0x3e3e3e3e,   /* 22,16 */
0x313e0a3e, 0x3e3e3e3e, 0x0a3e313e, 0x3e3e3e3e,   /* 22,17 */
0x313e0a3e, 0x3e3e3e65, 0x0a3e313e, 0x3e653e3e,   /* 22,18 */
0x31650a3e, 0x3e3e3e65, 0x0a3e3165, 0x3e653e3e,   /* 22,19 */
0x31650a3e, 0x3e653e65, 0x0a3e3165, 0x3e653e65,   /* 22,20 */
0x31650a65, 0x3e653e65, 0x0a653165, 0x3e653e65,   /* 22,21 */
0x31650a65, 0x65653e65, 0x0a653165, 0x3e656565,   /* 22,22 */
0x31653165, 0x65653e65, 0x31653165, 0x3e656565,   /* 22,23 */
0x31653165, 0x65656565, 0x31653165, 0x65656565,   /* 22,24 */
0x8c653165, 0x65656565, 0x31658c65, 0x65656565,   /* 22,25 */
0x8c653165, 0x65656565, 0x31658c65, 0x65656565,   /* 22,26 */
0x8c653165, 0x65656565, 0x31658c65, 0x65656565,   /* 22,27 */
0x8c653165, 0x65656565, 0x31658c65, 0x65656565,   /* 22,28 */
0x8c8c3165, 0x658c6565, 0x31658c8c, 0x6565658c,   /* 22,29 */
0x8c8c3165, 0x658c6565, 0x31658c8c, 0x6565658c,   /* 22,30 */
0x8c8c8c65, 0x658c658c, 0x8c658c8c, 0x658c658c,   /* 22,31 */
0x99589958, 0x99999958, 0x99589958, 0x99589999,   /* 23, 0 */
0x17589958, 0x99995858, 0x99581758, 0x58589999,   /* 23, 1 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 23, 2 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 23, 3 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 23, 4 */
0x17589958, 0x58585858, 0x99581758, 0x58585858,   /* 23, 5 */
0x17585858, 0x58585858, 0x58581758, 0x58585858,   /* 23, 6 */
0x17585858, 0x58585858, 0x58581758, 0x58585858,   /* 23, 7 */
0x17585858, 0x58585858, 0x58581758, 0x58585858,   /* 23, 8 */
0x0a585858, 0x58585858, 0x58580a58, 0x58585858,   /* 23, 9 */
0x0a585858, 0x5858583e, 0x58580a58, 0x583e5858,   /* 23,10 */
0x0a3e5858, 0x5858583e, 0x58580a3e, 0x583e5858,   /* 23,11 */
0x0a3e5858, 0x583e583e, 0x58580a3e, 0x583e583e,   /* 23,12 */
0x0a3e583e, 0x583e583e, 0x583e0a3e, 0x583e583e,   /* 23,13 */
0x0a3e583e, 0x3e3e583e, 0x583e0a3e, 0x583e3e3e,   /* 23,14 */
0x0a3e3e3e, 0x3e3e583e, 0x3e3e0a3e, 0x583e3e3e,   /* 23,15 */
0x0a3e3e3e, 0x3e3e3e3e, 0x3e3e0a3e, 0x3e3e3e3e,   /* 23,16 */
0x313e3e3e, 0x3e3e3e3e, 0x3e3e313e, 0x3e3e3e3e,   /* 23,17 */
0x313e3e3e, 0x3e3e3e65, 0x3e3e313e, 0x3e653e3e,   /* 23,18 */
0x31653e3e, 0x3e3e3e65, 0x3e3e3165, 0x3e653e3e,   /* 23,19 */
0x31653e3e, 0x3e653e65, 0x3e3e3165, 0x3e653e65,   /* 23,20 */
0x31653e65, 0x3e653e65, 0x3e653165, 0x3e653e65,   /* 23,21 */
0x31653e65, 0x65653e65, 0x3e653165, 0x3e656565,   /* 23,22 */
0x31656565, 0x65653e65, 0x65653165, 0x3e656565,   /* 23,23 */
0x31656565, 0x65656565, 0x65653165, 0x65656565,   /* 23,24 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 23,25 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 23,26 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 23,27 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 23,28 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 23,29 */
0x8c8c6565, 0x658c6565, 0x65658c8c, 0x6565658c,   /* 23,30 */
0x8c8c6565, 0x658c6565, 0x65658c8c, 0x6565658c,   /* 23,31 */
0x58589958, 0x99995858, 0x99585858, 0x58589999,   /* 24, 0 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 24, 1 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 24, 2 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 24, 3 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 24, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 24, 5 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 24, 6 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 24, 7 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 24, 8 */
0x3e585858, 0x58585858, 0x58583e58, 0x58585858,   /* 24, 9 */
0x3e585858, 0x5858583e, 0x58583e58, 0x583e5858,   /* 24,10 */
0x3e3e5858, 0x5858583e, 0x58583e3e, 0x583e5858,   /* 24,11 */
0x3e3e5858, 0x583e583e, 0x58583e3e, 0x583e583e,   /* 24,12 */
0x3e3e583e, 0x583e583e, 0x583e3e3e, 0x583e583e,   /* 24,13 */
0x3e3e583e, 0x3e3e583e, 0x583e3e3e, 0x583e3e3e,   /* 24,14 */
0x3e3e3e3e, 0x3e3e583e, 0x3e3e3e3e, 0x583e3e3e,   /* 24,15 */
0x3e3e3e3e, 0x3e3e3e3e, 0x3e3e3e3e, 0x3e3e3e3e,   /* 24,16 */
0x653e3e3e, 0x3e3e3e3e, 0x3e3e653e, 0x3e3e3e3e,   /* 24,17 */
0x653e3e3e, 0x3e3e3e65, 0x3e3e653e, 0x3e653e3e,   /* 24,18 */
0x65653e3e, 0x3e3e3e65, 0x3e3e6565, 0x3e653e3e,   /* 24,19 */
0x65653e3e, 0x3e653e65, 0x3e3e6565, 0x3e653e65,   /* 24,20 */
0x65653e65, 0x3e653e65, 0x3e656565, 0x3e653e65,   /* 24,21 */
0x65653e65, 0x65653e65, 0x3e656565, 0x3e656565,   /* 24,22 */
0x65656565, 0x65653e65, 0x65656565, 0x3e656565,   /* 24,23 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 24,24 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 24,25 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 24,26 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 24,27 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 24,28 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 24,29 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 24,30 */
0x8c8c6565, 0x658c6565, 0x65658c8c, 0x6565658c,   /* 24,31 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 25, 0 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 25, 1 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 25, 2 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 25, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 25, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 25, 5 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 25, 6 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 25, 7 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 25, 8 */
0x3e585858, 0x58585858, 0x58583e58, 0x58585858,   /* 25, 9 */
0x3e585858, 0x5858583e, 0x58583e58, 0x583e5858,   /* 25,10 */
0x3e3e5858, 0x5858583e, 0x58583e3e, 0x583e5858,   /* 25,11 */
0x3e3e5858, 0x583e583e, 0x58583e3e, 0x583e583e,   /* 25,12 */
0x3e3e583e, 0x583e583e, 0x583e3e3e, 0x583e583e,   /* 25,13 */
0x3e3e583e, 0x3e3e583e, 0x583e3e3e, 0x583e3e3e,   /* 25,14 */
0x3e3e3e3e, 0x3e3e583e, 0x3e3e3e3e, 0x583e3e3e,   /* 25,15 */
0x3e3e3e3e, 0x3e3ea63e, 0x3e3e3e3e, 0xa63e3e3e,   /* 25,16 */
0x653e3e3e, 0x3e3ea63e, 0x3e3e653e, 0xa63e3e3e,   /* 25,17 */
0x653e3e3e, 0x3e3ea665, 0x3e3e653e, 0xa6653e3e,   /* 25,18 */
0x65653e3e, 0x3e3ea665, 0x3e3e6565, 0xa6653e3e,   /* 25,19 */
0x65653e3e, 0x3e65a665, 0x3e3e6565, 0xa6653e65,   /* 25,20 */
0x65653e65, 0x3e65a665, 0x3e656565, 0xa6653e65,   /* 25,21 */
0x65653e65, 0x6565a665, 0x3e656565, 0xa6656565,   /* 25,22 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 25,23 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 25,24 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 25,25 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 25,26 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 25,27 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 25,28 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 25,29 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 25,30 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 25,31 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 26, 0 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 26, 1 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 26, 2 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 26, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 26, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 26, 5 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 26, 6 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 26, 7 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 26, 8 */
0x3e585858, 0x58585858, 0x58583e58, 0x58585858,   /* 26, 9 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 26,10 */
0x3e3e5858, 0x585858a6, 0x58583e3e, 0x58a65858,   /* 26,11 */
0x3e3e5858, 0x583e58a6, 0x58583e3e, 0x58a6583e,   /* 26,12 */
0x3e3e583e, 0x583e58a6, 0x583e3e3e, 0x58a6583e,   /* 26,13 */
0x3e3e583e, 0x3e3e58a6, 0x583e3e3e, 0x58a63e3e,   /* 26,14 */
0x3e3e3e3e, 0x3e3ea6a6, 0x3e3e3e3e, 0xa6a63e3e,   /* 26,15 */
0x3e3e3e3e, 0x3e3ea6a6, 0x3e3e3e3e, 0xa6a63e3e,   /* 26,16 */
0x653e3e3e, 0x3e3ea6a6, 0x3e3e653e, 0xa6a63e3e,   /* 26,17 */
0x653e3e3e, 0x3e3ea665, 0x3e3e653e, 0xa6653e3e,   /* 26,18 */
0x65653e3e, 0x3e3ea665, 0x3e3e6565, 0xa6653e3e,   /* 26,19 */
0x65653e3e, 0x3e65a665, 0x3e3e6565, 0xa6653e65,   /* 26,20 */
0x65653e65, 0x3e65a665, 0x3e656565, 0xa6653e65,   /* 26,21 */
0x65653e65, 0x6565a665, 0x3e656565, 0xa6656565,   /* 26,22 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 26,23 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 26,24 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 26,25 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 26,26 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 26,27 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 26,28 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 26,29 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 26,30 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 26,31 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 27, 0 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 27, 1 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 2 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 5 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 6 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 7 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 27, 8 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 27, 9 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 27,10 */
0x3e3e5858, 0x585858a6, 0x58583e3e, 0x58a65858,   /* 27,11 */
0x3e3e5858, 0x583e58a6, 0x58583e3e, 0x58a6583e,   /* 27,12 */
0x3e3e58a6, 0x583e58a6, 0x58a63e3e, 0x58a6583e,   /* 27,13 */
0x3e3e58a6, 0x3e3ea6a6, 0x58a63e3e, 0xa6a63e3e,   /* 27,14 */
0x3e3e3ea6, 0x3e3ea6a6, 0x3ea63e3e, 0xa6a63e3e,   /* 27,15 */
0x3e3e3ea6, 0x3e3ea6a6, 0x3ea63e3e, 0xa6a63e3e,   /* 27,16 */
0x653e3ea6, 0x3e3ea6a6, 0x3ea6653e, 0xa6a63e3e,   /* 27,17 */
0x653e3ea6, 0x3e3ea6a6, 0x3ea6653e, 0xa6a63e3e,   /* 27,18 */
0x65653ea6, 0x3e3ea665, 0x3ea66565, 0xa6653e3e,   /* 27,19 */
0x65653ea6, 0x3e65a665, 0x3ea66565, 0xa6653e65,   /* 27,20 */
0x65653e65, 0x3e65a665, 0x3e656565, 0xa6653e65,   /* 27,21 */
0x65653e65, 0x6565a665, 0x3e656565, 0xa6656565,   /* 27,22 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 27,23 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 27,24 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 27,25 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 27,26 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 27,27 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 27,28 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 27,29 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 27,30 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 27,31 */
0x58589958, 0x58585858, 0x99585858, 0x58585858,   /* 28, 0 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 1 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 2 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 5 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 6 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 28, 7 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 28, 8 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 28, 9 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 28,10 */
0x3e3e5858, 0x585858a6, 0x58583e3e, 0x58a65858,   /* 28,11 */
0x3e3e58a6, 0x583e58a6, 0x58a63e3e, 0x58a6583e,   /* 28,12 */
0x3e3e58a6, 0x583ea6a6, 0x58a63e3e, 0xa6a6583e,   /* 28,13 */
0x3e3e58a6, 0xa63ea6a6, 0x58a63e3e, 0xa6a6a63e,   /* 28,14 */
0x3e3e3ea6, 0xa63ea6a6, 0x3ea63e3e, 0xa6a6a63e,   /* 28,15 */
0x3e3e3ea6, 0xa63ea6a6, 0x3ea63e3e, 0xa6a6a63e,   /* 28,16 */
0x653e3ea6, 0xa63ea6a6, 0x3ea6653e, 0xa6a6a63e,   /* 28,17 */
0x653e3ea6, 0xa63ea6a6, 0x3ea6653e, 0xa6a6a63e,   /* 28,18 */
0x65653ea6, 0xa63ea6a6, 0x3ea66565, 0xa6a6a63e,   /* 28,19 */
0x65653ea6, 0xa665a665, 0x3ea66565, 0xa665a665,   /* 28,20 */
0x65653ea6, 0xa665a665, 0x3ea66565, 0xa665a665,   /* 28,21 */
0x65653e65, 0x6565a665, 0x3e656565, 0xa6656565,   /* 28,22 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 28,23 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 28,24 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 28,25 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 28,26 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 28,27 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 28,28 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 28,29 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 28,30 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 28,31 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 0 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 1 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 2 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 5 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 29, 6 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 29, 7 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 29, 8 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 29, 9 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 29,10 */
0x3ea658a6, 0x585858a6, 0x58a63ea6, 0x58a65858,   /* 29,11 */
0x3ea658a6, 0x583ea6a6, 0x58a63ea6, 0xa6a6583e,   /* 29,12 */
0x3ea658a6, 0xa63ea6a6, 0x58a63ea6, 0xa6a6a63e,   /* 29,13 */
0x3ea658a6, 0xa63ea6a6, 0x58a63ea6, 0xa6a6a63e,   /* 29,14 */
0x3ea63ea6, 0xa63ea6a6, 0x3ea63ea6, 0xa6a6a63e,   /* 29,15 */
0x3ea63ea6, 0xa63ea6a6, 0x3ea63ea6, 0xa6a6a63e,   /* 29,16 */
0x65a63ea6, 0xa63ea6a6, 0x3ea665a6, 0xa6a6a63e,   /* 29,17 */
0x65a63ea6, 0xa63ea6a6, 0x3ea665a6, 0xa6a6a63e,   /* 29,18 */
0x65653ea6, 0xa63ea6a6, 0x3ea66565, 0xa6a6a63e,   /* 29,19 */
0x65653ea6, 0xa665a6a6, 0x3ea66565, 0xa6a6a665,   /* 29,20 */
0x65653ea6, 0xa665a665, 0x3ea66565, 0xa665a665,   /* 29,21 */
0x65653ea6, 0xa665a665, 0x3ea66565, 0xa665a665,   /* 29,22 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 29,23 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 29,24 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 29,25 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 29,26 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 29,27 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 29,28 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 29,29 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 29,30 */
0x8c656565, 0x65656565, 0x65658c65, 0x65656565,   /* 29,31 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 30, 0 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 30, 1 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 30, 2 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 30, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 30, 4 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 30, 5 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 30, 6 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 30, 7 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 30, 8 */
0x3e585858, 0x585858a6, 0x58583e58, 0x58a65858,   /* 30, 9 */
0x3ea658a6, 0x585858a6, 0x58a63ea6, 0x58a65858,   /* 30,10 */
0x3ea658a6, 0x5858a6a6, 0x58a63ea6, 0xa6a65858,   /* 30,11 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 30,12 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 30,13 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 30,14 */
0x3ea63ea6, 0xa6a6a6a6, 0x3ea63ea6, 0xa6a6a6a6,   /* 30,15 */
0x3ea63ea6, 0xa6a6a6a6, 0x3ea63ea6, 0xa6a6a6a6,   /* 30,16 */
0x65a63ea6, 0xa6a6a6a6, 0x3ea665a6, 0xa6a6a6a6,   /* 30,17 */
0x65a63ea6, 0xa6a6a6a6, 0x3ea665a6, 0xa6a6a6a6,   /* 30,18 */
0x65a63ea6, 0xa6a6a6a6, 0x3ea665a6, 0xa6a6a6a6,   /* 30,19 */
0x65653ea6, 0xa665a6a6, 0x3ea66565, 0xa6a6a665,   /* 30,20 */
0x65653ea6, 0xa665a6a6, 0x3ea66565, 0xa6a6a665,   /* 30,21 */
0x65653ea6, 0xa665a665, 0x3ea66565, 0xa665a665,   /* 30,22 */
0x656565a6, 0xa665a665, 0x65a66565, 0xa665a665,   /* 30,23 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 30,24 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 30,25 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 30,26 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 30,27 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 30,28 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 30,29 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 30,30 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 30,31 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 31, 0 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 31, 1 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 31, 2 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 31, 3 */
0x58585858, 0x58585858, 0x58585858, 0x58585858,   /* 31, 4 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 31, 5 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 31, 6 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 31, 7 */
0x58585858, 0x585858a6, 0x58585858, 0x58a65858,   /* 31, 8 */
0x3ea658a6, 0x585858a6, 0x58a63ea6, 0x58a65858,   /* 31, 9 */
0x3ea658a6, 0x5858a6a6, 0x58a63ea6, 0xa6a65858,   /* 31,10 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 31,11 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 31,12 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 31,13 */
0x3ea658a6, 0xa6a6a6a6, 0x58a63ea6, 0xa6a6a6a6,   /* 31,14 */
0x3ea6a6a6, 0xa6a6a6a6, 0xa6a63ea6, 0xa6a6a6a6,   /* 31,15 */
0x3ea6a6a6, 0xa6a6a6a6, 0xa6a63ea6, 0xa6a6a6a6,   /* 31,16 */
0x65a6a6a6, 0xa6a6a6a6, 0xa6a665a6, 0xa6a6a6a6,   /* 31,17 */
0x65a6a6a6, 0xa6a6a6a6, 0xa6a665a6, 0xa6a6a6a6,   /* 31,18 */
0x65a6a6a6, 0xa6a6a6a6, 0xa6a665a6, 0xa6a6a6a6,   /* 31,19 */
0x65a6a6a6, 0xa6a6a6a6, 0xa6a665a6, 0xa6a6a6a6,   /* 31,20 */
0x6565a6a6, 0xa665a6a6, 0xa6a66565, 0xa6a6a665,   /* 31,21 */
0x6565a6a6, 0xa665a6a6, 0xa6a66565, 0xa6a6a665,   /* 31,22 */
0x656565a6, 0xa665a665, 0x65a66565, 0xa665a665,   /* 31,23 */
0x656565a6, 0xa665a665, 0x65a66565, 0xa665a665,   /* 31,24 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 31,25 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 31,26 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 31,27 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 31,28 */
0x65656565, 0x6565a665, 0x65656565, 0xa6656565,   /* 31,29 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 31,30 */
0x65656565, 0x65656565, 0x65656565, 0x65656565,   /* 31,31 */
}; /* DitherTable */

