/************************************************************************
*                                                                       *
*               INTEL CORPORATION PROPRIETARY INFORMATION               *
*                                                                       *
*    This listing is supplied under the terms of a license agreement    *
*      with INTEL Corporation and may not be copied nor disclosed       *
*        except in accordance with the terms of that agreement.         *
*                                                                       *
*************************************************************************
*                                                                       *
*               Copyright (C) 1994-1997 Intel Corp.                       *
*                         All Rights Reserved.                          *
*                                                                       *
************************************************************************/

#ifdef __RVMPTBL_H__
#pragma message("***** RVMPTBL.H Included Multiple Times")
#else /* __RVMPTBL_H__ */
#define __RVMPTBL_H__

#ifndef __DATATYPE_H__
#pragma message("rvmptbl.h requires datatype.h")
#endif /* __DATATYPE_H__ */

#define MAX_SYMBOLS 256
#define MAX_NABSVAL_LEN 66 /* 64 + 2 (Max for 8x8 block) */

typedef struct StaticRVTable_ {
	I32	iNAbsVal;
	U8	u8NAbsVal[MAX_NABSVAL_LEN];
	I32	iNFreqOrder;
	U8	u8FreqOrder[MAX_SYMBOLS];
}	StaticRVTable, *pStaticRVTable;

static StaticRVTable RVTblList[9] = {
/* MapTbl0 */ {
/* Number of NAbsVal entries */
	42,
/* NAbsVal table */
	{
	   1,
	  40,  14,   8,   6,   5,   5,   5,   6,   2,   2,
	   2,   1,   1,   1,   2,   2,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	  42,  41,   1,  43,  40,   0,  44,  39,  96,  95,
	  45,  38,  46,  37, 118, 117,  47,  36,  97,  94,
	  48,  35, 132, 131,  49,  34,  50,  33,  98,  93,
	 143, 142,  51,  32, 119, 116,  52,  31, 153, 152,
	  53,  99,  30,  92, 163, 162,  54,  29, 174, 173,
	  55,  28, 133, 100,  56, 130,  91,  27, 115, 120,
	  57,  26,  58, 182, 181,  25, 101,  59,  90,  24,
	 144, 141,  60,  23, 186, 185,  61,  22, 121, 114,
	 102,  89,  62,  21, 190, 189, 154, 134, 129,  63,
	 151,  20, 103,  64,  88, 193, 175,  19, 192, 164,
	 172, 161,  65, 204,  18, 203,  66, 122, 113, 195,
	  17, 194, 104,  87,  67, 200,  16, 145, 197, 199,
	  68, 140, 196,  15, 207, 176, 206, 171,  69, 128,
	 135, 105,  86,  14, 223, 222, 221, 220,  70, 123,
	  13, 112,  71, 170, 155, 165, 150,  12, 209, 177,
	 208,  72, 160, 219, 106,  85, 218,  11,  73, 214,
	 216, 183, 180, 217, 211,  10, 215, 146, 210, 139,
	  74, 238, 213, 239, 212, 178, 136, 127,   9, 236,
	  84, 107, 169, 111, 237, 225, 124,  75, 166, 159,
	 224, 156,   8, 149,  76,  77, 202,   7, 184,   6,
	 187, 108, 205, 230, 229,  83, 231, 228,  78, 227,
	 138, 179, 147, 226,  79, 168, 110, 167, 125, 234,
	 255, 235,   5, 254, 157,  80, 148, 158, 137, 126,
	   4,   3,  82,  81, 109, 191, 241, 233, 188,   2,
	 232, 198, 201, 240, 244, 252, 245, 253, 243, 242,
	 247, 246, 251, 250, 249, 248,
	},
},

/* MapTbl1 */ {
/* Number of NAbsVal entries */
	65,
/* NAbsVal table */
	{
	   1,
	  10,   5,   4,   4,   4,   3,   4,   5,   3,   3,
	   2,   2,   3,   2,   2,   3,   2,   2,   2,   2,
	   2,   2,   2,   2,   2,   2,   2,   2,   2,   1,
	   1,   2,   2,   1,   1,   2,   2,   1,   1,   1,
	   2,   1,   1,   1,   1,   1,   1,   1,   2,   1,
	   1,   1,   1,   1,   1,   1,   2,   1,   1,   1,
	   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	   0,  12,  11,  27,  26,  36,  35,  44,  43,  52,
	  51,  59,  75,  58,  74,  66,  65,  83,  82,  89,
	  88,  94,  93,  13,  98,  10,  97, 103, 102, 117,
	 108, 116, 107, 112, 111, 122, 121, 126,   1, 125,
	 130, 134, 138, 129, 142, 137, 133, 141, 154, 150,
	  28, 153, 149, 146, 145,  25, 158, 166, 157, 165,
	 170, 162, 169, 161, 182, 181,  14, 178,   9,  37,
	 177, 173, 190,  34, 189, 172, 174, 175, 187, 185,
	 194, 204, 184, 186, 193,  45, 203,  42, 222,  76,
	  73, 221, 201, 197,  53, 196, 200, 199,  50, 198,
	 207, 209, 206,  67, 240,  60, 208, 211,  57, 224,
	  64, 210, 239, 219, 225, 218, 213, 212, 215, 217,
	 227, 214, 216, 243,  15, 226, 242,   8, 229, 245,
	 231,  84, 228, 234, 235, 244, 230, 237, 232, 236,
	 233,  81, 255, 254, 247, 253, 246, 252, 249, 251,
	 248, 250,  29,  90,  24,  87,  95,  16,  92, 104,
	  99,   7,  96, 101, 115, 118,  72,  77, 109,  38,
	  33, 113, 106, 110,  46,  41,  17, 123, 120,  54,
	   6,  68,  63,  49,  61,  18,  23,  30,  56, 143,
	   5, 155, 139, 140,  71, 151,  19, 136, 152, 148,
	  78, 127, 124, 147,  85, 135, 144, 180, 171, 183,
	 132,   4, 128,  20, 168, 191,  80, 188, 131, 202,
	 167, 241, 179,  39, 164,  32,  21, 163, 223, 220,
	   3, 176, 159, 156,  31,  47,  40,  69, 238, 205,
	  22,  62,  86,  55, 195, 114,  91, 160,  70,  79,
	 105, 119, 192, 100,   2,  48,
	},
},

/* MapTbl2 */ {
/* Number of NAbsVal entries */
	65,
/* NAbsVal table */
	{
	   1,
	  16,   8,   7,   6,   6,   5,   5,   6,   3,   3,
	   3,   2,   2,   2,   2,   2,   2,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	  18,  17,   0,  42,  41,  19,  16,  57,  56,  70,
	  69,   1,  20,  15,  82,  81,  43,  40,  93,  92,
	 103, 102,  21, 114,  14, 113,  58,  55, 123, 122,
	  22,  44,  39,  13,  71, 129,  68, 128, 135, 134,
	  23,  83, 140, 139,  12,  80, 144, 143,  59,  54,
	  94,  91,  45,  38, 148, 147, 156, 155, 152, 104,
	 151, 115, 112, 101,  24,  11, 160, 159,  72,  67,
	  25,  10, 163, 162,  46,  37,  84,  79, 177,  60,
	 124,  53, 176, 121, 165, 175, 164, 174,  26, 169,
	 167,   9, 168, 171, 166, 170, 173, 172, 116,  90,
	 193,  95, 111, 192, 105, 100, 179, 178,  27, 191,
	   8, 190, 183,  73, 182, 130, 185, 180, 181, 127,
	 209,  66, 184,  47,  36, 208, 199, 189, 225, 188,
	 195, 187, 194, 198, 186, 197,  28, 224, 133,  85,
	 196, 136,   7,  61,  52,  78, 200, 201, 117, 207,
	 110, 206, 138, 141, 211, 210,  29, 203, 154, 241,
	   6,  96, 157, 205, 202,  89, 106,  99, 145, 142,
	 204, 213,  48, 212, 240,  35, 226, 120, 215, 125,
	 227,  74, 153, 223, 214,  65,  30, 150, 222, 149,
	 146,   5, 217, 216, 118,  62,  86, 109, 229, 221,
	  51, 219, 218, 220,  77, 228,  31, 161, 158, 243,
	   4, 242,  49, 231, 230,  34, 233, 107, 245,  97,
	  88, 239, 232, 237,  98, 236,  32, 235, 244, 238,
	 234, 131,   3, 126,  75, 247,  33, 246, 119,  64,
	 108, 255, 254, 249,   2, 253,  63, 252, 251, 248,
	  76, 132,  87,  50, 137, 250,
	},
},

/* MapTbl3 */ {
/* Number of NAbsVal entries */
	65,
/* NAbsVal table */
	{
	   1,
	  13,   7,   5,   5,   5,   4,   4,   5,   3,   3,
	   3,   3,   3,   2,   2,   3,   2,   2,   2,   2,
	   2,   2,   2,   2,   2,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	   0,  15,  14,  35,  34,  47,  46,  57,  56,  16,
	  13,  67,  66,  76,  75,  84,  83,  93,  92, 101,
	 100,  36,  33, 107, 106,  17,  12, 113, 112, 119,
	 118,  48,  45, 125, 124,   1, 130, 129, 139, 134,
	 138, 133,  58,  55, 144,  18, 143,  11,  68,  65,
	 148, 147,  32,  37,  77,  74,  94, 152,  85,  91,
	  82, 151, 156, 155, 160, 159, 164, 172, 163, 171,
	 168, 167,  19,  10, 176, 175,  49,  44, 179, 178,
	 102,  99, 181, 180, 183, 182, 193, 185,  59, 192,
	 184,  20,  54,   9, 190, 191,  38,  31, 189, 108,
	 187, 105, 186, 188, 195, 194,  69,  64, 199, 198,
	 197, 209, 196, 114, 208, 111, 201,  21,  90,  95,
	 200,  78,   8,  73, 207,  81,  86, 206, 120, 203,
	 117, 205, 204, 202, 225, 126, 224, 123,  43, 210,
	  50, 211, 140, 137, 213, 212, 128, 131,  22,   7,
	 214, 135, 215, 132,  30,  39, 241, 222, 226, 223,
	 240, 227,  60, 216, 217,  53, 218, 220, 221, 219,
	  23, 229,   6, 145, 142, 228,  89, 103,  98,  63,
	 242,  96, 243,  70, 231, 230, 237, 238, 233, 239,
	 236, 245, 244, 232, 234,  24,  79, 235,  87,  80,
	  72,   5,  40,  51,  29,  42, 255, 246, 247, 109,
	 104, 254, 249, 250, 248, 252,  25, 253, 251,   4,
	 146, 170, 149,  61, 174,  52,  88, 161, 158,  26,
	 173, 162, 177, 165,  97, 110, 150, 115, 166,   3,
	 154, 169, 153, 157,  62, 121,  71,  27, 136,  41,
	 116, 122,  28, 127,   2, 141,
	},
},

/* MapTbl4 */ {
/* Number of NAbsVal entries */
	16,
/* NAbsVal table */
	{
	   1,
	  89,  11,   6,   4,   3,   3,   2,   2,   1,   1,
	   1,   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	   0,  91,  90,  92, 191, 190,  89, 208, 207,  93,
	  88,  94, 218, 217,  87, 225, 192,  95, 224, 189,
	  86,  96, 231, 230,  85,  97,  84,  98,  83, 236,
	 209,  99, 193, 206,   1,  82, 188, 235, 100,  81,
	 101, 240,  80, 102, 239,  79, 103,  78, 243, 104,
	 242,  77, 194, 105,  76, 187, 106,  75, 245, 219,
	 107, 244,  74, 216, 108,  73, 109,  72, 110, 210,
	  71, 111,  70, 205, 195, 112, 226,  69,  68, 113,
	 186, 223, 114, 247,  67, 246, 115,  66, 116,  65,
	  64, 117, 118, 119,  63,  62, 196, 120, 232,  60,
	 229,  61, 121, 185,  59, 122, 123,  58, 124,  56,
	  57, 249, 211,  55, 248, 125, 127, 126, 197,  54,
	 128, 204,  53, 129, 131, 130,  51,  52, 220, 132,
	  48,  50, 184,  49, 133, 215, 134,  47, 135,  46,
	 136, 137, 198,  44,  43,  45, 140,  41, 138, 139,
	 141,  42, 142,  39, 212,  40, 183,  38, 143, 227,
	  35, 146, 145, 144,  37, 237, 150, 234,  36, 148,
	 199, 203, 149, 147,  34,  28, 222,  33,  31,  30,
	 151,  32,  29, 182, 251, 154, 152, 159,  27, 153,
	 155,  24,  23, 156,  26, 158,  25,  22, 157,  21,
	 250, 200, 161,  20, 221, 163, 162, 160, 213,  15,
	 228, 164,  13,  17, 253, 168, 170,  19,  16, 166,
	 252, 233,  18, 169, 165, 167, 255, 201, 214,  12,
	 181, 202, 254,  14,   8,  11, 241, 171,   7, 238,
	 173,  10, 172,   9, 174,   4,   5, 175, 180,   6,
	 176,   2, 177,   3, 178, 179,
	},
},

/* MapTbl5 */ {
/* Number of NAbsVal entries */
	42,
/* NAbsVal table */
	{
	   1,
	  34,  13,   9,   7,   6,   5,   5,   4,   3,   3,
	   3,   2,   2,   2,   2,   2,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	  36,  35,   0,  83,  37,  82,  34, 105, 104,  38,
	  33, 121, 120,  84,  81,  39,  32, 134, 133, 145,
	  40, 144,  31, 155, 154, 106, 103,  85, 164,  80,
	 163,  41,  30,   1, 171, 170,  42,  29, 177, 122,
	 176, 119, 183, 182,  86,  43,  79,  28, 188, 187,
	 107, 102,  44,  27, 192, 135, 132, 191, 196,  45,
	  26, 195,  87,  78, 146, 143, 200,  46,  25, 199,
	 204, 123, 156, 203, 118, 153,  47,  24, 108, 101,
	 165, 162,  77,  88,  48,  23, 207, 206,  49,  22,
	 209, 208, 136, 131,  89,  76,  50,  21, 172, 211,
	 169, 210, 213, 109, 100, 212,  20, 178, 215,  51,
	 175, 124, 117, 214, 217, 147, 142, 216,  52,  19,
	 219, 221,  75,  90, 218, 220, 184,  53,  18, 181,
	 157, 223, 152,  54,  17, 222, 166, 161, 110, 225,
	  99,  55, 189,  91,  74, 224,  16, 186, 137, 130,
	 227, 116,  56, 125,  15, 226, 229,  14, 228, 193,
	  57, 190,  92, 231,  73,  58, 237, 148,  13, 233,
	 197, 230, 194, 141,  98, 235, 111,  12, 232,  59,
	 236, 234, 239, 173, 238,  11,  60, 158, 168, 151,
	  93,  72,  61,  10, 126, 245, 241, 115, 129, 174,
	 179, 138, 240,   9,  62, 243, 167, 160, 244,  97,
	 242,  63, 201, 112,  71,   8, 202, 198, 205,  94,
	 246,  64, 247,   7,  65,   6, 149, 140, 249,   5,
	 248, 185,  66, 250, 251, 253, 180,  70, 255, 114,
	 252,   4,  95, 127,  67,  68,   3, 254,  96,   2,
	 113,  69, 128, 159, 139, 150,
	},
},

/* MapTbl6 */ {
/* Number of NAbsVal entries */
	26,
/* NAbsVal table */
	{
	   1,
	  60,  14,   8,   6,   4,   4,   3,   3,   3,   3,
	   2,   2,   2,   2,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	  42,  61,   0,  63,  60, 136, 135,  64,  59, 158,
	 157,  65,  58,   1, 137, 134, 172,  66, 171,  57,
	  67,  56, 182, 181,  68,  55, 190, 189, 138, 133,
	  69,  54, 159, 156, 197, 196,  70,  53, 203, 202,
	  71,  52, 139, 132,  72, 209,  51, 208, 173, 170,
	 215,  73,  50, 214,  74,  49, 220, 219, 160, 155,
	  75, 140,  48, 131,  47,  76, 223, 224, 183, 180,
	  77,  46, 228,  78,  45, 227, 141, 130,  79,  44,
	 191, 188,  43,  80, 169, 232, 174, 231, 161,  81,
	 154,  62,  41,  82, 235, 198, 234, 129, 142, 195,
	  83,  40,  84, 204,  39, 201, 237, 236,  38,  85,
	  37,  86, 128,  36,  87, 143,  35,  88, 162, 184,
	 179, 153, 168,  89,  34, 175,  90,  33, 239, 238,
	 207,  32,  91, 210, 144, 127,  31,  92, 216, 213,
	  30, 192,  93,  29, 187, 241,  94,  28, 240,  95,
	  27,  96, 126, 145, 152,  97, 163,  26,  98,  25,
	 167,  99, 243,  24, 242, 199, 100,  23, 244, 101,
	 176, 245,  22, 194, 221, 125,  21, 218, 247, 146,
	 200, 178, 102, 205, 103, 185, 246,  19,  20, 104,
	 249,  18, 106, 248, 105,  17, 151, 164,  16, 251,
	 124, 225, 253,  15, 107, 147, 108, 109, 222, 250,
	  14, 110, 252,  12,  13, 111, 166,  11, 112, 113,
	 123, 114, 186, 193, 177, 148,   9,  10,   8, 116,
	 115,   7,   6, 230, 229, 150, 117, 255, 206, 254,
	 233, 119, 211, 165, 226, 118,   4,   2,   3,   5,
	 212, 121, 120, 122, 217, 149,
	},
},

/* MapTbl7 */ {
/* Number of NAbsVal entries */
	50,
/* NAbsVal table */
	{
	   1,
	  23,  11,   8,   7,   6,   5,   5,   5,   4,   3,
	   3,   3,   3,   2,   2,   2,   2,   2,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	  25,  24,   0,  59,  58,  26,  23,  78,  77,  93,
	  92, 106, 105,  27,  22, 117, 116,  57,  60, 127,
	 126, 137, 136,  28,  21,  76,  79, 146, 145, 153,
	 152,  29,  20,  56,  61,  94,  91, 159,   1, 158,
	 165, 164, 171, 170,  30,  19, 107, 104, 176, 175,
	 180, 184, 179, 183,  75,  80,  31, 118,  18, 115,
	  55,  62, 128, 125, 138, 135, 188, 187,  32,  17,
	  95,  90, 192, 191,  54,  63,  33, 195,  16, 197,
	 194, 196, 199, 198,  74,  81, 201, 200, 108, 103,
	 205,  15,  34, 203, 147, 202, 204, 144,  64,  53,
	 154,  35,  14, 151, 119, 114, 207,  89,  96, 206,
	 129, 124, 209, 139,  36, 134,  73,  13, 208,  82,
	 160, 157, 211, 210,  52, 213,  37,  65, 212,  12,
	 166, 163, 109, 102, 215, 172, 169, 214, 221,  38,
	  11, 223, 219, 217, 220,  88, 216, 222,  97, 218,
	  72, 177,  10,  39,  83, 225, 224,  51,  66, 174,
	 113, 120, 227, 229, 226, 228,  40, 181,   9, 182,
	 185, 178, 130, 148, 123, 143, 230, 133, 140, 231,
	   8,  41, 234,  50, 233, 235,  67, 237, 101, 232,
	 236, 110,  71,  84,  98,  87, 155, 150,  42,   7,
	  43,   6, 239,  49, 238,  68, 112, 121,  44,   5,
	 156, 241, 161, 243,  85, 240,  70, 189,  99, 242,
	   4, 186, 131,  45, 141, 244,  86, 122, 245, 100,
	 132,  48, 111,  46,  69, 253, 247,   3, 162, 246,
	 167, 252, 173, 168,   2, 149, 142, 249,  47, 248,
	 251, 250, 255, 190, 193, 254,
	},
},

/* MapTbl8 */ {
/* Number of NAbsVal entries */
	51,
/* NAbsVal table */
	{
	   1,
	  26,  12,   9,   7,   6,   5,   5,   5,   3,   3,
	   2,   2,   2,   2,   2,   2,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
	   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,
	},
	256,
/* RV frequency ordering table */
	{
	  28,  27,  29,  26,   0,  66,  65,  30,  25,  87,
	  86,   1,  31,  24,  67,  64, 103, 102,  32,  23,
	 116, 115,  33,  22,  68,  63,  88,  85, 127, 126,
	  34,  21, 137, 136, 147,  35, 146,  69,  62,  20,
	 104, 101,  36,  89,  19,  84, 155, 154,  70,  61,
	  37, 117,  18, 114, 161, 160,  38,  17, 166, 165,
	  83, 128,  90, 105, 100, 125,  71,  60,  39, 170,
	  16, 169, 138, 174, 135, 173,  40,  15, 148, 145,
	  72,  59, 178, 177, 186, 182, 185, 118, 113,  41,
	  91, 181,  14,  82, 106,  99,  42,  13, 189, 188,
	  73,  58, 124, 129,  43, 191,  12, 190, 199, 197,
	 198, 196, 205, 203, 204, 193, 156, 195, 153, 201,
	 192, 202, 194,  92, 200, 139,  81,  44,  11, 134,
	 211, 207, 213, 119, 210, 206, 112, 149, 212, 107,
	 144, 208,  57,  74,  98, 209,  45,  10, 162, 227,
	 159, 221, 220, 226, 215,  46, 218, 219,   9, 214,
	 130, 217, 216, 225,  93, 123, 164, 167,  80,  75,
	 224,  56, 223,  47, 222,   8, 229, 228, 171, 140,
	 168, 120, 237, 111, 108, 133,  48, 150, 175,  97,
	   7, 236, 172, 231, 143, 230, 152,  49, 234, 235,
	 157,   6, 232,  76,  55, 253, 233, 239,  94,  79,
	 179, 187, 252, 176, 184, 238, 241, 240, 122, 131,
	 183,  50,   5, 180, 243, 242,  51,   4, 254, 250,
	 109, 121,  96, 141, 110,  77, 158, 163, 251, 132,
	 255, 245,  54,  52, 244, 142, 151,   3, 246, 247,
	  95, 249, 248,  78,  53,   2,
	},
},
}; /* RVTblList[9] */

#endif /* __RVMPTBL_H__ */
