/*--------------------------------------------------------------------*\
  File:      flag_data.cpp
  Creator:   Matt Bogosian <mbogosian@usa.net>
  Copyright: (c)1997, 1998, Matt Bogosian. All rights reserved.
  Description: Source file containing the definitions for the flag
      bitmaps.
  Conventions: Job security is job #1.
\*--------------------------------------------------------------------*/


/*--------------------------------------------------------------------*\
  =-=-=-=-=-=-=-=-=-=-=-=-=- Included Files -=-=-=-=-=-=-=-=-=-=-=-=-=
\*--------------------------------------------------------------------*/

#include "flag_data.h"

#include <GraphicsDefs.h>


/*--------------------------------------------------------------------*\
  =-=-=-=-=-=-=-= Definitions, Enums, Typedefs, Consts =-=-=-=-=-=-=-=
\*--------------------------------------------------------------------*/

const float k_flag_width = 21.0;
const float k_flag_height = 15.0;

const uint8 k_flag[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_belgium[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_china[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0xD9, 0x2D, 0x2D, 0x2D, 0xA4, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0xD9, 0xFA, 0xD9, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0xFA, 0xA4, 0xFA, 0x2D, 0x2D, 0xA4, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_czech_republic[] =
{
	0x18, 0x16, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x17, 0xD3, 0xAD, 0x1E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0xD3, 0x17, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0xD3, 0xAD, 0x1E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0xD3, 0x16, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0xD3, 0xAD, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x87, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x24, 0xF0, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x24, 0xF5, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x24, 0xF0, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x24, 0xF5, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x17, 0xF4, 0xEA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_france[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_germany[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0xA5, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_hong_kong[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1C, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1F, 0x1C, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x2D, 0xC4, 0x1D, 0x15, 0xDA, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x1F, 0x1E, 0x1F, 0x1D, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x15, 0x1F, 0x15, 0x1E, 0xA3, 0x1D, 0x15, 0x1E, 0x1E, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1F, 0x1F, 0xDA, 0x1F, 0x1D, 0xA3, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x1B, 0x15, 0x1F, 0x15, 0x1F, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1B, 0x1F, 0x1E, 0x1E, 0x15, 0x1F, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1E, 0xA3, 0xC4, 0x2D, 0x1E, 0x17, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xC4, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_india[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x8D, 0x8D, 0x8D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x8D, 0xB3, 0x23, 0xB3, 0x8D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x8D, 0x23, 0x23, 0x23, 0x8D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x8D, 0xB3, 0x23, 0xB3, 0x8D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x8D, 0x8D, 0x8D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_ireland[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x5C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_israel[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0xB3, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0xB3, 0x1F, 0xB3, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0xB3, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0xB3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_italy[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x3B, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

/*const uint8 k_flag_japan[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x1D, 0x1C, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0x82, 0xA3, 0xC4, 0xA3, 0x82, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1D, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xC4, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1D, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1E, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0x82, 0xA3, 0xC4, 0xA3, 0x82, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1D, 0x1C, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};*/

const uint8 k_flag_japan[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0x82, 0xA3, 0x82, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0xA3, 0x2D, 0x2D, 0x2D, 0xA3, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1D, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xA3, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x82, 0x1E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0xA3, 0x2D, 0x2D, 0x2D, 0xA3, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1C, 0x82, 0xA3, 0x82, 0x1C, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_netherlands[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_norway[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_philippines[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1B, 0x87, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x60, 0xD3, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0xFA, 0x1F, 0x1D, 0xAD, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x60, 0x87, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFE, 0xFD, 0x1F, 0xFE, 0x1F, 0x1F, 0x1D, 0xD3, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0xFA, 0xFA, 0xFA, 0x1F, 0x1F, 0x1F, 0x1B, 0x87, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFD, 0xFA, 0xFA, 0xFA, 0xFD, 0x1F, 0xFA, 0x1F, 0x1C, 0x1E, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0xFA, 0xFA, 0xFA, 0x1F, 0x1F, 0x1F, 0xDA, 0x82, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0xFE, 0x1F, 0xFD, 0xFE, 0x1F, 0x1B, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0xDA, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0xFA, 0x1F, 0x1C, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x82, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xDA, 0xC4, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_poland[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0xA3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_russia[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_scotland[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1E, 0x8D, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x8D, 0x1E, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x67, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x67, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xB4, 0x1C, 0x1F, 0x1F, 0x1F, 0x1E, 0x93, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x93, 0x1E, 0x1F, 0x1F, 0x1F, 0x1C, 0xB4, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0x87, 0x1F, 0x1F, 0x1F, 0x1F, 0x67, 0xBE, 0xBE, 0xBE, 0x67, 0x1F, 0x1F, 0x1F, 0x1F, 0x87, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0x94, 0x1C, 0x1F, 0x1F, 0x1F, 0x1D, 0x8D, 0x1D, 0x1F, 0x1F, 0x1F, 0x1C, 0x94, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x67, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x67, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x8D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x8D, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x67, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x67, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0x94, 0x1C, 0x1F, 0x1F, 0x1F, 0x1D, 0x8D, 0x1D, 0x1F, 0x1F, 0x1F, 0x1C, 0x94, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0x87, 0x1F, 0x1F, 0x1F, 0x1F, 0x67, 0xBE, 0xBE, 0xBE, 0x67, 0x1F, 0x1F, 0x1F, 0x1F, 0x87, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xB4, 0x1C, 0x1F, 0x1F, 0x1F, 0x1E, 0x93, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x93, 0x1E, 0x1F, 0x1F, 0x1F, 0x1C, 0xB4, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x67, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x67, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1E, 0x8D, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x8D, 0x1E, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_slovakia[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x2D, 0x2D, 0x2D, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x6C, 0x6C, 0x6C, 0x67, 0x15, 0x1F, 0x15, 0x67, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x1F, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x1F, 0x2D, 0x15, 0x1F, 0x15, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x1F, 0x2D, 0x2D, 0x1F, 0x2D, 0x2D, 0x1F, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xF5, 0xF5, 0x1F, 0x23, 0x2D, 0x23, 0x2D, 0x23, 0x1F, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0xF5, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0xA3, 0x1F, 0x23, 0x23, 0x23, 0x1F, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0xA3, 0x1F, 0x1F, 0x1F, 0xA3, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_sweden[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xFA, 0xFA, 0xFA, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0xBE, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

/*const uint8 k_flag_taiwan[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0xDA, 0x2D, 0xDA, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x2D, 0xA3, 0x2D, 0xA3, 0x2D, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0xDA, 0xA3, 0x2D, 0x2D, 0x2D, 0xA3, 0xDA, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x2D, 0x2D, 0x2D, 0xDA, 0x2D, 0x2D, 0x2D, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0xDA, 0xA3, 0x2D, 0x2D, 0x2D, 0xA3, 0xDA, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x2D, 0xA3, 0x2D, 0xA3, 0x2D, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0xDA, 0x2D, 0xDA, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x3E, 0x3E, 0x3E, 0x3E, 0x3E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};*/

const uint8 k_flag_taiwan[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x23, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x60, 0x60, 0x60, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x1F, 0x60, 0x1F, 0x60, 0x1F, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x60, 0x60, 0x60, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x1F, 0x23, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_united_kingdom[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xA3, 0x1D, 0x1E, 0xAE, 0x27, 0x27, 0x27, 0x27, 0xDA, 0x2D, 0xDA, 0x27, 0x27, 0x27, 0x27, 0xAE, 0xA3, 0xC4, 0x1C, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xA3, 0x2D, 0x82, 0x1F, 0x16, 0x26, 0x27, 0x27, 0xDA, 0x2D, 0xDA, 0x27, 0x27, 0xD5, 0x17, 0xC4, 0xA3, 0x1F, 0x1E, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xD5, 0x17, 0xC4, 0xC4, 0xDA, 0x1E, 0xAE, 0x27, 0xDA, 0x2D, 0xDA, 0x27, 0xAE, 0x15, 0x2D, 0x15, 0x1F, 0x18, 0xD5, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x27, 0x10, 0x82, 0x2D, 0xA3, 0x1E, 0x15, 0xDA, 0x2D, 0xDA, 0x16, 0xA3, 0xC4, 0xDA, 0x1F, 0x0F, 0x27, 0x27, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x27, 0x27, 0xD5, 0x1A, 0xA3, 0xC4, 0x16, 0xDA, 0x2D, 0xDA, 0xC4, 0xA3, 0x1E, 0x1A, 0xD5, 0x27, 0x27, 0x27, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0x2D, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0x2D, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0xDA, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x27, 0x27, 0xD5, 0x1A, 0x1E, 0xA3, 0xC4, 0xDA, 0x2D, 0xDA, 0x16, 0xC4, 0xA3, 0x1A, 0xD5, 0x27, 0x27, 0x27, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x27, 0x0F, 0x1F, 0xDA, 0xC4, 0xA3, 0x16, 0xDA, 0x2D, 0xDA, 0x15, 0x1E, 0xA3, 0x2D, 0x82, 0x10, 0x27, 0x27, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0xD5, 0x18, 0x1F, 0x15, 0x2D, 0x15, 0xAE, 0x27, 0xDA, 0x2D, 0xDA, 0x27, 0xAE, 0x1E, 0xDA, 0xC4, 0xC4, 0x17, 0xD5, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1E, 0x1F, 0xA3, 0xC4, 0x17, 0xD5, 0x27, 0x27, 0xDA, 0x2D, 0xDA, 0x27, 0x27, 0x26, 0x16, 0x1F, 0x82, 0x2D, 0xA3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1C, 0xC4, 0xA3, 0xAE, 0x27, 0x27, 0x27, 0x27, 0xDA, 0x2D, 0xDA, 0x27, 0x27, 0x27, 0x27, 0xAE, 0x1E, 0x1D, 0xA3, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_united_states[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x27, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x27, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x27, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x27, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x23, 0x1F, 0x27, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x27, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};

const uint8 k_flag_vietnam[] =
{
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xC5, 0xFA, 0xC5, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xC5, 0xFA, 0xC5, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0xFA, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xC5, 0xF9, 0xFA, 0xFA, 0xFA, 0xF9, 0xC5, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x98, 0xFF, 0xFA, 0xFF, 0x98, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xF9, 0xFF, 0xF9, 0xFF, 0xF9, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0xC5, 0xFA, 0xA5, 0x2D, 0xA5, 0xFA, 0xC5, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x2D, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT,
	0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT, B_TRANSPARENT_8_BIT
};
