
#ifndef	_APPSERVER2_COMMANDPROTOCOL_H_
#define	_APPSERVER2_COMMANDPROTOCOL_H_

namespace B {
namespace AppServer2 {

enum CommandProtocol {
	GR_CREATE_WINDOW = 0xec0,
	GR_NEW_BITMAP,
	GR_SET_BITS,
	GR_DELETE_BITMAP,
	GR_NEW_APP,
	GR_CREATE_OFF_WINDOW,
	GR_SET_RECT_TRACK,
	GR_FIND_WINDOW,
	GR_SET_BITS_24,
	GR_SET_BITS_24_TST,
	GR_SET_DRAG,
	GR_GET_SCS,
	GR_SET_DRAG_BM,

	GR_SHOW_CURSOR,
	GR_HIDE_CURSOR,
	GR_OBSCURE_CURSOR,

	GR_ZOOM,

	GR_IMPORT_PICTURE,
	GR_CLONE_PICTURE,
	GR_DELETE_PICTURE,
	GR_GET_PICTURE_SIZE,
	GR_GET_PICTURE_DATA,

	GR_SET_TEAM_ID,
	GR_SET_FONT_SET,
	GR_GET_FONT_SET,
	GR_COUNT_SETS,

	GR_IS_CURSOR_HIDDEN,
	GR_SET_CURSOR2,
	GR_TRUNCATE_STRINGS,

	GR_LOCK_SCREEN,
	GR_UNLOCK_SCREEN,

	GR_GET_DESKTOP_COLOR,
	GR_SET_DESKTOP_COLOR,

	GR_ACTIVATE_TEAM,
	GR_COUNT_WS,
	GR_SET_WS_COUNT,
	GR_CURRENT_WS,
	GR_SELECT_WS,

	GR_SET_SCREEN_RES,
	GR_SET_SCREEN_RATE,
	GR_SET_SCREEN_POS,

	GR_PROPOSE_DISPLAY_MODE,
	GR_GET_DISPLAY_MODE_LIST,
	GR_SET_DISPLAY_MODE,
	GR_GET_DISPLAY_MODE,
	GR_GET_FRAME_BUFFER_CONFIG,
	GR_GET_ACCELERANT_DEVICE_INFO,
	GR_GET_PIXEL_CLOCK_LIMITS,
	GR_GET_TIMING_CONSTRAINTS,
	GR_GET_DPMS_CAPABILITIES,
	GR_GET_DPMS_STATE,
	GR_SET_DPMS_STATE,

	GR_GET_ACCELERANT_IMAGE_PATH,
	GR_GET_ACCELERANT_CLONE_INFO,
	GR_ACCELERANT_PERFORM_HACK,
	GR_GET_DISPLAY_DEVICE_PATH,

	GR_GET_SCROLL_BAR_INFO,
	GR_SET_SCROLL_BAR_INFO,

	GR_CTRL_GRAPHICS_CARD,
	GR_GET_SCREEN_BITMAP,
	GR_LOCK_DIRECT_SCREEN,
	GR_GET_CLONE_INFO,
	GR_SET_STANDARD_SPACE,	
	GR_GET_DRIVER_INFO,
	GR_GET_SYNC_INFO,
	GR_GET_RETRACE_SEMAPHORE,
		
	GR_OPEN_INPUT_CHANNEL,
	GR_CLOSE_INPUT_CHANNEL,
	GR_SET_INPUT_CHANNEL,
	GR_GET_INPUT_CHANNEL,
	GR_SET_DRAG_PIXEL,
	
	GR_GET_FAMILY_LIST,
	GR_GET_STYLE_LIST,
	GR_GET_TUNED_FONT_LIST,
	GR_FONT_CHANGE_TIME,
	GR_STRING_WIDTH,
	GR_GET_ESCAPEMENTS,
	GR_GET_EDGES,
	GR_GET_HEIGHT,
	GR_GET_FONT_IDS,
	GR_GET_FONT_NAMES,
	
	GR_SET_CURSOR,
	
	GR_GET_STANDARD_FONTS,
	GR_SET_STANDARD_FONTS,
	GR_GET_FONT_CACHE_SETTINGS,
	GR_SET_FONT_CACHE_SETTINGS,
	GR_REMOVE_FONT_DIR,
	GR_CHANGE_FONT_DIR_STATUS,
	GR_CHANGE_FONT_FILE_STATUS,
	GR_GET_FONT_DIR_LIST,
	GR_GET_FONT_FILE_LIST,
	GR_SAVE_FONT_CACHE,
	GR_FONT_SET_CONTROL,
	GR_SAVE_TUNED_FONT_SET,
	
	GR_COUNT_WINDOWS,
	GR_GET_WINDOW_INFO,
	GR_DO_WINDOW_ACTION,

	// GR_SET_KEY_MODE obsolete, use GR_SET_FOCUS_FOLLOWS_MOUSE

	GR_GET_TOKEN_LIST,
	GR_DO_MINI_TEAM,
	GR_DO_ACTIVATE_TEAM,
	
	GR_GET_UI_SETTINGS,
	GR_SET_UI_SETTINGS,
	GR_SET_MOUSE_POSITION,
	GR_SELECT_WS_ASYNC,
	GR_SET_COLOR_MAP,

	GR_GET_IDLE_TIME,
	GR_GET_SCREEN_INFO,
	GR_SET_FOCUS_FOLLOWS_MOUSE,	// HL 1/15/98
	GR_GET_FOCUS_FOLLOWS_MOUSE,	// HL 1/15/98
	GR_DIRECT_WINDOW_INFO,		// PRR 1/27/98

	GR_GET_SERVER_HEAP_AREA,	// GEH 5/17/98
	GR_GET_FONT_GLYPHS,			// PRR 8/6/98
	GR_GET_FONT_FLAGS_INFO,		// PRR 8/19/98
	GR_GET_FONT_BBOX,			// PRR 9/3/98
	GR_GET_FONT_BLOCKS,			// PRR 9/3/98
	GR_GET_GLYPHS_BBOX,			// PRR 9/3/98
	GR_GET_STRINGS_BBOX,		// PRR 9/3/98
	GR_GET_HAS_GLYPHS,			// PRR 9/3/98

	GR_SET_MINI_ICON,			// GEH 9/??/98
	GR_GET_UNBLOCKED_SCREEN,	// PRR 9/14/98
	GR_OLD_SET_WINDOW_DECOR,	// GEH 9/??/98 -- no longer used
	GR_GET_OVERLAY_RESTRICTIONS,// GEH 5/19/99
	GR_NEW_CURSOR, 				// GEH 8/10/99
	GR_DELETE_CURSOR, 			// GEH 8/10/99

	GR_FREEZEDRY_BITMAP, 		// GEH 11/8/00
	GR_UPLOAD_BITMAP, 			// GEH 11/8/00
	
	GR_SET_WINDOW_DECOR,		// DKH 11/30/00
	GR_GET_WINDOW_DECOR,		// DKH 11/30/00
	
	GR_SET_INT32_SETTING,		// DKH 12/14/00
	GR_GET_INT32_SETTING,		// DKH 12/14/00
};

} }	// namespace B::AppServer2

using namespace B::AppServer2;

#endif	/* _APPSERVER2_COMMANDPROTOCOL_H_ */
