/************************************************************************
*                                                                       *
*               INTEL CORPORATION PROPRIETARY INFORMATION               *
*                                                                       *
*    This listing is supplied under the terms of a license agreement    *
*      with INTEL Corporation and may not be copied nor disclosed       *
*        except in accordance with the terms of that agreement.         *
*                                                                       *
*************************************************************************
*                                                                       *
*               Copyright (C) 1994-1997 Intel Corp.                     *
*                         All Rights Reserved.                          *
*                                                                       *
************************************************************************/
/*
 * This file is automatically generated. Do not hand-modify!
 *
 * This file contains tables supporting CLUT8. Tables include:
 *
 *    PalTable         : The palette
 *    [S]ICDY          : For Y dithering and clamping
 *    DitherTable      : For UV dithering
 *    [S]Truncate[VU]  : Maps 8 bit chroma to 5 bits
 *
 * These tables are used in CF_CLUT8, PT_[FIXED|CONFIG] mode
 *
 * Using segmented random traversal of UV points
 */

/*
 * Parameters:
 *    Y ranges from 24 to 232 in steps of 16 (14 points)
 *    Each Y point has 16 UV points
 */

#include "datatype.h"

#define PC_NOCOLLAPSE 0x04

I32 EntryCount = 224;

unsigned char PalTable[4*236] = {
    0,  47,   0, PC_NOCOLLAPSE,   /* YVU=( 24, 96, 96) */
    0,  66,   0, PC_NOCOLLAPSE,   /* YVU=( 40, 96, 96) */
    0,  85,   0, PC_NOCOLLAPSE,   /* YVU=( 56, 96, 96) */
   14, 103,   0, PC_NOCOLLAPSE,   /* YVU=( 72, 96, 96) */
   32, 122,  19, PC_NOCOLLAPSE,   /* YVU=( 88, 96, 96) */
   51, 140,  37, PC_NOCOLLAPSE,   /* YVU=(104, 96, 96) */
   70, 159,  56, PC_NOCOLLAPSE,   /* YVU=(120, 96, 96) */
   88, 178,  75, PC_NOCOLLAPSE,   /* YVU=(136, 96, 96) */
  107, 196,  93, PC_NOCOLLAPSE,   /* YVU=(152, 96, 96) */
  125, 215, 112, PC_NOCOLLAPSE,   /* YVU=(168, 96, 96) */
  144, 234, 130, PC_NOCOLLAPSE,   /* YVU=(184, 96, 96) */
  163, 252, 149, PC_NOCOLLAPSE,   /* YVU=(200, 96, 96) */
  181, 255, 168, PC_NOCOLLAPSE,   /* YVU=(216, 96, 96) */
  200, 255, 186, PC_NOCOLLAPSE,   /* YVU=(232, 96, 96) */
    0,  35,   9, PC_NOCOLLAPSE,   /* YVU=( 24, 96,128) */
    0,  53,  27, PC_NOCOLLAPSE,   /* YVU=( 40, 96,128) */
    0,  72,  46, PC_NOCOLLAPSE,   /* YVU=( 56, 96,128) */
   14,  91,  65, PC_NOCOLLAPSE,   /* YVU=( 72, 96,128) */
   32, 109,  83, PC_NOCOLLAPSE,   /* YVU=( 88, 96,128) */
   51, 128, 102, PC_NOCOLLAPSE,   /* YVU=(104, 96,128) */
   69, 147, 121, PC_NOCOLLAPSE,   /* YVU=(120, 96,128) */
   88, 165, 139, PC_NOCOLLAPSE,   /* YVU=(136, 96,128) */
  107, 184, 158, PC_NOCOLLAPSE,   /* YVU=(152, 96,128) */
  125, 202, 176, PC_NOCOLLAPSE,   /* YVU=(168, 96,128) */
  144, 221, 195, PC_NOCOLLAPSE,   /* YVU=(184, 96,128) */
  163, 240, 214, PC_NOCOLLAPSE,   /* YVU=(200, 96,128) */
  181, 255, 232, PC_NOCOLLAPSE,   /* YVU=(216, 96,128) */
  200, 255, 251, PC_NOCOLLAPSE,   /* YVU=(232, 96,128) */
    0,  22,  73, PC_NOCOLLAPSE,   /* YVU=( 24, 96,160) */
    0,  41,  92, PC_NOCOLLAPSE,   /* YVU=( 40, 96,160) */
    0,  60, 111, PC_NOCOLLAPSE,   /* YVU=( 56, 96,160) */
   14,  78, 129, PC_NOCOLLAPSE,   /* YVU=( 72, 96,160) */
   32,  97, 148, PC_NOCOLLAPSE,   /* YVU=( 88, 96,160) */
   51, 115, 166, PC_NOCOLLAPSE,   /* YVU=(104, 96,160) */
   69, 134, 185, PC_NOCOLLAPSE,   /* YVU=(120, 96,160) */
   88, 153, 204, PC_NOCOLLAPSE,   /* YVU=(136, 96,160) */
  107, 171, 222, PC_NOCOLLAPSE,   /* YVU=(152, 96,160) */
  125, 190, 241, PC_NOCOLLAPSE,   /* YVU=(168, 96,160) */
  144, 209, 255, PC_NOCOLLAPSE,   /* YVU=(184, 96,160) */
  163, 227, 255, PC_NOCOLLAPSE,   /* YVU=(200, 96,160) */
  181, 246, 255, PC_NOCOLLAPSE,   /* YVU=(216, 96,160) */
  200, 255, 255, PC_NOCOLLAPSE,   /* YVU=(232, 96,160) */
    0,  10, 138, PC_NOCOLLAPSE,   /* YVU=( 24, 96,192) */
    0,  28, 156, PC_NOCOLLAPSE,   /* YVU=( 40, 96,192) */
    0,  47, 175, PC_NOCOLLAPSE,   /* YVU=( 56, 96,192) */
   14,  66, 194, PC_NOCOLLAPSE,   /* YVU=( 72, 96,192) */
   32,  84, 212, PC_NOCOLLAPSE,   /* YVU=( 88, 96,192) */
   51, 103, 231, PC_NOCOLLAPSE,   /* YVU=(104, 96,192) */
   69, 122, 250, PC_NOCOLLAPSE,   /* YVU=(120, 96,192) */
   88, 140, 255, PC_NOCOLLAPSE,   /* YVU=(136, 96,192) */
  107, 159, 255, PC_NOCOLLAPSE,   /* YVU=(152, 96,192) */
  125, 177, 255, PC_NOCOLLAPSE,   /* YVU=(168, 96,192) */
  144, 196, 255, PC_NOCOLLAPSE,   /* YVU=(184, 96,192) */
  163, 215, 255, PC_NOCOLLAPSE,   /* YVU=(200, 96,192) */
  181, 233, 255, PC_NOCOLLAPSE,   /* YVU=(216, 96,192) */
  200, 252, 255, PC_NOCOLLAPSE,   /* YVU=(232, 96,192) */
    9,  21,   0, PC_NOCOLLAPSE,   /* YVU=( 24,128, 96) */
   27,  40,   0, PC_NOCOLLAPSE,   /* YVU=( 40,128, 96) */
   46,  59,   0, PC_NOCOLLAPSE,   /* YVU=( 56,128, 96) */
   65,  77,   0, PC_NOCOLLAPSE,   /* YVU=( 72,128, 96) */
   83,  96,  19, PC_NOCOLLAPSE,   /* YVU=( 88,128, 96) */
  102, 114,  37, PC_NOCOLLAPSE,   /* YVU=(104,128, 96) */
  121, 133,  56, PC_NOCOLLAPSE,   /* YVU=(120,128, 96) */
  139, 152,  75, PC_NOCOLLAPSE,   /* YVU=(136,128, 96) */
  158, 170,  93, PC_NOCOLLAPSE,   /* YVU=(152,128, 96) */
  176, 189, 112, PC_NOCOLLAPSE,   /* YVU=(168,128, 96) */
  195, 208, 131, PC_NOCOLLAPSE,   /* YVU=(184,128, 96) */
  214, 226, 149, PC_NOCOLLAPSE,   /* YVU=(200,128, 96) */
  232, 245, 168, PC_NOCOLLAPSE,   /* YVU=(216,128, 96) */
  251, 255, 186, PC_NOCOLLAPSE,   /* YVU=(232,128, 96) */
    9,   9,   9, PC_NOCOLLAPSE,   /* YVU=( 24,128,128) */
   27,  27,  27, PC_NOCOLLAPSE,   /* YVU=( 40,128,128) */
   46,  46,  46, PC_NOCOLLAPSE,   /* YVU=( 56,128,128) */
   65,  65,  65, PC_NOCOLLAPSE,   /* YVU=( 72,128,128) */
   83,  83,  83, PC_NOCOLLAPSE,   /* YVU=( 88,128,128) */
  102, 102, 102, PC_NOCOLLAPSE,   /* YVU=(104,128,128) */
  121, 121, 121, PC_NOCOLLAPSE,   /* YVU=(120,128,128) */
  139, 139, 139, PC_NOCOLLAPSE,   /* YVU=(136,128,128) */
  158, 158, 158, PC_NOCOLLAPSE,   /* YVU=(152,128,128) */
  176, 176, 176, PC_NOCOLLAPSE,   /* YVU=(168,128,128) */
  195, 195, 195, PC_NOCOLLAPSE,   /* YVU=(184,128,128) */
  214, 214, 214, PC_NOCOLLAPSE,   /* YVU=(200,128,128) */
  232, 232, 232, PC_NOCOLLAPSE,   /* YVU=(216,128,128) */
  251, 251, 251, PC_NOCOLLAPSE,   /* YVU=(232,128,128) */
    9,   0,  73, PC_NOCOLLAPSE,   /* YVU=( 24,128,160) */
   27,  15,  92, PC_NOCOLLAPSE,   /* YVU=( 40,128,160) */
   46,  34, 111, PC_NOCOLLAPSE,   /* YVU=( 56,128,160) */
   65,  52, 129, PC_NOCOLLAPSE,   /* YVU=( 72,128,160) */
   83,  71, 148, PC_NOCOLLAPSE,   /* YVU=( 88,128,160) */
  102,  89, 166, PC_NOCOLLAPSE,   /* YVU=(104,128,160) */
  121, 108, 185, PC_NOCOLLAPSE,   /* YVU=(120,128,160) */
  139, 127, 204, PC_NOCOLLAPSE,   /* YVU=(136,128,160) */
  158, 145, 222, PC_NOCOLLAPSE,   /* YVU=(152,128,160) */
  176, 164, 241, PC_NOCOLLAPSE,   /* YVU=(168,128,160) */
  195, 183, 255, PC_NOCOLLAPSE,   /* YVU=(184,128,160) */
  214, 201, 255, PC_NOCOLLAPSE,   /* YVU=(200,128,160) */
  232, 220, 255, PC_NOCOLLAPSE,   /* YVU=(216,128,160) */
  251, 238, 255, PC_NOCOLLAPSE,   /* YVU=(232,128,160) */
    9,   0, 138, PC_NOCOLLAPSE,   /* YVU=( 24,128,192) */
   27,   2, 157, PC_NOCOLLAPSE,   /* YVU=( 40,128,192) */
   46,  21, 175, PC_NOCOLLAPSE,   /* YVU=( 56,128,192) */
   65,  40, 194, PC_NOCOLLAPSE,   /* YVU=( 72,128,192) */
   83,  58, 212, PC_NOCOLLAPSE,   /* YVU=( 88,128,192) */
  102,  77, 231, PC_NOCOLLAPSE,   /* YVU=(104,128,192) */
  120,  96, 250, PC_NOCOLLAPSE,   /* YVU=(120,128,192) */
  139, 114, 255, PC_NOCOLLAPSE,   /* YVU=(136,128,192) */
  158, 133, 255, PC_NOCOLLAPSE,   /* YVU=(152,128,192) */
  176, 151, 255, PC_NOCOLLAPSE,   /* YVU=(168,128,192) */
  195, 170, 255, PC_NOCOLLAPSE,   /* YVU=(184,128,192) */
  214, 189, 255, PC_NOCOLLAPSE,   /* YVU=(200,128,192) */
  232, 207, 255, PC_NOCOLLAPSE,   /* YVU=(216,128,192) */
  251, 226, 255, PC_NOCOLLAPSE,   /* YVU=(232,128,192) */
   60,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 24,160, 96) */
   79,  14,   0, PC_NOCOLLAPSE,   /* YVU=( 40,160, 96) */
   97,  33,   0, PC_NOCOLLAPSE,   /* YVU=( 56,160, 96) */
  116,  51,   0, PC_NOCOLLAPSE,   /* YVU=( 72,160, 96) */
  134,  70,  19, PC_NOCOLLAPSE,   /* YVU=( 88,160, 96) */
  153,  88,  37, PC_NOCOLLAPSE,   /* YVU=(104,160, 96) */
  172, 107,  56, PC_NOCOLLAPSE,   /* YVU=(120,160, 96) */
  190, 126,  75, PC_NOCOLLAPSE,   /* YVU=(136,160, 96) */
  209, 144,  93, PC_NOCOLLAPSE,   /* YVU=(152,160, 96) */
  228, 163, 112, PC_NOCOLLAPSE,   /* YVU=(168,160, 96) */
  246, 182, 131, PC_NOCOLLAPSE,   /* YVU=(184,160, 96) */
  255, 200, 149, PC_NOCOLLAPSE,   /* YVU=(200,160, 96) */
  255, 219, 168, PC_NOCOLLAPSE,   /* YVU=(216,160, 96) */
  255, 237, 186, PC_NOCOLLAPSE,   /* YVU=(232,160, 96) */
   60,   0,   9, PC_NOCOLLAPSE,   /* YVU=( 24,160,128) */
   79,   1,  27, PC_NOCOLLAPSE,   /* YVU=( 40,160,128) */
   97,  20,  46, PC_NOCOLLAPSE,   /* YVU=( 56,160,128) */
  116,  39,  65, PC_NOCOLLAPSE,   /* YVU=( 72,160,128) */
  134,  57,  83, PC_NOCOLLAPSE,   /* YVU=( 88,160,128) */
  153,  76, 102, PC_NOCOLLAPSE,   /* YVU=(104,160,128) */
  172,  95, 121, PC_NOCOLLAPSE,   /* YVU=(120,160,128) */
  190, 113, 139, PC_NOCOLLAPSE,   /* YVU=(136,160,128) */
  209, 132, 158, PC_NOCOLLAPSE,   /* YVU=(152,160,128) */
  228, 150, 176, PC_NOCOLLAPSE,   /* YVU=(168,160,128) */
  246, 169, 195, PC_NOCOLLAPSE,   /* YVU=(184,160,128) */
  255, 188, 214, PC_NOCOLLAPSE,   /* YVU=(200,160,128) */
  255, 206, 232, PC_NOCOLLAPSE,   /* YVU=(216,160,128) */
  255, 225, 251, PC_NOCOLLAPSE,   /* YVU=(232,160,128) */
   60,   0,  73, PC_NOCOLLAPSE,   /* YVU=( 24,160,160) */
   78,   0,  92, PC_NOCOLLAPSE,   /* YVU=( 40,160,160) */
   97,   8, 111, PC_NOCOLLAPSE,   /* YVU=( 56,160,160) */
  116,  26, 129, PC_NOCOLLAPSE,   /* YVU=( 72,160,160) */
  134,  45, 148, PC_NOCOLLAPSE,   /* YVU=( 88,160,160) */
  153,  63, 167, PC_NOCOLLAPSE,   /* YVU=(104,160,160) */
  172,  82, 185, PC_NOCOLLAPSE,   /* YVU=(120,160,160) */
  190, 101, 204, PC_NOCOLLAPSE,   /* YVU=(136,160,160) */
  209, 119, 222, PC_NOCOLLAPSE,   /* YVU=(152,160,160) */
  227, 138, 241, PC_NOCOLLAPSE,   /* YVU=(168,160,160) */
  246, 157, 255, PC_NOCOLLAPSE,   /* YVU=(184,160,160) */
  255, 175, 255, PC_NOCOLLAPSE,   /* YVU=(200,160,160) */
  255, 194, 255, PC_NOCOLLAPSE,   /* YVU=(216,160,160) */
  255, 212, 255, PC_NOCOLLAPSE,   /* YVU=(232,160,160) */
   60,   0, 138, PC_NOCOLLAPSE,   /* YVU=( 24,160,192) */
   78,   0, 157, PC_NOCOLLAPSE,   /* YVU=( 40,160,192) */
   97,   0, 175, PC_NOCOLLAPSE,   /* YVU=( 56,160,192) */
  116,  14, 194, PC_NOCOLLAPSE,   /* YVU=( 72,160,192) */
  134,  32, 212, PC_NOCOLLAPSE,   /* YVU=( 88,160,192) */
  153,  51, 231, PC_NOCOLLAPSE,   /* YVU=(104,160,192) */
  172,  70, 250, PC_NOCOLLAPSE,   /* YVU=(120,160,192) */
  190,  88, 255, PC_NOCOLLAPSE,   /* YVU=(136,160,192) */
  209, 107, 255, PC_NOCOLLAPSE,   /* YVU=(152,160,192) */
  227, 125, 255, PC_NOCOLLAPSE,   /* YVU=(168,160,192) */
  246, 144, 255, PC_NOCOLLAPSE,   /* YVU=(184,160,192) */
  255, 163, 255, PC_NOCOLLAPSE,   /* YVU=(200,160,192) */
  255, 181, 255, PC_NOCOLLAPSE,   /* YVU=(216,160,192) */
  255, 200, 255, PC_NOCOLLAPSE,   /* YVU=(232,160,192) */
  111,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 24,192, 96) */
  130,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 40,192, 96) */
  148,   7,   0, PC_NOCOLLAPSE,   /* YVU=( 56,192, 96) */
  167,  25,   0, PC_NOCOLLAPSE,   /* YVU=( 72,192, 96) */
  185,  44,  19, PC_NOCOLLAPSE,   /* YVU=( 88,192, 96) */
  204,  62,  37, PC_NOCOLLAPSE,   /* YVU=(104,192, 96) */
  223,  81,  56, PC_NOCOLLAPSE,   /* YVU=(120,192, 96) */
  241, 100,  75, PC_NOCOLLAPSE,   /* YVU=(136,192, 96) */
  255, 118,  93, PC_NOCOLLAPSE,   /* YVU=(152,192, 96) */
  255, 137, 112, PC_NOCOLLAPSE,   /* YVU=(168,192, 96) */
  255, 156, 131, PC_NOCOLLAPSE,   /* YVU=(184,192, 96) */
  255, 174, 149, PC_NOCOLLAPSE,   /* YVU=(200,192, 96) */
  255, 193, 168, PC_NOCOLLAPSE,   /* YVU=(216,192, 96) */
  255, 211, 186, PC_NOCOLLAPSE,   /* YVU=(232,192, 96) */
  111,   0,   9, PC_NOCOLLAPSE,   /* YVU=( 24,192,128) */
  130,   0,  28, PC_NOCOLLAPSE,   /* YVU=( 40,192,128) */
  148,   0,  46, PC_NOCOLLAPSE,   /* YVU=( 56,192,128) */
  167,  13,  65, PC_NOCOLLAPSE,   /* YVU=( 72,192,128) */
  185,  31,  83, PC_NOCOLLAPSE,   /* YVU=( 88,192,128) */
  204,  50, 102, PC_NOCOLLAPSE,   /* YVU=(104,192,128) */
  223,  69, 121, PC_NOCOLLAPSE,   /* YVU=(120,192,128) */
  241,  87, 139, PC_NOCOLLAPSE,   /* YVU=(136,192,128) */
  255, 106, 158, PC_NOCOLLAPSE,   /* YVU=(152,192,128) */
  255, 124, 176, PC_NOCOLLAPSE,   /* YVU=(168,192,128) */
  255, 143, 195, PC_NOCOLLAPSE,   /* YVU=(184,192,128) */
  255, 162, 214, PC_NOCOLLAPSE,   /* YVU=(200,192,128) */
  255, 180, 232, PC_NOCOLLAPSE,   /* YVU=(216,192,128) */
  255, 199, 251, PC_NOCOLLAPSE,   /* YVU=(232,192,128) */
  111,   0,  73, PC_NOCOLLAPSE,   /* YVU=( 24,192,160) */
  130,   0,  92, PC_NOCOLLAPSE,   /* YVU=( 40,192,160) */
  148,   0, 111, PC_NOCOLLAPSE,   /* YVU=( 56,192,160) */
  167,   0, 129, PC_NOCOLLAPSE,   /* YVU=( 72,192,160) */
  185,  19, 148, PC_NOCOLLAPSE,   /* YVU=( 88,192,160) */
  204,  37, 167, PC_NOCOLLAPSE,   /* YVU=(104,192,160) */
  223,  56, 185, PC_NOCOLLAPSE,   /* YVU=(120,192,160) */
  241,  75, 204, PC_NOCOLLAPSE,   /* YVU=(136,192,160) */
  255,  93, 222, PC_NOCOLLAPSE,   /* YVU=(152,192,160) */
  255, 112, 241, PC_NOCOLLAPSE,   /* YVU=(168,192,160) */
  255, 131, 255, PC_NOCOLLAPSE,   /* YVU=(184,192,160) */
  255, 149, 255, PC_NOCOLLAPSE,   /* YVU=(200,192,160) */
  255, 168, 255, PC_NOCOLLAPSE,   /* YVU=(216,192,160) */
  255, 186, 255, PC_NOCOLLAPSE,   /* YVU=(232,192,160) */
  111,   0, 138, PC_NOCOLLAPSE,   /* YVU=( 24,192,192) */
  130,   0, 157, PC_NOCOLLAPSE,   /* YVU=( 40,192,192) */
  148,   0, 175, PC_NOCOLLAPSE,   /* YVU=( 56,192,192) */
  167,   0, 194, PC_NOCOLLAPSE,   /* YVU=( 72,192,192) */
  185,   6, 212, PC_NOCOLLAPSE,   /* YVU=( 88,192,192) */
  204,  25, 231, PC_NOCOLLAPSE,   /* YVU=(104,192,192) */
  223,  44, 250, PC_NOCOLLAPSE,   /* YVU=(120,192,192) */
  241,  62, 255, PC_NOCOLLAPSE,   /* YVU=(136,192,192) */
  255,  81, 255, PC_NOCOLLAPSE,   /* YVU=(152,192,192) */
  255,  99, 255, PC_NOCOLLAPSE,   /* YVU=(168,192,192) */
  255, 118, 255, PC_NOCOLLAPSE,   /* YVU=(184,192,192) */
  255, 137, 255, PC_NOCOLLAPSE,   /* YVU=(200,192,192) */
  255, 155, 255, PC_NOCOLLAPSE,   /* YVU=(216,192,192) */
  255, 174, 255, PC_NOCOLLAPSE,   /* YVU=(232,192,192) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
    0,   0,   0, PC_NOCOLLAPSE,   /* YVU=( 16,128,128) */
}; /* PalTable */

unsigned char ICDY[1024] = {
  0,   0,   0,   0, 	/*   0 */
  0,   0,   0,   0, 	/*   1 */
  0,   0,   0,   0, 	/*   2 */
  0,   0,   0,   0, 	/*   3 */
  0,   0,   0,   0, 	/*   4 */
  0,   0,   0,   0, 	/*   5 */
  0,   0,   0,   0, 	/*   6 */
  0,   0,   0,   0, 	/*   7 */
  0,   0,   0,   0, 	/*   8 */
  0,   0,   0,   0, 	/*   9 */
  0,   0,   0,   0, 	/*  10 */
  0,   0,   0,   0, 	/*  11 */
  0,   0,   0,   0, 	/*  12 */
  0,   0,   0,   0, 	/*  13 */
  0,   0,   0,   0, 	/*  14 */
  0,   0,   0,   0, 	/*  15 */
  0,   0,   0,   0, 	/*  16 */
  0,   0,   0,   0, 	/*  17 */
  0,   0,   0,   0, 	/*  18 */
  0,   0,   0,   0, 	/*  19 */
  0,   0,   0,   0, 	/*  20 */
  0,   0,   0,   0, 	/*  21 */
  0,   0,   0,   0, 	/*  22 */
  0,   0,   0,   0, 	/*  23 */
  0,   0,   0,   0, 	/*  24 */
  0,   0,   0,   0, 	/*  25 */
  0,   0,   0,   0, 	/*  26 */
  0,   0,   0,   1, 	/*  27 */
  0,   0,   0,   1, 	/*  28 */
  0,   0,   0,   1, 	/*  29 */
  0,   0,   0,   1, 	/*  30 */
  0,   0,   1,   1, 	/*  31 */
  0,   0,   1,   1, 	/*  32 */
  0,   0,   1,   1, 	/*  33 */
  0,   0,   1,   1, 	/*  34 */
  0,   1,   1,   1, 	/*  35 */
  0,   1,   1,   1, 	/*  36 */
  0,   1,   1,   1, 	/*  37 */
  0,   1,   1,   1, 	/*  38 */
  1,   1,   1,   1, 	/*  39 */
  1,   1,   1,   1, 	/*  40 */
  1,   1,   1,   1, 	/*  41 */
  1,   1,   1,   1, 	/*  42 */
  1,   1,   1,   2, 	/*  43 */
  1,   1,   1,   2, 	/*  44 */
  1,   1,   1,   2, 	/*  45 */
  1,   1,   1,   2, 	/*  46 */
  1,   1,   2,   2, 	/*  47 */
  1,   1,   2,   2, 	/*  48 */
  1,   1,   2,   2, 	/*  49 */
  1,   1,   2,   2, 	/*  50 */
  1,   2,   2,   2, 	/*  51 */
  1,   2,   2,   2, 	/*  52 */
  1,   2,   2,   2, 	/*  53 */
  1,   2,   2,   2, 	/*  54 */
  2,   2,   2,   2, 	/*  55 */
  2,   2,   2,   2, 	/*  56 */
  2,   2,   2,   2, 	/*  57 */
  2,   2,   2,   2, 	/*  58 */
  2,   2,   2,   3, 	/*  59 */
  2,   2,   2,   3, 	/*  60 */
  2,   2,   2,   3, 	/*  61 */
  2,   2,   2,   3, 	/*  62 */
  2,   2,   3,   3, 	/*  63 */
  2,   2,   3,   3, 	/*  64 */
  2,   2,   3,   3, 	/*  65 */
  2,   2,   3,   3, 	/*  66 */
  2,   3,   3,   3, 	/*  67 */
  2,   3,   3,   3, 	/*  68 */
  2,   3,   3,   3, 	/*  69 */
  2,   3,   3,   3, 	/*  70 */
  3,   3,   3,   3, 	/*  71 */
  3,   3,   3,   3, 	/*  72 */
  3,   3,   3,   3, 	/*  73 */
  3,   3,   3,   3, 	/*  74 */
  3,   3,   3,   4, 	/*  75 */
  3,   3,   3,   4, 	/*  76 */
  3,   3,   3,   4, 	/*  77 */
  3,   3,   3,   4, 	/*  78 */
  3,   3,   4,   4, 	/*  79 */
  3,   3,   4,   4, 	/*  80 */
  3,   3,   4,   4, 	/*  81 */
  3,   3,   4,   4, 	/*  82 */
  3,   4,   4,   4, 	/*  83 */
  3,   4,   4,   4, 	/*  84 */
  3,   4,   4,   4, 	/*  85 */
  3,   4,   4,   4, 	/*  86 */
  4,   4,   4,   4, 	/*  87 */
  4,   4,   4,   4, 	/*  88 */
  4,   4,   4,   4, 	/*  89 */
  4,   4,   4,   4, 	/*  90 */
  4,   4,   4,   5, 	/*  91 */
  4,   4,   4,   5, 	/*  92 */
  4,   4,   4,   5, 	/*  93 */
  4,   4,   4,   5, 	/*  94 */
  4,   4,   5,   5, 	/*  95 */
  4,   4,   5,   5, 	/*  96 */
  4,   4,   5,   5, 	/*  97 */
  4,   4,   5,   5, 	/*  98 */
  4,   5,   5,   5, 	/*  99 */
  4,   5,   5,   5, 	/* 100 */
  4,   5,   5,   5, 	/* 101 */
  4,   5,   5,   5, 	/* 102 */
  5,   5,   5,   5, 	/* 103 */
  5,   5,   5,   5, 	/* 104 */
  5,   5,   5,   5, 	/* 105 */
  5,   5,   5,   5, 	/* 106 */
  5,   5,   5,   6, 	/* 107 */
  5,   5,   5,   6, 	/* 108 */
  5,   5,   5,   6, 	/* 109 */
  5,   5,   5,   6, 	/* 110 */
  5,   5,   6,   6, 	/* 111 */
  5,   5,   6,   6, 	/* 112 */
  5,   5,   6,   6, 	/* 113 */
  5,   5,   6,   6, 	/* 114 */
  5,   6,   6,   6, 	/* 115 */
  5,   6,   6,   6, 	/* 116 */
  5,   6,   6,   6, 	/* 117 */
  5,   6,   6,   6, 	/* 118 */
  6,   6,   6,   6, 	/* 119 */
  6,   6,   6,   6, 	/* 120 */
  6,   6,   6,   6, 	/* 121 */
  6,   6,   6,   6, 	/* 122 */
  6,   6,   6,   7, 	/* 123 */
  6,   6,   6,   7, 	/* 124 */
  6,   6,   6,   7, 	/* 125 */
  6,   6,   6,   7, 	/* 126 */
  6,   6,   7,   7, 	/* 127 */
  6,   6,   7,   7, 	/* 128 */
  6,   6,   7,   7, 	/* 129 */
  6,   6,   7,   7, 	/* 130 */
  6,   7,   7,   7, 	/* 131 */
  6,   7,   7,   7, 	/* 132 */
  6,   7,   7,   7, 	/* 133 */
  6,   7,   7,   7, 	/* 134 */
  7,   7,   7,   7, 	/* 135 */
  7,   7,   7,   7, 	/* 136 */
  7,   7,   7,   7, 	/* 137 */
  7,   7,   7,   7, 	/* 138 */
  7,   7,   7,   8, 	/* 139 */
  7,   7,   7,   8, 	/* 140 */
  7,   7,   7,   8, 	/* 141 */
  7,   7,   7,   8, 	/* 142 */
  7,   7,   8,   8, 	/* 143 */
  7,   7,   8,   8, 	/* 144 */
  7,   7,   8,   8, 	/* 145 */
  7,   7,   8,   8, 	/* 146 */
  7,   8,   8,   8, 	/* 147 */
  7,   8,   8,   8, 	/* 148 */
  7,   8,   8,   8, 	/* 149 */
  7,   8,   8,   8, 	/* 150 */
  8,   8,   8,   8, 	/* 151 */
  8,   8,   8,   8, 	/* 152 */
  8,   8,   8,   8, 	/* 153 */
  8,   8,   8,   8, 	/* 154 */
  8,   8,   8,   9, 	/* 155 */
  8,   8,   8,   9, 	/* 156 */
  8,   8,   8,   9, 	/* 157 */
  8,   8,   8,   9, 	/* 158 */
  8,   8,   9,   9, 	/* 159 */
  8,   8,   9,   9, 	/* 160 */
  8,   8,   9,   9, 	/* 161 */
  8,   8,   9,   9, 	/* 162 */
  8,   9,   9,   9, 	/* 163 */
  8,   9,   9,   9, 	/* 164 */
  8,   9,   9,   9, 	/* 165 */
  8,   9,   9,   9, 	/* 166 */
  9,   9,   9,   9, 	/* 167 */
  9,   9,   9,   9, 	/* 168 */
  9,   9,   9,   9, 	/* 169 */
  9,   9,   9,   9, 	/* 170 */
  9,   9,   9,  10, 	/* 171 */
  9,   9,   9,  10, 	/* 172 */
  9,   9,   9,  10, 	/* 173 */
  9,   9,   9,  10, 	/* 174 */
  9,   9,  10,  10, 	/* 175 */
  9,   9,  10,  10, 	/* 176 */
  9,   9,  10,  10, 	/* 177 */
  9,   9,  10,  10, 	/* 178 */
  9,  10,  10,  10, 	/* 179 */
  9,  10,  10,  10, 	/* 180 */
  9,  10,  10,  10, 	/* 181 */
  9,  10,  10,  10, 	/* 182 */
 10,  10,  10,  10, 	/* 183 */
 10,  10,  10,  10, 	/* 184 */
 10,  10,  10,  10, 	/* 185 */
 10,  10,  10,  10, 	/* 186 */
 10,  10,  10,  11, 	/* 187 */
 10,  10,  10,  11, 	/* 188 */
 10,  10,  10,  11, 	/* 189 */
 10,  10,  10,  11, 	/* 190 */
 10,  10,  11,  11, 	/* 191 */
 10,  10,  11,  11, 	/* 192 */
 10,  10,  11,  11, 	/* 193 */
 10,  10,  11,  11, 	/* 194 */
 10,  11,  11,  11, 	/* 195 */
 10,  11,  11,  11, 	/* 196 */
 10,  11,  11,  11, 	/* 197 */
 10,  11,  11,  11, 	/* 198 */
 11,  11,  11,  11, 	/* 199 */
 11,  11,  11,  11, 	/* 200 */
 11,  11,  11,  11, 	/* 201 */
 11,  11,  11,  11, 	/* 202 */
 11,  11,  11,  12, 	/* 203 */
 11,  11,  11,  12, 	/* 204 */
 11,  11,  11,  12, 	/* 205 */
 11,  11,  11,  12, 	/* 206 */
 11,  11,  12,  12, 	/* 207 */
 11,  11,  12,  12, 	/* 208 */
 11,  11,  12,  12, 	/* 209 */
 11,  11,  12,  12, 	/* 210 */
 11,  12,  12,  12, 	/* 211 */
 11,  12,  12,  12, 	/* 212 */
 11,  12,  12,  12, 	/* 213 */
 11,  12,  12,  12, 	/* 214 */
 12,  12,  12,  12, 	/* 215 */
 12,  12,  12,  12, 	/* 216 */
 12,  12,  12,  12, 	/* 217 */
 12,  12,  12,  12, 	/* 218 */
 12,  12,  12,  13, 	/* 219 */
 12,  12,  12,  13, 	/* 220 */
 12,  12,  12,  13, 	/* 221 */
 12,  12,  12,  13, 	/* 222 */
 12,  12,  13,  13, 	/* 223 */
 12,  12,  13,  13, 	/* 224 */
 12,  12,  13,  13, 	/* 225 */
 12,  12,  13,  13, 	/* 226 */
 12,  13,  13,  13, 	/* 227 */
 12,  13,  13,  13, 	/* 228 */
 12,  13,  13,  13, 	/* 229 */
 12,  13,  13,  13, 	/* 230 */
 13,  13,  13,  13, 	/* 231 */
                               13,                                13,                                13,                                13, 	/* 232 */
                               13,                                13,                                13,                                13, 	/* 233 */
                               13,                                13,                                13,                                13, 	/* 234 */
                               13,                                13,                                13,                                13, 	/* 235 */
                               13,                                13,                                13,                                13, 	/* 236 */
                               13,                                13,                                13,                                13, 	/* 237 */
                               13,                                13,                                13,                                13, 	/* 238 */
                               13,                                13,                                13,                                13, 	/* 239 */
                               13,                                13,                                13,                                13, 	/* 240 */
                               13,                                13,                                13,                                13, 	/* 241 */
                               13,                                13,                                13,                                13, 	/* 242 */
                               13,                                13,                                13,                                13, 	/* 243 */
                               13,                                13,                                13,                                13, 	/* 244 */
                               13,                                13,                                13,                                13, 	/* 245 */
                               13,                                13,                                13,                                13, 	/* 246 */
                               13,                                13,                                13,                                13, 	/* 247 */
                               13,                                13,                                13,                                13, 	/* 248 */
                               13,                                13,                                13,                                13, 	/* 249 */
                               13,                                13,                                13,                                13, 	/* 250 */
                               13,                                13,                                13,                                13, 	/* 251 */
                               13,                                13,                                13,                                13, 	/* 252 */
                               13,                                13,                                13,                                13, 	/* 253 */
                               13,                                13,                                13,                                13, 	/* 254 */
                               13,                                13,                                13,                                13, 	/* 255 */
}; /* ICDY */

unsigned char SICDY[1024] = {
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   0, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   0,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   0,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  0,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   1, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   1,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   1,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  1,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   2, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   2,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   2,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  2,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   3, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   3,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   3,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  3,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   4, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   4,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   4,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  4,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   5, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   5,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   5,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  5,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   6, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   6,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   6,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  6,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   7, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   7,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   7,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  7,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   8, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   8,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   8,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  8,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,   9, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,   9,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,   9,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
  9,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  10, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  10,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  10,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 10,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  11, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  11,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  11,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 11,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  12, 
 12,  12,  12,  13, 
 12,  12,  12,  13, 
 12,  12,  12,  13, 
 12,  12,  12,  13, 
 12,  12,  13,  13, 
 12,  12,  13,  13, 
 12,  12,  13,  13, 
 12,  12,  13,  13, 
 12,  13,  13,  13, 
 12,  13,  13,  13, 
 12,  13,  13,  13, 
 12,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
 13,  13,  13,  13, 
}; /* SICDY */


unsigned int TruncateV[] = {
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    16,    16,    16,    16,    32,    32,
    32,    32,    48,    48,    48,    48,    64,    64,
    64,    64,    80,    80,    80,    80,    96,    96,
    96,    96,   112,   112,   112,   112,   128,   128,
   128,   128,   144,   144,   144,   144,   160,   160,
   160,   160,   176,   176,   176,   176,   192,   192,
   192,   192,   208,   208,   208,   208,   224,   224,
   224,   224,   240,   240,   240,   240,   256,   256,
   256,   256,   272,   272,   272,   272,   288,   288,
   288,   288,   304,   304,   304,   304,   320,   320,
   320,   320,   336,   336,   336,   336,   352,   352,
   352,   352,   368,   368,   368,   368,   384,   384,
   384,   384,   400,   400,   400,   400,   416,   416,
   416,   416,   432,   432,   432,   432,   448,   448,
   448,   448,   464,   464,   464,   464,   480,   480,
   480,   480,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
};

unsigned int TruncateU[] = {
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   512,   512,   512,   512,  1024,  1024,
  1024,  1024,  1536,  1536,  1536,  1536,  2048,  2048,
  2048,  2048,  2560,  2560,  2560,  2560,  3072,  3072,
  3072,  3072,  3584,  3584,  3584,  3584,  4096,  4096,
  4096,  4096,  4608,  4608,  4608,  4608,  5120,  5120,
  5120,  5120,  5632,  5632,  5632,  5632,  6144,  6144,
  6144,  6144,  6656,  6656,  6656,  6656,  7168,  7168,
  7168,  7168,  7680,  7680,  7680,  7680,  8192,  8192,
  8192,  8192,  8704,  8704,  8704,  8704,  9216,  9216,
  9216,  9216,  9728,  9728,  9728,  9728, 10240, 10240,
 10240, 10240, 10752, 10752, 10752, 10752, 11264, 11264,
 11264, 11264, 11776, 11776, 11776, 11776, 12288, 12288,
 12288, 12288, 12800, 12800, 12800, 12800, 13312, 13312,
 13312, 13312, 13824, 13824, 13824, 13824, 14336, 14336,
 14336, 14336, 14848, 14848, 14848, 14848, 15360, 15360,
 15360, 15360, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
};


unsigned int STruncateV[] = {
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,    16,    16,    16,    32,    32,    32,    32,
    48,    48,    48,    64,    64,    64,    64,    80,
    80,    80,    96,    96,    96,    96,   112,   112,
   112,   128,   128,   128,   128,   144,   144,   144,
   144,   160,   160,   160,   176,   176,   176,   176,
   192,   192,   192,   208,   208,   208,   208,   224,
   224,   224,   240,   240,   240,   240,   256,   256,
   256,   256,   272,   272,   272,   272,   288,   288,
   288,   304,   304,   304,   304,   320,   320,   320,
   336,   336,   336,   336,   352,   352,   352,   352,
   368,   368,   368,   384,   384,   384,   384,   400,
   400,   400,   416,   416,   416,   416,   432,   432,
   432,   448,   448,   448,   448,   464,   464,   464,
   480,   480,   480,   480,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
   496,   496,   496,   496,   496,   496,   496,   496,
};

unsigned int STruncateU[] = {
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,
     0,   512,   512,   512,  1024,  1024,  1024,  1024,
  1536,  1536,  1536,  2048,  2048,  2048,  2048,  2560,
  2560,  2560,  3072,  3072,  3072,  3072,  3584,  3584,
  3584,  4096,  4096,  4096,  4096,  4608,  4608,  4608,
  4608,  5120,  5120,  5120,  5632,  5632,  5632,  5632,
  6144,  6144,  6144,  6656,  6656,  6656,  6656,  7168,
  7168,  7168,  7680,  7680,  7680,  7680,  8192,  8192,
  8192,  8192,  8704,  8704,  8704,  8704,  9216,  9216,
  9216,  9728,  9728,  9728,  9728, 10240, 10240, 10240,
 10752, 10752, 10752, 10752, 11264, 11264, 11264, 11264,
 11776, 11776, 11776, 12288, 12288, 12288, 12288, 12800,
 12800, 12800, 13312, 13312, 13312, 13312, 13824, 13824,
 13824, 14336, 14336, 14336, 14336, 14848, 14848, 14848,
 15360, 15360, 15360, 15360, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
 15872, 15872, 15872, 15872, 15872, 15872, 15872, 15872,
};

unsigned long DitherTable[] = {	/*  U, V */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  0, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  0, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  0,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  0,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  0,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  0,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  0,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  0,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  0,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  0,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  0,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  0,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  0,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  0,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  0,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  0,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  0,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  0,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  0,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  0,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  0,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  0,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  0,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  0,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  1, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  1, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  1,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  1,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  1,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  1,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  1,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  1,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  1,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  1,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  1,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  1,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  1,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  1,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  1,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  1,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  1,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  1,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  1,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  1,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  1,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  1,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  1,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  1,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  2, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  2, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  2,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  2,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  2,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  2,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  2,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  2,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  2,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  2,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  2,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  2,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  2,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  2,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  2,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  2,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  2,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  2,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  2,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  2,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  2,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  2,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  2,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  2,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  3, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  3, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  3,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  3,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  3,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  3,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  3,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  3,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  3,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  3,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  3,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  3,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  3,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  3,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  3,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  3,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  3,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  3,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  3,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  3,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  3,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  3,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  3,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  3,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  4, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  4, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  4,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  4,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  4,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  4,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  4,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  4,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  4,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  4,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  4,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  4,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  4,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  4,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  4,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  4,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  4,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  4,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  4,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  4,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  4,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  4,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  4,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  4,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  5, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  5, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  5,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  5,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  5,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  5,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  5,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  5,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  5,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  5,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  5,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  5,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  5,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  5,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  5,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  5,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  5,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  5,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  5,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  5,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  5,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  5,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  5,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  5,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  6, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  6, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  6,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  6,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  6,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  6,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  6,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  6,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  6,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  6,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  6,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  6,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  6,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  6,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  6,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  6,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  6,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  6,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  6,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  6,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  6,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  6,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  6,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  6,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  7, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  7, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  7,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  7,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  7,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  7,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  7,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  7,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  7,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  7,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  7,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  7,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  7,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  7,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  7,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  7,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  7,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  7,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  7,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  7,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  7,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  7,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  7,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  7,31 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 0 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 1 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 2 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 3 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 4 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 5 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 6 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 7 */
0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a, 0x0a0a0a0a,   /*  8, 8 */
0x420a0a0a, 0x0a0a0a0a, 0x0a0a420a, 0x0a0a0a0a,   /*  8, 9 */
0x420a0a0a, 0x0a0a0a42, 0x0a0a420a, 0x0a420a0a,   /*  8,10 */
0x42420a0a, 0x0a0a0a42, 0x0a0a4242, 0x0a420a0a,   /*  8,11 */
0x42420a0a, 0x0a420a42, 0x0a0a4242, 0x0a420a42,   /*  8,12 */
0x42420a42, 0x0a420a42, 0x0a424242, 0x0a420a42,   /*  8,13 */
0x42420a42, 0x42420a42, 0x0a424242, 0x0a424242,   /*  8,14 */
0x42424242, 0x42420a42, 0x42424242, 0x0a424242,   /*  8,15 */
0x42424242, 0x42424242, 0x42424242, 0x42424242,   /*  8,16 */
0x7a424242, 0x42424242, 0x42427a42, 0x42424242,   /*  8,17 */
0x7a424242, 0x4242427a, 0x42427a42, 0x427a4242,   /*  8,18 */
0x7a7a4242, 0x4242427a, 0x42427a7a, 0x427a4242,   /*  8,19 */
0x7a7a4242, 0x427a427a, 0x42427a7a, 0x427a427a,   /*  8,20 */
0x7a7a427a, 0x427a427a, 0x427a7a7a, 0x427a427a,   /*  8,21 */
0x7a7a427a, 0x7a7a427a, 0x427a7a7a, 0x427a7a7a,   /*  8,22 */
0x7a7a7a7a, 0x7a7a427a, 0x7a7a7a7a, 0x427a7a7a,   /*  8,23 */
0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a, 0x7a7a7a7a,   /*  8,24 */
0xb27a7a7a, 0x7a7a7a7a, 0x7a7ab27a, 0x7a7a7a7a,   /*  8,25 */
0xb27a7a7a, 0x7a7a7ab2, 0x7a7ab27a, 0x7ab27a7a,   /*  8,26 */
0xb2b27a7a, 0x7a7a7ab2, 0x7a7ab2b2, 0x7ab27a7a,   /*  8,27 */
0xb2b27a7a, 0x7ab27ab2, 0x7a7ab2b2, 0x7ab27ab2,   /*  8,28 */
0xb2b27ab2, 0x7ab27ab2, 0x7ab2b2b2, 0x7ab27ab2,   /*  8,29 */
0xb2b27ab2, 0xb2b27ab2, 0x7ab2b2b2, 0x7ab2b2b2,   /*  8,30 */
0xb2b2b2b2, 0xb2b27ab2, 0xb2b2b2b2, 0x7ab2b2b2,   /*  8,31 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 0 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 1 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 2 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 3 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 4 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 5 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 6 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 7 */
0x0a0a0a0a, 0x0a0a180a, 0x0a0a0a0a, 0x180a0a0a,   /*  9, 8 */
0x420a0a0a, 0x0a0a180a, 0x0a0a420a, 0x180a0a0a,   /*  9, 9 */
0x420a0a0a, 0x0a0a1842, 0x0a0a420a, 0x18420a0a,   /*  9,10 */
0x42420a0a, 0x0a0a1842, 0x0a0a4242, 0x18420a0a,   /*  9,11 */
0x42420a0a, 0x0a421842, 0x0a0a4242, 0x18420a42,   /*  9,12 */
0x42420a42, 0x0a421842, 0x0a424242, 0x18420a42,   /*  9,13 */
0x42420a42, 0x42421842, 0x0a424242, 0x18424242,   /*  9,14 */
0x42424242, 0x42421842, 0x42424242, 0x18424242,   /*  9,15 */
0x42424242, 0x42425042, 0x42424242, 0x50424242,   /*  9,16 */
0x7a424242, 0x42425042, 0x42427a42, 0x50424242,   /*  9,17 */
0x7a424242, 0x4242507a, 0x42427a42, 0x507a4242,   /*  9,18 */
0x7a7a4242, 0x4242507a, 0x42427a7a, 0x507a4242,   /*  9,19 */
0x7a7a4242, 0x427a507a, 0x42427a7a, 0x507a427a,   /*  9,20 */
0x7a7a427a, 0x427a507a, 0x427a7a7a, 0x507a427a,   /*  9,21 */
0x7a7a427a, 0x7a7a507a, 0x427a7a7a, 0x507a7a7a,   /*  9,22 */
0x7a7a7a7a, 0x7a7a507a, 0x7a7a7a7a, 0x507a7a7a,   /*  9,23 */
0x7a7a7a7a, 0x7a7a887a, 0x7a7a7a7a, 0x887a7a7a,   /*  9,24 */
0xb27a7a7a, 0x7a7a887a, 0x7a7ab27a, 0x887a7a7a,   /*  9,25 */
0xb27a7a7a, 0x7a7a88b2, 0x7a7ab27a, 0x88b27a7a,   /*  9,26 */
0xb2b27a7a, 0x7a7a88b2, 0x7a7ab2b2, 0x88b27a7a,   /*  9,27 */
0xb2b27a7a, 0x7ab288b2, 0x7a7ab2b2, 0x88b27ab2,   /*  9,28 */
0xb2b27ab2, 0x7ab288b2, 0x7ab2b2b2, 0x88b27ab2,   /*  9,29 */
0xb2b27ab2, 0xb2b288b2, 0x7ab2b2b2, 0x88b2b2b2,   /*  9,30 */
0xb2b2b2b2, 0xb2b288b2, 0xb2b2b2b2, 0x88b2b2b2,   /*  9,31 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 0 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 1 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 2 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 3 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 4 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 5 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 6 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 7 */
0x0a0a0a0a, 0x0a0a1818, 0x0a0a0a0a, 0x18180a0a,   /* 10, 8 */
0x420a0a0a, 0x0a0a1818, 0x0a0a420a, 0x18180a0a,   /* 10, 9 */
0x420a0a0a, 0x0a0a1850, 0x0a0a420a, 0x18500a0a,   /* 10,10 */
0x42420a0a, 0x0a0a1850, 0x0a0a4242, 0x18500a0a,   /* 10,11 */
0x42420a0a, 0x0a421850, 0x0a0a4242, 0x18500a42,   /* 10,12 */
0x42420a42, 0x0a421850, 0x0a424242, 0x18500a42,   /* 10,13 */
0x42420a42, 0x42421850, 0x0a424242, 0x18504242,   /* 10,14 */
0x42424242, 0x42421850, 0x42424242, 0x18504242,   /* 10,15 */
0x42424242, 0x42425050, 0x42424242, 0x50504242,   /* 10,16 */
0x7a424242, 0x42425050, 0x42427a42, 0x50504242,   /* 10,17 */
0x7a424242, 0x42425088, 0x42427a42, 0x50884242,   /* 10,18 */
0x7a7a4242, 0x42425088, 0x42427a7a, 0x50884242,   /* 10,19 */
0x7a7a4242, 0x427a5088, 0x42427a7a, 0x5088427a,   /* 10,20 */
0x7a7a427a, 0x427a5088, 0x427a7a7a, 0x5088427a,   /* 10,21 */
0x7a7a427a, 0x7a7a5088, 0x427a7a7a, 0x50887a7a,   /* 10,22 */
0x7a7a7a7a, 0x7a7a5088, 0x7a7a7a7a, 0x50887a7a,   /* 10,23 */
0x7a7a7a7a, 0x7a7a8888, 0x7a7a7a7a, 0x88887a7a,   /* 10,24 */
0xb27a7a7a, 0x7a7a8888, 0x7a7ab27a, 0x88887a7a,   /* 10,25 */
0xb27a7a7a, 0x7a7a88c0, 0x7a7ab27a, 0x88c07a7a,   /* 10,26 */
0xb2b27a7a, 0x7a7a88c0, 0x7a7ab2b2, 0x88c07a7a,   /* 10,27 */
0xb2b27a7a, 0x7ab288c0, 0x7a7ab2b2, 0x88c07ab2,   /* 10,28 */
0xb2b27ab2, 0x7ab288c0, 0x7ab2b2b2, 0x88c07ab2,   /* 10,29 */
0xb2b27ab2, 0xb2b288c0, 0x7ab2b2b2, 0x88c0b2b2,   /* 10,30 */
0xb2b2b2b2, 0xb2b288c0, 0xb2b2b2b2, 0x88c0b2b2,   /* 10,31 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 0 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 1 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 2 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 3 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 4 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 5 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 6 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 7 */
0x0a0a0a18, 0x0a0a1818, 0x0a180a0a, 0x18180a0a,   /* 11, 8 */
0x420a0a18, 0x0a0a1818, 0x0a18420a, 0x18180a0a,   /* 11, 9 */
0x420a0a18, 0x0a0a1850, 0x0a18420a, 0x18500a0a,   /* 11,10 */
0x42420a18, 0x0a0a1850, 0x0a184242, 0x18500a0a,   /* 11,11 */
0x42420a18, 0x0a421850, 0x0a184242, 0x18500a42,   /* 11,12 */
0x42420a50, 0x0a421850, 0x0a504242, 0x18500a42,   /* 11,13 */
0x42420a50, 0x42421850, 0x0a504242, 0x18504242,   /* 11,14 */
0x42424250, 0x42421850, 0x42504242, 0x18504242,   /* 11,15 */
0x42424250, 0x42425050, 0x42504242, 0x50504242,   /* 11,16 */
0x7a424250, 0x42425050, 0x42507a42, 0x50504242,   /* 11,17 */
0x7a424250, 0x42425088, 0x42507a42, 0x50884242,   /* 11,18 */
0x7a7a4250, 0x42425088, 0x42507a7a, 0x50884242,   /* 11,19 */
0x7a7a4250, 0x427a5088, 0x42507a7a, 0x5088427a,   /* 11,20 */
0x7a7a4288, 0x427a5088, 0x42887a7a, 0x5088427a,   /* 11,21 */
0x7a7a4288, 0x7a7a5088, 0x42887a7a, 0x50887a7a,   /* 11,22 */
0x7a7a7a88, 0x7a7a5088, 0x7a887a7a, 0x50887a7a,   /* 11,23 */
0x7a7a7a88, 0x7a7a8888, 0x7a887a7a, 0x88887a7a,   /* 11,24 */
0xb27a7a88, 0x7a7a8888, 0x7a88b27a, 0x88887a7a,   /* 11,25 */
0xb27a7a88, 0x7a7a88c0, 0x7a88b27a, 0x88c07a7a,   /* 11,26 */
0xb2b27a88, 0x7a7a88c0, 0x7a88b2b2, 0x88c07a7a,   /* 11,27 */
0xb2b27a88, 0x7ab288c0, 0x7a88b2b2, 0x88c07ab2,   /* 11,28 */
0xb2b27ac0, 0x7ab288c0, 0x7ac0b2b2, 0x88c07ab2,   /* 11,29 */
0xb2b27ac0, 0xb2b288c0, 0x7ac0b2b2, 0x88c0b2b2,   /* 11,30 */
0xb2b2b2c0, 0xb2b288c0, 0xb2c0b2b2, 0x88c0b2b2,   /* 11,31 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 0 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 1 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 2 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 3 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 4 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 5 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 6 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 7 */
0x0a0a0a18, 0x180a1818, 0x0a180a0a, 0x1818180a,   /* 12, 8 */
0x420a0a18, 0x180a1818, 0x0a18420a, 0x1818180a,   /* 12, 9 */
0x420a0a18, 0x180a1850, 0x0a18420a, 0x1850180a,   /* 12,10 */
0x42420a18, 0x180a1850, 0x0a184242, 0x1850180a,   /* 12,11 */
0x42420a18, 0x18421850, 0x0a184242, 0x18501842,   /* 12,12 */
0x42420a50, 0x18421850, 0x0a504242, 0x18501842,   /* 12,13 */
0x42420a50, 0x50421850, 0x0a504242, 0x18505042,   /* 12,14 */
0x42424250, 0x50421850, 0x42504242, 0x18505042,   /* 12,15 */
0x42424250, 0x50425050, 0x42504242, 0x50505042,   /* 12,16 */
0x7a424250, 0x50425050, 0x42507a42, 0x50505042,   /* 12,17 */
0x7a424250, 0x50425088, 0x42507a42, 0x50885042,   /* 12,18 */
0x7a7a4250, 0x50425088, 0x42507a7a, 0x50885042,   /* 12,19 */
0x7a7a4250, 0x507a5088, 0x42507a7a, 0x5088507a,   /* 12,20 */
0x7a7a4288, 0x507a5088, 0x42887a7a, 0x5088507a,   /* 12,21 */
0x7a7a4288, 0x887a5088, 0x42887a7a, 0x5088887a,   /* 12,22 */
0x7a7a7a88, 0x887a5088, 0x7a887a7a, 0x5088887a,   /* 12,23 */
0x7a7a7a88, 0x887a8888, 0x7a887a7a, 0x8888887a,   /* 12,24 */
0xb27a7a88, 0x887a8888, 0x7a88b27a, 0x8888887a,   /* 12,25 */
0xb27a7a88, 0x887a88c0, 0x7a88b27a, 0x88c0887a,   /* 12,26 */
0xb2b27a88, 0x887a88c0, 0x7a88b2b2, 0x88c0887a,   /* 12,27 */
0xb2b27a88, 0x88b288c0, 0x7a88b2b2, 0x88c088b2,   /* 12,28 */
0xb2b27ac0, 0x88b288c0, 0x7ac0b2b2, 0x88c088b2,   /* 12,29 */
0xb2b27ac0, 0xc0b288c0, 0x7ac0b2b2, 0x88c0c0b2,   /* 12,30 */
0xb2b2b2c0, 0xc0b288c0, 0xb2c0b2b2, 0x88c0c0b2,   /* 12,31 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 0 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 1 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 2 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 3 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 4 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 5 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 6 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 7 */
0x0a180a18, 0x180a1818, 0x0a180a18, 0x1818180a,   /* 13, 8 */
0x42180a18, 0x180a1818, 0x0a184218, 0x1818180a,   /* 13, 9 */
0x42180a18, 0x180a1850, 0x0a184218, 0x1850180a,   /* 13,10 */
0x42500a18, 0x180a1850, 0x0a184250, 0x1850180a,   /* 13,11 */
0x42500a18, 0x18421850, 0x0a184250, 0x18501842,   /* 13,12 */
0x42500a50, 0x18421850, 0x0a504250, 0x18501842,   /* 13,13 */
0x42500a50, 0x50421850, 0x0a504250, 0x18505042,   /* 13,14 */
0x42504250, 0x50421850, 0x42504250, 0x18505042,   /* 13,15 */
0x42504250, 0x50425050, 0x42504250, 0x50505042,   /* 13,16 */
0x7a504250, 0x50425050, 0x42507a50, 0x50505042,   /* 13,17 */
0x7a504250, 0x50425088, 0x42507a50, 0x50885042,   /* 13,18 */
0x7a884250, 0x50425088, 0x42507a88, 0x50885042,   /* 13,19 */
0x7a884250, 0x507a5088, 0x42507a88, 0x5088507a,   /* 13,20 */
0x7a884288, 0x507a5088, 0x42887a88, 0x5088507a,   /* 13,21 */
0x7a884288, 0x887a5088, 0x42887a88, 0x5088887a,   /* 13,22 */
0x7a887a88, 0x887a5088, 0x7a887a88, 0x5088887a,   /* 13,23 */
0x7a887a88, 0x887a8888, 0x7a887a88, 0x8888887a,   /* 13,24 */
0xb2887a88, 0x887a8888, 0x7a88b288, 0x8888887a,   /* 13,25 */
0xb2887a88, 0x887a88c0, 0x7a88b288, 0x88c0887a,   /* 13,26 */
0xb2c07a88, 0x887a88c0, 0x7a88b2c0, 0x88c0887a,   /* 13,27 */
0xb2c07a88, 0x88b288c0, 0x7a88b2c0, 0x88c088b2,   /* 13,28 */
0xb2c07ac0, 0x88b288c0, 0x7ac0b2c0, 0x88c088b2,   /* 13,29 */
0xb2c07ac0, 0xc0b288c0, 0x7ac0b2c0, 0x88c0c0b2,   /* 13,30 */
0xb2c0b2c0, 0xc0b288c0, 0xb2c0b2c0, 0x88c0c0b2,   /* 13,31 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 0 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 1 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 2 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 3 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 4 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 5 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 6 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 7 */
0x0a180a18, 0x18181818, 0x0a180a18, 0x18181818,   /* 14, 8 */
0x42180a18, 0x18181818, 0x0a184218, 0x18181818,   /* 14, 9 */
0x42180a18, 0x18181850, 0x0a184218, 0x18501818,   /* 14,10 */
0x42500a18, 0x18181850, 0x0a184250, 0x18501818,   /* 14,11 */
0x42500a18, 0x18501850, 0x0a184250, 0x18501850,   /* 14,12 */
0x42500a50, 0x18501850, 0x0a504250, 0x18501850,   /* 14,13 */
0x42500a50, 0x50501850, 0x0a504250, 0x18505050,   /* 14,14 */
0x42504250, 0x50501850, 0x42504250, 0x18505050,   /* 14,15 */
0x42504250, 0x50505050, 0x42504250, 0x50505050,   /* 14,16 */
0x7a504250, 0x50505050, 0x42507a50, 0x50505050,   /* 14,17 */
0x7a504250, 0x50505088, 0x42507a50, 0x50885050,   /* 14,18 */
0x7a884250, 0x50505088, 0x42507a88, 0x50885050,   /* 14,19 */
0x7a884250, 0x50885088, 0x42507a88, 0x50885088,   /* 14,20 */
0x7a884288, 0x50885088, 0x42887a88, 0x50885088,   /* 14,21 */
0x7a884288, 0x88885088, 0x42887a88, 0x50888888,   /* 14,22 */
0x7a887a88, 0x88885088, 0x7a887a88, 0x50888888,   /* 14,23 */
0x7a887a88, 0x88888888, 0x7a887a88, 0x88888888,   /* 14,24 */
0xb2887a88, 0x88888888, 0x7a88b288, 0x88888888,   /* 14,25 */
0xb2887a88, 0x888888c0, 0x7a88b288, 0x88c08888,   /* 14,26 */
0xb2c07a88, 0x888888c0, 0x7a88b2c0, 0x88c08888,   /* 14,27 */
0xb2c07a88, 0x88c088c0, 0x7a88b2c0, 0x88c088c0,   /* 14,28 */
0xb2c07ac0, 0x88c088c0, 0x7ac0b2c0, 0x88c088c0,   /* 14,29 */
0xb2c07ac0, 0xc0c088c0, 0x7ac0b2c0, 0x88c0c0c0,   /* 14,30 */
0xb2c0b2c0, 0xc0c088c0, 0xb2c0b2c0, 0x88c0c0c0,   /* 14,31 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 0 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 1 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 2 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 3 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 4 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 5 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 6 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 7 */
0x0a181818, 0x18181818, 0x18180a18, 0x18181818,   /* 15, 8 */
0x42181818, 0x18181818, 0x18184218, 0x18181818,   /* 15, 9 */
0x42181818, 0x18181850, 0x18184218, 0x18501818,   /* 15,10 */
0x42501818, 0x18181850, 0x18184250, 0x18501818,   /* 15,11 */
0x42501818, 0x18501850, 0x18184250, 0x18501850,   /* 15,12 */
0x42501850, 0x18501850, 0x18504250, 0x18501850,   /* 15,13 */
0x42501850, 0x50501850, 0x18504250, 0x18505050,   /* 15,14 */
0x42505050, 0x50501850, 0x50504250, 0x18505050,   /* 15,15 */
0x42505050, 0x50505050, 0x50504250, 0x50505050,   /* 15,16 */
0x7a505050, 0x50505050, 0x50507a50, 0x50505050,   /* 15,17 */
0x7a505050, 0x50505088, 0x50507a50, 0x50885050,   /* 15,18 */
0x7a885050, 0x50505088, 0x50507a88, 0x50885050,   /* 15,19 */
0x7a885050, 0x50885088, 0x50507a88, 0x50885088,   /* 15,20 */
0x7a885088, 0x50885088, 0x50887a88, 0x50885088,   /* 15,21 */
0x7a885088, 0x88885088, 0x50887a88, 0x50888888,   /* 15,22 */
0x7a888888, 0x88885088, 0x88887a88, 0x50888888,   /* 15,23 */
0x7a888888, 0x88888888, 0x88887a88, 0x88888888,   /* 15,24 */
0xb2888888, 0x88888888, 0x8888b288, 0x88888888,   /* 15,25 */
0xb2888888, 0x888888c0, 0x8888b288, 0x88c08888,   /* 15,26 */
0xb2c08888, 0x888888c0, 0x8888b2c0, 0x88c08888,   /* 15,27 */
0xb2c08888, 0x88c088c0, 0x8888b2c0, 0x88c088c0,   /* 15,28 */
0xb2c088c0, 0x88c088c0, 0x88c0b2c0, 0x88c088c0,   /* 15,29 */
0xb2c088c0, 0xc0c088c0, 0x88c0b2c0, 0x88c0c0c0,   /* 15,30 */
0xb2c0c0c0, 0xc0c088c0, 0xc0c0b2c0, 0x88c0c0c0,   /* 15,31 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 0 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 1 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 2 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 3 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 4 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 5 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 6 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 7 */
0x18181818, 0x18181818, 0x18181818, 0x18181818,   /* 16, 8 */
0x50181818, 0x18181818, 0x18185018, 0x18181818,   /* 16, 9 */
0x50181818, 0x18181850, 0x18185018, 0x18501818,   /* 16,10 */
0x50501818, 0x18181850, 0x18185050, 0x18501818,   /* 16,11 */
0x50501818, 0x18501850, 0x18185050, 0x18501850,   /* 16,12 */
0x50501850, 0x18501850, 0x18505050, 0x18501850,   /* 16,13 */
0x50501850, 0x50501850, 0x18505050, 0x18505050,   /* 16,14 */
0x50505050, 0x50501850, 0x50505050, 0x18505050,   /* 16,15 */
0x50505050, 0x50505050, 0x50505050, 0x50505050,   /* 16,16 */
0x88505050, 0x50505050, 0x50508850, 0x50505050,   /* 16,17 */
0x88505050, 0x50505088, 0x50508850, 0x50885050,   /* 16,18 */
0x88885050, 0x50505088, 0x50508888, 0x50885050,   /* 16,19 */
0x88885050, 0x50885088, 0x50508888, 0x50885088,   /* 16,20 */
0x88885088, 0x50885088, 0x50888888, 0x50885088,   /* 16,21 */
0x88885088, 0x88885088, 0x50888888, 0x50888888,   /* 16,22 */
0x88888888, 0x88885088, 0x88888888, 0x50888888,   /* 16,23 */
0x88888888, 0x88888888, 0x88888888, 0x88888888,   /* 16,24 */
0xc0888888, 0x88888888, 0x8888c088, 0x88888888,   /* 16,25 */
0xc0888888, 0x888888c0, 0x8888c088, 0x88c08888,   /* 16,26 */
0xc0c08888, 0x888888c0, 0x8888c0c0, 0x88c08888,   /* 16,27 */
0xc0c08888, 0x88c088c0, 0x8888c0c0, 0x88c088c0,   /* 16,28 */
0xc0c088c0, 0x88c088c0, 0x88c0c0c0, 0x88c088c0,   /* 16,29 */
0xc0c088c0, 0xc0c088c0, 0x88c0c0c0, 0x88c0c0c0,   /* 16,30 */
0xc0c0c0c0, 0xc0c088c0, 0xc0c0c0c0, 0x88c0c0c0,   /* 16,31 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 0 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 1 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 2 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 3 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 4 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 5 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 6 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 7 */
0x18181818, 0x18182618, 0x18181818, 0x26181818,   /* 17, 8 */
0x50181818, 0x18182618, 0x18185018, 0x26181818,   /* 17, 9 */
0x50181818, 0x18182650, 0x18185018, 0x26501818,   /* 17,10 */
0x50501818, 0x18182650, 0x18185050, 0x26501818,   /* 17,11 */
0x50501818, 0x18502650, 0x18185050, 0x26501850,   /* 17,12 */
0x50501850, 0x18502650, 0x18505050, 0x26501850,   /* 17,13 */
0x50501850, 0x50502650, 0x18505050, 0x26505050,   /* 17,14 */
0x50505050, 0x50502650, 0x50505050, 0x26505050,   /* 17,15 */
0x50505050, 0x50505e50, 0x50505050, 0x5e505050,   /* 17,16 */
0x88505050, 0x50505e50, 0x50508850, 0x5e505050,   /* 17,17 */
0x88505050, 0x50505e88, 0x50508850, 0x5e885050,   /* 17,18 */
0x88885050, 0x50505e88, 0x50508888, 0x5e885050,   /* 17,19 */
0x88885050, 0x50885e88, 0x50508888, 0x5e885088,   /* 17,20 */
0x88885088, 0x50885e88, 0x50888888, 0x5e885088,   /* 17,21 */
0x88885088, 0x88885e88, 0x50888888, 0x5e888888,   /* 17,22 */
0x88888888, 0x88885e88, 0x88888888, 0x5e888888,   /* 17,23 */
0x88888888, 0x88889688, 0x88888888, 0x96888888,   /* 17,24 */
0xc0888888, 0x88889688, 0x8888c088, 0x96888888,   /* 17,25 */
0xc0888888, 0x888896c0, 0x8888c088, 0x96c08888,   /* 17,26 */
0xc0c08888, 0x888896c0, 0x8888c0c0, 0x96c08888,   /* 17,27 */
0xc0c08888, 0x88c096c0, 0x8888c0c0, 0x96c088c0,   /* 17,28 */
0xc0c088c0, 0x88c096c0, 0x88c0c0c0, 0x96c088c0,   /* 17,29 */
0xc0c088c0, 0xc0c096c0, 0x88c0c0c0, 0x96c0c0c0,   /* 17,30 */
0xc0c0c0c0, 0xc0c096c0, 0xc0c0c0c0, 0x96c0c0c0,   /* 17,31 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 0 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 1 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 2 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 3 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 4 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 5 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 6 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 7 */
0x18181818, 0x18182626, 0x18181818, 0x26261818,   /* 18, 8 */
0x50181818, 0x18182626, 0x18185018, 0x26261818,   /* 18, 9 */
0x50181818, 0x1818265e, 0x18185018, 0x265e1818,   /* 18,10 */
0x50501818, 0x1818265e, 0x18185050, 0x265e1818,   /* 18,11 */
0x50501818, 0x1850265e, 0x18185050, 0x265e1850,   /* 18,12 */
0x50501850, 0x1850265e, 0x18505050, 0x265e1850,   /* 18,13 */
0x50501850, 0x5050265e, 0x18505050, 0x265e5050,   /* 18,14 */
0x50505050, 0x5050265e, 0x50505050, 0x265e5050,   /* 18,15 */
0x50505050, 0x50505e5e, 0x50505050, 0x5e5e5050,   /* 18,16 */
0x88505050, 0x50505e5e, 0x50508850, 0x5e5e5050,   /* 18,17 */
0x88505050, 0x50505e96, 0x50508850, 0x5e965050,   /* 18,18 */
0x88885050, 0x50505e96, 0x50508888, 0x5e965050,   /* 18,19 */
0x88885050, 0x50885e96, 0x50508888, 0x5e965088,   /* 18,20 */
0x88885088, 0x50885e96, 0x50888888, 0x5e965088,   /* 18,21 */
0x88885088, 0x88885e96, 0x50888888, 0x5e968888,   /* 18,22 */
0x88888888, 0x88885e96, 0x88888888, 0x5e968888,   /* 18,23 */
0x88888888, 0x88889696, 0x88888888, 0x96968888,   /* 18,24 */
0xc0888888, 0x88889696, 0x8888c088, 0x96968888,   /* 18,25 */
0xc0888888, 0x888896ce, 0x8888c088, 0x96ce8888,   /* 18,26 */
0xc0c08888, 0x888896ce, 0x8888c0c0, 0x96ce8888,   /* 18,27 */
0xc0c08888, 0x88c096ce, 0x8888c0c0, 0x96ce88c0,   /* 18,28 */
0xc0c088c0, 0x88c096ce, 0x88c0c0c0, 0x96ce88c0,   /* 18,29 */
0xc0c088c0, 0xc0c096ce, 0x88c0c0c0, 0x96cec0c0,   /* 18,30 */
0xc0c0c0c0, 0xc0c096ce, 0xc0c0c0c0, 0x96cec0c0,   /* 18,31 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 0 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 1 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 2 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 3 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 4 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 5 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 6 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 7 */
0x18181826, 0x18182626, 0x18261818, 0x26261818,   /* 19, 8 */
0x50181826, 0x18182626, 0x18265018, 0x26261818,   /* 19, 9 */
0x50181826, 0x1818265e, 0x18265018, 0x265e1818,   /* 19,10 */
0x50501826, 0x1818265e, 0x18265050, 0x265e1818,   /* 19,11 */
0x50501826, 0x1850265e, 0x18265050, 0x265e1850,   /* 19,12 */
0x5050185e, 0x1850265e, 0x185e5050, 0x265e1850,   /* 19,13 */
0x5050185e, 0x5050265e, 0x185e5050, 0x265e5050,   /* 19,14 */
0x5050505e, 0x5050265e, 0x505e5050, 0x265e5050,   /* 19,15 */
0x5050505e, 0x50505e5e, 0x505e5050, 0x5e5e5050,   /* 19,16 */
0x8850505e, 0x50505e5e, 0x505e8850, 0x5e5e5050,   /* 19,17 */
0x8850505e, 0x50505e96, 0x505e8850, 0x5e965050,   /* 19,18 */
0x8888505e, 0x50505e96, 0x505e8888, 0x5e965050,   /* 19,19 */
0x8888505e, 0x50885e96, 0x505e8888, 0x5e965088,   /* 19,20 */
0x88885096, 0x50885e96, 0x50968888, 0x5e965088,   /* 19,21 */
0x88885096, 0x88885e96, 0x50968888, 0x5e968888,   /* 19,22 */
0x88888896, 0x88885e96, 0x88968888, 0x5e968888,   /* 19,23 */
0x88888896, 0x88889696, 0x88968888, 0x96968888,   /* 19,24 */
0xc0888896, 0x88889696, 0x8896c088, 0x96968888,   /* 19,25 */
0xc0888896, 0x888896ce, 0x8896c088, 0x96ce8888,   /* 19,26 */
0xc0c08896, 0x888896ce, 0x8896c0c0, 0x96ce8888,   /* 19,27 */
0xc0c08896, 0x88c096ce, 0x8896c0c0, 0x96ce88c0,   /* 19,28 */
0xc0c088ce, 0x88c096ce, 0x88cec0c0, 0x96ce88c0,   /* 19,29 */
0xc0c088ce, 0xc0c096ce, 0x88cec0c0, 0x96cec0c0,   /* 19,30 */
0xc0c0c0ce, 0xc0c096ce, 0xc0cec0c0, 0x96cec0c0,   /* 19,31 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 0 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 1 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 2 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 3 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 4 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 5 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 6 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 7 */
0x18181826, 0x26182626, 0x18261818, 0x26262618,   /* 20, 8 */
0x50181826, 0x26182626, 0x18265018, 0x26262618,   /* 20, 9 */
0x50181826, 0x2618265e, 0x18265018, 0x265e2618,   /* 20,10 */
0x50501826, 0x2618265e, 0x18265050, 0x265e2618,   /* 20,11 */
0x50501826, 0x2650265e, 0x18265050, 0x265e2650,   /* 20,12 */
0x5050185e, 0x2650265e, 0x185e5050, 0x265e2650,   /* 20,13 */
0x5050185e, 0x5e50265e, 0x185e5050, 0x265e5e50,   /* 20,14 */
0x5050505e, 0x5e50265e, 0x505e5050, 0x265e5e50,   /* 20,15 */
0x5050505e, 0x5e505e5e, 0x505e5050, 0x5e5e5e50,   /* 20,16 */
0x8850505e, 0x5e505e5e, 0x505e8850, 0x5e5e5e50,   /* 20,17 */
0x8850505e, 0x5e505e96, 0x505e8850, 0x5e965e50,   /* 20,18 */
0x8888505e, 0x5e505e96, 0x505e8888, 0x5e965e50,   /* 20,19 */
0x8888505e, 0x5e885e96, 0x505e8888, 0x5e965e88,   /* 20,20 */
0x88885096, 0x5e885e96, 0x50968888, 0x5e965e88,   /* 20,21 */
0x88885096, 0x96885e96, 0x50968888, 0x5e969688,   /* 20,22 */
0x88888896, 0x96885e96, 0x88968888, 0x5e969688,   /* 20,23 */
0x88888896, 0x96889696, 0x88968888, 0x96969688,   /* 20,24 */
0xc0888896, 0x96889696, 0x8896c088, 0x96969688,   /* 20,25 */
0xc0888896, 0x968896ce, 0x8896c088, 0x96ce9688,   /* 20,26 */
0xc0c08896, 0x968896ce, 0x8896c0c0, 0x96ce9688,   /* 20,27 */
0xc0c08896, 0x96c096ce, 0x8896c0c0, 0x96ce96c0,   /* 20,28 */
0xc0c088ce, 0x96c096ce, 0x88cec0c0, 0x96ce96c0,   /* 20,29 */
0xc0c088ce, 0xcec096ce, 0x88cec0c0, 0x96cecec0,   /* 20,30 */
0xc0c0c0ce, 0xcec096ce, 0xc0cec0c0, 0x96cecec0,   /* 20,31 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 0 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 1 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 2 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 3 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 4 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 5 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 6 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 7 */
0x18261826, 0x26182626, 0x18261826, 0x26262618,   /* 21, 8 */
0x50261826, 0x26182626, 0x18265026, 0x26262618,   /* 21, 9 */
0x50261826, 0x2618265e, 0x18265026, 0x265e2618,   /* 21,10 */
0x505e1826, 0x2618265e, 0x1826505e, 0x265e2618,   /* 21,11 */
0x505e1826, 0x2650265e, 0x1826505e, 0x265e2650,   /* 21,12 */
0x505e185e, 0x2650265e, 0x185e505e, 0x265e2650,   /* 21,13 */
0x505e185e, 0x5e50265e, 0x185e505e, 0x265e5e50,   /* 21,14 */
0x505e505e, 0x5e50265e, 0x505e505e, 0x265e5e50,   /* 21,15 */
0x505e505e, 0x5e505e5e, 0x505e505e, 0x5e5e5e50,   /* 21,16 */
0x885e505e, 0x5e505e5e, 0x505e885e, 0x5e5e5e50,   /* 21,17 */
0x885e505e, 0x5e505e96, 0x505e885e, 0x5e965e50,   /* 21,18 */
0x8896505e, 0x5e505e96, 0x505e8896, 0x5e965e50,   /* 21,19 */
0x8896505e, 0x5e885e96, 0x505e8896, 0x5e965e88,   /* 21,20 */
0x88965096, 0x5e885e96, 0x50968896, 0x5e965e88,   /* 21,21 */
0x88965096, 0x96885e96, 0x50968896, 0x5e969688,   /* 21,22 */
0x88968896, 0x96885e96, 0x88968896, 0x5e969688,   /* 21,23 */
0x88968896, 0x96889696, 0x88968896, 0x96969688,   /* 21,24 */
0xc0968896, 0x96889696, 0x8896c096, 0x96969688,   /* 21,25 */
0xc0968896, 0x968896ce, 0x8896c096, 0x96ce9688,   /* 21,26 */
0xc0ce8896, 0x968896ce, 0x8896c0ce, 0x96ce9688,   /* 21,27 */
0xc0ce8896, 0x96c096ce, 0x8896c0ce, 0x96ce96c0,   /* 21,28 */
0xc0ce88ce, 0x96c096ce, 0x88cec0ce, 0x96ce96c0,   /* 21,29 */
0xc0ce88ce, 0xcec096ce, 0x88cec0ce, 0x96cecec0,   /* 21,30 */
0xc0cec0ce, 0xcec096ce, 0xc0cec0ce, 0x96cecec0,   /* 21,31 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 0 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 1 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 2 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 3 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 4 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 5 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 6 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 7 */
0x18261826, 0x26262626, 0x18261826, 0x26262626,   /* 22, 8 */
0x50261826, 0x26262626, 0x18265026, 0x26262626,   /* 22, 9 */
0x50261826, 0x2626265e, 0x18265026, 0x265e2626,   /* 22,10 */
0x505e1826, 0x2626265e, 0x1826505e, 0x265e2626,   /* 22,11 */
0x505e1826, 0x265e265e, 0x1826505e, 0x265e265e,   /* 22,12 */
0x505e185e, 0x265e265e, 0x185e505e, 0x265e265e,   /* 22,13 */
0x505e185e, 0x5e5e265e, 0x185e505e, 0x265e5e5e,   /* 22,14 */
0x505e505e, 0x5e5e265e, 0x505e505e, 0x265e5e5e,   /* 22,15 */
0x505e505e, 0x5e5e5e5e, 0x505e505e, 0x5e5e5e5e,   /* 22,16 */
0x885e505e, 0x5e5e5e5e, 0x505e885e, 0x5e5e5e5e,   /* 22,17 */
0x885e505e, 0x5e5e5e96, 0x505e885e, 0x5e965e5e,   /* 22,18 */
0x8896505e, 0x5e5e5e96, 0x505e8896, 0x5e965e5e,   /* 22,19 */
0x8896505e, 0x5e965e96, 0x505e8896, 0x5e965e96,   /* 22,20 */
0x88965096, 0x5e965e96, 0x50968896, 0x5e965e96,   /* 22,21 */
0x88965096, 0x96965e96, 0x50968896, 0x5e969696,   /* 22,22 */
0x88968896, 0x96965e96, 0x88968896, 0x5e969696,   /* 22,23 */
0x88968896, 0x96969696, 0x88968896, 0x96969696,   /* 22,24 */
0xc0968896, 0x96969696, 0x8896c096, 0x96969696,   /* 22,25 */
0xc0968896, 0x969696ce, 0x8896c096, 0x96ce9696,   /* 22,26 */
0xc0ce8896, 0x969696ce, 0x8896c0ce, 0x96ce9696,   /* 22,27 */
0xc0ce8896, 0x96ce96ce, 0x8896c0ce, 0x96ce96ce,   /* 22,28 */
0xc0ce88ce, 0x96ce96ce, 0x88cec0ce, 0x96ce96ce,   /* 22,29 */
0xc0ce88ce, 0xcece96ce, 0x88cec0ce, 0x96cecece,   /* 22,30 */
0xc0cec0ce, 0xcece96ce, 0xc0cec0ce, 0x96cecece,   /* 22,31 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 0 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 1 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 2 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 3 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 4 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 5 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 6 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 7 */
0x18262626, 0x26262626, 0x26261826, 0x26262626,   /* 23, 8 */
0x50262626, 0x26262626, 0x26265026, 0x26262626,   /* 23, 9 */
0x50262626, 0x2626265e, 0x26265026, 0x265e2626,   /* 23,10 */
0x505e2626, 0x2626265e, 0x2626505e, 0x265e2626,   /* 23,11 */
0x505e2626, 0x265e265e, 0x2626505e, 0x265e265e,   /* 23,12 */
0x505e265e, 0x265e265e, 0x265e505e, 0x265e265e,   /* 23,13 */
0x505e265e, 0x5e5e265e, 0x265e505e, 0x265e5e5e,   /* 23,14 */
0x505e5e5e, 0x5e5e265e, 0x5e5e505e, 0x265e5e5e,   /* 23,15 */
0x505e5e5e, 0x5e5e5e5e, 0x5e5e505e, 0x5e5e5e5e,   /* 23,16 */
0x885e5e5e, 0x5e5e5e5e, 0x5e5e885e, 0x5e5e5e5e,   /* 23,17 */
0x885e5e5e, 0x5e5e5e96, 0x5e5e885e, 0x5e965e5e,   /* 23,18 */
0x88965e5e, 0x5e5e5e96, 0x5e5e8896, 0x5e965e5e,   /* 23,19 */
0x88965e5e, 0x5e965e96, 0x5e5e8896, 0x5e965e96,   /* 23,20 */
0x88965e96, 0x5e965e96, 0x5e968896, 0x5e965e96,   /* 23,21 */
0x88965e96, 0x96965e96, 0x5e968896, 0x5e969696,   /* 23,22 */
0x88969696, 0x96965e96, 0x96968896, 0x5e969696,   /* 23,23 */
0x88969696, 0x96969696, 0x96968896, 0x96969696,   /* 23,24 */
0xc0969696, 0x96969696, 0x9696c096, 0x96969696,   /* 23,25 */
0xc0969696, 0x969696ce, 0x9696c096, 0x96ce9696,   /* 23,26 */
0xc0ce9696, 0x969696ce, 0x9696c0ce, 0x96ce9696,   /* 23,27 */
0xc0ce9696, 0x96ce96ce, 0x9696c0ce, 0x96ce96ce,   /* 23,28 */
0xc0ce96ce, 0x96ce96ce, 0x96cec0ce, 0x96ce96ce,   /* 23,29 */
0xc0ce96ce, 0xcece96ce, 0x96cec0ce, 0x96cecece,   /* 23,30 */
0xc0cecece, 0xcece96ce, 0xcecec0ce, 0x96cecece,   /* 23,31 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 0 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 1 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 2 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 3 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 4 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 5 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 6 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 7 */
0x26262626, 0x26262626, 0x26262626, 0x26262626,   /* 24, 8 */
0x5e262626, 0x26262626, 0x26265e26, 0x26262626,   /* 24, 9 */
0x5e262626, 0x2626265e, 0x26265e26, 0x265e2626,   /* 24,10 */
0x5e5e2626, 0x2626265e, 0x26265e5e, 0x265e2626,   /* 24,11 */
0x5e5e2626, 0x265e265e, 0x26265e5e, 0x265e265e,   /* 24,12 */
0x5e5e265e, 0x265e265e, 0x265e5e5e, 0x265e265e,   /* 24,13 */
0x5e5e265e, 0x5e5e265e, 0x265e5e5e, 0x265e5e5e,   /* 24,14 */
0x5e5e5e5e, 0x5e5e265e, 0x5e5e5e5e, 0x265e5e5e,   /* 24,15 */
0x5e5e5e5e, 0x5e5e5e5e, 0x5e5e5e5e, 0x5e5e5e5e,   /* 24,16 */
0x965e5e5e, 0x5e5e5e5e, 0x5e5e965e, 0x5e5e5e5e,   /* 24,17 */
0x965e5e5e, 0x5e5e5e96, 0x5e5e965e, 0x5e965e5e,   /* 24,18 */
0x96965e5e, 0x5e5e5e96, 0x5e5e9696, 0x5e965e5e,   /* 24,19 */
0x96965e5e, 0x5e965e96, 0x5e5e9696, 0x5e965e96,   /* 24,20 */
0x96965e96, 0x5e965e96, 0x5e969696, 0x5e965e96,   /* 24,21 */
0x96965e96, 0x96965e96, 0x5e969696, 0x5e969696,   /* 24,22 */
0x96969696, 0x96965e96, 0x96969696, 0x5e969696,   /* 24,23 */
0x96969696, 0x96969696, 0x96969696, 0x96969696,   /* 24,24 */
0xce969696, 0x96969696, 0x9696ce96, 0x96969696,   /* 24,25 */
0xce969696, 0x969696ce, 0x9696ce96, 0x96ce9696,   /* 24,26 */
0xcece9696, 0x969696ce, 0x9696cece, 0x96ce9696,   /* 24,27 */
0xcece9696, 0x96ce96ce, 0x9696cece, 0x96ce96ce,   /* 24,28 */
0xcece96ce, 0x96ce96ce, 0x96cecece, 0x96ce96ce,   /* 24,29 */
0xcece96ce, 0xcece96ce, 0x96cecece, 0x96cecece,   /* 24,30 */
0xcececece, 0xcece96ce, 0xcececece, 0x96cecece,   /* 24,31 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 0 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 1 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 2 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 3 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 4 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 5 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 6 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 7 */
0x26262626, 0x26263426, 0x26262626, 0x34262626,   /* 25, 8 */
0x5e262626, 0x26263426, 0x26265e26, 0x34262626,   /* 25, 9 */
0x5e262626, 0x2626345e, 0x26265e26, 0x345e2626,   /* 25,10 */
0x5e5e2626, 0x2626345e, 0x26265e5e, 0x345e2626,   /* 25,11 */
0x5e5e2626, 0x265e345e, 0x26265e5e, 0x345e265e,   /* 25,12 */
0x5e5e265e, 0x265e345e, 0x265e5e5e, 0x345e265e,   /* 25,13 */
0x5e5e265e, 0x5e5e345e, 0x265e5e5e, 0x345e5e5e,   /* 25,14 */
0x5e5e5e5e, 0x5e5e345e, 0x5e5e5e5e, 0x345e5e5e,   /* 25,15 */
0x5e5e5e5e, 0x5e5e6c5e, 0x5e5e5e5e, 0x6c5e5e5e,   /* 25,16 */
0x965e5e5e, 0x5e5e6c5e, 0x5e5e965e, 0x6c5e5e5e,   /* 25,17 */
0x965e5e5e, 0x5e5e6c96, 0x5e5e965e, 0x6c965e5e,   /* 25,18 */
0x96965e5e, 0x5e5e6c96, 0x5e5e9696, 0x6c965e5e,   /* 25,19 */
0x96965e5e, 0x5e966c96, 0x5e5e9696, 0x6c965e96,   /* 25,20 */
0x96965e96, 0x5e966c96, 0x5e969696, 0x6c965e96,   /* 25,21 */
0x96965e96, 0x96966c96, 0x5e969696, 0x6c969696,   /* 25,22 */
0x96969696, 0x96966c96, 0x96969696, 0x6c969696,   /* 25,23 */
0x96969696, 0x9696a496, 0x96969696, 0xa4969696,   /* 25,24 */
0xce969696, 0x9696a496, 0x9696ce96, 0xa4969696,   /* 25,25 */
0xce969696, 0x9696a4ce, 0x9696ce96, 0xa4ce9696,   /* 25,26 */
0xcece9696, 0x9696a4ce, 0x9696cece, 0xa4ce9696,   /* 25,27 */
0xcece9696, 0x96cea4ce, 0x9696cece, 0xa4ce96ce,   /* 25,28 */
0xcece96ce, 0x96cea4ce, 0x96cecece, 0xa4ce96ce,   /* 25,29 */
0xcece96ce, 0xcecea4ce, 0x96cecece, 0xa4cecece,   /* 25,30 */
0xcececece, 0xcecea4ce, 0xcececece, 0xa4cecece,   /* 25,31 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 0 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 1 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 2 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 3 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 4 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 5 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 6 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 7 */
0x26262626, 0x26263434, 0x26262626, 0x34342626,   /* 26, 8 */
0x5e262626, 0x26263434, 0x26265e26, 0x34342626,   /* 26, 9 */
0x5e262626, 0x2626346c, 0x26265e26, 0x346c2626,   /* 26,10 */
0x5e5e2626, 0x2626346c, 0x26265e5e, 0x346c2626,   /* 26,11 */
0x5e5e2626, 0x265e346c, 0x26265e5e, 0x346c265e,   /* 26,12 */
0x5e5e265e, 0x265e346c, 0x265e5e5e, 0x346c265e,   /* 26,13 */
0x5e5e265e, 0x5e5e346c, 0x265e5e5e, 0x346c5e5e,   /* 26,14 */
0x5e5e5e5e, 0x5e5e346c, 0x5e5e5e5e, 0x346c5e5e,   /* 26,15 */
0x5e5e5e5e, 0x5e5e6c6c, 0x5e5e5e5e, 0x6c6c5e5e,   /* 26,16 */
0x965e5e5e, 0x5e5e6c6c, 0x5e5e965e, 0x6c6c5e5e,   /* 26,17 */
0x965e5e5e, 0x5e5e6ca4, 0x5e5e965e, 0x6ca45e5e,   /* 26,18 */
0x96965e5e, 0x5e5e6ca4, 0x5e5e9696, 0x6ca45e5e,   /* 26,19 */
0x96965e5e, 0x5e966ca4, 0x5e5e9696, 0x6ca45e96,   /* 26,20 */
0x96965e96, 0x5e966ca4, 0x5e969696, 0x6ca45e96,   /* 26,21 */
0x96965e96, 0x96966ca4, 0x5e969696, 0x6ca49696,   /* 26,22 */
0x96969696, 0x96966ca4, 0x96969696, 0x6ca49696,   /* 26,23 */
0x96969696, 0x9696a4a4, 0x96969696, 0xa4a49696,   /* 26,24 */
0xce969696, 0x9696a4a4, 0x9696ce96, 0xa4a49696,   /* 26,25 */
0xce969696, 0x9696a4dc, 0x9696ce96, 0xa4dc9696,   /* 26,26 */
0xcece9696, 0x9696a4dc, 0x9696cece, 0xa4dc9696,   /* 26,27 */
0xcece9696, 0x96cea4dc, 0x9696cece, 0xa4dc96ce,   /* 26,28 */
0xcece96ce, 0x96cea4dc, 0x96cecece, 0xa4dc96ce,   /* 26,29 */
0xcece96ce, 0xcecea4dc, 0x96cecece, 0xa4dccece,   /* 26,30 */
0xcececece, 0xcecea4dc, 0xcececece, 0xa4dccece,   /* 26,31 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 0 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 1 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 2 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 3 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 4 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 5 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 6 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 7 */
0x26262634, 0x26263434, 0x26342626, 0x34342626,   /* 27, 8 */
0x5e262634, 0x26263434, 0x26345e26, 0x34342626,   /* 27, 9 */
0x5e262634, 0x2626346c, 0x26345e26, 0x346c2626,   /* 27,10 */
0x5e5e2634, 0x2626346c, 0x26345e5e, 0x346c2626,   /* 27,11 */
0x5e5e2634, 0x265e346c, 0x26345e5e, 0x346c265e,   /* 27,12 */
0x5e5e266c, 0x265e346c, 0x266c5e5e, 0x346c265e,   /* 27,13 */
0x5e5e266c, 0x5e5e346c, 0x266c5e5e, 0x346c5e5e,   /* 27,14 */
0x5e5e5e6c, 0x5e5e346c, 0x5e6c5e5e, 0x346c5e5e,   /* 27,15 */
0x5e5e5e6c, 0x5e5e6c6c, 0x5e6c5e5e, 0x6c6c5e5e,   /* 27,16 */
0x965e5e6c, 0x5e5e6c6c, 0x5e6c965e, 0x6c6c5e5e,   /* 27,17 */
0x965e5e6c, 0x5e5e6ca4, 0x5e6c965e, 0x6ca45e5e,   /* 27,18 */
0x96965e6c, 0x5e5e6ca4, 0x5e6c9696, 0x6ca45e5e,   /* 27,19 */
0x96965e6c, 0x5e966ca4, 0x5e6c9696, 0x6ca45e96,   /* 27,20 */
0x96965ea4, 0x5e966ca4, 0x5ea49696, 0x6ca45e96,   /* 27,21 */
0x96965ea4, 0x96966ca4, 0x5ea49696, 0x6ca49696,   /* 27,22 */
0x969696a4, 0x96966ca4, 0x96a49696, 0x6ca49696,   /* 27,23 */
0x969696a4, 0x9696a4a4, 0x96a49696, 0xa4a49696,   /* 27,24 */
0xce9696a4, 0x9696a4a4, 0x96a4ce96, 0xa4a49696,   /* 27,25 */
0xce9696a4, 0x9696a4dc, 0x96a4ce96, 0xa4dc9696,   /* 27,26 */
0xcece96a4, 0x9696a4dc, 0x96a4cece, 0xa4dc9696,   /* 27,27 */
0xcece96a4, 0x96cea4dc, 0x96a4cece, 0xa4dc96ce,   /* 27,28 */
0xcece96dc, 0x96cea4dc, 0x96dccece, 0xa4dc96ce,   /* 27,29 */
0xcece96dc, 0xcecea4dc, 0x96dccece, 0xa4dccece,   /* 27,30 */
0xcececedc, 0xcecea4dc, 0xcedccece, 0xa4dccece,   /* 27,31 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 0 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 1 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 2 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 3 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 4 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 5 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 6 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 7 */
0x26262634, 0x34263434, 0x26342626, 0x34343426,   /* 28, 8 */
0x5e262634, 0x34263434, 0x26345e26, 0x34343426,   /* 28, 9 */
0x5e262634, 0x3426346c, 0x26345e26, 0x346c3426,   /* 28,10 */
0x5e5e2634, 0x3426346c, 0x26345e5e, 0x346c3426,   /* 28,11 */
0x5e5e2634, 0x345e346c, 0x26345e5e, 0x346c345e,   /* 28,12 */
0x5e5e266c, 0x345e346c, 0x266c5e5e, 0x346c345e,   /* 28,13 */
0x5e5e266c, 0x6c5e346c, 0x266c5e5e, 0x346c6c5e,   /* 28,14 */
0x5e5e5e6c, 0x6c5e346c, 0x5e6c5e5e, 0x346c6c5e,   /* 28,15 */
0x5e5e5e6c, 0x6c5e6c6c, 0x5e6c5e5e, 0x6c6c6c5e,   /* 28,16 */
0x965e5e6c, 0x6c5e6c6c, 0x5e6c965e, 0x6c6c6c5e,   /* 28,17 */
0x965e5e6c, 0x6c5e6ca4, 0x5e6c965e, 0x6ca46c5e,   /* 28,18 */
0x96965e6c, 0x6c5e6ca4, 0x5e6c9696, 0x6ca46c5e,   /* 28,19 */
0x96965e6c, 0x6c966ca4, 0x5e6c9696, 0x6ca46c96,   /* 28,20 */
0x96965ea4, 0x6c966ca4, 0x5ea49696, 0x6ca46c96,   /* 28,21 */
0x96965ea4, 0xa4966ca4, 0x5ea49696, 0x6ca4a496,   /* 28,22 */
0x969696a4, 0xa4966ca4, 0x96a49696, 0x6ca4a496,   /* 28,23 */
0x969696a4, 0xa496a4a4, 0x96a49696, 0xa4a4a496,   /* 28,24 */
0xce9696a4, 0xa496a4a4, 0x96a4ce96, 0xa4a4a496,   /* 28,25 */
0xce9696a4, 0xa496a4dc, 0x96a4ce96, 0xa4dca496,   /* 28,26 */
0xcece96a4, 0xa496a4dc, 0x96a4cece, 0xa4dca496,   /* 28,27 */
0xcece96a4, 0xa4cea4dc, 0x96a4cece, 0xa4dca4ce,   /* 28,28 */
0xcece96dc, 0xa4cea4dc, 0x96dccece, 0xa4dca4ce,   /* 28,29 */
0xcece96dc, 0xdccea4dc, 0x96dccece, 0xa4dcdcce,   /* 28,30 */
0xcececedc, 0xdccea4dc, 0xcedccece, 0xa4dcdcce,   /* 28,31 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 0 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 1 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 2 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 3 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 4 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 5 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 6 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 7 */
0x26342634, 0x34263434, 0x26342634, 0x34343426,   /* 29, 8 */
0x5e342634, 0x34263434, 0x26345e34, 0x34343426,   /* 29, 9 */
0x5e342634, 0x3426346c, 0x26345e34, 0x346c3426,   /* 29,10 */
0x5e6c2634, 0x3426346c, 0x26345e6c, 0x346c3426,   /* 29,11 */
0x5e6c2634, 0x345e346c, 0x26345e6c, 0x346c345e,   /* 29,12 */
0x5e6c266c, 0x345e346c, 0x266c5e6c, 0x346c345e,   /* 29,13 */
0x5e6c266c, 0x6c5e346c, 0x266c5e6c, 0x346c6c5e,   /* 29,14 */
0x5e6c5e6c, 0x6c5e346c, 0x5e6c5e6c, 0x346c6c5e,   /* 29,15 */
0x5e6c5e6c, 0x6c5e6c6c, 0x5e6c5e6c, 0x6c6c6c5e,   /* 29,16 */
0x966c5e6c, 0x6c5e6c6c, 0x5e6c966c, 0x6c6c6c5e,   /* 29,17 */
0x966c5e6c, 0x6c5e6ca4, 0x5e6c966c, 0x6ca46c5e,   /* 29,18 */
0x96a45e6c, 0x6c5e6ca4, 0x5e6c96a4, 0x6ca46c5e,   /* 29,19 */
0x96a45e6c, 0x6c966ca4, 0x5e6c96a4, 0x6ca46c96,   /* 29,20 */
0x96a45ea4, 0x6c966ca4, 0x5ea496a4, 0x6ca46c96,   /* 29,21 */
0x96a45ea4, 0xa4966ca4, 0x5ea496a4, 0x6ca4a496,   /* 29,22 */
0x96a496a4, 0xa4966ca4, 0x96a496a4, 0x6ca4a496,   /* 29,23 */
0x96a496a4, 0xa496a4a4, 0x96a496a4, 0xa4a4a496,   /* 29,24 */
0xcea496a4, 0xa496a4a4, 0x96a4cea4, 0xa4a4a496,   /* 29,25 */
0xcea496a4, 0xa496a4dc, 0x96a4cea4, 0xa4dca496,   /* 29,26 */
0xcedc96a4, 0xa496a4dc, 0x96a4cedc, 0xa4dca496,   /* 29,27 */
0xcedc96a4, 0xa4cea4dc, 0x96a4cedc, 0xa4dca4ce,   /* 29,28 */
0xcedc96dc, 0xa4cea4dc, 0x96dccedc, 0xa4dca4ce,   /* 29,29 */
0xcedc96dc, 0xdccea4dc, 0x96dccedc, 0xa4dcdcce,   /* 29,30 */
0xcedccedc, 0xdccea4dc, 0xcedccedc, 0xa4dcdcce,   /* 29,31 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 0 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 1 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 2 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 3 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 4 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 5 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 6 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 7 */
0x26342634, 0x34343434, 0x26342634, 0x34343434,   /* 30, 8 */
0x5e342634, 0x34343434, 0x26345e34, 0x34343434,   /* 30, 9 */
0x5e342634, 0x3434346c, 0x26345e34, 0x346c3434,   /* 30,10 */
0x5e6c2634, 0x3434346c, 0x26345e6c, 0x346c3434,   /* 30,11 */
0x5e6c2634, 0x346c346c, 0x26345e6c, 0x346c346c,   /* 30,12 */
0x5e6c266c, 0x346c346c, 0x266c5e6c, 0x346c346c,   /* 30,13 */
0x5e6c266c, 0x6c6c346c, 0x266c5e6c, 0x346c6c6c,   /* 30,14 */
0x5e6c5e6c, 0x6c6c346c, 0x5e6c5e6c, 0x346c6c6c,   /* 30,15 */
0x5e6c5e6c, 0x6c6c6c6c, 0x5e6c5e6c, 0x6c6c6c6c,   /* 30,16 */
0x966c5e6c, 0x6c6c6c6c, 0x5e6c966c, 0x6c6c6c6c,   /* 30,17 */
0x966c5e6c, 0x6c6c6ca4, 0x5e6c966c, 0x6ca46c6c,   /* 30,18 */
0x96a45e6c, 0x6c6c6ca4, 0x5e6c96a4, 0x6ca46c6c,   /* 30,19 */
0x96a45e6c, 0x6ca46ca4, 0x5e6c96a4, 0x6ca46ca4,   /* 30,20 */
0x96a45ea4, 0x6ca46ca4, 0x5ea496a4, 0x6ca46ca4,   /* 30,21 */
0x96a45ea4, 0xa4a46ca4, 0x5ea496a4, 0x6ca4a4a4,   /* 30,22 */
0x96a496a4, 0xa4a46ca4, 0x96a496a4, 0x6ca4a4a4,   /* 30,23 */
0x96a496a4, 0xa4a4a4a4, 0x96a496a4, 0xa4a4a4a4,   /* 30,24 */
0xcea496a4, 0xa4a4a4a4, 0x96a4cea4, 0xa4a4a4a4,   /* 30,25 */
0xcea496a4, 0xa4a4a4dc, 0x96a4cea4, 0xa4dca4a4,   /* 30,26 */
0xcedc96a4, 0xa4a4a4dc, 0x96a4cedc, 0xa4dca4a4,   /* 30,27 */
0xcedc96a4, 0xa4dca4dc, 0x96a4cedc, 0xa4dca4dc,   /* 30,28 */
0xcedc96dc, 0xa4dca4dc, 0x96dccedc, 0xa4dca4dc,   /* 30,29 */
0xcedc96dc, 0xdcdca4dc, 0x96dccedc, 0xa4dcdcdc,   /* 30,30 */
0xcedccedc, 0xdcdca4dc, 0xcedccedc, 0xa4dcdcdc,   /* 30,31 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 0 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 1 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 2 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 3 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 4 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 5 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 6 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 7 */
0x26343434, 0x34343434, 0x34342634, 0x34343434,   /* 31, 8 */
0x5e343434, 0x34343434, 0x34345e34, 0x34343434,   /* 31, 9 */
0x5e343434, 0x3434346c, 0x34345e34, 0x346c3434,   /* 31,10 */
0x5e6c3434, 0x3434346c, 0x34345e6c, 0x346c3434,   /* 31,11 */
0x5e6c3434, 0x346c346c, 0x34345e6c, 0x346c346c,   /* 31,12 */
0x5e6c346c, 0x346c346c, 0x346c5e6c, 0x346c346c,   /* 31,13 */
0x5e6c346c, 0x6c6c346c, 0x346c5e6c, 0x346c6c6c,   /* 31,14 */
0x5e6c6c6c, 0x6c6c346c, 0x6c6c5e6c, 0x346c6c6c,   /* 31,15 */
0x5e6c6c6c, 0x6c6c6c6c, 0x6c6c5e6c, 0x6c6c6c6c,   /* 31,16 */
0x966c6c6c, 0x6c6c6c6c, 0x6c6c966c, 0x6c6c6c6c,   /* 31,17 */
0x966c6c6c, 0x6c6c6ca4, 0x6c6c966c, 0x6ca46c6c,   /* 31,18 */
0x96a46c6c, 0x6c6c6ca4, 0x6c6c96a4, 0x6ca46c6c,   /* 31,19 */
0x96a46c6c, 0x6ca46ca4, 0x6c6c96a4, 0x6ca46ca4,   /* 31,20 */
0x96a46ca4, 0x6ca46ca4, 0x6ca496a4, 0x6ca46ca4,   /* 31,21 */
0x96a46ca4, 0xa4a46ca4, 0x6ca496a4, 0x6ca4a4a4,   /* 31,22 */
0x96a4a4a4, 0xa4a46ca4, 0xa4a496a4, 0x6ca4a4a4,   /* 31,23 */
0x96a4a4a4, 0xa4a4a4a4, 0xa4a496a4, 0xa4a4a4a4,   /* 31,24 */
0xcea4a4a4, 0xa4a4a4a4, 0xa4a4cea4, 0xa4a4a4a4,   /* 31,25 */
0xcea4a4a4, 0xa4a4a4dc, 0xa4a4cea4, 0xa4dca4a4,   /* 31,26 */
0xcedca4a4, 0xa4a4a4dc, 0xa4a4cedc, 0xa4dca4a4,   /* 31,27 */
0xcedca4a4, 0xa4dca4dc, 0xa4a4cedc, 0xa4dca4dc,   /* 31,28 */
0xcedca4dc, 0xa4dca4dc, 0xa4dccedc, 0xa4dca4dc,   /* 31,29 */
0xcedca4dc, 0xdcdca4dc, 0xa4dccedc, 0xa4dcdcdc,   /* 31,30 */
0xcedcdcdc, 0xdcdca4dc, 0xdcdccedc, 0xa4dcdcdc,   /* 31,31 */
}; /* DitherTable */

