#ifndef MAP_VIEW_H
#include "map_view.h"
#endif
#include <Screen.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <Application.h>
#include <Roster.h>
#include <Entry.h>
#include <Path.h>

//--------------------------------------------------------
float	bright[];
//--------------------------------------------------------

HelloView::HelloView(BRect rect, char *name)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW)
{
	LoadData();
	the_off = new BBitmap(BRect(0,0,1023,810), B_COLOR_8_BIT, TRUE);
	the_off->AddChild(off_view = new BView(BRect(0,0,800,800), "", B_FOLLOW_ALL, B_WILL_DRAW));
	sx = 10;
	sy = 1.0;
	dx = (5*3600) + (30*60) + (55);
	dx *= 15;
	dy = (0*3600) + (0*60) + 46;
}

//--------------------------------------------------------

static ulong
byte_me (ulong x)
{
  return (x >> 24
		  | (x & 0x00ff0000) >> 8
		  | (x & 0x0000ff00) << 8
		  | x << 24);
}

//--------------------------------------------------------

	HelloView::~HelloView()
{
	delete the_off;
}

//--------------------------------------------------------


void	HelloView::sort_by_dec()
{
	char	again;
	long	i;
	long	k;
	long	v1;
	long	v2;
	long	o1;
	long	o2;
	long	step;
	long	last;
	star	tmp;

	step = NS;

	while (step != 1) {
		step = (step / 3) - 1;
		if (step <= 0)
			step = 1;
		printf("step=%ld\n", step);
		again = TRUE;
		last = NS;
		
		while (again) {
			again = 0;
			k = 0;

			do {
				i = k + step;
				do {
					if (stars[i-step].dec > stars[i].dec) {
						again = TRUE;
						tmp = stars[i-step];
						stars[i-step] = stars[i];
						stars[i] = tmp;
					}
					i += step;
				} while (i < NS);
				
				k++;
			} while (k < step);
		}
	}
}


//--------------------------------------------------------

void	HelloView::LoadData()
{
	long		ref;
	long		i,j;
	long		k;
	ulong		tmp;
	long		v;
	char		q;
	float		dx,dy;
	long		cnt;
	app_info	info;	
	entry_ref	eref;
	BEntry		*entry;
	BPath		path;
	float		mag1;
	float		mag2;
	char		buf[256];
	char		tmpp[256];
	float		*pp;

	be_app->GetAppInfo(&info);
	eref = info.ref;
	entry = new BEntry(&eref, FALSE);
	entry->GetPath(&path);
	path.GetParent(&path);
	strcpy(buf, path.Path());

	delete entry;

	sprintf(tmpp, "%s/%s", buf, "output");
	printf("%s\n", tmpp);
	ref = open(tmpp, O_RDWR);
	lseek(ref, 0, 0);
	read(ref, stars, sizeof(stars));
	//sort_by_dec();
	//lseek(ref, 0, 0);
	//write(ref, stars, sizeof(stars));
	
	close(ref);

	for (i = 0; i < NS; i++) {
		stars[i].ra *= 15.0;

		if (stars[i].mag < -5) stars[i].mag = 12;

		mag1 = exp(stars[i].mag);
		mag1 = 270000.0/mag1;
		
		mag1 *= 0.19;
		if (mag1 < 2) mag1 = 2;

		if (stars[i].mag < -10)
			{mag1 = 0;}

		stars[i].mag = mag1;
	}		
}

//--------------------------------------------------------

void HelloView::AttachedToWindow()
{
}

//--------------------------------------------------------


void	HelloView::MouseDown(BPoint where)
{
	BPoint	w;
	ulong	state;
	float	ppx,ppy;

	do {
		GetMouse(&w, &state);
		ppx = w.x - 400;
		ppy = w.y - 400;
		ppx *= sx;
		ppy *= sx;

		dx -= ppx/4;
		dy -= ppy/4;

		if (state == 1) {
			sx *= 1.03;
		}
		if (state == 2) {
			sx /= 1.03;
		}
		Draw(BRect(0,0,32000,32000));
	} while(state);
}


//--------------------------------------------------------

void	HelloView::sub(char *base, long v)
{
	long	rd;

	v /= 3;
	rd = *(base+1);
	rd+=v;
	if (rd>30) rd = 30;
	*(base+1) = rd;
		
	rd = *(base-1);
	rd+=v;
	if (rd>30) rd = 30;
	*(base-1) = rd;

	rd = *(base-1024);
	rd+=v;
	if (rd>30) rd = 30;
	*(base-1024) = rd;

	rd = *(base+1024);
	rd+=v;
	if (rd>30) rd = 30;
	*(base+1024) = rd;

	if (v > 16) {
		v /= 2;
		sub(base+1024,v);
		sub(base-1024,v);
		sub(base+1,v);
		sub(base-1,v);
	}
}

//--------------------------------------------------------

void	HelloView::render(char *base)
{
	long	i;
	float	ra;
	float	dec;
	long	x,y;
	long	rd;	
	float	scale_x,scale_y;
	long	m;
	char	*p;
	long	vmin;
	float	mx;
	float	dec_max;
	long	j;

	vmin = sx;
	scale_x = (1.0)/sx;
	scale_y = (1.0)/sx;
	

	dx -= sx*400;
	dy -= sx*400;


	j = 0;

	while(j < NS) {
		if (stars[j].dec < dy)
			j+=20;
		else
			goto out0;
	}

out0:;
	
	j -= 20;
	if (j < 0) j = 0;

	dec_max = dy + sx*800;

	for (i = j; i < NS; i++) {
		ra = stars[i].ra;
		if (ra > dx) {
			dec = stars[i].dec;
			if (dec > (dec_max))
				goto out1;

			ra -= dx;
			dec -= dy;
			x = 0.5 + ra * scale_x;
			y = 0.5 + dec * scale_y;
		
		
			if (x > 4)
			if (x < 795)
			if ((y > 4) && (y < 795)) {
				m = stars[i].mag;
				p = base + (800-y)*1024+(800-x);

				rd = *p;
				rd+=m;
				if (rd>30) rd = 30;
				*p = rd;
				if (m > 30)
					sub(p, m);
			}
		}
	}
out1:;
	dx += sx*400;
	dy += sx*400;

}

//--------------------------------------------------------


void HelloView::Draw(BRect)
{
	char		*base;
	BScreen		screen;
	long		*cp;
	double		s,e;
	long		frames;

	cp = (long *)the_off->Bits();
	base = (char *)cp;
	
	the_off->Lock();
	off_view->SetHighColor(0,0,0);
	off_view->FillRect(BRect(0,0,800,800));
	off_view->Sync();
	render(base);
	the_off->Unlock();
	DrawBitmap(the_off, BPoint(0,0));
out:;
}










float	bright[] = {
24300.000000,-60180.000000,0.000000,
23030.000000,-189660.000000,0.000000,
51340.000000,69060.000000,0.000000,
18140.000000,147900.000000,0.000000,
67010.000000,139620.000000,0.040000,
19000.000000,165600.000000,0.060000,
18870.000000,-29521.000000,0.150000,
52770.000000,-219003.000000,0.330000,
27550.000000,18843.000000,0.360000,
5860.000000,-206104.000000,0.490000,
50630.000000,-217326.000000,0.610000,
71440.000000,31927.000000,0.750000,
44790.000000,-227168.000000,0.800000,
21310.000000,26648.000000,0.800000,
16550.000000,59408.000000,0.860000,
48310.000000,-40149.000000,0.970000,
59360.000000,-95170.000000,1.080000,
27910.000000,100871.000000,1.150000,
82650.000000,-106631.000000,1.150000,
74480.000000,162972.000000,1.250000,
46060.000000,-214932.000000,1.270000,
36500.000000,43093.000000,1.350000,
25110.000000,-104295.000000,1.500000,
63210.000000,-133576.000000,1.620000,
19500.000000,22876.000000,1.630000,
19570.000000,102976.000000,1.650000,
45070.000000,-205636.000000,1.660000,
33190.000000,-250996.000000,1.680000,
20170.000000,-4336.000000,1.690000,
79690.000000,-169097.000000,1.740000,
39820.000000,222317.000000,1.790000,
46440.000000,201437.000000,1.790000,
12260.000000,179478.000000,1.800000,
66250.000000,-123798.000000,1.830000,
29370.000000,-170478.000000,1.830000,
25700.000000,-95058.000000,1.840000,
63430.000000,-154818.000000,1.860000,
49650.000000,177558.000000,1.880000,
30150.000000,-214218.000000,1.880000,
21570.000000,161839.000000,1.900000,
37190.000000,71479.000000,1.900000,
73530.000000,-204259.000000,1.920000,
23860.000000,59059.000000,1.930000,
60520.000000,-248539.000000,1.930000,
31480.000000,-196999.000000,1.950000,
22960.000000,-64639.000000,1.980000,
34050.000000,-31219.000000,1.980000,
27270.000000,114799.000000,1.990000,
8360.000000,-10760.000000,2.000000,
57570.000000,93320.000000,2.000000,
7630.000000,84440.000000,2.010000,
2610.000000,-64760.000000,2.030000,
9070.000000,321320.000000,2.040000,
20440.000000,-7040.000000,2.050000,
4180.000000,128240.000000,2.060000,
20860.000000,-34820.000000,2.060000,
68110.000000,-94700.000000,2.060000,
500.000000,104720.000000,2.070000,
63290.000000,45260.000000,2.070000,
50800.000000,-131000.000000,2.070000,
53440.000000,266960.000000,2.070000,
44790.000000,-227180.000000,2.090000,
7430.000000,152421.000000,2.100000,
81760.000000,-168801.000000,2.100000,
42540.000000,52461.000000,2.130000,
11290.000000,147441.000000,2.150000,
45690.000000,-176301.000000,2.160000,
19920.000000,-1102.000000,2.200000,
73330.000000,144922.000000,2.210000,
2430.000000,203542.000000,2.220000,
64590.000000,185362.000000,2.230000,
56080.000000,96202.000000,2.230000,
32880.000000,-156382.000000,2.240000,
33420.000000,-213382.000000,2.250000,
29010.000000,-144022.000000,2.250000,
48230.000000,197782.000000,2.270000,
550.000000,212962.000000,2.270000,
49190.000000,-192503.000000,2.300000,
57620.000000,-81443.000000,2.300000,
60610.000000,-123503.000000,2.300000,
52910.000000,-170663.000000,2.310000,
52530.000000,-151763.000000,2.320000,
39710.000000,203003.000000,2.380000,
1570.000000,-152303.000000,2.390000,
53090.000000,97524.000000,2.400000,
78250.000000,35604.000000,2.400000,
63740.000000,-140544.000000,2.410000,
61820.000000,-56604.000000,2.430000,
42820.000000,193344.000000,2.430000,
76710.000000,225324.000000,2.440000,
26640.000000,-105504.000000,2.440000,
74770.000000,122304.000000,2.460000,
33720.000000,-198084.000000,2.490000,
83080.000000,54745.000000,2.500000,
10930.000000,14785.000000,2.520000,
50130.000000,-170305.000000,2.540000,
83020.000000,101125.000000,2.560000,
40440.000000,73885.000000,2.560000,
3400.000000,218605.000000,2.570000,
59820.000000,-38065.000000,2.570000,
19960.000000,-64225.000000,2.580000,
43700.000000,-182605.000000,2.580000,
44140.000000,-63145.000000,2.590000,
68550.000000,-107546.000000,2.600000,
55020.000000,-33806.000000,2.610000,
57920.000000,-71306.000000,2.630000,
20370.000000,-122726.000000,2.630000,
6870.000000,74906.000000,2.630000,
56650.000000,23126.000000,2.650000,
21580.000000,133946.000000,2.660000,
53910.000000,-155306.000000,2.670000,
45260.000000,-84266.000000,2.670000,
38800.000000,-177986.000000,2.680000,
5140.000000,216866.000000,2.680000,
50080.000000,66266.000000,2.680000,
66060.000000,-107366.000000,2.690000,
17820.000000,119366.000000,2.690000,
45430.000000,-248907.000000,2.700000,
63040.000000,-134307.000000,2.700000,
26220.000000,-133587.000000,2.700000,
71170.000000,38247.000000,2.720000,
59030.000000,221427.000000,2.730000,
58460.000000,-13287.000000,2.730000,
53450.000000,-57807.000000,2.750000,
48030.000000,-132207.000000,2.750000,
20120.000000,-21327.000000,2.760000,
38570.000000,-231807.000000,2.760000,
56100.000000,-148227.000000,2.770000,
18470.000000,-18327.000000,2.770000,
63800.000000,16467.000000,2.770000,
59410.000000,77367.000000,2.780000,
63020.000000,188367.000000,2.790000,
1540.000000,-278128.000000,2.800000,
29250.000000,-87508.000000,2.810000,
60070.000000,113788.000000,2.810000,
44100.000000,-211528.000000,2.810000,
78420.000000,-58108.000000,2.830000,
59750.000000,-101608.000000,2.830000,
790.000000,54688.000000,2.830000,
46930.000000,39508.000000,2.830000,
66470.000000,-91588.000000,2.830000,
19690.000000,-74728.000000,2.840000,
57300.000000,-228388.000000,2.840000,
62710.000000,-199948.000000,2.840000,
14040.000000,114808.000000,2.850000,
80310.000000,-216928.000000,2.850000,
7120.000000,-221668.000000,2.860000,
71090.000000,162508.000000,2.870000,
13640.000000,86848.000000,2.870000,
58870.000000,-92128.000000,2.880000,
46560.000000,137968.000000,2.880000,
77490.000000,-20128.000000,2.880000,
14270.000000,144028.000000,2.890000,
68980.000000,-75688.000000,2.890000,
22970.000000,81088.000000,2.890000,
55130.000000,-247288.000000,2.890000,
26820.000000,29848.000000,2.890000,
57530.000000,-94049.000000,2.900000,
24590.000000,-182249.000000,2.920000,
79540.000000,-1169.000000,2.930000,
63110.000000,-179609.000000,2.940000,
11080.000000,192629.000000,2.940000,
44990.000000,-59489.000000,2.950000,
81780.000000,108809.000000,2.950000,
14280.000000,-48689.000000,2.950000,
35150.000000,85589.000000,2.970000,
18110.000000,157829.000000,2.980000,
20250.000000,76169.000000,2.980000,
47930.000000,-83489.000000,2.980000,
68720.000000,49949.000000,2.990000,
24230.000000,90509.000000,2.990000,
65140.000000,-109589.000000,2.990000,
43800.000000,-81449.000000,2.990000,
7770.000000,125970.000000,3.000000,
78830.000000,-134550.000000,3.000000,
40180.000000,160170.000000,3.000000,
22810.000000,-108270.000000,3.020000,
13370.000000,172050.000000,3.020000,
64050.000000,-144450.000000,3.030000,
25380.000000,-85830.000000,3.030000,
37330.000000,149430.000000,3.030000,
52320.000000,137970.000000,3.040000,
55240.000000,258630.000000,3.040000,
45970.000000,-245250.000000,3.050000,
73260.000000,-53250.000000,3.070000,
69150.000000,243630.000000,3.070000,
70240.000000,100710.000000,3.080000,
74250.000000,-170251.000000,3.110000,
65850.000000,-132391.000000,3.110000,
32120.000000,21451.000000,3.110000,
21050.000000,-128791.000000,3.110000,
38970.000000,-58291.000000,3.110000,
34270.000000,-205351.000000,3.120000,
61110.000000,-201571.000000,3.120000,
53940.000000,-151591.000000,3.130000,
41740.000000,-226891.000000,3.130000,
62100.000000,89431.000000,3.140000,
60710.000000,-137011.000000,3.140000,
33660.000000,123871.000000,3.140000,
32350.000000,172951.000000,3.150000,
35220.000000,-234271.000000,3.150000,
62100.000000,132511.000000,3.160000,
18390.000000,148471.000000,3.170000,
23860.000000,-155491.000000,3.170000,
77310.000000,254011.000000,3.180000,
52950.000000,-233911.000000,3.180000,
34370.000000,186091.000000,3.180000,
61720.000000,236611.000000,3.180000,
67540.000000,-97231.000000,3.180000,
17390.000000,25051.000000,3.190000,
76370.000000,108871.000000,3.190000,
18320.000000,-80551.000000,3.190000,
22490.000000,81032.000000,3.200000,
64190.000000,-133412.000000,3.200000,
61060.000000,33812.000000,3.200000,
55280.000000,-146372.000000,3.210000,
85160.000000,279452.000000,3.220000,
58690.000000,-16952.000000,3.230000,
26950.000000,-155912.000000,3.240000,
72670.000000,-2972.000000,3.240000,
68330.000000,117692.000000,3.250000,
2360.000000,111152.000000,3.250000,
66070.000000,-10412.000000,3.250000,
16440.000000,-198212.000000,3.260000,
24490.000000,-222992.000000,3.260000,
50780.000000,-96092.000000,3.260000,
82470.000000,-56972.000000,3.270000,
13630.000000,-267332.000000,3.270000,
62520.000000,-90032.000000,3.280000,
3960.000000,-168213.000000,3.300000,
55490.000000,212313.000000,3.300000,
44120.000000,205353.000000,3.310000,
37920.000000,-222093.000000,3.310000,
36820.000000,-252153.000000,3.310000,
68810.000000,-99633.000000,3.310000,
62720.000000,-203013.000000,3.320000,
18770.000000,-58353.000000,3.320000,
54240.000000,-91053.000000,3.320000,
61920.000000,-155673.000000,3.330000,
15260.000000,-224913.000000,3.340000,
40450.000000,55593.000000,3.340000,
64740.000000,-35253.000000,3.340000,
19460.000000,-8613.000000,3.350000,
28150.000000,-89553.000000,3.350000,
30610.000000,218613.000000,3.350000,
24310.000000,46473.000000,3.350000,
79850.000000,209553.000000,3.350000,
55360.000000,-160953.000000,3.360000,
48880.000000,-2193.000000,3.360000,
69920.000000,11253.000000,3.360000,
31600.000000,23133.000000,3.370000,
6860.000000,229293.000000,3.370000,
46530.000000,12213.000000,3.370000,
37020.000000,-220833.000000,3.380000,
81680.000000,39033.000000,3.390000,
57600.000000,-138274.000000,3.400000,
54730.000000,-187594.000000,3.400000,
20010.000000,-224974.000000,3.400000,
35110.000000,-225094.000000,3.400000,
5300.000000,-155974.000000,3.400000,
63980.000000,99874.000000,3.410000,
16120.000000,57154.000000,3.410000,
49770.000000,-150094.000000,3.410000,
14440.000000,44974.000000,3.410000,
6780.000000,106534.000000,3.410000,
10690.000000,-145114.000000,3.420000,
74710.000000,222634.000000,3.420000,
74690.000000,-238354.000000,3.420000,
67800.000000,120154.000000,3.430000,
68770.000000,-17614.000000,3.430000,
37000.000000,84334.000000,3.430000,
2940.000000,208174.000000,3.440000,
33050.000000,-212314.000000,3.440000,
4110.000000,-36694.000000,3.440000,
37020.000000,154534.000000,3.450000,
9790.000000,11674.000000,3.460000,
40700.000000,119134.000000,3.460000,
25300.000000,-100594.000000,3.460000,
28600.000000,-190774.000000,3.460000,
49770.000000,-152974.000000,3.470000,
34860.000000,35674.000000,3.480000,
54930.000000,119974.000000,3.480000,
82110.000000,-184774.000000,3.480000,
71920.000000,70174.000000,3.480000,
54110.000000,145414.000000,3.490000,
82200.000000,88594.000000,3.490000,
62070.000000,51815.000000,3.500000,
66410.000000,-165515.000000,3.500000,
71540.000000,3635.000000,3.500000,
6240.000000,-57395.000000,3.500000,
68260.000000,-75995.000000,3.500000,
82180.000000,238355.000000,3.500000,
11110.000000,139835.000000,3.500000,
79810.000000,22355.000000,3.510000,
29790.000000,33155.000000,3.520000,
26400.000000,79175.000000,3.530000,
36440.000000,60395.000000,3.530000,
60170.000000,140195.000000,3.530000,
13390.000000,-35195.000000,3.530000,
16110.000000,69095.000000,3.530000,
35810.000000,-196535.000000,3.540000,
63450.000000,-55475.000000,3.540000,
41580.000000,-114695.000000,3.540000,
20810.000000,-53435.000000,3.540000,
1160.000000,-31835.000000,3.540000,
8190.000000,-185495.000000,3.550000,
15470.000000,-121715.000000,3.550000,
55300.000000,-130595.000000,3.550000,
56970.000000,-12335.000000,3.550000,
51560.000000,-165875.000000,3.550000,
66060.000000,261875.000000,3.560000,
25720.000000,-253835.000000,3.560000,
27860.000000,87875.000000,3.560000,
73080.000000,-45155.000000,3.560000,
60740.000000,-136895.000000,3.560000,
40760.000000,-53195.000000,3.560000,
32610.000000,169775.000000,3.570000,
26280.000000,59555.000000,3.570000,
52310.000000,109415.000000,3.570000,
72520.000000,-238295.000000,3.570000,
5870.000000,175055.000000,3.570000,
19050.000000,-24695.000000,3.580000,
34240.000000,-145715.000000,3.580000,
74250.000000,52595.000000,3.580000,
56220.000000,-101315.000000,3.580000,
63060.000000,-218495.000000,3.590000,
12280.000000,32555.000000,3.590000,
27910.000000,-136775.000000,3.590000,
44480.000000,-217475.000000,3.590000,
24760.000000,122316.000000,3.600000,
20660.000000,-80856.000000,3.600000,
5040.000000,-29496.000000,3.600000,
10190.000000,98196.000000,3.610000,
36630.000000,-44556.000000,3.610000,
42640.000000,6396.000000,3.610000,
46930.000000,-257616.000000,3.610000,
25720.000000,-253836.000000,3.620000,
5480.000000,55296.000000,3.620000,
31210.000000,-190536.000000,3.620000,
82910.000000,152376.000000,3.620000,
63940.000000,-233076.000000,3.620000,
42330.000000,-240216.000000,3.630000,
13750.000000,86616.000000,3.630000,
15580.000000,56256.000000,3.630000,
60870.000000,-152496.000000,3.630000,
2210.000000,194076.000000,3.640000,
75280.000000,-210456.000000,3.640000,
50660.000000,231756.000000,3.650000,
56320.000000,-107256.000000,3.650000,
34290.000000,227076.000000,3.660000,
80930.000000,-96.000000,3.660000,
20100.000000,35796.000000,3.660000,
78000.000000,-60036.000000,3.660000,
83360.000000,-76236.000000,3.660000,
56770.000000,55536.000000,3.670000,
65190.000000,-180396.000000,3.670000,
55660.000000,104796.000000,3.670000,
45700.000000,-5256.000000,3.680000,
17470.000000,20196.000000,3.680000,
6950.000000,-185796.000000,3.690000,
31410.000000,-119556.000000,3.690000,
83830.000000,11856.000000,3.690000,
64660.000000,105336.000000,3.690000,
11970.000000,-78337.000000,3.700000,
13490.000000,86857.000000,3.700000,
42360.000000,172057.000000,3.700000,
71710.000000,23077.000000,3.710000,
57040.000000,16177.000000,3.710000,
21380.000000,-51037.000000,3.710000,
28330.000000,-146137.000000,3.710000,
21570.000000,195457.000000,3.710000,
17650.000000,8857.000000,3.720000,
12430.000000,35077.000000,3.720000,
6680.000000,-37237.000000,3.720000,
75890.000000,158197.000000,3.720000,
65240.000000,34477.000000,3.730000,
76480.000000,137017.000000,3.730000,
20320.000000,-9397.000000,3.730000,
53170.000000,6877.000000,3.730000,
12770.000000,-34117.000000,3.730000,
58910.000000,68977.000000,3.740000,
38230.000000,-173617.000000,3.740000,
77200.000000,-80737.000000,3.740000,
64070.000000,9817.000000,3.740000,
32640.000000,-169597.000000,3.740000,
64410.000000,204757.000000,3.740000,
81070.000000,181057.000000,3.750000,
60580.000000,-212617.000000,3.750000,
68680.000000,-78277.000000,3.760000,
79620.000000,91237.000000,3.760000,
15770.000000,63157.000000,3.760000,
30340.000000,-238117.000000,3.760000,
82350.000000,-27337.000000,3.760000,
74370.000000,57337.000000,3.770000,
13510.000000,153337.000000,3.770000,
10240.000000,201277.000000,3.770000,
74860.000000,-34237.000000,3.770000,
70180.000000,186277.000000,3.770000,
69420.000000,192157.000000,3.770000,
78080.000000,-278617.000000,3.780000,
72810.000000,168277.000000,3.780000,
21070.000000,-75157.000000,3.780000,
39210.000000,-211897.000000,3.780000,
26740.000000,100117.000000,3.780000,
35450.000000,212617.000000,3.790000,
11370.000000,161557.000000,3.790000,
63560.000000,165698.000000,3.800000,
71240.000000,66758.000000,3.800000,
59450.000000,7178.000000,3.810000,
33530.000000,132578.000000,3.810000,
37670.000000,-211538.000000,3.810000,
39190.000000,123218.000000,3.810000,
16530.000000,-110078.000000,3.810000,
37560.000000,-60698.000000,3.810000,
56560.000000,94718.000000,3.820000,
50290.000000,-151598.000000,3.820000,
26080.000000,-96398.000000,3.820000,
13450.000000,116258.000000,3.830000,
71290.000000,252998.000000,3.830000,
65250.000000,103598.000000,3.830000,
41480.000000,249638.000000,3.830000,
32100.000000,-218378.000000,3.840000,
80490.000000,-5018.000000,3.840000,
36880.000000,-151718.000000,3.840000,
20830.000000,-183878.000000,3.840000,
57380.000000,56378.000000,3.840000,
58520.000000,-229298.000000,3.840000,
22920.000000,-120398.000000,3.840000,
13450.000000,-233318.000000,3.840000,
64570.000000,134138.000000,3.840000,
66220.000000,78398.000000,3.840000,
66910.000000,-29738.000000,3.840000,
31230.000000,-167978.000000,3.850000,
11520.000000,-104378.000000,3.850000,
45460.000000,-174758.000000,3.850000,
37960.000000,33518.000000,3.850000,
16110.000000,57458.000000,3.850000,
15240.000000,-152258.000000,3.850000,
53270.000000,-284558.000000,3.850000,
3400.000000,138638.000000,3.860000,
65620.000000,-75818.000000,3.860000,
54710.000000,-175478.000000,3.860000,
16690.000000,-51518.000000,3.860000,
50320.000000,-161318.000000,3.860000,
19870.000000,-127778.000000,3.860000,
24840.000000,-87158.000000,3.860000,
45200.000000,251258.000000,3.870000,
560.000000,-164738.000000,3.870000,
57410.000000,-105218.000000,3.880000,
40860.000000,-196238.000000,3.880000,
33260.000000,8378.000000,3.880000,
48660.000000,-141878.000000,3.880000,
44390.000000,-2438.000000,3.880000,
45140.000000,-259718.000000,3.880000,
13540.000000,87758.000000,3.880000,
52980.000000,-20378.000000,3.880000,
85050.000000,167318.000000,3.880000,
59600.000000,-284018.000000,3.880000,
34790.000000,-4118.000000,3.880000,
58780.000000,166778.000000,3.890000,
71940.000000,126338.000000,3.890000,
30340.000000,-14138.000000,3.890000,
83420.000000,-162938.000000,3.890000,
10580.000000,-32078.000000,3.890000,
35560.000000,93698.000000,3.890000,
56130.000000,-53259.000000,3.900000,
31560.000000,-165819.000000,3.900000,
14580.000000,21639.000000,3.900000,
68210.000000,-242139.000000,3.900000,
68120.000000,158259.000000,3.900000,
61210.000000,111339.000000,3.910000,
76550.000000,18939.000000,3.910000,
16570.000000,-12099.000000,3.920000,
44880.000000,-180879.000000,3.920000,
31480.000000,65379.000000,3.930000,
75430.000000,148239.000000,3.930000,
1570.000000,-157299.000000,3.930000,
69700.000000,-64299.000000,3.930000,
27670.000000,-34419.000000,3.930000,
5470.000000,-176739.000000,3.930000,
4100.000000,-198939.000000,3.940000,
27700.000000,-261399.000000,3.940000,
57050.000000,-121059.000000,3.940000,
24590.000000,-117099.000000,3.940000,
40110.000000,-212379.000000,3.940000,
23800.000000,-69339.000000,3.940000,
41030.000000,37959.000000,3.950000,
10450.000000,189999.000000,3.950000,
7400.000000,260739.000000,3.950000,
81990.000000,84879.000000,3.950000,
21540.000000,-154179.000000,3.950000,
15840.000000,-122499.000000,3.950000,
64830.000000,10599.000000,3.960000,
32430.000000,150459.000000,3.960000,
72030.000000,-262479.000000,3.960000,
27820.000000,-104259.000000,3.960000,
43890.000000,-188559.000000,3.960000,
69830.000000,-146259.000000,3.960000,
80950.000000,-156579.000000,3.960000,
84170.000000,-72399.000000,3.960000,
31200.000000,-127119.000000,3.970000,
22490.000000,-22659.000000,3.970000,
58000.000000,-74439.000000,3.970000,
26210.000000,-244659.000000,3.970000,
21090.000000,140979.000000,3.980000,
33070.000000,-224379.000000,3.980000,
83840.000000,-209679.000000,3.980000,
37460.000000,-266559.000000,3.980000,
72920.000000,171759.000000,3.980000,
78210.000000,211659.000000,3.990000,
7200.000000,-75939.000000,3.990000,
38700.000000,-214960.000000,4.000000,
58320.000000,-70120.000000,4.000000,
67380.000000,-257200.000000,4.000000,
34330.000000,-226120.000000,4.000000,
8230.000000,121900.000000,4.000000,
48310.000000,198040.000000,4.000000,
32540.000000,-239080.000000,4.000000,
52910.000000,-136120.000000,4.000000,
10430.000000,-179680.000000,4.000000,
71430.000000,118540.000000,4.000000,
69750.000000,-160120.000000,4.010000,
73760.000000,109360.000000,4.010000,
57710.000000,210880.000000,4.010000,
31830.000000,-99760.000000,4.010000,
82170.000000,-48940.000000,4.010000,
17130.000000,-11740.000000,4.020000,
81320.000000,-460.000000,4.020000,
86350.000000,24760.000000,4.020000,
77630.000000,164200.000000,4.020000,
68500.000000,-20740.000000,4.020000,
68370.000000,54280.000000,4.020000,
46470.000000,-205900.000000,4.030000,
31600.000000,103600.000000,4.030000,
14920.000000,171820.000000,4.030000,
73990.000000,40720.000000,4.030000,
40860.000000,21760.000000,4.030000,
43700.000000,-89020.000000,4.030000,
42350.000000,23500.000000,4.030000,
51630.000000,-136480.000000,4.040000,
18200.000000,217660.000000,4.040000,
58790.000000,-180640.000000,4.040000,
52670.000000,-177940.000000,4.040000,
53010.000000,-126700.000000,4.040000,
49760.000000,56920.000000,4.040000,
14330.000000,128860.000000,4.040000,
54530.000000,-163060.000000,4.050000,
31460.000000,-153580.000000,4.050000,
15110.000000,-24640.000000,4.050000,
51910.000000,186700.000000,4.050000,
11340.000000,178660.000000,4.050000,
61170.000000,-191380.000000,4.050000,
41090.000000,-63700.000000,4.060000,
44300.000000,-230440.000000,4.060000,
75950.000000,-62080.000000,4.060000,
55050.000000,-211720.000000,4.060000,
6210.000000,182500.000000,4.060000,
9560.000000,1240.000000,4.060000,
29910.000000,-276940.000000,4.060000,
2840.000000,87400.000000,4.060000,
24850.000000,-43420.000000,4.060000,
27350.000000,96880.000000,4.060000,
17780.000000,48640.000000,4.070000,
10940.000000,-85060.000000,4.070000,
34460.000000,-213280.000000,4.070000,
39580.000000,-65920.000000,4.070000,
76920.000000,71380.000000,4.080000,
8500.000000,-247240.000000,4.080000,
51360.000000,-21640.000000,4.080000,
20210.000000,33460.000000,4.080000,
24270.000000,295660.000000,4.090000,
5800.000000,149080.000000,4.090000,
28150.000000,-166961.000000,4.100000,
56200.000000,-238781.000000,4.100000,
68960.000000,-136541.000000,4.100000,
9570.000000,-245801.000000,4.100000,
42390.000000,-220241.000000,4.100000,
69000.000000,-141641.000000,4.100000,
35480.000000,-53501.000000,4.100000,
9640.000000,-143501.000000,4.100000,
56920.000000,65321.000000,4.100000,
9850.000000,177221.000000,4.110000,
25420.000000,-56321.000000,4.110000,
82850.000000,-189941.000000,4.110000,
12650.000000,46661.000000,4.110000,
75100.000000,-97001.000000,4.110000,
21740.000000,34781.000000,4.120000,
80980.000000,-157541.000000,4.120000,
43510.000000,31481.000000,4.120000,
71710.000000,-150761.000000,4.120000,
66530.000000,-176681.000000,4.120000,
15290.000000,174281.000000,4.130000,
31050.000000,-154781.000000,4.130000,
74760.000000,-91001.000000,4.130000,
85190.000000,20321.000000,4.130000,
19430.000000,-28121.000000,4.130000,
80150.000000,135941.000000,4.130000,
44250.000000,-244661.000000,4.130000,
25910.000000,-1841.000000,4.140000,
85220.000000,159641.000000,4.140000,
43610.000000,-232601.000000,4.140000,
78270.000000,92381.000000,4.140000,
57450.000000,96821.000000,4.140000,
31060.000000,20561.000000,4.140000,
81960.000000,-293021.000000,4.140000,
57230.000000,-60281.000000,4.140000,
38120.000000,-283001.000000,4.140000,
23330.000000,72821.000000,4.150000,
25440.000000,74081.000000,4.150000,
80200.000000,-28061.000000,4.150000,
59780.000000,-126941.000000,4.150000,
57860.000000,-41021.000000,4.160000,
21840.000000,83801.000000,4.160000,
1980.000000,226601.000000,4.160000,
55970.000000,112961.000000,4.160000,
13760.000000,-130361.000000,4.160000,
26940.000000,114461.000000,4.170000,
62780.000000,-87101.000000,4.170000,
81640.000000,-97421.000000,4.170000,
51380.000000,165941.000000,4.180000,
13570.000000,86261.000000,4.180000,
51170.000000,-37061.000000,4.180000,
60350.000000,295361.000000,4.190000,
80100.000000,205421.000000,4.190000,
19840.000000,21462.000000,4.200000,
67530.000000,74022.000000,4.200000,
82000.000000,43902.000000,4.200000,
68780.000000,-133422.000000,4.200000,
37670.000000,132162.000000,4.200000,
82550.000000,-117162.000000,4.200000,
74740.000000,110622.000000,4.200000,
65120.000000,9042.000000,4.200000,
59640.000000,152862.000000,4.200000,
28610.000000,-82422.000000,4.200000,
64050.000000,-100242.000000,4.200000,
19930.000000,66942.000000,4.200000,
49760.000000,-124062.000000,4.200000,
66040.000000,256842.000000,4.210000,
67930.000000,-223902.000000,4.210000,
12540.000000,215862.000000,4.210000,
73770.000000,226782.000000,4.210000,
57990.000000,-132522.000000,4.210000,
83750.000000,-32742.000000,4.220000,
15920.000000,80322.000000,4.220000,
10230.000000,137982.000000,4.220000,
13610.000000,-83742.000000,4.220000,
67630.000000,-17142.000000,4.220000,
83660.000000,-21822.000000,4.220000,
32300.000000,42762.000000,4.230000,
56080.000000,37962.000000,4.230000,
60180.000000,-279102.000000,4.230000,
28390.000000,-173262.000000,4.230000,
59480.000000,-124962.000000,4.230000,
78400.000000,177582.000000,4.230000,
12990.000000,173562.000000,4.230000,
76640.000000,141882.000000,4.230000,
49540.000000,-118962.000000,4.230000,
77180.000000,-235362.000000,4.230000,
16600.000000,148602.000000,4.230000,
4120.000000,310542.000000,4.230000,
4170.000000,170142.000000,4.240000,
73050.000000,-45042.000000,4.240000,
8810.000000,-171762.000000,4.240000,
9840.000000,-49962.000000,4.240000,
15360.000000,-185382.000000,4.240000,
1200.000000,-233622.000000,4.240000,
37630.000000,-111942.000000,4.240000,
16540.000000,36582.000000,4.250000,
29360.000000,-170502.000000,4.250000,
4540.000000,-247962.000000,4.250000,
52050.000000,272502.000000,4.250000,
58120.000000,161802.000000,4.250000,
63680.000000,-46362.000000,4.250000,
22780.000000,-28242.000000,4.250000,
27790.000000,104022.000000,4.250000,
30170.000000,155562.000000,4.250000,
21590.000000,165462.000000,4.250000,
50490.000000,5622.000000,4.260000,
47210.000000,-179682.000000,4.260000,
55110.000000,-172362.000000,4.260000,
38350.000000,-200202.000000,4.260000,
46400.000000,-144702.000000,4.260000,
79580.000000,-49962.000000,4.260000,
12820.000000,-77922.000000,4.260000,
9890.000000,36462.000000,4.260000,
47510.000000,100422.000000,4.260000,
11990.000000,-155082.000000,4.260000,
6320.000000,32982.000000,4.260000,
83210.000000,-156762.000000,4.270000,
74790.000000,58122.000000,4.270000,
16680.000000,45102.000000,4.270000,
18540.000000,-31542.000000,4.270000,
44300.000000,-285522.000000,4.270000,
85080.000000,155802.000000,4.270000,
8880.000000,30522.000000,4.270000,
45220.000000,148902.000000,4.270000,
76930.000000,-60642.000000,4.270000,
3770.000000,28422.000000,4.270000,
84470.000000,23022.000000,4.270000,
81090.000000,-116502.000000,4.280000,
42770.000000,-122082.000000,4.280000,
59460.000000,-59862.000000,4.280000,
78320.000000,220122.000000,4.280000,
72800.000000,203682.000000,4.280000,
16930.000000,82722.000000,4.280000,
69790.000000,-161322.000000,4.280000,
13010.000000,1482.000000,4.280000,
63390.000000,-139122.000000,4.280000,
34620.000000,292782.000000,4.280000,
79420.000000,232662.000000,4.290000,
19170.000000,-47502.000000,4.290000,
31390.000000,12222.000000,4.290000,
15330.000000,32082.000000,4.290000,
14790.000000,181302.000000,4.290000,
15970.000000,82182.000000,4.290000,
62840.000000,-107562.000000,4.290000,
15920.000000,64603.000000,4.300000,
28690.000000,-177283.000000,4.300000,
65100.000000,-106543.000000,4.300000,
68070.000000,132883.000000,4.300000,
26010.000000,-160783.000000,4.300000,
56640.000000,280123.000000,4.300000,
13510.000000,88123.000000,4.300000,
3510.000000,-105763.000000,4.300000,
45120.000000,-58363.000000,4.300000,
79800.000000,119443.000000,4.300000,
41810.000000,-2983.000000,4.300000,
17640.000000,238843.000000,4.300000,
55470.000000,134623.000000,4.310000,
31580.000000,-48823.000000,4.310000,
74300.000000,-4003.000000,4.310000,
16820.000000,-70843.000000,4.310000,
42580.000000,-229663.000000,4.310000,
52010.000000,-301243.000000,4.310000,
34300.000000,82783.000000,4.310000,
43380.000000,-227923.000000,4.320000,
31230.000000,-215143.000000,4.320000,
26890.000000,32203.000000,4.320000,
59220.000000,-66523.000000,4.320000,
51610.000000,-203083.000000,4.320000,
58040.000000,-75163.000000,4.320000,
78270.000000,62503.000000,4.320000,
6890.000000,146503.000000,4.320000,
46380.000000,-176263.000000,4.320000,
65990.000000,129883.000000,4.320000,
7320.000000,10003.000000,4.330000,
62440.000000,-46303.000000,4.330000,
53490.000000,-156943.000000,4.330000,
56280.000000,-153283.000000,4.330000,
78290.000000,-118963.000000,4.330000,
4260.000000,198583.000000,4.330000,
22520.000000,106243.000000,4.330000,
55070.000000,-108583.000000,4.330000,
33370.000000,-207163.000000,4.330000,
34610.000000,-177703.000000,4.340000,
23510.000000,-84343.000000,4.340000,
29270.000000,-247063.000000,4.340000,
80950.000000,210343.000000,4.340000,
29310.000000,-10783.000000,4.340000,
30030.000000,-278983.000000,4.340000,
65310.000000,-229243.000000,4.340000,
20680.000000,-236683.000000,4.340000,
50500.000000,-164203.000000,4.340000,
62790.000000,14983.000000,4.340000,
80970.000000,171823.000000,4.340000,
67480.000000,135403.000000,4.350000,
31700.000000,21043.000000,4.350000,
1890.000000,-226723.000000,4.350000,
51970.000000,-163423.000000,4.350000,
25030.000000,210343.000000,4.350000,
67620.000000,65503.000000,4.350000,
63130.000000,311743.000000,4.350000,
71980.000000,-127063.000000,4.350000,
50760.000000,-148303.000000,4.350000,
69380.000000,137323.000000,4.350000,
44810.000000,101803.000000,4.350000,
11490.000000,71083.000000,4.350000,
12630.000000,172843.000000,4.350000,
2600.000000,-206923.000000,4.360000,
65320.000000,74983.000000,4.360000,
21450.000000,-127063.000000,4.360000,
70600.000000,-4723.000000,4.360000,
2210.000000,121423.000000,4.360000,
18790.000000,-46663.000000,4.360000,
70800.000000,64903.000000,4.360000,
66190.000000,-221383.000000,4.360000,
17430.000000,32083.000000,4.360000,
7980.000000,31903.000000,4.360000,
22590.000000,-126523.000000,4.360000,
14680.000000,79543.000000,4.360000,
47390.000000,-19963.000000,4.370000,
72530.000000,279823.000000,4.370000,
36470.000000,36043.000000,4.370000,
84770.000000,-136183.000000,4.370000,
60840.000000,36643.000000,4.370000,
70860.000000,62983.000000,4.370000,
2310.000000,105583.000000,4.370000,
76790.000000,-192463.000000,4.380000,
69220.000000,140923.000000,4.380000,
39600.000000,-152023.000000,4.380000,
17570.000000,-19663.000000,4.380000,
24960.000000,-61423.000000,4.380000,
23690.000000,-190783.000000,4.380000,
28930.000000,8503.000000,4.380000,
79070.000000,-197983.000000,4.390000,
25860.000000,108943.000000,4.390000,
26320.000000,-89863.000000,4.390000,
64710.000000,108763.000000,4.390000,
24590.000000,-193063.000000,4.390000,
3430.000000,84343.000000,4.390000,
84360.000000,-74323.000000,4.390000,
62460.000000,-76004.000000,4.400000,
29340.000000,-69344.000000,4.400000,
83870.000000,-33104.000000,4.400000,
21260.000000,73004.000000,4.400000,
54170.000000,7544.000000,4.400000,
63040.000000,94004.000000,4.400000,
870.000000,-68204.000000,4.400000,
6810.000000,-166784.000000,4.400000,
35250.000000,41204.000000,4.400000,
40690.000000,113564.000000,4.410000,
83270.000000,271424.000000,4.410000,
39740.000000,72704.000000,4.410000,
20080.000000,34184.000000,4.410000,
52350.000000,-181724.000000,4.410000,
51780.000000,-142244.000000,4.410000,
22050.000000,53204.000000,4.410000,
84320.000000,84284.000000,4.410000,
83930.000000,-117164.000000,4.410000,
23870.000000,-65684.000000,4.410000,
53410.000000,-100724.000000,4.410000,
74860.000000,-18164.000000,4.410000,
110.000000,-21704.000000,4.410000,
10690.000000,-145124.000000,4.420000,
26050.000000,-94904.000000,4.420000,
74600.000000,54344.000000,4.420000,
80610.000000,188084.000000,4.420000,
73430.000000,115904.000000,4.420000,
70120.000000,88844.000000,4.420000,
13770.000000,235964.000000,4.420000,
13560.000000,-43604.000000,4.420000,
17830.000000,193604.000000,4.430000,
52860.000000,49424.000000,4.430000,
16830.000000,-150764.000000,4.430000,
29640.000000,-145304.000000,4.430000,
15310.000000,-27644.000000,4.430000,
56780.000000,26504.000000,4.430000,
31120.000000,12104.000000,4.430000,
2920.000000,27344.000000,4.430000,
64900.000000,4724.000000,4.440000,
23020.000000,16604.000000,4.440000,
15380.000000,-213584.000000,4.440000,
70440.000000,26624.000000,4.440000,
29910.000000,-132044.000000,4.440000,
38740.000000,-290024.000000,4.440000,
38130.000000,-207224.000000,4.440000,
6080.000000,19784.000000,4.440000,
18730.000000,-42764.000000,4.450000,
22770.000000,212504.000000,4.450000,
27240.000000,-80324.000000,4.450000,
32400.000000,-148544.000000,4.450000,
10140.000000,-116744.000000,4.450000,
29480.000000,-142664.000000,4.450000,
69330.000000,264104.000000,4.450000,
82350.000000,-118364.000000,4.460000,
76670.000000,125684.000000,4.460000,
59230.000000,-171284.000000,4.460000,
43680.000000,-182384.000000,4.460000,
33870.000000,94304.000000,4.460000,
18790.000000,10364.000000,4.460000,
59520.000000,-77324.000000,4.460000,
40600.000000,-13184.000000,4.460000,
52480.000000,107144.000000,4.460000,
24470.000000,8684.000000,4.460000,
17910.000000,6224.000000,4.460000,
42660.000000,-162644.000000,4.460000,
28080.000000,-93404.000000,4.470000,
80830.000000,-233864.000000,4.470000,
83200.000000,-85544.000000,4.470000,
32930.000000,185804.000000,4.470000,
40290.000000,-82244.000000,4.470000,
22310.000000,51224.000000,4.470000,
23290.000000,-117344.000000,4.470000,
9900.000000,-66944.000000,4.470000,
79560.000000,-142424.000000,4.470000,
12020.000000,104624.000000,4.470000,
85360.000000,-52424.000000,4.480000,
76460.000000,36044.000000,4.480000,
23570.000000,26444.000000,4.480000,
36440.000000,126944.000000,4.480000,
28350.000000,-139964.000000,4.480000,
25950.000000,-168404.000000,4.480000,
53830.000000,-15644.000000,4.480000,
32700.000000,-261404.000000,4.480000,
81630.000000,159404.000000,4.480000,
8940.000000,242684.000000,4.490000,
70580.000000,180824.000000,4.490000,
24230.000000,47684.000000,4.490000,
80030.000000,143024.000000,4.490000,
36470.000000,-1364.000000,4.490000,
34490.000000,187424.000000,4.490000,
79700.000000,-118844.000000,4.490000,
31600.000000,-204404.000000,4.490000,
81020.000000,155324.000000,4.490000,
86390.000000,-236144.000000,4.490000,
15980.000000,56264.000000,4.490000,
59040.000000,-72164.000000,4.490000,
39330.000000,89145.000000,4.500000,
37250.000000,-201765.000000,4.500000,
55400.000000,-213645.000000,4.500000,
27520.000000,-96525.000000,4.500000,
49630.000000,62865.000000,4.500000,
76020.000000,-90045.000000,4.500000,
85320.000000,6465.000000,4.500000,
74640.000000,-187005.000000,4.500000,
77320.000000,-78585.000000,4.500000,
16410.000000,-107205.000000,4.500000,
4300.000000,108405.000000,4.500000,
20990.000000,-202185.000000,4.500000,
34150.000000,-129465.000000,4.500000,
72160.000000,-99765.000000,4.500000,
56490.000000,70905.000000,4.510000,
20950.000000,141105.000000,4.510000,
20350.000000,14865.000000,4.510000,
34760.000000,-220845.000000,4.510000,
74720.000000,207345.000000,4.510000,
76170.000000,-41025.000000,4.510000,
10070.000000,105345.000000,4.510000,
72160.000000,244365.000000,4.510000,
14450.000000,-223785.000000,4.510000,
62620.000000,133725.000000,4.520000,
48150.000000,-219585.000000,4.520000,
74840.000000,131385.000000,4.520000,
27440.000000,-125985.000000,4.520000,
51540.000000,-48225.000000,4.520000,
1100.000000,132465.000000,4.520000,
83030.000000,13785.000000,4.520000,
2980.000000,147945.000000,4.520000,
83550.000000,177945.000000,4.520000,
48240.000000,-232365.000000,4.520000,
21600.000000,-11145.000000,4.520000,
54260.000000,97065.000000,4.520000,
72940.000000,100125.000000,4.520000,
71810.000000,-97845.000000,4.520000,
83220.000000,33885.000000,4.520000,
54730.000000,-71325.000000,4.530000,
51200.000000,186465.000000,4.530000,
65470.000000,-165465.000000,4.530000,
75990.000000,171585.000000,4.530000,
55380.000000,-132765.000000,4.530000,
62790.000000,-18345.000000,4.530000,
26980.000000,43305.000000,4.530000,
2680.000000,173865.000000,4.540000,
56150.000000,-161865.000000,4.540000,
19090.000000,120165.000000,4.540000,
18260.000000,-127785.000000,4.540000,
42470.000000,72825.000000,4.540000,
23700.000000,-82725.000000,4.540000,
58830.000000,-87045.000000,4.540000,
220.000000,-62505.000000,4.540000,
84540.000000,46005.000000,4.540000,
25200.000000,277125.000000,4.540000,
10290.000000,126285.000000,4.540000,
21200.000000,99405.000000,4.550000,
75580.000000,171105.000000,4.550000,
77390.000000,85125.000000,4.550000,
26800.000000,177225.000000,4.550000,
51960.000000,-162825.000000,4.550000,
34460.000000,251445.000000,4.550000,
34450.000000,131025.000000,4.550000,
50050.000000,-102945.000000,4.550000,
78110.000000,256785.000000,4.550000,
14320.000000,-221085.000000,4.550000,
85730.000000,-101325.000000,4.560000,
12590.000000,212025.000000,4.560000,
34310.000000,-4305.000000,4.560000,
80670.000000,178125.000000,4.560000,
65280.000000,-102465.000000,4.560000,
32790.000000,138465.000000,4.560000,
37170.000000,-198165.000000,4.560000,
38610.000000,-218085.000000,4.560000,
71600.000000,86745.000000,4.570000,
35520.000000,194685.000000,4.570000,
80460.000000,167565.000000,4.570000,
68080.000000,81585.000000,4.570000,
58330.000000,-100605.000000,4.570000,
35500.000000,-167625.000000,4.570000,
75120.000000,97545.000000,4.570000,
13020.000000,-145005.000000,4.570000,
13370.000000,-134385.000000,4.580000,
27810.000000,-102285.000000,4.580000,
49880.000000,233025.000000,4.580000,
63340.000000,-167445.000000,4.580000,
69640.000000,236625.000000,4.580000,
84030.000000,85545.000000,4.580000,
2470.000000,-165945.000000,4.580000,
68900.000000,-145845.000000,4.580000,
53850.000000,237405.000000,4.580000,
59120.000000,50565.000000,4.590000,
20120.000000,-17445.000000,4.590000,
19610.000000,11205.000000,4.590000,
47530.000000,-215745.000000,4.590000,
70600.000000,-89625.000000,4.590000,
63710.000000,259785.000000,4.590000,
32880.000000,-93105.000000,4.590000,
15490.000000,181125.000000,4.590000,
36300.000000,-47085.000000,4.590000,
34140.000000,-10005.000000,4.590000,
86060.000000,207045.000000,4.590000,
39400.000000,-133725.000000,4.590000,
31210.000000,231645.000000,4.590000,
57210.000000,-91246.000000,4.600000,
23320.000000,-25366.000000,4.600000,
40350.000000,-217186.000000,4.600000,
55520.000000,-139486.000000,4.600000,
1020.000000,139306.000000,4.600000,
39990.000000,-224746.000000,4.600000,
53110.000000,61126.000000,4.600000,
74030.000000,126946.000000,4.600000,
53480.000000,68806.000000,4.610000,
69700.000000,-57526.000000,4.610000,
64820.000000,-13306.000000,4.610000,
57160.000000,152866.000000,4.610000,
6810.000000,11566.000000,4.610000,
11470.000000,142666.000000,4.610000,
320.000000,-20566.000000,4.610000,
56050.000000,-36286.000000,4.610000,
68170.000000,15166.000000,4.620000,
27530.000000,-96526.000000,4.620000,
33340.000000,-134746.000000,4.620000,
62260.000000,134326.000000,4.620000,
28790.000000,-66226.000000,4.620000,
19910.000000,-26386.000000,4.620000,
28380.000000,-178666.000000,4.620000,
21830.000000,72526.000000,4.620000,
63470.000000,-29266.000000,4.620000,
41680.000000,-195406.000000,4.620000,
56470.000000,-160846.000000,4.620000,
31420.000000,-26086.000000,4.620000,
56970.000000,93886.000000,4.620000,
3400.000000,213046.000000,4.620000,
59260.000000,-30166.000000,4.630000,
27320.000000,-102166.000000,4.630000,
39900.000000,26506.000000,4.630000,
72060.000000,100006.000000,4.630000,
81440.000000,185626.000000,4.630000,
46470.000000,-212986.000000,4.630000,
14020.000000,-88606.000000,4.630000,
66680.000000,-224206.000000,4.630000,
66810.000000,-152386.000000,4.630000,
40510.000000,83146.000000,4.630000,
45980.000000,-203386.000000,4.640000,
14390.000000,-86506.000000,4.640000,
43250.000000,23866.000000,4.640000,
18180.000000,77806.000000,4.640000,
57050.000000,-92746.000000,4.640000,
45590.000000,-143986.000000,4.640000,
6570.000000,-38506.000000,4.640000,
27040.000000,-111526.000000,4.640000,
57790.000000,-177286.000000,4.640000,
65230.000000,31486.000000,4.640000,
49590.000000,-185206.000000,4.640000,
83050.000000,180226.000000,4.640000,
21240.000000,-227146.000000,4.640000,
26190.000000,-100426.000000,4.640000,
86260.000000,90526.000000,4.640000,
57810.000000,-208066.000000,4.650000,
38320.000000,-213106.000000,4.650000,
4420.000000,88546.000000,4.650000,
67870.000000,213826.000000,4.650000,
24050.000000,35626.000000,4.650000,
13820.000000,256786.000000,4.650000,
48860.000000,176506.000000,4.650000,
9800.000000,99826.000000,4.650000,
16430.000000,53506.000000,4.650000,
60590.000000,-38866.000000,4.650000,
70760.000000,108586.000000,4.650000,
4280.000000,75766.000000,4.650000,
45550.000000,-28846.000000,4.650000,
65880.000000,-97426.000000,4.650000,
24930.000000,-72586.000000,4.660000,
75670.000000,-116206.000000,4.660000,
74110.000000,52906.000000,4.660000,
80710.000000,4966.000000,4.660000,
69990.000000,1246.000000,4.660000,
56380.000000,-123946.000000,4.660000,
64800.000000,60346.000000,4.660000,
45750.000000,-175786.000000,4.660000,
49240.000000,196906.000000,4.660000,
33050.000000,228706.000000,4.670000,
77820.000000,-70126.000000,4.670000,
12560.000000,178306.000000,4.670000,
76220.000000,36526.000000,4.670000,
18270.000000,55486.000000,4.670000,
17690.000000,36646.000000,4.670000,
21970.000000,-53866.000000,4.670000,
31390.000000,77326.000000,4.670000,
39230.000000,155506.000000,4.670000,
64810.000000,15766.000000,4.670000,
78120.000000,184306.000000,4.670000,
38320.000000,115186.000000,4.670000,
34700.000000,16786.000000,4.670000,
81810.000000,-67846.000000,4.670000,
79400.000000,-204466.000000,4.670000,
27490.000000,-91366.000000,4.680000,
16750.000000,57346.000000,4.680000,
77860.000000,-28306.000000,4.680000,
37640.000000,-207586.000000,4.680000,
6890.000000,-243526.000000,4.680000,
66220.000000,-32206.000000,4.680000,
28870.000000,-5086.000000,4.680000,
48710.000000,-22546.000000,4.680000,
84790.000000,-75346.000000,4.690000,
32170.000000,-189826.000000,4.690000,
83390.000000,-80866.000000,4.690000,
7470.000000,-105526.000000,4.690000,
15990.000000,53026.000000,4.690000,
70340.000000,250786.000000,4.690000,
34030.000000,-80446.000000,4.690000,
84900.000000,-153467.000000,4.700000,
19220.000000,-76487.000000,4.700000,
7310.000000,255287.000000,4.700000,
47170.000000,-174527.000000,4.700000,
12560.000000,-226607.000000,4.700000,
19780.000000,-3947.000000,4.700000,
48580.000000,-83867.000000,4.700000,
76670.000000,-115847.000000,4.700000,
10720.000000,142847.000000,4.700000,
66550.000000,-52487.000000,4.700000,
32730.000000,-253967.000000,4.700000,
10780.000000,32147.000000,4.700000,
42010.000000,-125087.000000,4.700000,
67640.000000,-20627.000000,4.700000,
15290.000000,145787.000000,4.700000,
71750.000000,-94727.000000,4.700000,
33790.000000,-103847.000000,4.700000,
5630.000000,213287.000000,4.700000,
28100.000000,-169547.000000,4.700000,
71650.000000,30527.000000,4.700000,
50250.000000,-229307.000000,4.700000,
82460.000000,303707.000000,4.700000,
36010.000000,28967.000000,4.700000,
1680.000000,64427.000000,4.700000,
19140.000000,144407.000000,4.710000,
29470.000000,-46607.000000,4.710000,
43450.000000,-227447.000000,4.710000,
18330.000000,-206987.000000,4.710000,
49900.000000,-118847.000000,4.720000,
49990.000000,-115007.000000,4.720000,
54300.000000,-169427.000000,4.720000,
67330.000000,-32627.000000,4.720000,
5150.000000,245267.000000,4.720000,
45930.000000,-219587.000000,4.720000,
57980.000000,-162647.000000,4.720000,
75160.000000,-32387.000000,4.720000,
85070.000000,-163847.000000,4.720000,
19300.000000,-1427.000000,4.720000,
26290.000000,-132287.000000,4.720000,
47850.000000,146087.000000,4.720000,
78160.000000,-67967.000000,4.720000,
42280.000000,-66107.000000,4.720000,
8730.000000,181067.000000,4.720000,
56510.000000,-70847.000000,4.720000,
33690.000000,-93527.000000,4.720000,
17550.000000,51347.000000,4.720000,
78240.000000,103487.000000,4.730000,
44440.000000,64127.000000,4.730000,
62190.000000,-1667.000000,4.730000,
58820.000000,-283367.000000,4.730000,
37820.000000,-259247.000000,4.730000,
70300.000000,124067.000000,4.730000,
12630.000000,-18287.000000,4.730000,
37550.000000,121667.000000,4.730000,
42490.000000,-240587.000000,4.730000,
9580.000000,-154427.000000,4.740000,
29480.000000,-154787.000000,4.740000,
34870.000000,-84947.000000,4.740000,
24870.000000,47447.000000,4.740000,
83910.000000,245267.000000,4.740000,
57760.000000,165767.000000,4.740000,
68580.000000,-151607.000000,4.740000,
77870.000000,223547.000000,4.740000,
56560.000000,-124967.000000,4.740000,
47900.000000,-65927.000000,4.740000,
10220.000000,-270287.000000,4.740000,
49900.000000,124007.000000,4.740000,
39710.000000,-8987.000000,4.740000,
21060.000000,134387.000000,4.740000,
37990.000000,145547.000000,4.750000,
51360.000000,184967.000000,4.750000,
26070.000000,-173807.000000,4.750000,
6810.000000,69467.000000,4.750000,
73240.000000,-45947.000000,4.750000,
50990.000000,-192467.000000,4.750000,
21140.000000,6707.000000,4.750000,
82050.000000,299387.000000,4.750000,
64780.000000,-85787.000000,4.750000,
79390.000000,-7787.000000,4.750000,
41800.000000,-35327.000000,4.750000,
9120.000000,-54947.000000,4.750000,
29340.000000,-220727.000000,4.750000,
11130.000000,204227.000000,4.750000,
2650.000000,-38207.000000,4.750000,
48440.000000,-57527.000000,4.750000,
24440.000000,29027.000000,4.750000,
57070.000000,75587.000000,4.750000,
1880.000000,-175727.000000,4.760000,
54220.000000,171647.000000,4.760000,
10260.000000,-75647.000000,4.760000,
4760.000000,98207.000000,4.760000,
31270.000000,-170387.000000,4.760000,
15920.000000,79967.000000,4.760000,
51640.000000,-162767.000000,4.760000,
60830.000000,-152567.000000,4.760000,
19960.000000,115907.000000,4.760000,
74130.000000,-218147.000000,4.760000,
63620.000000,-177947.000000,4.760000,
83220.000000,91727.000000,4.760000,
17550.000000,132167.000000,4.760000,
41410.000000,-10847.000000,4.760000,
72210.000000,-136607.000000,4.760000,
51780.000000,-100007.000000,4.760000,
32550.000000,243527.000000,4.760000,
69370.000000,77087.000000,4.770000,
7070.000000,85007.000000,4.770000,
73730.000000,-64187.000000,4.770000,
40740.000000,137507.000000,4.770000,
66750.000000,205427.000000,4.770000,
44640.000000,185687.000000,4.770000,
62510.000000,-244007.000000,4.770000,
90.000000,-277487.000000,4.770000,
3180.000000,-4127.000000,4.770000,
46730.000000,62747.000000,4.770000,
20100.000000,-21647.000000,4.780000,
72910.000000,92147.000000,4.780000,
35050.000000,-100007.000000,4.780000,
33580.000000,-43127.000000,4.780000,
58130.000000,131447.000000,4.780000,
22730.000000,249587.000000,4.780000,
58690.000000,-103067.000000,4.780000,
28660.000000,-109247.000000,4.780000,
16230.000000,58367.000000,4.780000,
67520.000000,-233567.000000,4.780000,
2520.000000,181907.000000,4.780000,
29610.000000,-129287.000000,4.780000,
75190.000000,159887.000000,4.780000,
17990.000000,-45167.000000,4.780000,
13560.000000,228107.000000,4.780000,
80130.000000,-148907.000000,4.780000,
79780.000000,260507.000000,4.780000,
80470.000000,102047.000000,4.790000,
1900.000000,196307.000000,4.790000,
59410.000000,-90467.000000,4.790000,
47710.000000,-244487.000000,4.790000,
80870.000000,16967.000000,4.790000,
23960.000000,153047.000000,4.790000,
47850.000000,19727.000000,4.790000,
29300.000000,185508.000000,4.800000,
64210.000000,-144348.000000,4.800000,
32210.000000,-213288.000000,4.800000,
33020.000000,241728.000000,4.800000,
3180.000000,220128.000000,4.800000,
52090.000000,-8088.000000,4.800000,
86300.000000,185028.000000,4.800000,
11750.000000,-31788.000000,4.800000,
74310.000000,76368.000000,4.800000,
63080.000000,-86328.000000,4.800000,
20330.000000,-26028.000000,4.800000,
7700.000000,136308.000000,4.800000,
15840.000000,62868.000000,4.800000,
21470.000000,93468.000000,4.800000,
22210.000000,-197928.000000,4.800000,
18080.000000,-25848.000000,4.800000,
38530.000000,-232128.000000,4.800000,
38250.000000,-48228.000000,4.800000,
63410.000000,247548.000000,4.800000,
37180.000000,70188.000000,4.800000,
33650.000000,-224748.000000,4.800000,
51480.000000,127848.000000,4.800000,
54120.000000,90048.000000,4.800000,
47230.000000,99528.000000,4.800000,
25250.000000,-185148.000000,4.800000,
870.000000,72768.000000,4.800000,
46460.000000,-34428.000000,4.800000,
44790.000000,-185268.000000,4.810000,
44550.000000,93108.000000,4.810000,
33620.000000,-34428.000000,4.810000,
66320.000000,-74028.000000,4.810000,
76840.000000,-146988.000000,4.810000,
45290.000000,81528.000000,4.810000,
81700.000000,105528.000000,4.810000,
28820.000000,-228888.000000,4.810000,
54760.000000,-160248.000000,4.810000,
58920.000000,3768.000000,4.810000,
18580.000000,56208.000000,4.810000,
34500.000000,142668.000000,4.810000,
57070.000000,128388.000000,4.810000,
19040.000000,-125688.000000,4.810000,
68060.000000,256728.000000,4.810000,
67560.000000,95988.000000,4.810000,
61260.000000,-15228.000000,4.810000,
41070.000000,-39168.000000,4.810000,
30150.000000,-174588.000000,4.820000,
68050.000000,-81948.000000,4.820000,
3300.000000,212328.000000,4.820000,
26190.000000,-83988.000000,4.820000,
57730.000000,82128.000000,4.820000,
33370.000000,194508.000000,4.820000,
24810.000000,-72828.000000,4.820000,
25730.000000,-142848.000000,4.820000,
38640.000000,-230268.000000,4.820000,
64150.000000,-114168.000000,4.820000,
85300.000000,-64188.000000,4.820000,
30080.000000,-119028.000000,4.820000,
11920.000000,123228.000000,4.820000,
66350.000000,236088.000000,4.820000,
18820.000000,-241908.000000,4.820000,
68220.000000,-21108.000000,4.820000,
50930.000000,279228.000000,4.820000,
53000.000000,95508.000000,4.820000,
1670.000000,-118908.000000,4.820000,
60550.000000,165588.000000,4.830000,
72790.000000,168588.000000,4.830000,
75860.000000,-71508.000000,4.830000,
49040.000000,130668.000000,4.830000,
74930.000000,166068.000000,4.830000,
62240.000000,119208.000000,4.830000,
5250.000000,163488.000000,4.830000,
15230.000000,33408.000000,4.830000,
81810.000000,-149148.000000,4.830000,
83860.000000,176508.000000,4.830000,
81030.000000,-38448.000000,4.830000,
42310.000000,29808.000000,4.830000,
9930.000000,-243468.000000,4.830000,
73060.000000,136968.000000,4.830000,
11990.000000,236388.000000,4.830000,
37830.000000,201588.000000,4.830000,
51020.000000,90408.000000,4.830000,
7030.000000,-170628.000000,4.830000,
71930.000000,-94368.000000,4.830000,
37330.000000,-149988.000000,4.830000,
60050.000000,232608.000000,4.830000,
23950.000000,-50928.000000,4.830000,
7990.000000,159288.000000,4.830000,
5410.000000,22188.000000,4.830000,
26990.000000,-82908.000000,4.840000,
20470.000000,59568.000000,4.840000,
84600.000000,210828.000000,4.840000,
9570.000000,-42828.000000,4.840000,
81930.000000,-192648.000000,4.840000,
11510.000000,267888.000000,4.840000,
47010.000000,-178308.000000,4.840000,
27560.000000,-137988.000000,4.840000,
44790.000000,-227268.000000,4.840000,
47520.000000,-136128.000000,4.840000,
11960.000000,12168.000000,4.840000,
38100.000000,272628.000000,4.840000,
39630.000000,13068.000000,4.840000,
59550.000000,41388.000000,4.840000,
79540.000000,18228.000000,4.840000,
69330.000000,-91008.000000,4.850000,
66050.000000,12228.000000,4.850000,
31300.000000,-57468.000000,4.850000,
36530.000000,-186528.000000,4.850000,
38810.000000,-231828.000000,4.850000,
15690.000000,167448.000000,4.850000,
30920.000000,-208908.000000,4.850000,
64600.000000,-159708.000000,4.850000,
58920.000000,111228.000000,4.850000,
55050.000000,-229008.000000,4.850000,
51580.000000,58788.000000,4.850000,
7000.000000,-81168.000000,4.850000,
13710.000000,-135528.000000,4.860000,
19650.000000,79008.000000,4.860000,
31340.000000,-191268.000000,4.860000,
8220.000000,123228.000000,4.860000,
31180.000000,-106428.000000,4.860000,
86320.000000,-12888.000000,4.860000,
15260.000000,-36948.000000,4.860000,
18800.000000,138588.000000,4.860000,
57490.000000,-51408.000000,4.860000,
83190.000000,213948.000000,4.860000,
61490.000000,-122868.000000,4.860000,
45900.000000,163608.000000,4.860000,
60310.000000,204468.000000,4.860000,
20940.000000,88488.000000,4.860000,
52890.000000,29388.000000,4.860000,
47830.000000,-240468.000000,4.860000,
71180.000000,-71208.000000,4.860000,
24370.000000,214068.000000,4.870000,
67460.000000,-128328.000000,4.870000,
11900.000000,-81108.000000,4.870000,
9350.000000,20148.000000,4.870000,
81550.000000,140628.000000,4.870000,
21180.000000,-121728.000000,4.870000,
68320.000000,-133608.000000,4.870000,
63800.000000,-78108.000000,4.870000,
4940.000000,163908.000000,4.870000,
85620.000000,211188.000000,4.870000,
64660.000000,-150228.000000,4.870000,
81170.000000,-223188.000000,4.870000,
63130.000000,198708.000000,4.880000,
63130.000000,198648.000000,4.880000,
32130.000000,-99708.000000,4.880000,
86340.000000,200748.000000,4.880000,
37880.000000,-193428.000000,4.880000,
74990.000000,-121668.000000,4.880000,
25990.000000,-162708.000000,4.880000,
45710.000000,36888.000000,4.880000,
8750.000000,-44268.000000,4.880000,
670.000000,-55728.000000,4.880000,
70510.000000,-173208.000000,4.880000,
77680.000000,138768.000000,4.880000,
35650.000000,-93408.000000,4.880000,
17390.000000,135048.000000,4.880000,
74200.000000,-9228.000000,4.880000,
27960.000000,66648.000000,4.880000,
74960.000000,-166488.000000,4.880000,
38230.000000,-98748.000000,4.880000,
51050.000000,-58728.000000,4.880000,
42710.000000,-234768.000000,4.890000,
67410.000000,-29808.000000,4.890000,
46810.000000,110868.000000,4.890000,
25050.000000,162348.000000,4.890000,
57800.000000,-139008.000000,4.890000,
20970.000000,45588.000000,4.890000,
27550.000000,124548.000000,4.890000,
60960.000000,234528.000000,4.890000,
59300.000000,-252408.000000,4.890000,
5130.000000,-52608.000000,4.890000,
22790.000000,-10668.000000,4.890000,
61520.000000,45949.000000,4.900000,
43170.000000,-281629.000000,4.900000,
9230.000000,-101689.000000,4.900000,
18440.000000,67189.000000,4.900000,
59920.000000,176149.000000,4.900000,
46240.000000,-122449.000000,4.900000,
11690.000000,75769.000000,4.900000,
82510.000000,31789.000000,4.900000,
51490.000000,-291649.000000,4.900000,
59640.000000,-158629.000000,4.900000,
18080.000000,-72229.000000,4.900000,
2930.000000,183529.000000,4.900000,
54870.000000,-113509.000000,4.900000,
9730.000000,144709.000000,4.900000,
42390.000000,-145849.000000,4.900000,
71050.000000,134509.000000,4.900000,
38310.000000,-60769.000000,4.900000,
20540.000000,5389.000000,4.900000,
74690.000000,91009.000000,4.900000,
73770.000000,-10429.000000,4.900000,
78990.000000,229129.000000,4.900000,
22670.000000,221509.000000,4.900000,
27060.000000,296689.000000,4.900000,
59310.000000,150829.000000,4.900000,
71730.000000,188809.000000,4.910000,
47650.000000,-212809.000000,4.910000,
53090.000000,-126709.000000,4.910000,
45710.000000,-214909.000000,4.910000,
67990.000000,182569.000000,4.910000,
25810.000000,-15289.000000,4.910000,
16310.000000,-229.000000,4.910000,
49780.000000,76609.000000,4.910000,
25900.000000,141589.000000,4.910000,
57920.000000,-71329.000000,4.920000,
23910.000000,-173629.000000,4.920000,
51750.000000,-210469.000000,4.920000,
84410.000000,4549.000000,4.920000,
54050.000000,-30709.000000,4.920000,
25430.000000,-178549.000000,4.920000,
31780.000000,-163129.000000,4.920000,
21890.000000,-59389.000000,4.920000,
15050.000000,-151189.000000,4.920000,
79800.000000,-117229.000000,4.920000,
60090.000000,-63949.000000,4.920000,
19150.000000,79609.000000,4.920000,
47620.000000,144589.000000,4.920000,
46840.000000,202969.000000,4.930000,
46390.000000,76489.000000,4.930000,
85440.000000,105709.000000,4.930000,
48840.000000,13189.000000,4.930000,
58320.000000,-36289.000000,4.930000,
20450.000000,-4129.000000,4.930000,
44780.000000,98209.000000,4.930000,
54430.000000,89629.000000,4.930000,
55450.000000,-37249.000000,4.930000,
34930.000000,-86149.000000,4.930000,
42050.000000,-223549.000000,4.930000,
15620.000000,124489.000000,4.930000,
33330.000000,-138889.000000,4.930000,
27330.000000,-189169.000000,4.930000,
28780.000000,-13249.000000,4.930000,
68400.000000,115729.000000,4.930000,
72440.000000,-190429.000000,4.930000,
17950.000000,136429.000000,4.940000,
52840.000000,59149.000000,4.940000,
39920.000000,-98269.000000,4.940000,
7940.000000,109129.000000,4.940000,
37860.000000,-263629.000000,4.940000,
82320.000000,155989.000000,4.940000,
37440.000000,236089.000000,4.940000,
72870.000000,132529.000000,4.940000,
12080.000000,156049.000000,4.940000,
58650.000000,272749.000000,4.940000,
19480.000000,6649.000000,4.940000,
71460.000000,81409.000000,4.940000,
72560.000000,132709.000000,4.940000,
22320.000000,58129.000000,4.940000,
71750.000000,138589.000000,4.940000,
46300.000000,99169.000000,4.940000,
53460.000000,-8329.000000,4.940000,
44180.000000,86269.000000,4.940000,
45280.000000,252109.000000,4.940000,
10740.000000,126709.000000,4.940000,
29010.000000,100069.000000,4.940000,
27620.000000,-55009.000000,4.940000,
66010.000000,79129.000000,4.940000,
24970.000000,-175429.000000,4.940000,
35690.000000,-68449.000000,4.940000,
73800.000000,176269.000000,4.950000,
21710.000000,-38209.000000,4.950000,
6030.000000,146089.000000,4.950000,
15620.000000,98509.000000,4.950000,
21290.000000,200569.000000,4.950000,
72850.000000,54769.000000,4.950000,
2600.000000,169369.000000,4.950000,
70610.000000,-25369.000000,4.950000,
66700.000000,-165349.000000,4.950000,
57460.000000,197149.000000,4.950000,
4510.000000,-163969.000000,4.950000,
6100.000000,153469.000000,4.950000,
85560.000000,167149.000000,4.950000,
41270.000000,10309.000000,4.950000,
44420.000000,11989.000000,4.950000,
56410.000000,-85849.000000,4.950000,
26320.000000,-88489.000000,4.950000,
64890.000000,77809.000000,4.960000,
13340.000000,122329.000000,4.960000,
52090.000000,-106249.000000,4.960000,
74830.000000,123769.000000,4.960000,
15430.000000,74149.000000,4.960000,
28410.000000,96349.000000,4.960000,
26530.000000,-68509.000000,4.960000,
42590.000000,-252829.000000,4.960000,
69450.000000,-68269.000000,4.960000,
21320.000000,-133669.000000,4.960000,
34310.000000,40729.000000,4.960000,
16100.000000,58909.000000,4.960000,
14470.000000,-219949.000000,4.960000,
71750.000000,211909.000000,4.960000,
82580.000000,179089.000000,4.960000,
55880.000000,278509.000000,4.960000,
68170.000000,15169.000000,4.970000,
84830.000000,112789.000000,4.970000,
69840.000000,106729.000000,4.970000,
14240.000000,227149.000000,4.970000,
59270.000000,247609.000000,4.970000,
48500.000000,49669.000000,4.970000,
40960.000000,156589.000000,4.970000,
47340.000000,-83269.000000,4.970000,
32750.000000,18409.000000,4.970000,
31200.000000,-44929.000000,4.970000,
84290.000000,224269.000000,4.970000,
65510.000000,113089.000000,4.970000,
83930.000000,-34609.000000,4.980000,
27780.000000,211429.000000,4.980000,
49300.000000,-196429.000000,4.980000,
18400.000000,185809.000000,4.980000,
4800.000000,209689.000000,4.980000,
10720.000000,-230689.000000,4.980000,
25370.000000,-15349.000000,4.980000,
37370.000000,-240889.000000,4.980000,
6960.000000,247309.000000,4.980000,
48880.000000,133909.000000,4.980000,
19460.000000,62629.000000,4.980000,
58620.000000,-180289.000000,4.980000,
29600.000000,-56869.000000,4.980000,
57570.000000,-150289.000000,4.980000,
5960.000000,159889.000000,4.980000,
24650.000000,-123769.000000,4.980000,
69230.000000,207769.000000,4.980000,
6160.000000,-13369.000000,4.980000,
61380.000000,50749.000000,4.980000,
76700.000000,158209.000000,4.980000,
66230.000000,211729.000000,4.990000,
39640.000000,22009.000000,4.990000,
55900.000000,147289.000000,4.990000,
19370.000000,12829.000000,4.990000,
71180.000000,121489.000000,4.990000,
24960.000000,-50629.000000,4.990000,
19470.000000,134689.000000,4.990000,
57680.000000,107509.000000,4.990000,
86250.000000,-231529.000000,4.990000,
44810.000000,96649.000000,4.990000,
12480.000000,176689.000000,4.990000,
13330.000000,-115009.000000,4.990000,
7760.000000,93409.000000,4.990000,
55320.000000,-172609.000000,4.990000,
65240.000000,156529.000000,4.990000,
44190.000000,119029.000000,4.990000,
68100.000000,-81709.000000,4.990000,
79700.000000,-122629.000000,4.990000,
27220.000000,-52309.000000,4.990000,
51130.000000,8750.000000,5.000000,
58400.000000,-196730.000000,5.000000,
14050.000000,-10670.000000,5.000000,
58080.000000,61430.000000,5.000000,
72250.000000,-115430.000000,5.000000,
26980.000000,100550.000000,5.000000,
14220.000000,220070.000000,5.000000,
44340.000000,-198530.000000,5.000000,
16730.000000,-43670.000000,5.000000,
85180.000000,-51290.000000,5.000000,
80490.000000,43970.000000,5.000000,
33060.000000,-161630.000000,5.000000,
34440.000000,-184610.000000,5.000000,
22540.000000,-49430.000000,5.000000,
7330.000000,196190.000000,5.000000,
30880.000000,-179870.000000,5.000000,
69630.000000,-19550.000000,5.000000,
26730.000000,33410.000000,5.000000,
22020.000000,-223790.000000,5.000000,
34390.000000,-76070.000000,5.000000,
66130.000000,-139190.000000,5.000000,
8570.000000,-265190.000000,5.000000,
38580.000000,248750.000000,5.000000,
24640.000000,150470.000000,5.000000,
75270.000000,101090.000000,5.000000,
57800.000000,-93170.000000,5.000000,
40990.000000,-130250.000000,5.000000,
53870.000000,-275990.000000,5.000000,
23090.000000,177470.000000,5.000000,
29050.000000,-117710.000000,5.000000,
62410.000000,65090.000000,5.000000,
49290.000000,-31370.000000,5.000000,
45000.000000,249170.000000,5.000000,
26000.000000,58250.000000,5.000000,
1300.000000,-72290.000000,5.000000,
72100.000000,-213830.000000,5.000000,
78460.000000,-111290.000000,5.010000,
28330.000000,-124970.000000,5.010000,
37970.000000,-169250.000000,5.010000,
57200.000000,-72650.000000,5.010000,
67490.000000,7430.000000,5.010000,
22050.000000,-134150.000000,5.010000,
64160.000000,277130.000000,5.010000,
44750.000000,140510.000000,5.010000,
18130.000000,-94670.000000,5.010000,
34630.000000,24650.000000,5.010000,
50190.000000,99050.000000,5.010000,
76400.000000,-252530.000000,5.010000,
22270.000000,-236150.000000,5.010000,
71330.000000,68930.000000,5.020000,
69910.000000,-88250.000000,5.020000,
18920.000000,117710.000000,5.020000,
59130.000000,-84470.000000,5.020000,
70470.000000,71210.000000,5.020000,
45300.000000,66230.000000,5.020000,
65500.000000,-85370.000000,5.020000,
85670.000000,244130.000000,5.020000,
71870.000000,-55790.000000,5.020000,
26310.000000,178130.000000,5.020000,
16130.000000,47030.000000,5.020000,
26210.000000,-131810.000000,5.020000,
130.000000,-107090.000000,5.020000,
53570.000000,-136130.000000,5.020000,
65630.000000,231890.000000,5.020000,
39340.000000,120650.000000,5.020000,
49790.000000,-65330.000000,5.020000,
81460.000000,-15290.000000,5.020000,
55020.000000,258590.000000,5.020000,
70240.000000,-10070.000000,5.020000,
18290.000000,-178550.000000,5.020000,
8330.000000,103190.000000,5.030000,
68480.000000,169070.000000,5.030000,
61310.000000,-115790.000000,5.030000,
22580.000000,44210.000000,5.030000,
21790.000000,-94670.000000,5.030000,
21540.000000,-34490.000000,5.030000,
7590.000000,81590.000000,5.030000,
6360.000000,-192710.000000,5.030000,
64140.000000,182870.000000,5.030000,
77810.000000,145550.000000,5.030000,
19200.000000,122270.000000,5.030000,
26960.000000,101270.000000,5.030000,
68300.000000,-190610.000000,5.030000,
610.000000,165890.000000,5.030000,
79150.000000,263510.000000,5.030000,
74250.000000,-221510.000000,5.030000,
11770.000000,183410.000000,5.030000,
26600.000000,90230.000000,5.030000,
17410.000000,-58430.000000,5.030000,
71430.000000,190790.000000,5.030000,
43480.000000,-275510.000000,5.030000,
62310.000000,39170.000000,5.030000,
24180.000000,160310.000000,5.030000,
55850.000000,147050.000000,5.030000,
83810.000000,-27830.000000,5.030000,
69770.000000,-196010.000000,5.040000,
4080.000000,158270.000000,5.040000,
38600.000000,83570.000000,5.040000,
27930.000000,-52490.000000,5.040000,
68080.000000,-56270.000000,5.040000,
11940.000000,180410.000000,5.040000,
14660.000000,213050.000000,5.040000,
47520.000000,-58370.000000,5.040000,
16920.000000,-133730.000000,5.040000,
48300.000000,-269690.000000,5.040000,
60700.000000,88790.000000,5.040000,
29200.000000,-162950.000000,5.040000,
79890.000000,213950.000000,5.040000,
35550.000000,-29210.000000,5.050000,
19350.000000,285290.000000,5.050000,
31140.000000,-81590.000000,5.050000,
74340.000000,36350.000000,5.050000,
16790.000000,191150.000000,5.050000,
51290.000000,36410.000000,5.050000,
72080.000000,180470.000000,5.050000,
75000.000000,158690.000000,5.050000,
67350.000000,199970.000000,5.050000,
48560.000000,-184250.000000,5.050000,
22310.000000,-23630.000000,5.050000,
23270.000000,-17210.000000,5.050000,
51740.000000,-288470.000000,5.050000,
25100.000000,-122870.000000,5.050000,
74310.000000,86870.000000,5.050000,
13750.000000,86930.000000,5.050000,
22120.000000,-247850.000000,5.050000,
85580.000000,12590.000000,5.050000,
70950.000000,-58130.000000,5.050000,
42210.000000,-224990.000000,5.050000,
39560.000000,145610.000000,5.050000,
27770.000000,-162650.000000,5.050000,
84020.000000,19430.000000,5.050000,
27560.000000,63650.000000,5.050000,
66090.000000,176870.000000,5.050000,
85940.000000,68870.000000,5.050000,
12600.000000,199670.000000,5.060000,
67460.000000,142850.000000,5.060000,
51290.000000,-205550.000000,5.060000,
13690.000000,40130.000000,5.060000,
55150.000000,6410.000000,5.060000,
11560.000000,-4370.000000,5.060000,
19300.000000,-89210.000000,5.060000,
78590.000000,108710.000000,5.060000,
68240.000000,-74390.000000,5.060000,
78780.000000,93350.000000,5.060000,
16250.000000,-161870.000000,5.060000,
34810.000000,-51650.000000,5.060000,
37810.000000,-2330.000000,5.060000,
18920.000000,-97010.000000,5.060000,
39650.000000,141230.000000,5.060000,
29890.000000,-236270.000000,5.060000,
63110.000000,245330.000000,5.060000,
19460.000000,-3230.000000,5.060000,
24450.000000,-32450.000000,5.060000,
2910.000000,-269750.000000,5.060000,
85400.000000,37250.000000,5.060000,
65160.000000,80090.000000,5.060000,
35390.000000,-164690.000000,5.070000,
56360.000000,131990.000000,5.070000,
41310.000000,-153650.000000,5.070000,
61840.000000,-160490.000000,5.070000,
36370.000000,-170570.000000,5.070000,
5980.000000,-202370.000000,5.070000,
34310.000000,35030.000000,5.070000,
38040.000000,-85550.000000,5.070000,
16750.000000,56930.000000,5.070000,
72410.000000,85070.000000,5.070000,
78790.000000,-48830.000000,5.070000,
81340.000000,265130.000000,5.070000,
2930.000000,61010.000000,5.070000,
38080.000000,25070.000000,5.070000,
38180.000000,-214490.000000,5.070000,
19650.000000,124130.000000,5.070000,
18020.000000,292370.000000,5.070000,
61770.000000,146810.000000,5.070000,
27620.000000,313310.000000,5.070000,
7430.000000,152450.000000,5.080000,
82950.000000,153950.000000,5.080000,
28040.000000,-138710.000000,5.080000,
28630.000000,-158810.000000,5.080000,
59770.000000,190610.000000,5.080000,
81840.000000,150590.000000,5.080000,
84180.000000,44390.000000,5.080000,
20120.000000,-19550.000000,5.080000,
51850.000000,20990.000000,5.080000,
29630.000000,-130790.000000,5.080000,
30450.000000,-191150.000000,5.080000,
41000.000000,-67670.000000,5.080000,
82800.000000,205070.000000,5.080000,
22210.000000,-269150.000000,5.080000,
80180.000000,-149870.000000,5.080000,
57320.000000,-247010.000000,5.080000,
78300.000000,-32690.000000,5.080000,
55010.000000,-219470.000000,5.080000,
31830.000000,-167510.000000,5.090000,
74900.000000,-158390.000000,5.090000,
81510.000000,204530.000000,5.090000,
44160.000000,53690.000000,5.090000,
13770.000000,119150.000000,5.090000,
23610.000000,-4490.000000,5.090000,
68810.000000,39890.000000,5.090000,
2160.000000,195050.000000,5.090000,
35310.000000,165710.000000,5.090000,
26780.000000,-183710.000000,5.090000,
77970.000000,8150.000000,5.090000,
48360.000000,-143150.000000,5.090000,
7040.000000,64190.000000,5.090000,
72300.000000,71990.000000,5.090000,
39210.000000,196550.000000,5.090000,
12160.000000,74690.000000,5.090000,
41570.000000,-111950.000000,5.090000,
80400.000000,-289610.000000,5.090000,
34420.000000,-176511.000000,5.100000,
41000.000000,-233871.000000,5.100000,
18400.000000,-16791.000000,5.100000,
65220.000000,110091.000000,5.100000,
15000.000000,290511.000000,5.100000,
69510.000000,3951.000000,5.100000,
26510.000000,73671.000000,5.100000,
78010.000000,155811.000000,5.100000,
10630.000000,115011.000000,5.100000,
57070.000000,-11151.000000,5.100000,
17480.000000,67851.000000,5.100000,
26310.000000,-132351.000000,5.100000,
33970.000000,-192231.000000,5.100000,
20990.000000,-240951.000000,5.100000,
34430.000000,-291471.000000,5.100000,
14010.000000,-125091.000000,5.100000,
100.000000,-10971.000000,5.100000,
11010.000000,-215151.000000,5.100000,
47810.000000,-113511.000000,5.100000,
86330.000000,-189891.000000,5.100000,
28740.000000,-83931.000000,5.100000,
75910.000000,-197031.000000,5.100000,
74400.000000,-65331.000000,5.100000,
16450.000000,-29631.000000,5.100000,
18450.000000,-228291.000000,5.100000,
77760.000000,163431.000000,5.100000,
13320.000000,227631.000000,5.100000,
5370.000000,-77931.000000,5.110000,
15830.000000,34131.000000,5.110000,
70240.000000,100731.000000,5.110000,
4460.000000,-28611.000000,5.110000,
41500.000000,-214011.000000,5.110000,
79500.000000,224271.000000,5.110000,
45340.000000,-147711.000000,5.110000,
29100.000000,47271.000000,5.110000,
6860.000000,-153051.000000,5.110000,
66250.000000,142251.000000,5.110000,
65330.000000,72231.000000,5.110000,
62650.000000,-159051.000000,5.110000,
83010.000000,-125151.000000,5.110000,
70850.000000,163911.000000,5.110000,
74400.000000,-218031.000000,5.110000,
85920.000000,-295311.000000,5.110000,
70500.000000,-38091.000000,5.110000,
33380.000000,-159411.000000,5.110000,
38510.000000,236631.000000,5.110000,
64120.000000,92271.000000,5.110000,
42520.000000,-96351.000000,5.110000,
51800.000000,30471.000000,5.120000,
26520.000000,132411.000000,5.120000,
43930.000000,279471.000000,5.120000,
60400.000000,-241611.000000,5.120000,
66060.000000,103971.000000,5.120000,
29610.000000,-169191.000000,5.120000,
71590.000000,207171.000000,5.120000,
24820.000000,248031.000000,5.120000,
35860.000000,147831.000000,5.120000,
18520.000000,-16071.000000,5.120000,
63840.000000,-186651.000000,5.120000,
69100.000000,204711.000000,5.120000,
57670.000000,64191.000000,5.120000,
68310.000000,-216771.000000,5.120000,
25410.000000,39471.000000,5.120000,
45990.000000,59691.000000,5.120000,
49610.000000,-130551.000000,5.130000,
67420.000000,-137991.000000,5.130000,
69220.000000,8271.000000,5.130000,
71460.000000,37551.000000,5.130000,
30350.000000,27231.000000,5.130000,
860.000000,-28071.000000,5.130000,
20110.000000,-19431.000000,5.130000,
69960.000000,130791.000000,5.130000,
8880.000000,-121791.000000,5.130000,
12620.000000,40911.000000,5.130000,
43420.000000,-152811.000000,5.130000,
24590.000000,-167811.000000,5.130000,
27430.000000,-14811.000000,5.130000,
30000.000000,98031.000000,5.130000,
19580.000000,-212151.000000,5.130000,
66900.000000,-39531.000000,5.130000,
51570.000000,-8211.000000,5.130000,
80490.000000,-77811.000000,5.130000,
22660.000000,-60591.000000,5.130000,
58260.000000,-105951.000000,5.130000,
51160.000000,-98151.000000,5.130000,
2200.000000,160191.000000,5.130000,
7300.000000,-161031.000000,5.130000,
56110.000000,140511.000000,5.130000,
40030.000000,-153531.000000,5.140000,
1960.000000,-226971.000000,5.140000,
67460.000000,142611.000000,5.140000,
44520.000000,-243111.000000,5.140000,
74790.000000,58131.000000,5.140000,
69920.000000,71331.000000,5.140000,
28050.000000,120351.000000,5.140000,
83370.000000,31311.000000,5.140000,
19400.000000,207231.000000,5.140000,
47890.000000,178851.000000,5.140000,
62450.000000,88251.000000,5.140000,
21800.000000,70971.000000,5.140000,
74510.000000,-240411.000000,5.140000,
28300.000000,6411.000000,5.140000,
41880.000000,-222591.000000,5.140000,
75880.000000,-277311.000000,5.140000,
54870.000000,242511.000000,5.140000,
32960.000000,79431.000000,5.140000,
25840.000000,-176211.000000,5.140000,
41820.000000,-220671.000000,5.140000,
50080.000000,-5511.000000,5.140000,
27820.000000,-147411.000000,5.140000,
79560.000000,162111.000000,5.140000,
60350.000000,30951.000000,5.140000,
29710.000000,-226551.000000,5.150000,
76970.000000,24591.000000,5.150000,
70750.000000,19491.000000,5.150000,
32360.000000,-212751.000000,5.150000,
64390.000000,144111.000000,5.150000,
36810.000000,-239031.000000,5.150000,
43320.000000,155031.000000,5.150000,
27210.000000,56991.000000,5.150000,
24140.000000,63591.000000,5.150000,
83500.000000,31491.000000,5.150000,
55710.000000,6651.000000,5.150000,
31420.000000,-179451.000000,5.150000,
11910.000000,180831.000000,5.150000,
24650.000000,243291.000000,5.150000,
50310.000000,-89931.000000,5.150000,
40110.000000,-223011.000000,5.150000,
38100.000000,205551.000000,5.150000,
68940.000000,275691.000000,5.150000,
53440.000000,-57651.000000,5.150000,
1260.000000,136731.000000,5.150000,
68780.000000,-188451.000000,5.150000,
69890.000000,43071.000000,5.150000,
31910.000000,157491.000000,5.150000,
28670.000000,-164091.000000,5.150000,
56070.000000,-101031.000000,5.150000,
9120.000000,130191.000000,5.150000,
32900.000000,240771.000000,5.150000,
24260.000000,-111891.000000,5.160000,
37910.000000,-162291.000000,5.160000,
41960.000000,-235491.000000,5.160000,
74360.000000,1791.000000,5.160000,
10590.000000,-13431.000000,5.160000,
66740.000000,-142971.000000,5.160000,
4660.000000,13071.000000,5.160000,
4260.000000,113211.000000,5.160000,
20380.000000,93231.000000,5.160000,
46620.000000,-184371.000000,5.160000,
23710.000000,100911.000000,5.160000,
82340.000000,35451.000000,5.160000,
4090.000000,197751.000000,5.160000,
9480.000000,262191.000000,5.160000,
21050.000000,-187671.000000,5.160000,
75330.000000,49431.000000,5.160000,
34970.000000,260151.000000,5.160000,
78180.000000,260451.000000,5.160000,
270.000000,-37911.000000,5.160000,
55690.000000,-60231.000000,5.160000,
28770.000000,-218211.000000,5.160000,
66680.000000,-66291.000000,5.170000,
32330.000000,-170091.000000,5.170000,
7530.000000,274071.000000,5.170000,
85880.000000,-68151.000000,5.170000,
25450.000000,-204351.000000,5.170000,
42960.000000,-61791.000000,5.170000,
15820.000000,-13551.000000,5.170000,
41500.000000,-214311.000000,5.170000,
18460.000000,73551.000000,5.170000,
44650.000000,94011.000000,5.170000,
76760.000000,233571.000000,5.170000,
85630.000000,-180891.000000,5.170000,
56060.000000,-33111.000000,5.170000,
73110.000000,125991.000000,5.170000,
41140.000000,-230331.000000,5.170000,
33260.000000,221151.000000,5.170000,
72930.000000,84651.000000,5.170000,
25340.000000,87171.000000,5.170000,
1290.000000,-104391.000000,5.170000,
67960.000000,-187611.000000,5.170000,
70590.000000,160911.000000,5.170000,
26640.000000,146451.000000,5.170000,
47270.000000,-38691.000000,5.170000,
43670.000000,-271371.000000,5.170000,
25190.000000,-244551.000000,5.170000,
40630.000000,7311.000000,5.170000,
55540.000000,55611.000000,5.170000,
20760.000000,-116391.000000,5.170000,
8540.000000,201051.000000,5.180000,
46470.000000,-205911.000000,5.180000,
28300.000000,-50091.000000,5.180000,
64880.000000,77811.000000,5.180000,
23480.000000,-44631.000000,5.180000,
19910.000000,-274911.000000,5.180000,
6170.000000,254271.000000,5.180000,
1820.000000,-85671.000000,5.180000,
69770.000000,94611.000000,5.180000,
38610.000000,166371.000000,5.180000,
78090.000000,-50631.000000,5.180000,
8660.000000,180051.000000,5.180000,
75980.000000,-116451.000000,5.180000,
28180.000000,-62031.000000,5.180000,
18700.000000,57771.000000,5.180000,
24110.000000,-33051.000000,5.180000,
27990.000000,135111.000000,5.180000,
31140.000000,-253431.000000,5.190000,
84150.000000,-54171.000000,5.190000,
30080.000000,-131391.000000,5.190000,
31210.000000,-145011.000000,5.190000,
22490.000000,68991.000000,5.190000,
14790.000000,99411.000000,5.190000,
73890.000000,269931.000000,5.190000,
1690.000000,159831.000000,5.190000,
15400.000000,193071.000000,5.190000,
56790.000000,225411.000000,5.190000,
17680.000000,41211.000000,5.190000,
72850.000000,103311.000000,5.190000,
3000.000000,-38391.000000,5.190000,
8550.000000,-85791.000000,5.190000,
23230.000000,1131.000000,5.190000,
53730.000000,-216471.000000,5.190000,
1800.000000,107152.000000,5.200000,
21530.000000,2092.000000,5.200000,
4060.000000,-149392.000000,5.200000,
31190.000000,-191032.000000,5.200000,
40360.000000,-231112.000000,5.200000,
2110.000000,-13012.000000,5.200000,
62280.000000,-87532.000000,5.200000,
71430.000000,139432.000000,5.200000,
25440.000000,-152452.000000,5.200000,
45930.000000,27652.000000,5.200000,
21290.000000,215632.000000,5.200000,
32230.000000,55192.000000,5.200000,
9890.000000,44812.000000,5.200000,
29370.000000,-158932.000000,5.200000,
71990.000000,133372.000000,5.200000,
23920.000000,143692.000000,5.200000,
47140.000000,128932.000000,5.200000,
35890.000000,44812.000000,5.200000,
81280.000000,-74572.000000,5.200000,
9640.000000,-196432.000000,5.200000,
54280.000000,-230572.000000,5.200000,
31790.000000,-118012.000000,5.200000,
54960.000000,-149392.000000,5.200000,
59440.000000,-221932.000000,5.200000,
54310.000000,-147892.000000,5.200000,
48770.000000,-36652.000000,5.200000,
75090.000000,-185872.000000,5.200000,
69380.000000,-163732.000000,5.200000,
26150.000000,214732.000000,5.200000,
83080.000000,-194332.000000,5.200000,
54390.000000,-58552.000000,5.200000,
25310.000000,-20692.000000,5.200000,
58940.000000,121732.000000,5.200000,
35190.000000,205672.000000,5.200000,
76170.000000,246592.000000,5.200000,
77320.000000,-250252.000000,5.200000,
16650.000000,-8932.000000,5.210000,
68840.000000,117052.000000,5.210000,
53160.000000,-91612.000000,5.210000,
47800.000000,34012.000000,5.210000,
66430.000000,772.000000,5.210000,
83940.000000,-48472.000000,5.210000,
53220.000000,-188632.000000,5.210000,
23200.000000,210352.000000,5.210000,
42100.000000,-117052.000000,5.210000,
51590.000000,-220672.000000,5.210000,
81510.000000,228952.000000,5.210000,
15270.000000,36112.000000,5.210000,
3040.000000,-183592.000000,5.210000,
84670.000000,141292.000000,5.210000,
32130.000000,100612.000000,5.210000,
23360.000000,-204712.000000,5.210000,
47750.000000,-71872.000000,5.210000,
24450.000000,175732.000000,5.210000,
23050.000000,-41572.000000,5.210000,
10720.000000,-10072.000000,5.220000,
30560.000000,-161032.000000,5.220000,
32500.000000,-187972.000000,5.220000,
35930.000000,-129292.000000,5.220000,
70950.000000,42592.000000,5.220000,
47390.000000,63112.000000,5.220000,
41120.000000,-129892.000000,5.220000,
37760.000000,-9952.000000,5.220000,
12970.000000,-62932.000000,5.220000,
21850.000000,-24172.000000,5.220000,
18360.000000,212332.000000,5.220000,
81680.000000,144832.000000,5.220000,
19300.000000,150532.000000,5.220000,
68940.000000,21892.000000,5.220000,
62760.000000,-182392.000000,5.220000,
58430.000000,-42652.000000,5.220000,
24690.000000,78412.000000,5.230000,
30330.000000,-186292.000000,5.230000,
26880.000000,25072.000000,5.230000,
72120.000000,89812.000000,5.230000,
73010.000000,145372.000000,5.230000,
76010.000000,139492.000000,5.230000,
60460.000000,18952.000000,5.230000,
13660.000000,-85972.000000,5.230000,
23500.000000,41632.000000,5.230000,
28050.000000,-167872.000000,5.230000,
32860.000000,38452.000000,5.230000,
2680.000000,-79252.000000,5.230000,
7960.000000,76372.000000,5.230000,
28760.000000,-141472.000000,5.230000,
11890.000000,-225052.000000,5.230000,
67660.000000,-145552.000000,5.230000,
15710.000000,-228232.000000,5.230000,
55760.000000,-168292.000000,5.230000,
77360.000000,167572.000000,5.230000,
33400.000000,-22912.000000,5.230000,
83010.000000,241972.000000,5.230000,
12280.000000,232552.000000,5.230000,
48400.000000,-45772.000000,5.230000,
67790.000000,117232.000000,5.240000,
4420.000000,27352.000000,5.240000,
62590.000000,-170932.000000,5.240000,
33260.000000,-155692.000000,5.240000,
38790.000000,-231412.000000,5.240000,
78600.000000,62272.000000,5.240000,
39210.000000,-72532.000000,5.240000,
24400.000000,156952.000000,5.240000,
78120.000000,-83812.000000,5.240000,
58820.000000,-283252.000000,5.240000,
79990.000000,310012.000000,5.240000,
26310.000000,-141232.000000,5.240000,
46520.000000,235612.000000,5.240000,
63480.000000,-196252.000000,5.240000,
27120.000000,6952.000000,5.240000,
19410.000000,-50152.000000,5.240000,
66250.000000,-158872.000000,5.240000,
31310.000000,-163552.000000,5.240000,
13470.000000,-4252.000000,5.240000,
37050.000000,-29092.000000,5.240000,
41750.000000,-171532.000000,5.240000,
700.000000,-126532.000000,5.240000,
79900.000000,204712.000000,5.240000,
23540.000000,-135772.000000,5.240000,
54370.000000,196432.000000,5.240000,
59430.000000,73792.000000,5.240000,
56260.000000,145312.000000,5.240000,
76530.000000,-74392.000000,5.240000,
67540.000000,266752.000000,5.240000,
6150.000000,73012.000000,5.240000,
23860.000000,-116452.000000,5.240000,
60870.000000,-22192.000000,5.240000,
51120.000000,250012.000000,5.240000,
59260.000000,-27412.000000,5.240000,
10750.000000,76852.000000,5.250000,
13810.000000,92152.000000,5.250000,
73630.000000,-65572.000000,5.250000,
44430.000000,-80032.000000,5.250000,
24440.000000,-136612.000000,5.250000,
26860.000000,77272.000000,5.250000,
63290.000000,222772.000000,5.250000,
51320.000000,-65572.000000,5.250000,
10140.000000,-226132.000000,5.250000,
38950.000000,37972.000000,5.250000,
61290.000000,120892.000000,5.250000,
34700.000000,144892.000000,5.250000,
30910.000000,-209692.000000,5.250000,
38810.000000,-204412.000000,5.250000,
33480.000000,-183832.000000,5.250000,
47480.000000,-156172.000000,5.250000,
41760.000000,249652.000000,5.250000,
58900.000000,248812.000000,5.250000,
9090.000000,8212.000000,5.250000,
42410.000000,200332.000000,5.250000,
66160.000000,64252.000000,5.250000,
16450.000000,-32392.000000,5.250000,
50890.000000,178132.000000,5.250000,
50870.000000,157912.000000,5.250000,
17280.000000,204412.000000,5.260000,
31070.000000,-94552.000000,5.260000,
20880.000000,23272.000000,5.260000,
41190.000000,-220072.000000,5.260000,
20140.000000,-17512.000000,5.260000,
68340.000000,49072.000000,5.260000,
11190.000000,-22012.000000,5.260000,
39150.000000,-206152.000000,5.260000,
54860.000000,105052.000000,5.260000,
11050.000000,-27472.000000,5.260000,
68830.000000,130012.000000,5.260000,
15630.000000,54352.000000,5.260000,
5170.000000,69052.000000,5.260000,
76380.000000,-142012.000000,5.260000,
37860.000000,297232.000000,5.260000,
82050.000000,-70672.000000,5.260000,
57010.000000,7972.000000,5.260000,
5400.000000,169252.000000,5.260000,
37730.000000,-231112.000000,5.260000,
33250.000000,-200092.000000,5.260000,
56180.000000,36112.000000,5.260000,
42040.000000,76912.000000,5.260000,
6120.000000,-116452.000000,5.260000,
85340.000000,-55672.000000,5.260000,
730.000000,-64672.000000,5.260000,
7170.000000,232672.000000,5.270000,
20860.000000,50092.000000,5.270000,
85560.000000,-67312.000000,5.270000,
14190.000000,182512.000000,5.270000,
36520.000000,-236992.000000,5.270000,
64740.000000,-109012.000000,5.270000,
51980.000000,69292.000000,5.270000,
27840.000000,181612.000000,5.270000,
7970.000000,-110692.000000,5.270000,
35740.000000,179452.000000,5.270000,
17060.000000,-215092.000000,5.270000,
36800.000000,-184492.000000,5.270000,
64940.000000,75052.000000,5.270000,
14490.000000,-5632.000000,5.270000,
12070.000000,76192.000000,5.270000,
85450.000000,-65872.000000,5.270000,
26330.000000,-95752.000000,5.270000,
9100.000000,-284872.000000,5.270000,
600.000000,-296092.000000,5.270000,
68380.000000,94492.000000,5.270000,
68080.000000,-315412.000000,5.270000,
65950.000000,88012.000000,5.270000,
79500.000000,226072.000000,5.270000,
33340.000000,204292.000000,5.270000,
72080.000000,233392.000000,5.270000,
8510.000000,1432.000000,5.270000,
33440.000000,-269632.000000,5.280000,
41340.000000,141652.000000,5.280000,
30120.000000,-264292.000000,5.280000,
46150.000000,300292.000000,5.280000,
10850.000000,188512.000000,5.280000,
62810.000000,-165052.000000,5.280000,
15210.000000,27832.000000,5.280000,
80670.000000,-260152.000000,5.280000,
78650.000000,-297832.000000,5.280000,
5910.000000,263032.000000,5.280000,
73160.000000,-68872.000000,5.280000,
30300.000000,-86572.000000,5.280000,
31630.000000,-6892.000000,5.280000,
71770.000000,41152.000000,5.280000,
7500.000000,278272.000000,5.280000,
69460.000000,41812.000000,5.280000,
8890.000000,106852.000000,5.280000,
60770.000000,114172.000000,5.280000,
43250.000000,-70792.000000,5.280000,
24940.000000,-82672.000000,5.280000,
24410.000000,-51952.000000,5.280000,
8150.000000,120172.000000,5.280000,
21290.000000,-189532.000000,5.280000,
20260.000000,-103312.000000,5.280000,
15640.000000,234592.000000,5.280000,
53260.000000,-93952.000000,5.280000,
77520.000000,-148312.000000,5.280000,
15960.000000,113272.000000,5.280000,
59880.000000,201712.000000,5.280000,
76540.000000,-54652.000000,5.280000,
79430.000000,227272.000000,5.280000,
44930.000000,93352.000000,5.290000,
76110.000000,-76372.000000,5.290000,
62120.000000,-95812.000000,5.290000,
77210.000000,175852.000000,5.290000,
79480.000000,-3292.000000,5.290000,
4230.000000,247672.000000,5.290000,
85950.000000,39412.000000,5.290000,
12190.000000,177172.000000,5.290000,
19190.000000,-44392.000000,5.290000,
42340.000000,-164512.000000,5.290000,
23790.000000,138472.000000,5.290000,
36600.000000,-46192.000000,5.290000,
8010.000000,183892.000000,5.290000,
78360.000000,82672.000000,5.290000,
28700.000000,8032.000000,5.290000,
27840.000000,92872.000000,5.290000,
9640.000000,97493.000000,5.300000,
69460.000000,82973.000000,5.300000,
74350.000000,-53873.000000,5.300000,
6330.000000,-90233.000000,5.300000,
48310.000000,-232193.000000,5.300000,
59270.000000,-230693.000000,5.300000,
80690.000000,-208133.000000,5.300000,
20780.000000,-167813.000000,5.300000,
67780.000000,-73193.000000,5.300000,
44040.000000,-164633.000000,5.300000,
51390.000000,-215753.000000,5.300000,
18970.000000,123593.000000,5.300000,
25930.000000,-145853.000000,5.300000,
31760.000000,-12413.000000,5.300000,
42470.000000,29753.000000,5.300000,
27970.000000,38813.000000,5.300000,
16970.000000,156113.000000,5.300000,
24360.000000,-53273.000000,5.300000,
26690.000000,42053.000000,5.300000,
9440.000000,-189233.000000,5.300000,
9520.000000,79133.000000,5.300000,
77240.000000,133673.000000,5.300000,
22520.000000,58133.000000,5.300000,
85140.000000,181733.000000,5.300000,
29260.000000,77753.000000,5.300000,
42880.000000,-92633.000000,5.300000,
2460.000000,142133.000000,5.300000,
16960.000000,-181793.000000,5.300000,
74030.000000,-160313.000000,5.300000,
18160.000000,-256793.000000,5.300000,
85230.000000,-115553.000000,5.300000,
72110.000000,-241073.000000,5.300000,
44450.000000,-48893.000000,5.300000,
53660.000000,-88793.000000,5.300000,
42140.000000,240353.000000,5.300000,
3360.000000,-40613.000000,5.300000,
4860.000000,103493.000000,5.300000,
58600.000000,-193793.000000,5.300000,
67170.000000,-155513.000000,5.300000,
9420.000000,123413.000000,5.300000,
32030.000000,-171113.000000,5.310000,
34840.000000,-208793.000000,5.310000,
10960.000000,-27713.000000,5.310000,
63020.000000,-3893.000000,5.310000,
70840.000000,-58673.000000,5.310000,
72670.000000,-130013.000000,5.310000,
71510.000000,-143633.000000,5.310000,
52730.000000,159893.000000,5.310000,
22690.000000,-71933.000000,5.310000,
14620.000000,19673.000000,5.310000,
16630.000000,3653.000000,5.310000,
20530.000000,-124853.000000,5.310000,
44610.000000,-127493.000000,5.310000,
12740.000000,165833.000000,5.310000,
73390.000000,19253.000000,5.310000,
56550.000000,-134753.000000,5.310000,
66000.000000,-57053.000000,5.310000,
44380.000000,176393.000000,5.310000,
33410.000000,-141893.000000,5.310000,
22060.000000,-69053.000000,5.310000,
59500.000000,-150593.000000,5.320000,
30540.000000,-172613.000000,5.320000,
23390.000000,-180893.000000,5.320000,
83250.000000,167033.000000,5.320000,
18740.000000,266273.000000,5.320000,
44990.000000,210293.000000,5.320000,
29080.000000,286193.000000,5.320000,
33220.000000,155633.000000,5.320000,
8350.000000,170633.000000,5.320000,
37410.000000,-136853.000000,5.320000,
14820.000000,104453.000000,5.320000,
70490.000000,106133.000000,5.320000,
28140.000000,-89753.000000,5.320000,
29560.000000,246533.000000,5.320000,
51880.000000,-89333.000000,5.320000,
73000.000000,88853.000000,5.320000,
68990.000000,-246413.000000,5.320000,
54910.000000,17873.000000,5.320000,
17680.000000,28073.000000,5.320000,
46790.000000,239813.000000,5.320000,
22370.000000,236633.000000,5.320000,
40550.000000,47933.000000,5.320000,
17600.000000,9113.000000,5.320000,
84110.000000,114593.000000,5.330000,
15550.000000,-159413.000000,5.330000,
27300.000000,111533.000000,5.330000,
26680.000000,-114593.000000,5.330000,
61940.000000,38153.000000,5.330000,
56500.000000,46313.000000,5.330000,
43690.000000,-175313.000000,5.330000,
35510.000000,87893.000000,5.330000,
20010.000000,-4253.000000,5.330000,
26680.000000,-58373.000000,5.330000,
66720.000000,-164813.000000,5.330000,
14150.000000,172433.000000,5.330000,
71860.000000,60473.000000,5.330000,
22540.000000,45233.000000,5.330000,
27930.000000,-123113.000000,5.330000,
16020.000000,290993.000000,5.330000,
19980.000000,-231293.000000,5.330000,
42060.000000,123173.000000,5.330000,
48180.000000,-63893.000000,5.330000,
79960.000000,124673.000000,5.330000,
47830.000000,49253.000000,5.330000,
30760.000000,73673.000000,5.330000,
6350.000000,-20693.000000,5.330000,
75490.000000,80393.000000,5.330000,
18470.000000,30653.000000,5.340000,
71990.000000,-124973.000000,5.340000,
53740.000000,-121913.000000,5.340000,
66660.000000,-118793.000000,5.340000,
19960.000000,-5813.000000,5.340000,
13540.000000,21833.000000,5.340000,
10150.000000,62933.000000,5.340000,
3940.000000,77333.000000,5.340000,
64980.000000,-29513.000000,5.340000,
68220.000000,118493.000000,5.340000,
34330.000000,-146393.000000,5.340000,
55260.000000,2633.000000,5.340000,
43470.000000,-245993.000000,5.340000,
71280.000000,-202973.000000,5.340000,
21080.000000,-27113.000000,5.340000,
65820.000000,-201713.000000,5.340000,
69160.000000,-28613.000000,5.340000,
26120.000000,-110573.000000,5.340000,
82220.000000,-288473.000000,5.340000,
38770.000000,-232313.000000,5.340000,
37080.000000,-104453.000000,5.340000,
8690.000000,-217193.000000,5.340000,
31830.000000,-240473.000000,5.340000,
19150.000000,9413.000000,5.340000,
9120.000000,-3833.000000,5.340000,
7270.000000,-108053.000000,5.340000,
26060.000000,11273.000000,5.340000,
24400.000000,205853.000000,5.340000,
75220.000000,-143393.000000,5.340000,
78130.000000,20453.000000,5.340000,
41900.000000,29333.000000,5.340000,
84800.000000,81053.000000,5.340000,
53110.000000,-226433.000000,5.350000,
66830.000000,188513.000000,5.350000,
49380.000000,12833.000000,5.350000,
21990.000000,138533.000000,5.350000,
71820.000000,-212093.000000,5.350000,
36970.000000,105593.000000,5.350000,
43190.000000,13253.000000,5.350000,
67580.000000,271613.000000,5.350000,
70480.000000,152753.000000,5.350000,
20050.000000,13613.000000,5.350000,
40350.000000,-176813.000000,5.350000,
45770.000000,-227093.000000,5.350000,
80410.000000,-28193.000000,5.350000,
38750.000000,110513.000000,5.350000,
15560.000000,76193.000000,5.350000,
28540.000000,71633.000000,5.350000,
75770.000000,-139133.000000,5.350000,
64970.000000,-87473.000000,5.350000,
14650.000000,10193.000000,5.350000,
3760.000000,-167093.000000,5.350000,
68170.000000,-153773.000000,5.350000,
29490.000000,-28013.000000,5.350000,
22200.000000,212213.000000,5.350000,
22730.000000,-33833.000000,5.350000,
36560.000000,-221633.000000,5.350000,
62600.000000,-101393.000000,5.350000,
30690.000000,65213.000000,5.350000,
57270.000000,155393.000000,5.350000,
70920.000000,199673.000000,5.350000,
52220.000000,-178313.000000,5.360000,
16790.000000,192593.000000,5.360000,
68360.000000,-46313.000000,5.360000,
80420.000000,20873.000000,5.360000,
29980.000000,-257513.000000,5.360000,
80290.000000,-193133.000000,5.360000,
34060.000000,-21893.000000,5.360000,
2390.000000,77213.000000,5.360000,
60920.000000,66413.000000,5.360000,
20120.000000,86573.000000,5.360000,
58510.000000,-170573.000000,5.360000,
77860.000000,69593.000000,5.360000,
33840.000000,-290873.000000,5.360000,
22900.000000,192473.000000,5.360000,
26990.000000,178913.000000,5.360000,
61380.000000,-191693.000000,5.360000,
36060.000000,114953.000000,5.360000,
4030.000000,-222473.000000,5.360000,
72380.000000,129593.000000,5.360000,
63390.000000,175013.000000,5.360000,
33310.000000,53813.000000,5.360000,
1230.000000,29513.000000,5.360000,
58190.000000,-12533.000000,5.360000,
2790.000000,55793.000000,5.360000,
60690.000000,-148493.000000,5.360000,
57410.000000,-122333.000000,5.370000,
29230.000000,-74033.000000,5.370000,
75670.000000,166253.000000,5.370000,
21990.000000,-15173.000000,5.370000,
17160.000000,42173.000000,5.370000,
19140.000000,121553.000000,5.370000,
80020.000000,163673.000000,5.370000,
79790.000000,-122513.000000,5.370000,
14950.000000,-59033.000000,5.370000,
57230.000000,-88373.000000,5.370000,
16030.000000,82853.000000,5.370000,
49320.000000,-211673.000000,5.370000,
55300.000000,118613.000000,5.370000,
63820.000000,-48713.000000,5.370000,
68440.000000,200453.000000,5.370000,
31260.000000,165053.000000,5.370000,
34290.000000,126413.000000,5.370000,
53350.000000,-50993.000000,5.380000,
55480.000000,-142973.000000,5.380000,
41610.000000,-146153.000000,5.380000,
25600.000000,-40673.000000,5.380000,
74530.000000,181313.000000,5.380000,
24530.000000,-54593.000000,5.380000,
18160.000000,-177053.000000,5.380000,
33430.000000,-247313.000000,5.380000,
24780.000000,214073.000000,5.380000,
72320.000000,55853.000000,5.380000,
15570.000000,78413.000000,5.380000,
68690.000000,192293.000000,5.380000,
44330.000000,270653.000000,5.380000,
10190.000000,-100613.000000,5.380000,
15630.000000,-74393.000000,5.380000,
53770.000000,-190133.000000,5.380000,
74030.000000,46973.000000,5.380000,
62410.000000,91973.000000,5.380000,
16740.000000,28373.000000,5.380000,
65710.000000,-74633.000000,5.380000,
59380.000000,-166493.000000,5.380000,
26610.000000,-115973.000000,5.380000,
66830.000000,-118913.000000,5.380000,
68410.000000,181973.000000,5.380000,
16800.000000,43973.000000,5.380000,
44560.000000,-207653.000000,5.380000,
83400.000000,35453.000000,5.380000,
66980.000000,32933.000000,5.380000,
20840.000000,63833.000000,5.380000,
2540.000000,-235733.000000,5.380000,
59040.000000,-141173.000000,5.380000,
23120.000000,-250913.000000,5.380000,
41040.000000,5093.000000,5.380000,
56330.000000,-69533.000000,5.380000,
66580.000000,-7193.000000,5.380000,
26600.000000,-100253.000000,5.380000,
59310.000000,2453.000000,5.380000,
80.000000,-181313.000000,5.380000,
38110.000000,-142493.000000,5.380000,
61680.000000,129413.000000,5.390000,
15750.000000,92333.000000,5.390000,
62080.000000,51833.000000,5.390000,
72000.000000,63113.000000,5.390000,
66170.000000,-132053.000000,5.390000,
26170.000000,-56213.000000,5.390000,
62800.000000,72353.000000,5.390000,
24680.000000,-255473.000000,5.390000,
14550.000000,-1013.000000,5.390000,
3040.000000,231353.000000,5.390000,
83320.000000,7733.000000,5.390000,
45540.000000,75893.000000,5.390000,
79920.000000,218813.000000,5.390000,
24410.000000,-184613.000000,5.390000,
5750.000000,-55493.000000,5.390000,
72330.000000,223193.000000,5.390000,
58940.000000,121373.000000,5.390000,
72290.000000,244913.000000,5.390000,
58080.000000,-94853.000000,5.390000,
78180.000000,148193.000000,5.390000,
85070.000000,66294.000000,5.400000,
79870.000000,183054.000000,5.400000,
22620.000000,35874.000000,5.400000,
16320.000000,194154.000000,5.400000,
19630.000000,64734.000000,5.400000,
62520.000000,-252474.000000,5.400000,
560.000000,-100854.000000,5.400000,
10420.000000,138054.000000,5.400000,
68290.000000,62574.000000,5.400000,
34100.000000,32694.000000,5.400000,
62430.000000,116934.000000,5.400000,
20310.000000,109854.000000,5.400000,
52640.000000,-166134.000000,5.400000,
80050.000000,-75894.000000,5.400000,
1950.000000,73134.000000,5.400000,
13750.000000,255234.000000,5.400000,
71360.000000,-261054.000000,5.400000,
70760.000000,154194.000000,5.400000,
50310.000000,78174.000000,5.400000,
48500.000000,215874.000000,5.400000,
49170.000000,190614.000000,5.400000,
15550.000000,180234.000000,5.400000,
56640.000000,-56454.000000,5.400000,
17060.000000,40194.000000,5.400000,
29380.000000,-172674.000000,5.400000,
77260.000000,240534.000000,5.400000,
1480.000000,222654.000000,5.400000,
56760.000000,-6534.000000,5.400000,
6120.000000,126894.000000,5.400000,
26360.000000,-59034.000000,5.400000,
15050.000000,95394.000000,5.400000,
75080.000000,101754.000000,5.400000,
51550.000000,46854.000000,5.400000,
71760.000000,59934.000000,5.400000,
66080.000000,-67914.000000,5.400000,
9750.000000,-182934.000000,5.400000,
66410.000000,-173274.000000,5.400000,
4590.000000,-9054.000000,5.400000,
5080.000000,-149454.000000,5.400000,
60890.000000,75474.000000,5.400000,
51190.000000,-193254.000000,5.400000,
74950.000000,-247614.000000,5.400000,
6790.000000,146694.000000,5.400000,
76390.000000,-99534.000000,5.400000,
21340.000000,72594.000000,5.400000,
30690.000000,-70494.000000,5.410000,
79250.000000,-102474.000000,5.410000,
59080.000000,-106974.000000,5.410000,
25700.000000,57354.000000,5.410000,
68690.000000,-14574.000000,5.410000,
11900.000000,-3414.000000,5.410000,
39890.000000,-128934.000000,5.410000,
68570.000000,-13374.000000,5.410000,
40420.000000,-354.000000,5.410000,
77260.000000,99414.000000,5.410000,
8530.000000,-3234.000000,5.410000,
57230.000000,-86394.000000,5.410000,
71830.000000,145374.000000,5.410000,
2860.000000,269514.000000,5.410000,
68200.000000,-134454.000000,5.410000,
32200.000000,-308454.000000,5.410000,
16230.000000,49434.000000,5.410000,
57660.000000,119934.000000,5.410000,
3780.000000,-17454.000000,5.410000,
42430.000000,-207714.000000,5.410000,
77040.000000,-75174.000000,5.410000,
28810.000000,266154.000000,5.410000,
52120.000000,-24894.000000,5.410000,
23620.000000,-130494.000000,5.410000,
7180.000000,-75054.000000,5.410000,
35020.000000,50574.000000,5.410000,
2710.000000,198834.000000,5.420000,
85730.000000,224034.000000,5.420000,
53800.000000,-226014.000000,5.420000,
19930.000000,61434.000000,5.420000,
59070.000000,-135294.000000,5.420000,
66990.000000,120534.000000,5.420000,
75540.000000,15534.000000,5.420000,
34540.000000,128994.000000,5.420000,
82760.000000,3534.000000,5.420000,
46550.000000,-204714.000000,5.420000,
32560.000000,88074.000000,5.420000,
58320.000000,-30834.000000,5.420000,
19210.000000,147954.000000,5.420000,
62930.000000,1254.000000,5.420000,
26940.000000,-139734.000000,5.420000,
27670.000000,-138774.000000,5.420000,
28610.000000,-156654.000000,5.420000,
38560.000000,-213234.000000,5.420000,
26580.000000,-115014.000000,5.420000,
43090.000000,-202794.000000,5.420000,
74220.000000,95334.000000,5.420000,
32880.000000,106794.000000,5.420000,
28380.000000,-130974.000000,5.420000,
44140.000000,261294.000000,5.420000,
64220.000000,105594.000000,5.420000,
23610.000000,50994.000000,5.420000,
69930.000000,-86274.000000,5.420000,
1700.000000,-143754.000000,5.420000,
82260.000000,-140994.000000,5.420000,
73870.000000,177234.000000,5.420000,
38580.000000,94794.000000,5.430000,
83110.000000,-27774.000000,5.430000,
54670.000000,-199314.000000,5.430000,
55120.000000,-217854.000000,5.430000,
18560.000000,35454.000000,5.430000,
20750.000000,179454.000000,5.430000,
40120.000000,-101154.000000,5.430000,
38810.000000,-62334.000000,5.430000,
7390.000000,534.000000,5.430000,
73320.000000,88074.000000,5.430000,
10280.000000,54354.000000,5.430000,
76670.000000,-64794.000000,5.430000,
80050.000000,-100014.000000,5.430000,
56320.000000,-188634.000000,5.430000,
9840.000000,159534.000000,5.430000,
34120.000000,164214.000000,5.430000,
56630.000000,117114.000000,5.430000,
45210.000000,119754.000000,5.430000,
23510.000000,-29394.000000,5.430000,
41850.000000,-171954.000000,5.430000,
34630.000000,-193254.000000,5.440000,
58750.000000,-153714.000000,5.440000,
58790.000000,143034.000000,5.440000,
19870.000000,11934.000000,5.440000,
66990.000000,24114.000000,5.440000,
45460.000000,-97734.000000,5.440000,
15280.000000,-223974.000000,5.440000,
65940.000000,26154.000000,5.440000,
24860.000000,-4134.000000,5.440000,
57980.000000,244134.000000,5.440000,
24990.000000,-286014.000000,5.440000,
74260.000000,41034.000000,5.440000,
10640.000000,-85974.000000,5.440000,
25880.000000,-1134.000000,5.440000,
54170.000000,-117594.000000,5.440000,
57510.000000,-89454.000000,5.440000,
16090.000000,301794.000000,5.440000,
34200.000000,-185514.000000,5.440000,
55630.000000,-132414.000000,5.440000,
13700.000000,84354.000000,5.440000,
44900.000000,-140574.000000,5.440000,
45100.000000,-213954.000000,5.440000,
64520.000000,93834.000000,5.440000,
19160.000000,-182274.000000,5.440000,
15020.000000,-24954.000000,5.440000,
3300.000000,-250374.000000,5.440000,
19060.000000,-48774.000000,5.440000,
20390.000000,-117534.000000,5.440000,
83970.000000,175134.000000,5.440000,
35180.000000,-276474.000000,5.440000,
55570.000000,123654.000000,5.440000,
57270.000000,73134.000000,5.440000,
56170.000000,-159894.000000,5.440000,
78440.000000,218574.000000,5.440000,
49640.000000,-64374.000000,5.440000,
12020.000000,279894.000000,5.450000,
63710.000000,57474.000000,5.450000,
46490.000000,-306534.000000,5.450000,
70190.000000,-97194.000000,5.450000,
45060.000000,88494.000000,5.450000,
78980.000000,-134214.000000,5.450000,
43860.000000,-85014.000000,5.450000,
32210.000000,118554.000000,5.450000,
76090.000000,-320274.000000,5.450000,
50800.000000,-33594.000000,5.450000,
6040.000000,155934.000000,5.450000,
13480.000000,87474.000000,5.450000,
32720.000000,174774.000000,5.450000,
70660.000000,-16794.000000,5.450000,
57340.000000,136674.000000,5.450000,
14630.000000,29574.000000,5.450000,
32970.000000,-31674.000000,5.450000,
16760.000000,-51714.000000,5.450000,
82180.000000,201294.000000,5.450000,
22540.000000,216054.000000,5.450000,
38780.000000,68034.000000,5.450000,
53480.000000,213534.000000,5.450000,
49650.000000,-181194.000000,5.450000,
9340.000000,124914.000000,5.450000,
21990.000000,-83274.000000,5.460000,
25050.000000,-88734.000000,5.460000,
19800.000000,-169554.000000,5.460000,
68090.000000,149814.000000,5.460000,
38710.000000,-289734.000000,5.460000,
80920.000000,-140934.000000,5.460000,
31030.000000,-226314.000000,5.460000,
3290.000000,85074.000000,5.460000,
3160.000000,-86454.000000,5.460000,
11160.000000,285954.000000,5.460000,
30870.000000,234594.000000,5.460000,
66210.000000,-270174.000000,5.460000,
18960.000000,40914.000000,5.460000,
62760.000000,211194.000000,5.460000,
80820.000000,234534.000000,5.460000,
30350.000000,-151854.000000,5.460000,
65590.000000,-148914.000000,5.460000,
79830.000000,-41634.000000,5.460000,
4280.000000,231174.000000,5.460000,
33400.000000,-31554.000000,5.460000,
31280.000000,-284334.000000,5.460000,
21010.000000,-285774.000000,5.460000,
64510.000000,259254.000000,5.460000,
57620.000000,-59574.000000,5.460000,
25810.000000,-99054.000000,5.460000,
16200.000000,300054.000000,5.460000,
64600.000000,-14754.000000,5.460000,
73690.000000,293214.000000,5.460000,
32370.000000,116754.000000,5.460000,
43290.000000,129774.000000,5.460000,
65750.000000,-159174.000000,5.460000,
34020.000000,-257814.000000,5.460000,
34290.000000,-263154.000000,5.460000,
53800.000000,-41094.000000,5.460000,
46050.000000,240474.000000,5.460000,
72790.000000,-3714.000000,5.460000,
17710.000000,-269814.000000,5.460000,
13960.000000,-19374.000000,5.470000,
32050.000000,110094.000000,5.470000,
41900.000000,157134.000000,5.470000,
14180.000000,126354.000000,5.470000,
31590.000000,-165354.000000,5.470000,
43730.000000,-148434.000000,5.470000,
12720.000000,172914.000000,5.470000,
11860.000000,158514.000000,5.470000,
19660.000000,57174.000000,5.470000,
45220.000000,-34074.000000,5.470000,
81000.000000,117354.000000,5.470000,
24370.000000,286494.000000,5.470000,
10790.000000,170034.000000,5.470000,
65420.000000,-223254.000000,5.470000,
38780.000000,51114.000000,5.470000,
39220.000000,-7734.000000,5.470000,
71020.000000,92814.000000,5.470000,
49620.000000,138834.000000,5.470000,
74860.000000,290034.000000,5.470000,
19970.000000,-138714.000000,5.470000,
65650.000000,-78174.000000,5.470000,
24280.000000,104334.000000,5.470000,
58390.000000,18174.000000,5.470000,
61030.000000,-119814.000000,5.470000,
10240.000000,-128454.000000,5.470000,
46510.000000,-154554.000000,5.470000,
55890.000000,-264294.000000,5.480000,
66770.000000,110094.000000,5.480000,
25390.000000,-213114.000000,5.480000,
58770.000000,-111354.000000,5.480000,
41920.000000,-47574.000000,5.480000,
41540.000000,219954.000000,5.480000,
20970.000000,-52194.000000,5.480000,
34190.000000,-95754.000000,5.480000,
38240.000000,-211494.000000,5.480000,
52690.000000,194514.000000,5.480000,
22070.000000,-151794.000000,5.480000,
31770.000000,-145194.000000,5.480000,
67730.000000,-157254.000000,5.480000,
59140.000000,284334.000000,5.480000,
59120.000000,134634.000000,5.480000,
16230.000000,56514.000000,5.480000,
77050.000000,-46374.000000,5.480000,
26810.000000,-83154.000000,5.480000,
82620.000000,175314.000000,5.480000,
48030.000000,-189954.000000,5.480000,
58240.000000,273234.000000,5.480000,
67930.000000,77154.000000,5.480000,
69630.000000,-3294.000000,5.480000,
44960.000000,86874.000000,5.480000,
51240.000000,46734.000000,5.480000,
23310.000000,109794.000000,5.480000,
82640.000000,74814.000000,5.480000,
340.000000,48234.000000,5.480000,
2770.000000,-81114.000000,5.480000,
85670.000000,-10014.000000,5.480000,
540.000000,65574.000000,5.480000,
53430.000000,134214.000000,5.480000,
17840.000000,61794.000000,5.480000,
84480.000000,-314994.000000,5.480000,
67490.000000,-142914.000000,5.480000,
45840.000000,-102054.000000,5.480000,
77110.000000,-12834.000000,5.480000,
75230.000000,120414.000000,5.480000,
6360.000000,-182994.000000,5.480000,
52200.000000,-163194.000000,5.490000,
80990.000000,15954.000000,5.490000,
27510.000000,126234.000000,5.490000,
5020.000000,135834.000000,5.490000,
49590.000000,196014.000000,5.490000,
22130.000000,-80814.000000,5.490000,
28450.000000,-129234.000000,5.490000,
31160.000000,-192414.000000,5.490000,
58940.000000,-178494.000000,5.490000,
8680.000000,38214.000000,5.490000,
71910.000000,111594.000000,5.490000,
67430.000000,115014.000000,5.490000,
52110.000000,179514.000000,5.490000,
2240.000000,127494.000000,5.490000,
34680.000000,-155514.000000,5.490000,
59650.000000,-255594.000000,5.490000,
14950.000000,70674.000000,5.490000,
65280.000000,131094.000000,5.490000,
18880.000000,18594.000000,5.490000,
27960.000000,-24474.000000,5.490000,
57530.000000,131994.000000,5.490000,
66120.000000,83874.000000,5.490000,
67940.000000,-167814.000000,5.490000,
60680.000000,4435.000000,5.500000,
7370.000000,119875.000000,5.500000,
18480.000000,87415.000000,5.500000,
600.000000,40135.000000,5.500000,
10930.000000,-258955.000000,5.500000,
79830.000000,252535.000000,5.500000,
58530.000000,-30175.000000,5.500000,
39790.000000,-40735.000000,5.500000,
55950.000000,-70855.000000,5.500000,
60610.000000,26155.000000,5.500000,
68660.000000,-111835.000000,5.500000,
11720.000000,110035.000000,5.500000,
84430.000000,253375.000000,5.500000,
42940.000000,56395.000000,5.500000,
82770.000000,-106135.000000,5.500000,
80270.000000,-279115.000000,5.500000,
55970.000000,-60715.000000,5.500000,
4300.000000,234115.000000,5.500000,
26430.000000,-187555.000000,5.500000,
17780.000000,-18715.000000,5.500000,
1230.000000,-250735.000000,5.500000,
3760.000000,114535.000000,5.500000,
4180.000000,70795.000000,5.500000,
10580.000000,64915.000000,5.500000,
71010.000000,-55735.000000,5.500000,
29520.000000,-167995.000000,5.500000,
17250.000000,-61015.000000,5.500000,
12080.000000,-85135.000000,5.500000,
67890.000000,190795.000000,5.500000,
8210.000000,-23155.000000,5.500000,
55970.000000,-4315.000000,5.500000,
5570.000000,-132775.000000,5.500000,
79150.000000,-138235.000000,5.500000,
55200.000000,106675.000000,5.500000,
41690.000000,-176935.000000,5.500000,
5200.000000,69295.000000,5.500000,
27100.000000,61555.000000,5.500000,
65440.000000,11995.000000,5.500000,
81940.000000,-167635.000000,5.500000,
39610.000000,163975.000000,5.500000,
78640.000000,-250735.000000,5.500000,
30400.000000,45595.000000,5.500000,
44840.000000,-212395.000000,5.500000,
45380.000000,214195.000000,5.500000,
50710.000000,-276535.000000,5.500000,
7220.000000,-30715.000000,5.500000,
68780.000000,29695.000000,5.500000,
17700.000000,199015.000000,5.510000,
31330.000000,-173215.000000,5.510000,
62340.000000,-167935.000000,5.510000,
56570.000000,188575.000000,5.510000,
38410.000000,-234415.000000,5.510000,
36040.000000,-296035.000000,5.510000,
30220.000000,191695.000000,5.510000,
3740.000000,-113635.000000,5.510000,
19370.000000,147775.000000,5.510000,
72630.000000,96895.000000,5.510000,
22830.000000,-122995.000000,5.510000,
36160.000000,79075.000000,5.510000,
68020.000000,133195.000000,5.510000,
68470.000000,94735.000000,5.510000,
23790.000000,-18835.000000,5.510000,
78750.000000,103735.000000,5.510000,
83090.000000,-247855.000000,5.510000,
4100.000000,20395.000000,5.510000,
11750.000000,-278635.000000,5.510000,
18640.000000,169075.000000,5.510000,
83890.000000,-146995.000000,5.510000,
62320.000000,103855.000000,5.510000,
59740.000000,-235855.000000,5.510000,
72240.000000,26275.000000,5.510000,
38340.000000,193255.000000,5.510000,
58300.000000,131215.000000,5.510000,
85620.000000,206875.000000,5.510000,
72700.000000,96595.000000,5.510000,
75560.000000,214015.000000,5.510000,
15700.000000,218695.000000,5.510000,
54080.000000,-10015.000000,5.510000,
37000.000000,49495.000000,5.510000,
58630.000000,215155.000000,5.510000,
69430.000000,-240055.000000,5.520000,
26930.000000,173515.000000,5.520000,
28070.000000,-43975.000000,5.520000,
14910.000000,137035.000000,5.520000,
25430.000000,-157015.000000,5.520000,
40010.000000,7075.000000,5.520000,
23780.000000,-67255.000000,5.520000,
65400.000000,-110695.000000,5.520000,
30430.000000,-252415.000000,5.520000,
48840.000000,199315.000000,5.520000,
17040.000000,-67255.000000,5.520000,
80990.000000,283855.000000,5.520000,
29870.000000,214555.000000,5.520000,
6710.000000,198595.000000,5.520000,
13230.000000,-18835.000000,5.520000,
84390.000000,-189895.000000,5.520000,
63200.000000,69415.000000,5.520000,
2140.000000,-172855.000000,5.520000,
26450.000000,-51715.000000,5.520000,
21050.000000,100735.000000,5.520000,
54180.000000,126835.000000,5.520000,
60400.000000,-141835.000000,5.520000,
2820.000000,43195.000000,5.520000,
53850.000000,-655.000000,5.520000,
65260.000000,-61795.000000,5.520000,
29100.000000,-191215.000000,5.520000,
80760.000000,254875.000000,5.520000,
26730.000000,-284815.000000,5.520000,
75060.000000,-136555.000000,5.520000,
9360.000000,-28255.000000,5.520000,
26000.000000,185215.000000,5.520000,
31890.000000,-25855.000000,5.530000,
31330.000000,-191215.000000,5.530000,
59020.000000,222115.000000,5.530000,
55260.000000,-21055.000000,5.530000,
57810.000000,276535.000000,5.530000,
3290.000000,301435.000000,5.530000,
38010.000000,125995.000000,5.530000,
53390.000000,103075.000000,5.530000,
74590.000000,240055.000000,5.530000,
74780.000000,-141175.000000,5.530000,
16980.000000,-255415.000000,5.530000,
69570.000000,44575.000000,5.530000,
53970.000000,141415.000000,5.530000,
29440.000000,-49735.000000,5.530000,
11540.000000,24055.000000,5.530000,
11860.000000,-225295.000000,5.530000,
5880.000000,208795.000000,5.530000,
33170.000000,-213955.000000,5.530000,
79390.000000,-23515.000000,5.530000,
13670.000000,-108655.000000,5.530000,
75500.000000,160135.000000,5.530000,
22620.000000,-135895.000000,5.530000,
57430.000000,51955.000000,5.530000,
30400.000000,-45175.000000,5.530000,
64550.000000,80935.000000,5.530000,
35990.000000,204535.000000,5.530000,
19810.000000,227095.000000,5.530000,
62110.000000,-120835.000000,5.530000,
71440.000000,-213175.000000,5.540000,
75330.000000,45295.000000,5.540000,
17880.000000,90235.000000,5.540000,
7420.000000,93415.000000,5.540000,
28140.000000,-203095.000000,5.540000,
26870.000000,-104995.000000,5.540000,
56930.000000,-13795.000000,5.540000,
21140.000000,51115.000000,5.540000,
71670.000000,87595.000000,5.540000,
19860.000000,-75175.000000,5.540000,
57640.000000,-30355.000000,5.540000,
83730.000000,-12595.000000,5.540000,
13470.000000,131335.000000,5.540000,
80910.000000,-243055.000000,5.540000,
77460.000000,217675.000000,5.540000,
15610.000000,183415.000000,5.540000,
68890.000000,-69535.000000,5.540000,
20010.000000,66775.000000,5.540000,
35190.000000,-161215.000000,5.540000,
20030.000000,51535.000000,5.540000,
32480.000000,-150775.000000,5.540000,
15860.000000,122935.000000,5.540000,
16110.000000,5035.000000,5.540000,
75120.000000,-19855.000000,5.540000,
84420.000000,314335.000000,5.540000,
21380.000000,-113035.000000,5.540000,
12130.000000,99475.000000,5.540000,
3470.000000,104395.000000,5.540000,
63800.000000,87595.000000,5.540000,
75190.000000,162715.000000,5.540000,
23240.000000,10495.000000,5.540000,
46180.000000,-259195.000000,5.540000,
49030.000000,256495.000000,5.540000,
74420.000000,-120415.000000,5.540000,
47310.000000,-32395.000000,5.540000,
13490.000000,-1135.000000,5.540000,
63740.000000,88495.000000,5.540000,
21670.000000,-122155.000000,5.540000,
23230.000000,-1075.000000,5.540000,
52570.000000,-166555.000000,5.540000,
23920.000000,141895.000000,5.540000,
8050.000000,-244255.000000,5.540000,
37930.000000,50935.000000,5.540000,
79370.000000,160795.000000,5.550000,
37770.000000,-110275.000000,5.550000,
47280.000000,-235135.000000,5.550000,
3400.000000,217315.000000,5.550000,
28960.000000,-148795.000000,5.550000,
71440.000000,-38815.000000,5.550000,
64400.000000,-125635.000000,5.550000,
35020.000000,-194095.000000,5.550000,
44810.000000,-118255.000000,5.550000,
71520.000000,89995.000000,5.550000,
83730.000000,255295.000000,5.550000,
68790.000000,103075.000000,5.550000,
20220.000000,61435.000000,5.550000,
69630.000000,-80695.000000,5.550000,
27230.000000,-130855.000000,5.550000,
10780.000000,-8935.000000,5.550000,
62220.000000,-117655.000000,5.550000,
83800.000000,191575.000000,5.550000,
25570.000000,124195.000000,5.550000,
55100.000000,74095.000000,5.550000,
43240.000000,-37675.000000,5.550000,
34930.000000,249355.000000,5.550000,
35450.000000,-225955.000000,5.550000,
21020.000000,51595.000000,5.550000,
80200.000000,-46255.000000,5.550000,
7170.000000,-151375.000000,5.550000,
70270.000000,181195.000000,5.550000,
48010.000000,144595.000000,5.550000,
34470.000000,-21355.000000,5.550000,
2020.000000,-106495.000000,5.550000,
22170.000000,-52555.000000,5.550000,
84150.000000,216535.000000,5.550000,
28840.000000,62395.000000,5.550000,
85910.000000,10555.000000,5.550000,
28480.000000,171235.000000,5.550000,
44450.000000,208375.000000,5.550000,
22950.000000,-251995.000000,5.550000,
54320.000000,173395.000000,5.560000,
42730.000000,-205195.000000,5.560000,
33150.000000,-157075.000000,5.560000,
3940.000000,77335.000000,5.560000,
11250.000000,-284395.000000,5.560000,
49170.000000,38755.000000,5.560000,
29530.000000,63595.000000,5.560000,
14660.000000,86875.000000,5.560000,
70060.000000,-195595.000000,5.560000,
8390.000000,-201415.000000,5.560000,
70040.000000,188395.000000,5.560000,
12570.000000,-45655.000000,5.560000,
19690.000000,-134095.000000,5.560000,
79010.000000,43555.000000,5.560000,
56590.000000,-304135.000000,5.560000,
73100.000000,133255.000000,5.560000,
5820.000000,43795.000000,5.560000,
60430.000000,-210055.000000,5.560000,
40010.000000,-255175.000000,5.560000,
43060.000000,-224875.000000,5.560000,
51740.000000,-125275.000000,5.560000,
63280.000000,-40495.000000,5.560000,
71160.000000,-114955.000000,5.560000,
380.000000,231115.000000,5.560000,
13330.000000,70975.000000,5.560000,
2880.000000,-78235.000000,5.560000,
68230.000000,9175.000000,5.560000,
63110.000000,102355.000000,5.560000,
61950.000000,226375.000000,5.560000,
10550.000000,221515.000000,5.560000,
2060.000000,-188635.000000,5.560000,
6140.000000,-193555.000000,5.560000,
30080.000000,-72355.000000,5.560000,
13190.000000,11095.000000,5.560000,
43920.000000,74035.000000,5.560000,
52900.000000,41995.000000,5.560000,
68120.000000,23875.000000,5.560000,
77600.000000,-161455.000000,5.560000,
84870.000000,120655.000000,5.560000,
44420.000000,95935.000000,5.560000,
68160.000000,65275.000000,5.560000,
37440.000000,121435.000000,5.560000,
82480.000000,-58615.000000,5.560000,
75980.000000,-149035.000000,5.560000,
32150.000000,41875.000000,5.560000,
690.000000,-100135.000000,5.560000,
22210.000000,-145315.000000,5.560000,
34600.000000,112255.000000,5.560000,
79320.000000,208855.000000,5.560000,
74860.000000,21655.000000,5.570000,
2730.000000,269995.000000,5.570000,
45710.000000,24535.000000,5.570000,
47020.000000,-74155.000000,5.570000,
78490.000000,-170395.000000,5.570000,
2240.000000,-89215.000000,5.570000,
23040.000000,-132175.000000,5.570000,
6140.000000,244975.000000,5.570000,
3960.000000,-35515.000000,5.570000,
69390.000000,17455.000000,5.570000,
63450.000000,87535.000000,5.570000,
49250.000000,-308875.000000,5.570000,
8520.000000,-38875.000000,5.570000,
84290.000000,116635.000000,5.570000,
58150.000000,-208615.000000,5.570000,
90.000000,220435.000000,5.570000,
14730.000000,-99655.000000,5.570000,
8140.000000,90235.000000,5.570000,
8280.000000,6355.000000,5.570000,
49470.000000,-58315.000000,5.570000,
69320.000000,54355.000000,5.570000,
16800.000000,-88195.000000,5.570000,
12950.000000,-40375.000000,5.570000,
37600.000000,-197635.000000,5.570000,
70160.000000,52555.000000,5.570000,
76860.000000,85915.000000,5.570000,
42900.000000,30475.000000,5.570000,
82380.000000,60715.000000,5.570000,
83590.000000,205855.000000,5.570000,
79260.000000,2215.000000,5.570000,
80940.000000,32935.000000,5.570000,
33710.000000,-151975.000000,5.570000,
82420.000000,161155.000000,5.580000,
32990.000000,-109315.000000,5.580000,
73340.000000,-151435.000000,5.580000,
25110.000000,-91555.000000,5.580000,
1450.000000,187315.000000,5.580000,
20110.000000,36895.000000,5.580000,
12260.000000,120775.000000,5.580000,
16200.000000,56335.000000,5.580000,
3900.000000,53815.000000,5.580000,
55390.000000,109075.000000,5.580000,
63080.000000,9835.000000,5.580000,
79750.000000,119455.000000,5.580000,
61570.000000,79555.000000,5.580000,
2350.000000,177715.000000,5.580000,
13410.000000,-37795.000000,5.580000,
8450.000000,180655.000000,5.580000,
78390.000000,-40975.000000,5.580000,
4070.000000,74695.000000,5.580000,
25880.000000,96715.000000,5.580000,
41050.000000,-260155.000000,5.580000,
12530.000000,179515.000000,5.580000,
13260.000000,135295.000000,5.580000,
65730.000000,151855.000000,5.580000,
280.000000,-257275.000000,5.580000,
27790.000000,-129835.000000,5.580000,
31210.000000,-190915.000000,5.580000,
58190.000000,-120835.000000,5.580000,
7380.000000,231835.000000,5.580000,
37860.000000,-49015.000000,5.580000,
55130.000000,-146875.000000,5.580000,
30380.000000,-14455.000000,5.580000,
27190.000000,11875.000000,5.580000,
61780.000000,-37975.000000,5.580000,
68130.000000,-59035.000000,5.580000,
80020.000000,-90715.000000,5.580000,
26150.000000,170095.000000,5.580000,
32190.000000,232615.000000,5.580000,
41420.000000,66355.000000,5.580000,
29890.000000,-127675.000000,5.580000,
36930.000000,-155275.000000,5.580000,
63770.000000,-133075.000000,5.580000,
61250.000000,81535.000000,5.580000,
69970.000000,-78415.000000,5.580000,
12250.000000,89035.000000,5.580000,
26950.000000,-6895.000000,5.580000,
37760.000000,-106855.000000,5.580000,
33920.000000,-18475.000000,5.580000,
37540.000000,-25435.000000,5.580000,
59780.000000,-154315.000000,5.580000,
23540.000000,-21175.000000,5.590000,
32920.000000,-30955.000000,5.590000,
28660.000000,-217135.000000,5.590000,
53590.000000,-263575.000000,5.590000,
74870.000000,172255.000000,5.590000,
67050.000000,225115.000000,5.590000,
79530.000000,104335.000000,5.590000,
55200.000000,187075.000000,5.590000,
12500.000000,121795.000000,5.590000,
47730.000000,147115.000000,5.590000,
31890.000000,-207535.000000,5.590000,
84420.000000,154555.000000,5.590000,
77110.000000,168235.000000,5.590000,
15590.000000,50575.000000,5.590000,
23470.000000,-186595.000000,5.590000,
49990.000000,64615.000000,5.590000,
47190.000000,-149755.000000,5.590000,
66300.000000,-110755.000000,5.590000,
3670.000000,-140155.000000,5.590000,
1900.000000,190255.000000,5.590000,
39080.000000,213595.000000,5.590000,
62420.000000,166495.000000,5.590000,
76110.000000,108776.000000,5.600000,
61000.000000,-83396.000000,5.600000,
83210.000000,-140096.000000,5.600000,
82580.000000,149816.000000,5.600000,
13550.000000,164516.000000,5.600000,
56800.000000,-124916.000000,5.600000,
23720.000000,-132476.000000,5.600000,
17450.000000,-192536.000000,5.600000,
60110.000000,-71816.000000,5.600000,
53380.000000,175436.000000,5.600000,
59500.000000,164216.000000,5.600000,
82280.000000,222176.000000,5.600000,
74460.000000,116336.000000,5.600000,
47150.000000,163016.000000,5.600000,
44160.000000,146456.000000,5.600000,
23540.000000,116936.000000,5.600000,
22970.000000,-202976.000000,5.600000,
38990.000000,-122696.000000,5.600000,
69970.000000,72416.000000,5.600000,
8280.000000,71696.000000,5.600000,
51900.000000,-245516.000000,5.600000,
84870.000000,144896.000000,5.600000,
18230.000000,-87896.000000,5.600000,
26470.000000,162896.000000,5.600000,
810.000000,147776.000000,5.600000,
71430.000000,146216.000000,5.600000,
30270.000000,-13556.000000,5.600000,
70650.000000,-51536.000000,5.600000,
23110.000000,25556.000000,5.600000,
62500.000000,143936.000000,5.600000,
51280.000000,-150656.000000,5.600000,
17350.000000,113216.000000,5.600000,
24430.000000,-200036.000000,5.600000,
28210.000000,-33116.000000,5.600000,
19220.000000,225596.000000,5.600000,
35180.000000,42536.000000,5.600000,
14370.000000,-45296.000000,5.600000,
19500.000000,-37256.000000,5.600000,
36430.000000,-61736.000000,5.600000,
79550.000000,-214736.000000,5.600000,
85290.000000,-64976.000000,5.600000,
68690.000000,114356.000000,5.600000,
49300.000000,-121016.000000,5.600000,
76980.000000,-81656.000000,5.600000,
11970.000000,-86876.000000,5.600000,
74720.000000,65216.000000,5.600000,
57040.000000,54536.000000,5.600000,
77220.000000,-153236.000000,5.610000,
75510.000000,181676.000000,5.610000,
26570.000000,199076.000000,5.610000,
83960.000000,-18476.000000,5.610000,
46560.000000,137996.000000,5.610000,
80580.000000,-165416.000000,5.610000,
71320.000000,42596.000000,5.610000,
80790.000000,15896.000000,5.610000,
65740.000000,-227036.000000,5.610000,
56720.000000,19676.000000,5.610000,
63210.000000,-20696.000000,5.610000,
71680.000000,1076.000000,5.610000,
43120.000000,-231656.000000,5.610000,
66660.000000,61016.000000,5.610000,
5670.000000,-56456.000000,5.610000,
20830.000000,52196.000000,5.610000,
57330.000000,-94616.000000,5.610000,
27870.000000,-88856.000000,5.610000,
69570.000000,-127556.000000,5.610000,
23670.000000,-117836.000000,5.610000,
41130.000000,59276.000000,5.610000,
53830.000000,59036.000000,5.610000,
29970.000000,272816.000000,5.610000,
12730.000000,305696.000000,5.610000,
28300.000000,-76256.000000,5.610000,
34920.000000,143216.000000,5.610000,
80610.000000,-89216.000000,5.610000,
35470.000000,-166376.000000,5.610000,
66200.000000,-130496.000000,5.610000,
78600.000000,-233036.000000,5.610000,
39070.000000,203756.000000,5.610000,
84310.000000,-204716.000000,5.610000,
25440.000000,-19256.000000,5.610000,
7420.000000,-14816.000000,5.610000,
75870.000000,19856.000000,5.610000,
17520.000000,228656.000000,5.610000,
44850.000000,200636.000000,5.610000,
37510.000000,31676.000000,5.610000,
86080.000000,416.000000,5.610000,
72270.000000,116036.000000,5.620000,
78200.000000,137876.000000,5.620000,
79260.000000,47276.000000,5.620000,
49030.000000,-222176.000000,5.620000,
66930.000000,85016.000000,5.620000,
66050.000000,107576.000000,5.620000,
4330.000000,286916.000000,5.620000,
58550.000000,-208496.000000,5.620000,
54940.000000,1436.000000,5.620000,
59550.000000,19916.000000,5.620000,
37780.000000,303356.000000,5.620000,
35010.000000,107936.000000,5.620000,
24790.000000,-68576.000000,5.620000,
25260.000000,-90776.000000,5.620000,
10940.000000,15776.000000,5.620000,
15410.000000,222716.000000,5.620000,
6730.000000,182936.000000,5.620000,
73170.000000,224156.000000,5.620000,
86220.000000,200576.000000,5.620000,
53780.000000,178676.000000,5.620000,
7880.000000,30896.000000,5.620000,
53420.000000,297056.000000,5.620000,
21890.000000,15056.000000,5.620000,
68180.000000,234956.000000,5.620000,
41700.000000,197276.000000,5.620000,
84430.000000,-210596.000000,5.620000,
6460.000000,229976.000000,5.620000,
34630.000000,-115916.000000,5.620000,
28490.000000,-206336.000000,5.620000,
69190.000000,-44276.000000,5.620000,
23030.000000,-92096.000000,5.620000,
24720.000000,85016.000000,5.620000,
86360.000000,-106256.000000,5.620000,
47180.000000,81476.000000,5.620000,
71510.000000,169316.000000,5.620000,
38560.000000,-117836.000000,5.630000,
38100.000000,31196.000000,5.630000,
73430.000000,-152816.000000,5.630000,
26820.000000,-64376.000000,5.630000,
24620.000000,-114176.000000,5.630000,
53790.000000,-172376.000000,5.630000,
29580.000000,106796.000000,5.630000,
15800.000000,60476.000000,5.630000,
47210.000000,-129116.000000,5.630000,
78430.000000,9716.000000,5.630000,
31610.000000,43676.000000,5.630000,
62740.000000,216236.000000,5.630000,
33710.000000,-199916.000000,5.630000,
73650.000000,138476.000000,5.630000,
24000.000000,-290936.000000,5.630000,
58050.000000,35696.000000,5.630000,
61530.000000,-3236.000000,5.630000,
21860.000000,-115856.000000,5.630000,
71950.000000,83216.000000,5.630000,
22530.000000,-1856.000000,5.630000,
31150.000000,234116.000000,5.630000,
55300.000000,-173996.000000,5.630000,
26070.000000,43676.000000,5.630000,
27670.000000,173336.000000,5.630000,
47650.000000,-71816.000000,5.630000,
49260.000000,81056.000000,5.630000,
14660.000000,-46136.000000,5.630000,
37210.000000,-171776.000000,5.630000,
42660.000000,-19256.000000,5.630000,
81220.000000,203876.000000,5.630000,
84070.000000,-97196.000000,5.630000,
77180.000000,-136256.000000,5.630000,
36650.000000,-30416.000000,5.630000,
43910.000000,93236.000000,5.630000,
20540.000000,236576.000000,5.630000,
30380.000000,100436.000000,5.630000,
21290.000000,-143876.000000,5.630000,
41560.000000,-145616.000000,5.630000,
45010.000000,-85376.000000,5.630000,
19090.000000,154136.000000,5.630000,
30000.000000,-257456.000000,5.640000,
28870.000000,17576.000000,5.640000,
27920.000000,-52976.000000,5.640000,
58050.000000,-45956.000000,5.640000,
61200.000000,-196616.000000,5.640000,
40120.000000,88856.000000,5.640000,
76300.000000,216056.000000,5.640000,
22880.000000,-42476.000000,5.640000,
82540.000000,130916.000000,5.640000,
56420.000000,-264476.000000,5.640000,
19560.000000,-70976.000000,5.640000,
50010.000000,-128456.000000,5.640000,
21150.000000,-135536.000000,5.640000,
30620.000000,-115796.000000,5.640000,
71590.000000,-11216.000000,5.640000,
23180.000000,202676.000000,5.640000,
16880.000000,173936.000000,5.640000,
19460.000000,-61196.000000,5.640000,
69310.000000,76436.000000,5.640000,
17760.000000,190376.000000,5.640000,
32640.000000,195476.000000,5.640000,
60100.000000,-178796.000000,5.640000,
67770.000000,-156416.000000,5.640000,
35180.000000,6476.000000,5.640000,
26670.000000,99536.000000,5.640000,
41830.000000,-273296.000000,5.640000,
9390.000000,44876.000000,5.640000,
55390.000000,-218456.000000,5.640000,
66330.000000,28976.000000,5.640000,
20220.000000,-289736.000000,5.640000,
9460.000000,-12296.000000,5.640000,
73540.000000,77156.000000,5.640000,
54100.000000,-299636.000000,5.640000,
54280.000000,-298976.000000,5.640000,
15420.000000,208376.000000,5.640000,
68540.000000,-89516.000000,5.640000,
55350.000000,142556.000000,5.640000,
79260.000000,29816.000000,5.640000,
60320.000000,56756.000000,5.640000,
3210.000000,-226376.000000,5.640000,
59770.000000,190496.000000,5.650000,
27360.000000,-52196.000000,5.650000,
69380.000000,52436.000000,5.650000,
17940.000000,-59036.000000,5.650000,
73940.000000,-35576.000000,5.650000,
70630.000000,59276.000000,5.650000,
77930.000000,206996.000000,5.650000,
24390.000000,-36416.000000,5.650000,
61930.000000,-142316.000000,5.650000,
50030.000000,193436.000000,5.650000,
16440.000000,20156.000000,5.650000,
66500.000000,-140396.000000,5.650000,
81530.000000,-119156.000000,5.650000,
15500.000000,77756.000000,5.650000,
30690.000000,86756.000000,5.650000,
2660.000000,172376.000000,5.650000,
79310.000000,190436.000000,5.650000,
9780.000000,198476.000000,5.650000,
13510.000000,89516.000000,5.650000,
27490.000000,-175016.000000,5.650000,
72020.000000,-121376.000000,5.650000,
83810.000000,-223256.000000,5.650000,
4210.000000,151556.000000,5.650000,
39250.000000,-49616.000000,5.650000,
49710.000000,112316.000000,5.650000,
48770.000000,-55376.000000,5.650000,
55350.000000,228116.000000,5.650000,
68050.000000,100496.000000,5.650000,
26170.000000,-168476.000000,5.650000,
72850.000000,-188876.000000,5.650000,
84050.000000,109556.000000,5.650000,
37140.000000,-232856.000000,5.660000,
64020.000000,63776.000000,5.660000,
9740.000000,72116.000000,5.660000,
70840.000000,-2276.000000,5.660000,
77910.000000,20816.000000,5.660000,
14500.000000,36056.000000,5.660000,
58330.000000,-102356.000000,5.660000,
13920.000000,23576.000000,5.660000,
72920.000000,121496.000000,5.660000,
48350.000000,-254276.000000,5.660000,
76210.000000,192896.000000,5.660000,
31480.000000,36356.000000,5.660000,
70560.000000,-89036.000000,5.660000,
21650.000000,-184436.000000,5.660000,
52860.000000,-130136.000000,5.660000,
84540.000000,-227276.000000,5.660000,
39870.000000,-171656.000000,5.660000,
27400.000000,-70976.000000,5.660000,
50110.000000,-187856.000000,5.660000,
84980.000000,7616.000000,5.660000,
42090.000000,114356.000000,5.660000,
77280.000000,116036.000000,5.660000,
84050.000000,137516.000000,5.660000,
13800.000000,161936.000000,5.660000,
46100.000000,-99416.000000,5.660000,
31100.000000,192296.000000,5.660000,
21890.000000,19616.000000,5.660000,
27190.000000,-69956.000000,5.660000,
68200.000000,208196.000000,5.660000,
25280.000000,254996.000000,5.660000,
960.000000,-113276.000000,5.660000,
21280.000000,-42476.000000,5.660000,
47550.000000,41636.000000,5.660000,
64790.000000,163856.000000,5.660000,
34150.000000,-74756.000000,5.660000,
60630.000000,107396.000000,5.660000,
20100.000000,-21716.000000,5.670000,
19290.000000,-1556.000000,5.670000,
29360.000000,-58556.000000,5.670000,
7960.000000,-8696.000000,5.670000,
76160.000000,-263516.000000,5.670000,
76850.000000,116876.000000,5.670000,
47670.000000,40856.000000,5.670000,
53240.000000,-92276.000000,5.670000,
11530.000000,98216.000000,5.670000,
49290.000000,233456.000000,5.670000,
80080.000000,154676.000000,5.670000,
74550.000000,297176.000000,5.670000,
30290.000000,-83396.000000,5.670000,
37080.000000,234416.000000,5.670000,
62640.000000,82676.000000,5.670000,
32250.000000,56156.000000,5.670000,
72200.000000,57776.000000,5.670000,
74510.000000,150236.000000,5.670000,
1500.000000,191036.000000,5.670000,
59290.000000,-211016.000000,5.670000,
53130.000000,2636.000000,5.670000,
22320.000000,71336.000000,5.670000,
77070.000000,94316.000000,5.670000,
7110.000000,177176.000000,5.670000,
32510.000000,-1796.000000,5.670000,
76920.000000,177896.000000,5.670000,
280.000000,241856.000000,5.670000,
44600.000000,-89456.000000,5.670000,
45980.000000,34376.000000,5.670000,
16980.000000,-110816.000000,5.670000,
27050.000000,246536.000000,5.670000,
74330.000000,109256.000000,5.670000,
82860.000000,-183476.000000,5.670000,
54500.000000,94736.000000,5.670000,
78130.000000,4676.000000,5.670000,
72260.000000,-2576.000000,5.670000,
27610.000000,138056.000000,5.670000,
60820.000000,-155036.000000,5.670000,
56850.000000,199436.000000,5.680000,
53910.000000,-99596.000000,5.680000,
44250.000000,104276.000000,5.680000,
60840.000000,-150536.000000,5.680000,
23550.000000,-115316.000000,5.680000,
78720.000000,200936.000000,5.680000,
49920.000000,-190196.000000,5.680000,
1940.000000,25076.000000,5.680000,
65390.000000,11276.000000,5.680000,
5760.000000,-107696.000000,5.680000,
64810.000000,288056.000000,5.680000,
38190.000000,-44096.000000,5.680000,
30720.000000,-191576.000000,5.680000,
6970.000000,134156.000000,5.680000,
21530.000000,46196.000000,5.680000,
75410.000000,-34976.000000,5.680000,
76750.000000,211076.000000,5.680000,
48100.000000,7556.000000,5.680000,
78810.000000,70856.000000,5.680000,
21650.000000,172496.000000,5.680000,
7720.000000,210416.000000,5.680000,
33450.000000,168596.000000,5.680000,
5930.000000,-76616.000000,5.680000,
31390.000000,45656.000000,5.680000,
71520.000000,172556.000000,5.680000,
60280.000000,-147056.000000,5.680000,
17750.000000,54236.000000,5.680000,
70010.000000,-107096.000000,5.680000,
77030.000000,87476.000000,5.680000,
150.000000,30596.000000,5.680000,
1820.000000,-173636.000000,5.680000,
5210.000000,-47096.000000,5.680000,
36270.000000,194096.000000,5.680000,
75400.000000,-94736.000000,5.680000,
53410.000000,86156.000000,5.680000,
29950.000000,225056.000000,5.680000,
12060.000000,13316.000000,5.680000,
17460.000000,175496.000000,5.680000,
35970.000000,106736.000000,5.680000,
48550.000000,38996.000000,5.680000,
5840.000000,-305216.000000,5.680000,
11180.000000,47516.000000,5.680000,
24350.000000,-188696.000000,5.680000,
30260.000000,-291356.000000,5.680000,
15480.000000,-288836.000000,5.680000,
75960.000000,-108476.000000,5.680000,
480.000000,-120776.000000,5.680000,
12750.000000,-181436.000000,5.680000,
8120.000000,-243956.000000,5.680000,
53020.000000,145736.000000,5.680000,
25210.000000,57956.000000,5.680000,
45410.000000,61556.000000,5.680000,
49010.000000,88616.000000,5.680000,
18680.000000,-42716.000000,5.680000,
54710.000000,-175556.000000,5.690000,
2500.000000,-203456.000000,5.690000,
20220.000000,97016.000000,5.690000,
22180.000000,-82016.000000,5.690000,
370.000000,-176756.000000,5.690000,
42080.000000,-155156.000000,5.690000,
48750.000000,-103376.000000,5.690000,
42620.000000,-225596.000000,5.690000,
62670.000000,58736.000000,5.690000,
37380.000000,122156.000000,5.690000,
77110.000000,-35096.000000,5.690000,
19420.000000,-596.000000,5.690000,
28350.000000,-195776.000000,5.690000,
36700.000000,-209096.000000,5.690000,
5650.000000,134096.000000,5.690000,
26860.000000,-82316.000000,5.690000,
69970.000000,-54236.000000,5.690000,
75350.000000,170756.000000,5.690000,
32000.000000,223136.000000,5.690000,
28330.000000,-53456.000000,5.690000,
14210.000000,80936.000000,5.690000,
4480.000000,-3596.000000,5.690000,
17990.000000,-37016.000000,5.690000,
64100.000000,74096.000000,5.690000,
63050.000000,112256.000000,5.690000,
15040.000000,-31796.000000,5.690000,
17700.000000,-60296.000000,5.690000,
9920.000000,-229376.000000,5.690000,
12590.000000,-282116.000000,5.690000,
31560.000000,-7436.000000,5.690000,
57950.000000,-260756.000000,5.690000,
63210.000000,58796.000000,5.690000,
34620.000000,-91136.000000,5.690000,
68040.000000,-76976.000000,5.690000,
48410.000000,-149456.000000,5.690000,
31230.000000,-162716.000000,5.690000,
27390.000000,166316.000000,5.690000,
16470.000000,104337.000000,5.700000,
3270.000000,69177.000000,5.700000,
16880.000000,103077.000000,5.700000,
39550.000000,-121497.000000,5.700000,
20190.000000,-21897.000000,5.700000,
35650.000000,-163077.000000,5.700000,
62190.000000,4377.000000,5.700000,
71670.000000,-29637.000000,5.700000,
82060.000000,-50637.000000,5.700000,
43450.000000,77337.000000,5.700000,
11920.000000,-66837.000000,5.700000,
9670.000000,-2577.000000,5.700000,
14060.000000,-145317.000000,5.700000,
54100.000000,-597.000000,5.700000,
41710.000000,-170577.000000,5.700000,
26080.000000,-168717.000000,5.700000,
56150.000000,196737.000000,5.700000,
70160.000000,-156477.000000,5.700000,
59060.000000,198777.000000,5.700000,
56830.000000,50817.000000,5.700000,
36260.000000,-87477.000000,5.700000,
45150.000000,-49917.000000,5.700000,
10770.000000,-91017.000000,5.700000,
66570.000000,85977.000000,5.700000,
68280.000000,137817.000000,5.700000,
16690.000000,74517.000000,5.700000,
47250.000000,-192477.000000,5.700000,
61090.000000,-182397.000000,5.700000,
79390.000000,41037.000000,5.700000,
21960.000000,-237837.000000,5.700000,
9870.000000,55137.000000,5.700000,
39950.000000,-98277.000000,5.700000,
75990.000000,112317.000000,5.700000,
6520.000000,117717.000000,5.700000,
32110.000000,-197937.000000,5.700000,
22630.000000,18417.000000,5.700000,
6950.000000,84897.000000,5.700000,
60.000000,-175797.000000,5.700000,
33110.000000,-71157.000000,5.700000,
6100.000000,-218937.000000,5.700000,
23980.000000,-109737.000000,5.700000,
66590.000000,-170037.000000,5.700000,
12450.000000,-128517.000000,5.700000,
5600.000000,210057.000000,5.700000,
25330.000000,55257.000000,5.700000,
50080.000000,-243657.000000,5.700000,
78850.000000,-15477.000000,5.700000,
28170.000000,-119877.000000,5.700000,
55650.000000,-232377.000000,5.700000,
84250.000000,-186837.000000,5.700000,
56260.000000,249477.000000,5.700000,
77050.000000,-251097.000000,5.700000,
22460.000000,64497.000000,5.710000,
77770.000000,-94257.000000,5.710000,
33500.000000,127377.000000,5.710000,
16430.000000,-24297.000000,5.710000,
58030.000000,-132357.000000,5.710000,
51610.000000,-155097.000000,5.710000,
82510.000000,-17997.000000,5.710000,
41790.000000,-120897.000000,5.710000,
1800.000000,-14337.000000,5.710000,
63280.000000,-117357.000000,5.710000,
30920.000000,-28797.000000,5.710000,
25900.000000,-75237.000000,5.710000,
35690.000000,-180897.000000,5.710000,
6120.000000,-132657.000000,5.710000,
30880.000000,131157.000000,5.710000,
68790.000000,87357.000000,5.710000,
26280.000000,147237.000000,5.710000,
63390.000000,110877.000000,5.710000,
66470.000000,22377.000000,5.710000,
19620.000000,108777.000000,5.710000,
27400.000000,-175797.000000,5.710000,
77940.000000,73017.000000,5.710000,
28880.000000,212637.000000,5.710000,
53350.000000,166077.000000,5.710000,
15080.000000,19977.000000,5.710000,
17710.000000,-59157.000000,5.710000,
66710.000000,-156717.000000,5.710000,
17100.000000,-76677.000000,5.710000,
85450.000000,-231957.000000,5.710000,
58520.000000,67797.000000,5.710000,
24580.000000,117417.000000,5.710000,
52690.000000,157137.000000,5.710000,
66830.000000,-86577.000000,5.710000,
54980.000000,-80697.000000,5.710000,
19400.000000,-142857.000000,5.710000,
26150.000000,100497.000000,5.710000,
45500.000000,6717.000000,5.710000,
57060.000000,-198237.000000,5.720000,
23830.000000,-133197.000000,5.720000,
82750.000000,42297.000000,5.720000,
65370.000000,14457.000000,5.720000,
81530.000000,70317.000000,5.720000,
16080.000000,77877.000000,5.720000,
43800.000000,20997.000000,5.720000,
15720.000000,50697.000000,5.720000,
20600.000000,-66837.000000,5.720000,
32940.000000,-65997.000000,5.720000,
49430.000000,187497.000000,5.720000,
77570.000000,179997.000000,5.720000,
61420.000000,49017.000000,5.720000,
17560.000000,153357.000000,5.720000,
19270.000000,106497.000000,5.720000,
56510.000000,66537.000000,5.720000,
46250.000000,-190137.000000,5.720000,
44980.000000,75297.000000,5.720000,
67710.000000,-234357.000000,5.720000,
72100.000000,89337.000000,5.720000,
11370.000000,104757.000000,5.720000,
66910.000000,65577.000000,5.720000,
60100.000000,4317.000000,5.720000,
42580.000000,125817.000000,5.720000,
34490.000000,259977.000000,5.720000,
48930.000000,-19497.000000,5.720000,
39290.000000,122577.000000,5.720000,
13510.000000,-170517.000000,5.720000,
86250.000000,-295917.000000,5.720000,
35440.000000,-169017.000000,5.720000,
49180.000000,-144297.000000,5.720000,
73320.000000,164877.000000,5.720000,
30110.000000,-63357.000000,5.720000,
34620.000000,59217.000000,5.720000,
8840.000000,114537.000000,5.720000,
18310.000000,-94197.000000,5.720000,
44100.000000,252777.000000,5.720000,
82870.000000,-103917.000000,5.720000,
22800.000000,52797.000000,5.720000,
74320.000000,47997.000000,5.720000,
15050.000000,120957.000000,5.720000,
30330.000000,7617.000000,5.720000,
62370.000000,288537.000000,5.720000,
52480.000000,177777.000000,5.720000,
27720.000000,51237.000000,5.720000,
58100.000000,30777.000000,5.720000,
60030.000000,15237.000000,5.730000,
78140.000000,147897.000000,5.730000,
73100.000000,199497.000000,5.730000,
64910.000000,-82077.000000,5.730000,
54990.000000,-219297.000000,5.730000,
27580.000000,-137397.000000,5.730000,
67480.000000,135357.000000,5.730000,
15870.000000,122337.000000,5.730000,
1010.000000,221577.000000,5.730000,
16060.000000,-225117.000000,5.730000,
13360.000000,215937.000000,5.730000,
19090.000000,263817.000000,5.730000,
63830.000000,193737.000000,5.730000,
53180.000000,-170817.000000,5.730000,
40410.000000,-214677.000000,5.730000,
66190.000000,-43317.000000,5.730000,
24580.000000,58377.000000,5.730000,
68590.000000,-137757.000000,5.730000,
79640.000000,70137.000000,5.730000,
83260.000000,177537.000000,5.730000,
69980.000000,46917.000000,5.730000,
33740.000000,-165837.000000,5.730000,
41150.000000,201117.000000,5.730000,
72210.000000,107697.000000,5.730000,
29420.000000,91917.000000,5.730000,
44530.000000,-245937.000000,5.730000,
65140.000000,116157.000000,5.730000,
32210.000000,164337.000000,5.730000,
12480.000000,-40677.000000,5.730000,
28570.000000,-217917.000000,5.730000,
38500.000000,246477.000000,5.730000,
7980.000000,55077.000000,5.730000,
75620.000000,69597.000000,5.730000,
76540.000000,-191817.000000,5.740000,
51390.000000,-239757.000000,5.740000,
22180.000000,83277.000000,5.740000,
30470.000000,-126477.000000,5.740000,
24550.000000,-8277.000000,5.740000,
57530.000000,-234177.000000,5.740000,
81650.000000,52437.000000,5.740000,
85050.000000,-47097.000000,5.740000,
26050.000000,-14037.000000,5.740000,
71920.000000,-249057.000000,5.740000,
1110.000000,113517.000000,5.740000,
46270.000000,-217257.000000,5.740000,
66810.000000,-53577.000000,5.740000,
58620.000000,-244617.000000,5.740000,
67730.000000,69657.000000,5.740000,
19820.000000,55377.000000,5.740000,
34340.000000,-69957.000000,5.740000,
16140.000000,-47037.000000,5.740000,
79730.000000,-66777.000000,5.740000,
52600.000000,-144837.000000,5.740000,
890.000000,-34557.000000,5.740000,
24910.000000,91377.000000,5.740000,
48410.000000,283197.000000,5.740000,
80220.000000,-19437.000000,5.740000,
55850.000000,231237.000000,5.740000,
9370.000000,-108237.000000,5.740000,
21510.000000,-158637.000000,5.740000,
25660.000000,26997.000000,5.740000,
32110.000000,-65697.000000,5.740000,
72910.000000,-97377.000000,5.740000,
85970.000000,-32457.000000,5.740000,
20110.000000,-119157.000000,5.740000,
63180.000000,148557.000000,5.740000,
85480.000000,-283737.000000,5.740000,
49900.000000,-249897.000000,5.740000,
2900.000000,19077.000000,5.740000,
50540.000000,-98817.000000,5.740000,
24620.000000,48357.000000,5.740000,
66580.000000,279237.000000,5.740000,
83440.000000,63417.000000,5.740000,
9280.000000,-28377.000000,5.740000,
26960.000000,-37197.000000,5.740000,
79830.000000,41877.000000,5.740000,
40150.000000,130737.000000,5.740000,
11550.000000,-206457.000000,5.740000,
77060.000000,-147657.000000,5.750000,
33920.000000,-223077.000000,5.750000,
24900.000000,-73557.000000,5.750000,
83380.000000,213657.000000,5.750000,
17000.000000,179937.000000,5.750000,
23140.000000,-173517.000000,5.750000,
41370.000000,-88137.000000,5.750000,
76760.000000,137697.000000,5.750000,
9030.000000,90957.000000,5.750000,
28360.000000,-19617.000000,5.750000,
130.000000,97557.000000,5.750000,
71550.000000,-197997.000000,5.750000,
81390.000000,-114057.000000,5.750000,
9330.000000,134337.000000,5.750000,
81130.000000,274497.000000,5.750000,
57360.000000,-217797.000000,5.750000,
85760.000000,3897.000000,5.750000,
46130.000000,50877.000000,5.750000,
43730.000000,-159597.000000,5.750000,
25640.000000,-85857.000000,5.750000,
27580.000000,-137817.000000,5.750000,
44000.000000,-140157.000000,5.750000,
67670.000000,114417.000000,5.750000,
49900.000000,-168897.000000,5.750000,
4270.000000,135897.000000,5.750000,
31490.000000,-133797.000000,5.750000,
57330.000000,153297.000000,5.750000,
24990.000000,166617.000000,5.750000,
67110.000000,-84657.000000,5.750000,
6490.000000,61077.000000,5.750000,
52990.000000,-90057.000000,5.750000,
54570.000000,-241557.000000,5.750000,
31630.000000,-166197.000000,5.750000,
48270.000000,-18597.000000,5.750000,
13560.000000,241977.000000,5.750000,
72690.000000,223557.000000,5.750000,
5620.000000,-25317.000000,5.750000,
59380.000000,-52437.000000,5.750000,
1520.000000,7017.000000,5.750000,
10870.000000,-27597.000000,5.750000,
65390.000000,131337.000000,5.750000,
18860.000000,-129537.000000,5.750000,
28850.000000,91497.000000,5.750000,
76110.000000,-230217.000000,5.750000,
19980.000000,-126537.000000,5.750000,
59780.000000,-8457.000000,5.750000,
72020.000000,-241077.000000,5.750000,
18160.000000,-82077.000000,5.750000,
40420.000000,-191697.000000,5.750000,
8280.000000,208497.000000,5.750000,
24490.000000,-4797.000000,5.750000,
62500.000000,192357.000000,5.750000,
74480.000000,-113817.000000,5.750000,
57330.000000,-216717.000000,5.760000,
31950.000000,116997.000000,5.760000,
13910.000000,123717.000000,5.760000,
18500.000000,-31257.000000,5.760000,
57000.000000,-191577.000000,5.760000,
24640.000000,-1977.000000,5.760000,
58480.000000,121977.000000,5.760000,
73990.000000,-291537.000000,5.760000,
14020.000000,208797.000000,5.760000,
23900.000000,104397.000000,5.760000,
72110.000000,-49137.000000,5.760000,
62800.000000,173817.000000,5.760000,
21290.000000,114177.000000,5.760000,
64600.000000,-101097.000000,5.760000,
24760.000000,30237.000000,5.760000,
81970.000000,160437.000000,5.760000,
26940.000000,-113277.000000,5.760000,
25780.000000,-90897.000000,5.760000,
67490.000000,-90117.000000,5.760000,
62650.000000,-218517.000000,5.760000,
12750.000000,33777.000000,5.760000,
13550.000000,88497.000000,5.760000,
62320.000000,-158937.000000,5.760000,
37260.000000,247557.000000,5.760000,
64390.000000,22017.000000,5.760000,
57800.000000,131877.000000,5.760000,
41660.000000,11097.000000,5.760000,
75620.000000,-184557.000000,5.760000,
17310.000000,-58797.000000,5.760000,
71680.000000,133257.000000,5.760000,
23470.000000,-126957.000000,5.760000,
16910.000000,137817.000000,5.760000,
23310.000000,-62937.000000,5.760000,
15640.000000,22137.000000,5.760000,
45210.000000,-46257.000000,5.760000,
57130.000000,200997.000000,5.760000,
29630.000000,203277.000000,5.760000,
77710.000000,-14397.000000,5.760000,
48050.000000,-168777.000000,5.760000,
54220.000000,-176757.000000,5.760000,
66610.000000,-67497.000000,5.760000,
82440.000000,145437.000000,5.760000,
36760.000000,16677.000000,5.760000,
81090.000000,-309537.000000,5.760000,
62630.000000,31857.000000,5.760000,
65170.000000,-17217.000000,5.760000,
83040.000000,-149397.000000,5.760000,
83690.000000,-148077.000000,5.760000,
56790.000000,199797.000000,5.760000,
790.000000,-306057.000000,5.760000,
22340.000000,117777.000000,5.760000,
7830.000000,70257.000000,5.760000,
80640.000000,-17517.000000,5.770000,
36800.000000,-186417.000000,5.770000,
81140.000000,143277.000000,5.770000,
65210.000000,-156417.000000,5.770000,
71240.000000,138357.000000,5.770000,
28150.000000,-217077.000000,5.770000,
83600.000000,39897.000000,5.770000,
23850.000000,204717.000000,5.770000,
80800.000000,283737.000000,5.770000,
12590.000000,-153537.000000,5.770000,
5750.000000,62817.000000,5.770000,
19790.000000,6537.000000,5.770000,
38630.000000,-231297.000000,5.770000,
32020.000000,-217317.000000,5.770000,
76760.000000,178257.000000,5.770000,
4110.000000,209817.000000,5.770000,
22780.000000,-123897.000000,5.770000,
26720.000000,-90837.000000,5.770000,
44720.000000,-126717.000000,5.770000,
46400.000000,-217257.000000,5.770000,
26700.000000,-49557.000000,5.770000,
80710.000000,-253617.000000,5.770000,
9610.000000,-34077.000000,5.770000,
17310.000000,-20457.000000,5.770000,
85780.000000,131157.000000,5.770000,
45280.000000,-160857.000000,5.770000,
32950.000000,-44517.000000,5.770000,
61330.000000,91917.000000,5.770000,
27270.000000,-97317.000000,5.770000,
64290.000000,-216657.000000,5.770000,
14010.000000,175197.000000,5.770000,
32440.000000,-219537.000000,5.770000,
67410.000000,-232437.000000,5.770000,
29650.000000,-127797.000000,5.770000,
62870.000000,-188337.000000,5.770000,
26690.000000,186837.000000,5.770000,
25530.000000,33117.000000,5.770000,
83990.000000,151557.000000,5.770000,
33700.000000,204237.000000,5.770000,
5210.000000,-117237.000000,5.770000,
49240.000000,71937.000000,5.780000,
39010.000000,-32097.000000,5.780000,
46770.000000,-13737.000000,5.780000,
49000.000000,-95457.000000,5.780000,
78690.000000,71397.000000,5.780000,
6190.000000,218037.000000,5.780000,
23510.000000,-211617.000000,5.780000,
68080.000000,175977.000000,5.780000,
41530.000000,-105417.000000,5.780000,
53550.000000,-229797.000000,5.780000,
20810.000000,34317.000000,5.780000,
26870.000000,-41637.000000,5.780000,
64730.000000,-132777.000000,5.780000,
34100.000000,29517.000000,5.780000,
38600.000000,17157.000000,5.780000,
33570.000000,-57057.000000,5.780000,
34220.000000,-210117.000000,5.780000,
40980.000000,-204477.000000,5.780000,
59540.000000,218997.000000,5.780000,
61170.000000,-249417.000000,5.780000,
63670.000000,-168957.000000,5.780000,
15090.000000,-73317.000000,5.780000,
15650.000000,-293697.000000,5.780000,
19300.000000,30417.000000,5.780000,
33090.000000,-167757.000000,5.780000,
26190.000000,-137997.000000,5.780000,
74950.000000,-92877.000000,5.780000,
79670.000000,78177.000000,5.780000,
24060.000000,1797.000000,5.780000,
74030.000000,168177.000000,5.780000,
70540.000000,133017.000000,5.780000,
28180.000000,-238317.000000,5.780000,
44620.000000,-140097.000000,5.780000,
38620.000000,205917.000000,5.780000,
49210.000000,-232557.000000,5.780000,
73620.000000,177837.000000,5.780000,
8570.000000,149097.000000,5.780000,
56290.000000,168537.000000,5.780000,
61200.000000,-89997.000000,5.780000,
47460.000000,-152097.000000,5.780000,
72240.000000,61497.000000,5.780000,
21000.000000,35577.000000,5.780000,
9410.000000,-124497.000000,5.780000,
55430.000000,-44577.000000,5.780000,
70130.000000,89217.000000,5.780000,
27760.000000,-94917.000000,5.780000,
62580.000000,-203577.000000,5.780000,
10060.000000,293217.000000,5.780000,
24620.000000,-61557.000000,5.780000,
53350.000000,-87357.000000,5.780000,
7740.000000,-156717.000000,5.780000,
31550.000000,-286257.000000,5.780000,
35470.000000,-213957.000000,5.780000,
79510.000000,96057.000000,5.780000,
80210.000000,-32577.000000,5.780000,
80290.000000,226137.000000,5.780000,
9450.000000,236757.000000,5.780000,
66760.000000,85077.000000,5.780000,
71640.000000,-30897.000000,5.780000,
20080.000000,-265497.000000,5.780000,
54720.000000,68337.000000,5.780000,
45360.000000,-143577.000000,5.790000,
24330.000000,-111477.000000,5.790000,
2740.000000,-171237.000000,5.790000,
66590.000000,-207117.000000,5.790000,
40440.000000,29037.000000,5.790000,
53840.000000,-77157.000000,5.790000,
73270.000000,230397.000000,5.790000,
44000.000000,37017.000000,5.790000,
63040.000000,313137.000000,5.790000,
23050.000000,-217017.000000,5.790000,
54490.000000,-146157.000000,5.790000,
70140.000000,7077.000000,5.790000,
21920.000000,-127917.000000,5.790000,
9890.000000,244197.000000,5.790000,
6770.000000,-60957.000000,5.790000,
16690.000000,57777.000000,5.790000,
27520.000000,-131457.000000,5.790000,
300.000000,220737.000000,5.790000,
23710.000000,3237.000000,5.790000,
30950.000000,-183537.000000,5.790000,
77690.000000,-72357.000000,5.790000,
8140.000000,92877.000000,5.790000,
41430.000000,155457.000000,5.790000,
8920.000000,107817.000000,5.790000,
56310.000000,181557.000000,5.790000,
3520.000000,-41037.000000,5.790000,
9170.000000,124377.000000,5.790000,
22230.000000,-97797.000000,5.790000,
80950.000000,96417.000000,5.790000,
40390.000000,-159837.000000,5.790000,
77230.000000,-76377.000000,5.790000,
20190.000000,196017.000000,5.790000,
35170.000000,24177.000000,5.790000,
76860.000000,26517.000000,5.790000,
85880.000000,33597.000000,5.790000,
36570.000000,-247318.000000,5.800000,
46150.000000,99238.000000,5.800000,
66680.000000,-38938.000000,5.800000,
23310.000000,-116578.000000,5.800000,
29660.000000,-165058.000000,5.800000,
85050.000000,160018.000000,5.800000,
33660.000000,137578.000000,5.800000,
61520.000000,196138.000000,5.800000,
41200.000000,-191458.000000,5.800000,
28980.000000,-116938.000000,5.800000,
67580.000000,-80698.000000,5.800000,
12810.000000,143698.000000,5.800000,
27250.000000,12178.000000,5.800000,
21960.000000,-107218.000000,5.800000,
30840.000000,-7798.000000,5.800000,
40190.000000,-116578.000000,5.800000,
49530.000000,-94078.000000,5.800000,
67050.000000,-1198.000000,5.800000,
2180.000000,217258.000000,5.800000,
29370.000000,-201958.000000,5.800000,
26810.000000,72958.000000,5.800000,
67070.000000,-77098.000000,5.800000,
72040.000000,-162478.000000,5.800000,
28730.000000,-218998.000000,5.800000,
22730.000000,-75358.000000,5.800000,
78890.000000,203818.000000,5.800000,
16350.000000,-11578.000000,5.800000,
25620.000000,-147238.000000,5.800000,
39600.000000,-157738.000000,5.800000,
67190.000000,187978.000000,5.800000,
53270.000000,-95998.000000,5.800000,
82400.000000,-41878.000000,5.800000,
56910.000000,101458.000000,5.800000,
30200.000000,66058.000000,5.800000,
27840.000000,-129838.000000,5.800000,
58400.000000,-200038.000000,5.800000,
32190.000000,144778.000000,5.800000,
50400.000000,-90058.000000,5.800000,
10680.000000,74458.000000,5.800000,
37110.000000,-202078.000000,5.800000,
67760.000000,-164938.000000,5.800000,
19760.000000,-12478.000000,5.800000,
34240.000000,121258.000000,5.800000,
34860.000000,-206158.000000,5.800000,
43510.000000,276898.000000,5.800000,
47350.000000,36118.000000,5.800000,
69190.000000,-93298.000000,5.800000,
84790.000000,-278638.000000,5.800000,
250.000000,-59578.000000,5.800000,
26090.000000,-97378.000000,5.800000,
1240.000000,118498.000000,5.800000,
24020.000000,280858.000000,5.800000,
47900.000000,122758.000000,5.800000,
59470.000000,79978.000000,5.800000,
19680.000000,62158.000000,5.800000,
26140.000000,28858.000000,5.800000,
67080.000000,142858.000000,5.800000,
85430.000000,-55078.000000,5.800000,
52030.000000,-166138.000000,5.810000,
46140.000000,300358.000000,5.810000,
65500.000000,120478.000000,5.810000,
63270.000000,34558.000000,5.810000,
85650.000000,168598.000000,5.810000,
67600.000000,-36538.000000,5.810000,
83390.000000,-154318.000000,5.810000,
63710.000000,259798.000000,5.810000,
69980.000000,71698.000000,5.810000,
48300.000000,85978.000000,5.810000,
64570.000000,2458.000000,5.810000,
41780.000000,-219838.000000,5.810000,
76690.000000,-16318.000000,5.810000,
78500.000000,139198.000000,5.810000,
20320.000000,-146638.000000,5.810000,
55240.000000,160018.000000,5.810000,
26540.000000,-21598.000000,5.810000,
37330.000000,148498.000000,5.810000,
5500.000000,-109078.000000,5.810000,
9390.000000,27898.000000,5.810000,
23220.000000,-208858.000000,5.810000,
33420.000000,-52498.000000,5.810000,
48370.000000,165778.000000,5.810000,
50180.000000,-167818.000000,5.810000,
54510.000000,90418.000000,5.810000,
68900.000000,188818.000000,5.810000,
69920.000000,-50098.000000,5.810000,
28620.000000,56878.000000,5.810000,
13710.000000,-75298.000000,5.810000,
44700.000000,204478.000000,5.810000,
39360.000000,22318.000000,5.810000,
22470.000000,-16498.000000,5.820000,
67520.000000,19858.000000,5.820000,
6550.000000,172498.000000,5.820000,
52530.000000,-149518.000000,5.820000,
75380.000000,182698.000000,5.820000,
37030.000000,83218.000000,5.820000,
83230.000000,-182578.000000,5.820000,
49550.000000,-44818.000000,5.820000,
52270.000000,-243838.000000,5.820000,
65090.000000,-129298.000000,5.820000,
26080.000000,89698.000000,5.820000,
60890.000000,-148258.000000,5.820000,
84460.000000,90658.000000,5.820000,
68610.000000,6598.000000,5.820000,
18470.000000,78178.000000,5.820000,
22560.000000,-59878.000000,5.820000,
12650.000000,-239458.000000,5.820000,
12630.000000,173278.000000,5.820000,
10120.000000,90718.000000,5.820000,
26280.000000,-158458.000000,5.820000,
15000.000000,311938.000000,5.820000,
67850.000000,-35218.000000,5.820000,
70720.000000,197938.000000,5.820000,
49120.000000,-106498.000000,5.820000,
5470.000000,253018.000000,5.820000,
9490.000000,-108718.000000,5.820000,
76330.000000,-145018.000000,5.820000,
69830.000000,156298.000000,5.820000,
10910.000000,-35878.000000,5.820000,
22430.000000,-13558.000000,5.820000,
44090.000000,-75058.000000,5.820000,
69740.000000,-1018.000000,5.820000,
63420.000000,260938.000000,5.820000,
40600.000000,178138.000000,5.820000,
56260.000000,-83398.000000,5.820000,
57650.000000,15958.000000,5.820000,
10970.000000,-169198.000000,5.820000,
10680.000000,-85018.000000,5.820000,
41090.000000,41218.000000,5.820000,
41380.000000,55558.000000,5.820000,
15780.000000,-89638.000000,5.820000,
28220.000000,-181858.000000,5.820000,
31960.000000,-139498.000000,5.820000,
44990.000000,-203518.000000,5.820000,
7060.000000,100078.000000,5.820000,
53160.000000,54538.000000,5.820000,
41770.000000,100078.000000,5.830000,
16040.000000,40378.000000,5.830000,
75720.000000,204058.000000,5.830000,
17860.000000,86278.000000,5.830000,
43150.000000,119458.000000,5.830000,
67200.000000,-28138.000000,5.830000,
73080.000000,146698.000000,5.830000,
83670.000000,267298.000000,5.830000,
12810.000000,197938.000000,5.830000,
56990.000000,-176158.000000,5.830000,
70960.000000,116758.000000,5.830000,
29470.000000,-174538.000000,5.830000,
2200.000000,54898.000000,5.830000,
54510.000000,-154378.000000,5.830000,
41340.000000,222418.000000,5.830000,
6650.000000,187018.000000,5.830000,
25940.000000,86938.000000,5.830000,
3860.000000,221818.000000,5.830000,
32320.000000,-58138.000000,5.830000,
83190.000000,71698.000000,5.830000,
49360.000000,126058.000000,5.830000,
610.000000,-18958.000000,5.830000,
2520.000000,238198.000000,5.830000,
14330.000000,-19738.000000,5.830000,
35790.000000,-120358.000000,5.830000,
640.000000,-45358.000000,5.830000,
30020.000000,74758.000000,5.830000,
9360.000000,24898.000000,5.830000,
45680.000000,-166198.000000,5.830000,
82840.000000,10918.000000,5.830000,
5010.000000,-111478.000000,5.830000,
52350.000000,199498.000000,5.830000,
44250.000000,191578.000000,5.830000,
46490.000000,169978.000000,5.830000,
38960.000000,-213658.000000,5.840000,
81410.000000,-146158.000000,5.840000,
26450.000000,-97138.000000,5.840000,
6100.000000,-40798.000000,5.840000,
65550.000000,-265258.000000,5.840000,
6600.000000,80278.000000,5.840000,
58300.000000,152638.000000,5.840000,
2960.000000,-48838.000000,5.840000,
47830.000000,-158398.000000,5.840000,
27190.000000,-89038.000000,5.840000,
54120.000000,-101098.000000,5.840000,
21900.000000,154798.000000,5.840000,
28150.000000,-168718.000000,5.840000,
15640.000000,-27418.000000,5.840000,
33240.000000,-158998.000000,5.840000,
65160.000000,-30058.000000,5.840000,
53770.000000,52078.000000,5.840000,
70100.000000,10558.000000,5.840000,
60230.000000,122578.000000,5.840000,
49600.000000,92578.000000,5.840000,
72370.000000,191458.000000,5.840000,
42700.000000,-111058.000000,5.840000,
47650.000000,-282478.000000,5.840000,
70450.000000,184498.000000,5.840000,
59770.000000,167878.000000,5.840000,
75500.000000,39058.000000,5.840000,
53660.000000,-42838.000000,5.840000,
64340.000000,-124018.000000,5.840000,
17930.000000,-296938.000000,5.840000,
11840.000000,-171958.000000,5.840000,
84890.000000,257938.000000,5.840000,
42950.000000,203818.000000,5.840000,
56250.000000,196318.000000,5.840000,
35780.000000,32218.000000,5.840000,
37000.000000,91438.000000,5.840000,
18160.000000,-15178.000000,5.840000,
32560.000000,26278.000000,5.840000,
73520.000000,-103258.000000,5.840000,
52020.000000,-236998.000000,5.840000,
64830.000000,119698.000000,5.840000,
37910.000000,116638.000000,5.850000,
17480.000000,-125698.000000,5.850000,
36240.000000,-65218.000000,5.850000,
23980.000000,46858.000000,5.850000,
15680.000000,-418.000000,5.850000,
65470.000000,-273298.000000,5.850000,
59050.000000,25078.000000,5.850000,
54080.000000,216778.000000,5.850000,
13770.000000,227878.000000,5.850000,
46030.000000,226078.000000,5.850000,
49570.000000,147958.000000,5.850000,
56180.000000,58078.000000,5.850000,
57460.000000,-75538.000000,5.850000,
27970.000000,-136678.000000,5.850000,
65580.000000,139678.000000,5.850000,
13740.000000,158338.000000,5.850000,
58270.000000,-148078.000000,5.850000,
65460.000000,-148978.000000,5.850000,
17560.000000,100498.000000,5.850000,
28530.000000,31978.000000,5.850000,
46110.000000,217198.000000,5.850000,
38340.000000,136558.000000,5.850000,
33290.000000,-135418.000000,5.850000,
13100.000000,-26638.000000,5.850000,
49350.000000,281098.000000,5.850000,
62300.000000,139798.000000,5.850000,
38980.000000,-35518.000000,5.850000,
83300.000000,-103858.000000,5.850000,
82800.000000,-90658.000000,5.850000,
1880.000000,120958.000000,5.850000,
26250.000000,187678.000000,5.850000,
19890.000000,-165418.000000,5.850000,
34220.000000,-56158.000000,5.850000,
3340.000000,-26518.000000,5.850000,
73220.000000,64138.000000,5.850000,
79940.000000,227938.000000,5.850000,
33030.000000,111598.000000,5.850000,
8760.000000,-55258.000000,5.860000,
19620.000000,-147478.000000,5.860000,
46570.000000,194818.000000,5.860000,
60420.000000,7498.000000,5.860000,
65270.000000,94018.000000,5.860000,
42510.000000,51478.000000,5.860000,
23970.000000,101818.000000,5.860000,
73760.000000,201898.000000,5.860000,
27250.000000,-84538.000000,5.860000,
51540.000000,-92998.000000,5.860000,
150.000000,238018.000000,5.860000,
4780.000000,-1858.000000,5.860000,
16410.000000,-226258.000000,5.860000,
10910.000000,95338.000000,5.860000,
48130.000000,18658.000000,5.860000,
16580.000000,231418.000000,5.860000,
33440.000000,-269098.000000,5.860000,
45400.000000,-21058.000000,5.860000,
45690.000000,225838.000000,5.860000,
62280.000000,62458.000000,5.860000,
62800.000000,124978.000000,5.860000,
20530.000000,-80578.000000,5.860000,
84840.000000,-4558.000000,5.860000,
23200.000000,-5518.000000,5.860000,
49990.000000,103138.000000,5.860000,
75460.000000,-57778.000000,5.860000,
29350.000000,-175318.000000,5.860000,
28890.000000,59278.000000,5.860000,
57540.000000,179638.000000,5.860000,
21920.000000,-36898.000000,5.860000,
52410.000000,-198118.000000,5.860000,
26960.000000,-27238.000000,5.860000,
66470.000000,-107398.000000,5.860000,
5870.000000,-298738.000000,5.860000,
60100.000000,-119398.000000,5.860000,
30820.000000,17218.000000,5.860000,
49570.000000,138658.000000,5.860000,
55840.000000,-59878.000000,5.860000,
76860.000000,-16498.000000,5.860000,
70280.000000,95878.000000,5.860000,
73080.000000,-78538.000000,5.860000,
2880.000000,261718.000000,5.860000,
47680.000000,-176278.000000,5.860000,
52410.000000,-189718.000000,5.860000,
62570.000000,-208918.000000,5.860000,
46870.000000,61738.000000,5.860000,
2650.000000,-138358.000000,5.860000,
21330.000000,-16678.000000,5.860000,
39610.000000,-50758.000000,5.860000,
64770.000000,-17398.000000,5.860000,
69320.000000,109918.000000,5.860000,
71020.000000,150418.000000,5.860000,
25350.000000,60058.000000,5.860000,
51440.000000,55018.000000,5.860000,
61190.000000,-90358.000000,5.860000,
56640.000000,9118.000000,5.870000,
83800.000000,-160198.000000,5.870000,
81840.000000,142078.000000,5.870000,
70400.000000,-163018.000000,5.870000,
38890.000000,-114178.000000,5.870000,
15710.000000,203458.000000,5.870000,
20990.000000,-82738.000000,5.870000,
22630.000000,-134158.000000,5.870000,
69150.000000,77638.000000,5.870000,
7370.000000,233698.000000,5.870000,
37800.000000,140158.000000,5.870000,
30510.000000,51238.000000,5.870000,
68990.000000,-150838.000000,5.870000,
1220.000000,111418.000000,5.870000,
27870.000000,-136618.000000,5.870000,
72720.000000,95398.000000,5.870000,
11430.000000,42838.000000,5.870000,
20280.000000,27238.000000,5.870000,
3510.000000,238918.000000,5.870000,
25510.000000,81538.000000,5.870000,
4060.000000,-35278.000000,5.870000,
9410.000000,139498.000000,5.870000,
23110.000000,-3418.000000,5.870000,
32930.000000,122098.000000,5.870000,
7200.000000,11218.000000,5.870000,
36990.000000,84658.000000,5.870000,
64720.000000,130678.000000,5.870000,
31800.000000,-106078.000000,5.870000,
45130.000000,-262858.000000,5.870000,
45540.000000,-109558.000000,5.870000,
59290.000000,-133858.000000,5.870000,
23440.000000,209458.000000,5.870000,
23530.000000,17578.000000,5.870000,
2360.000000,76558.000000,5.870000,
10110.000000,65878.000000,5.870000,
8790.000000,-72238.000000,5.870000,
70620.000000,-65698.000000,5.870000,
81620.000000,-110398.000000,5.870000,
34290.000000,-128638.000000,5.870000,
23400.000000,168118.000000,5.870000,
32460.000000,-247318.000000,5.870000,
5680.000000,66538.000000,5.870000,
39570.000000,-58918.000000,5.870000,
49860.000000,124858.000000,5.870000,
63080.000000,-291178.000000,5.870000,
26460.000000,-93238.000000,5.870000,
16410.000000,261178.000000,5.880000,
67580.000000,-3538.000000,5.880000,
58600.000000,104998.000000,5.880000,
21500.000000,6718.000000,5.880000,
78930.000000,235258.000000,5.880000,
68610.000000,-247618.000000,5.880000,
13000.000000,2218.000000,5.880000,
61990.000000,-241978.000000,5.880000,
48360.000000,260698.000000,5.880000,
17350.000000,117418.000000,5.880000,
85310.000000,26158.000000,5.880000,
73760.000000,131278.000000,5.880000,
66350.000000,107398.000000,5.880000,
71140.000000,27478.000000,5.880000,
12760.000000,127678.000000,5.880000,
62640.000000,-226378.000000,5.880000,
50020.000000,-192238.000000,5.880000,
61460.000000,-207838.000000,5.880000,
78150.000000,38998.000000,5.880000,
20800.000000,56998.000000,5.880000,
43350.000000,-249118.000000,5.880000,
11230.000000,230638.000000,5.880000,
22280.000000,49198.000000,5.880000,
60860.000000,-152998.000000,5.880000,
72740.000000,-45478.000000,5.880000,
71980.000000,-35878.000000,5.880000,
46490.000000,-158998.000000,5.880000,
10300.000000,168658.000000,5.880000,
10890.000000,-101158.000000,5.880000,
81240.000000,-5698.000000,5.880000,
80180.000000,206038.000000,5.880000,
26360.000000,9898.000000,5.880000,
32270.000000,-174898.000000,5.880000,
66770.000000,-266338.000000,5.880000,
85260.000000,-42118.000000,5.880000,
8520.000000,-63658.000000,5.880000,
46000.000000,-119998.000000,5.880000,
55570.000000,-245938.000000,5.880000,
63680.000000,186598.000000,5.880000,
75820.000000,191878.000000,5.880000,
27400.000000,200818.000000,5.880000,
2860.000000,-65098.000000,5.880000,
48190.000000,-17758.000000,5.880000,
55100.000000,-1738.000000,5.880000,
66760.000000,-53578.000000,5.880000,
78910.000000,-222838.000000,5.890000,
30170.000000,-94918.000000,5.890000,
18700.000000,3778.000000,5.890000,
27120.000000,-32038.000000,5.890000,
75840.000000,-20998.000000,5.890000,
7170.000000,75838.000000,5.890000,
36820.000000,-145318.000000,5.890000,
51510.000000,-67438.000000,5.890000,
85780.000000,103858.000000,5.890000,
47560.000000,-238498.000000,5.890000,
250.000000,224278.000000,5.890000,
74770.000000,-77518.000000,5.890000,
13580.000000,-105658.000000,5.890000,
44320.000000,-2878.000000,5.890000,
24210.000000,14218.000000,5.890000,
28030.000000,-81118.000000,5.890000,
67600.000000,190858.000000,5.890000,
31950.000000,-174178.000000,5.890000,
24980.000000,35878.000000,5.890000,
57270.000000,-90958.000000,5.890000,
28850.000000,-194998.000000,5.890000,
68160.000000,-83458.000000,5.890000,
1020.000000,172678.000000,5.890000,
15810.000000,75598.000000,5.890000,
58120.000000,-85318.000000,5.890000,
38700.000000,242758.000000,5.890000,
75980.000000,257218.000000,5.890000,
30020.000000,207898.000000,5.890000,
14440.000000,65578.000000,5.890000,
74970.000000,45178.000000,5.890000,
18670.000000,-9058.000000,5.890000,
2420.000000,-214078.000000,5.890000,
41540.000000,-241078.000000,5.890000,
37950.000000,-160678.000000,5.890000,
47650.000000,-211318.000000,5.890000,
67250.000000,225958.000000,5.890000,
10780.000000,147778.000000,5.890000,
35900.000000,262378.000000,5.890000,
22170.000000,79918.000000,5.890000,
56110.000000,194218.000000,5.890000,
40170.000000,155578.000000,5.890000,
64220.000000,-193079.000000,5.900000,
47510.000000,-251879.000000,5.900000,
18010.000000,141899.000000,5.900000,
39340.000000,2699.000000,5.900000,
57870.000000,-136379.000000,5.900000,
16600.000000,-223499.000000,5.900000,
68320.000000,50099.000000,5.900000,
82600.000000,-172739.000000,5.900000,
34110.000000,-240119.000000,5.900000,
34400.000000,-82379.000000,5.900000,
68740.000000,-56459.000000,5.900000,
36600.000000,-30299.000000,5.900000,
54670.000000,-305339.000000,5.900000,
42890.000000,-227819.000000,5.900000,
71960.000000,164819.000000,5.900000,
27470.000000,175619.000000,5.900000,
49640.000000,-180959.000000,5.900000,
70440.000000,-144179.000000,5.900000,
50180.000000,3839.000000,5.900000,
83900.000000,150479.000000,5.900000,
83240.000000,76139.000000,5.900000,
78240.000000,-53159.000000,5.900000,
39420.000000,-182819.000000,5.900000,
31260.000000,-176159.000000,5.900000,
53320.000000,-239759.000000,5.900000,
21290.000000,71159.000000,5.900000,
38280.000000,-206159.000000,5.900000,
25930.000000,-93479.000000,5.900000,
26800.000000,-122939.000000,5.900000,
33520.000000,-185639.000000,5.900000,
60080.000000,-245939.000000,5.900000,
49040.000000,-167219.000000,5.900000,
64330.000000,-125339.000000,5.900000,
75920.000000,281279.000000,5.900000,
11880.000000,-103679.000000,5.900000,
16100.000000,53099.000000,5.900000,
60090.000000,96959.000000,5.900000,
74410.000000,217919.000000,5.900000,
72960.000000,164099.000000,5.900000,
51220.000000,-3059.000000,5.900000,
43960.000000,-252599.000000,5.900000,
26380.000000,25739.000000,5.900000,
27390.000000,21179.000000,5.900000,
45720.000000,-249959.000000,5.900000,
57670.000000,-229679.000000,5.900000,
11990.000000,97559.000000,5.900000,
6500.000000,13319.000000,5.900000,
2440.000000,-15719.000000,5.900000,
18760.000000,-21839.000000,5.900000,
11600.000000,173639.000000,5.900000,
8070.000000,-148259.000000,5.900000,
25010.000000,168119.000000,5.900000,
63440.000000,-180239.000000,5.900000,
74310.000000,85259.000000,5.900000,
22290.000000,88019.000000,5.900000,
40730.000000,5999.000000,5.900000,
9180.000000,-124799.000000,5.900000,
85630.000000,-42959.000000,5.900000,
30770.000000,136919.000000,5.900000,
52690.000000,65939.000000,5.900000,
28000.000000,235739.000000,5.900000,
26050.000000,-35819.000000,5.900000,
80010.000000,103079.000000,5.900000,
4220.000000,91739.000000,5.900000,
23710.000000,35999.000000,5.900000,
55670.000000,218459.000000,5.900000,
58130.000000,12479.000000,5.900000,
72050.000000,30899.000000,5.900000,
74290.000000,-292739.000000,5.900000,
81430.000000,271379.000000,5.900000,
1060.000000,185219.000000,5.900000,
11740.000000,205739.000000,5.910000,
22500.000000,49919.000000,5.910000,
5060.000000,-24959.000000,5.910000,
53300.000000,87779.000000,5.910000,
10210.000000,-129059.000000,5.910000,
62330.000000,-126059.000000,5.910000,
53930.000000,-40199.000000,5.910000,
34890.000000,112679.000000,5.910000,
70370.000000,-191519.000000,5.910000,
64420.000000,-125279.000000,5.910000,
71050.000000,249719.000000,5.910000,
74350.000000,78599.000000,5.910000,
56680.000000,62219.000000,5.910000,
48370.000000,-4319.000000,5.910000,
8570.000000,-184019.000000,5.910000,
4360.000000,-136319.000000,5.910000,
73420.000000,134939.000000,5.910000,
33210.000000,-170519.000000,5.910000,
30030.000000,86519.000000,5.910000,
52350.000000,80219.000000,5.910000,
61430.000000,-137399.000000,5.910000,
82500.000000,133559.000000,5.910000,
24320.000000,-114539.000000,5.910000,
10410.000000,-138419.000000,5.910000,
7370.000000,-55199.000000,5.910000,
60800.000000,-73559.000000,5.910000,
67130.000000,-75839.000000,5.910000,
53160.000000,-83399.000000,5.910000,
58800.000000,76199.000000,5.910000,
74430.000000,-58139.000000,5.910000,
58820.000000,-198599.000000,5.910000,
75380.000000,177179.000000,5.910000,
13560.000000,24599.000000,5.910000,
22500.000000,-73079.000000,5.910000,
24030.000000,258359.000000,5.910000,
34120.000000,-224219.000000,5.910000,
39310.000000,-217919.000000,5.910000,
75280.000000,-64559.000000,5.910000,
31150.000000,189839.000000,5.910000,
31090.000000,118139.000000,5.910000,
13710.000000,839.000000,5.910000,
59940.000000,-134039.000000,5.920000,
73810.000000,39299.000000,5.920000,
48880.000000,-47639.000000,5.920000,
47940.000000,126479.000000,5.920000,
35390.000000,76319.000000,5.920000,
3810.000000,219899.000000,5.920000,
74340.000000,57059.000000,5.920000,
21880.000000,-162359.000000,5.920000,
11540.000000,-160019.000000,5.920000,
39210.000000,251519.000000,5.920000,
85970.000000,-11459.000000,5.920000,
14880.000000,62459.000000,5.920000,
39270.000000,-222659.000000,5.920000,
73200.000000,48839.000000,5.920000,
14440.000000,-109799.000000,5.920000,
62850.000000,-107039.000000,5.920000,
75700.000000,-96839.000000,5.920000,
46210.000000,135119.000000,5.920000,
20460.000000,1259.000000,5.920000,
63450.000000,-56159.000000,5.920000,
35630.000000,-184139.000000,5.920000,
17040.000000,-30659.000000,5.920000,
24390.000000,31019.000000,5.920000,
79470.000000,-96599.000000,5.920000,
14940.000000,48299.000000,5.920000,
21140.000000,71579.000000,5.920000,
43940.000000,-226679.000000,5.920000,
67570.000000,149219.000000,5.920000,
22950.000000,45299.000000,5.920000,
34290.000000,-114779.000000,5.920000,
2130.000000,-1859.000000,5.920000,
53340.000000,136139.000000,5.920000,
49780.000000,221399.000000,5.920000,
21560.000000,179819.000000,5.920000,
35830.000000,206759.000000,5.920000,
75670.000000,129779.000000,5.920000,
80610.000000,-25979.000000,5.920000,
80660.000000,-48779.000000,5.920000,
25410.000000,105659.000000,5.920000,
2890.000000,26339.000000,5.920000,
62570.000000,-134039.000000,5.920000,
7880.000000,-6659.000000,5.920000,
18110.000000,2639.000000,5.920000,
20040.000000,-5339.000000,5.920000,
23410.000000,-36359.000000,5.920000,
46590.000000,-259979.000000,5.920000,
54010.000000,-277799.000000,5.920000,
63490.000000,-39419.000000,5.920000,
50600.000000,-202439.000000,5.920000,
5980.000000,59099.000000,5.920000,
10680.000000,139079.000000,5.920000,
46380.000000,-197939.000000,5.920000,
4300.000000,-8159.000000,5.920000,
42940.000000,-102539.000000,5.920000,
85830.000000,-51899.000000,5.920000,
5100.000000,-231779.000000,5.920000,
53960.000000,16499.000000,5.920000,
38920.000000,-7139.000000,5.920000,
56660.000000,-150599.000000,5.930000,
22920.000000,213779.000000,5.930000,
460.000000,-81119.000000,5.930000,
12860.000000,88139.000000,5.930000,
48720.000000,-67499.000000,5.930000,
3770.000000,148859.000000,5.930000,
77140.000000,132059.000000,5.930000,
68810.000000,-58499.000000,5.930000,
41220.000000,-44519.000000,5.930000,
5420.000000,-94379.000000,5.930000,
68630.000000,-183779.000000,5.930000,
2490.000000,88739.000000,5.930000,
66580.000000,-52559.000000,5.930000,
66710.000000,-3659.000000,5.930000,
6650.000000,-180779.000000,5.930000,
23910.000000,-60779.000000,5.930000,
30170.000000,-187679.000000,5.930000,
40970.000000,231659.000000,5.930000,
69100.000000,112679.000000,5.930000,
51560.000000,-133259.000000,5.930000,
64240.000000,80339.000000,5.930000,
52190.000000,2999.000000,5.930000,
5390.000000,66179.000000,5.930000,
2690.000000,-153659.000000,5.930000,
52840.000000,48779.000000,5.930000,
82220.000000,151079.000000,5.930000,
23440.000000,-100019.000000,5.930000,
22020.000000,-123599.000000,5.930000,
65880.000000,65339.000000,5.930000,
36120.000000,-217559.000000,5.930000,
44620.000000,153239.000000,5.930000,
21140.000000,-205799.000000,5.930000,
25020.000000,121319.000000,5.930000,
12380.000000,-98399.000000,5.930000,
12640.000000,22379.000000,5.930000,
61330.000000,232679.000000,5.930000,
73050.000000,240719.000000,5.930000,
49340.000000,297959.000000,5.930000,
18140.000000,-114419.000000,5.930000,
1990.000000,197699.000000,5.930000,
5900.000000,-131579.000000,5.930000,
6510.000000,136679.000000,5.930000,
75740.000000,-138779.000000,5.930000,
82890.000000,-17039.000000,5.930000,
45300.000000,78839.000000,5.930000,
14010.000000,-168839.000000,5.930000,
47380.000000,60659.000000,5.930000,
47380.000000,-37259.000000,5.930000,
60840.000000,-208559.000000,5.930000,
27710.000000,48599.000000,5.930000,
69610.000000,207539.000000,5.930000,
77330.000000,79919.000000,5.930000,
78290.000000,224939.000000,5.930000,
11500.000000,293339.000000,5.940000,
12680.000000,99299.000000,5.940000,
64570.000000,-56999.000000,5.940000,
18280.000000,266699.000000,5.940000,
23290.000000,253979.000000,5.940000,
73790.000000,-66959.000000,5.940000,
52340.000000,96059.000000,5.940000,
50030.000000,-169739.000000,5.940000,
41680.000000,60539.000000,5.940000,
57300.000000,-69839.000000,5.940000,
25220.000000,-30299.000000,5.940000,
79380.000000,-274079.000000,5.940000,
53670.000000,-119879.000000,5.940000,
19600.000000,123839.000000,5.940000,
44710.000000,-41819.000000,5.940000,
56510.000000,-273959.000000,5.940000,
60980.000000,-188279.000000,5.940000,
71900.000000,228779.000000,5.940000,
27550.000000,87239.000000,5.940000,
44220.000000,-60119.000000,5.940000,
51840.000000,29759.000000,5.940000,
60050.000000,44639.000000,5.940000,
66150.000000,43379.000000,5.940000,
85150.000000,271079.000000,5.940000,
31020.000000,34799.000000,5.940000,
45110.000000,-228659.000000,5.940000,
30540.000000,-159059.000000,5.940000,
60380.000000,-210659.000000,5.940000,
85590.000000,240419.000000,5.940000,
46430.000000,-217439.000000,5.940000,
69870.000000,-100379.000000,5.940000,
26090.000000,-149159.000000,5.940000,
63080.000000,-204959.000000,5.940000,
19470.000000,112199.000000,5.940000,
21800.000000,42119.000000,5.940000,
57960.000000,-85019.000000,5.940000,
77660.000000,186179.000000,5.940000,
6650.000000,39839.000000,5.940000,
37500.000000,-210899.000000,5.940000,
61720.000000,-109499.000000,5.940000,
79690.000000,91979.000000,5.940000,
80980.000000,-97619.000000,5.940000,
75920.000000,21539.000000,5.940000,
56390.000000,-215699.000000,5.940000,
20790.000000,4259.000000,5.940000,
65180.000000,-129779.000000,5.940000,
33020.000000,79259.000000,5.940000,
63690.000000,22799.000000,5.940000,
23860.000000,221399.000000,5.940000,
15430.000000,-23339.000000,5.940000,
26990.000000,-189599.000000,5.940000,
56290.000000,-75719.000000,5.940000,
3490.000000,122339.000000,5.940000,
10410.000000,-80639.000000,5.940000,
32190.000000,-60179.000000,5.940000,
54610.000000,-94859.000000,5.940000,
53220.000000,-137879.000000,5.940000,
61160.000000,204119.000000,5.940000,
66560.000000,-288899.000000,5.940000,
820.000000,-93779.000000,5.940000,
39060.000000,-11219.000000,5.940000,
48670.000000,151619.000000,5.940000,
50130.000000,-297659.000000,5.940000,
36670.000000,134639.000000,5.940000,
43780.000000,6899.000000,5.940000,
39810.000000,-59.000000,5.940000,
41560.000000,-28259.000000,5.940000,
15900.000000,-220499.000000,5.940000,
20220.000000,39779.000000,5.940000,
27030.000000,-195899.000000,5.940000,
34370.000000,-48719.000000,5.940000,
64350.000000,4799.000000,5.940000,
73360.000000,147719.000000,5.940000,
35620.000000,21539.000000,5.940000,
56040.000000,-144239.000000,5.940000,
10540.000000,66059.000000,5.940000,
66800.000000,-139499.000000,5.950000,
60570.000000,47819.000000,5.950000,
1820.000000,215939.000000,5.950000,
19130.000000,-65339.000000,5.950000,
25130.000000,13019.000000,5.950000,
16240.000000,-128399.000000,5.950000,
21670.000000,111779.000000,5.950000,
21760.000000,179699.000000,5.950000,
27690.000000,13139.000000,5.950000,
37100.000000,-150059.000000,5.950000,
21120.000000,-32639.000000,5.950000,
30920.000000,-96719.000000,5.950000,
33350.000000,262679.000000,5.950000,
76880.000000,117479.000000,5.950000,
11860.000000,141539.000000,5.950000,
28890.000000,-134279.000000,5.950000,
32030.000000,127979.000000,5.950000,
20230.000000,-100439.000000,5.950000,
20310.000000,-23759.000000,5.950000,
20350.000000,105239.000000,5.950000,
64710.000000,-103619.000000,5.950000,
30810.000000,-139919.000000,5.950000,
4440.000000,58139.000000,5.950000,
55350.000000,223379.000000,5.950000,
34960.000000,126359.000000,5.950000,
69410.000000,169259.000000,5.950000,
12330.000000,-249659.000000,5.950000,
83420.000000,156779.000000,5.950000,
57440.000000,-130319.000000,5.950000,
14720.000000,79259.000000,5.950000,
71520.000000,41939.000000,5.950000,
30580.000000,242339.000000,5.950000,
1630.000000,-92039.000000,5.950000,
41860.000000,-243479.000000,5.950000,
74400.000000,156479.000000,5.950000,
28800.000000,169259.000000,5.950000,
58150.000000,23039.000000,5.950000,
71260.000000,91439.000000,5.950000,
78040.000000,197579.000000,5.950000,
31950.000000,102059.000000,5.950000,
16110.000000,-70079.000000,5.950000,
13140.000000,-20339.000000,5.950000,
21010.000000,16019.000000,5.950000,
28610.000000,-152699.000000,5.950000,
4230.000000,8879.000000,5.950000,
57720.000000,190559.000000,5.950000,
70270.000000,-246419.000000,5.950000,
72800.000000,218339.000000,5.950000,
42040.000000,-194339.000000,5.950000,
30170.000000,-27239.000000,5.950000,
44510.000000,-202979.000000,5.950000,
61890.000000,-176039.000000,5.950000,
75390.000000,161819.000000,5.950000,
15810.000000,152819.000000,5.960000,
60300.000000,-102659.000000,5.960000,
64620.000000,299.000000,5.960000,
67780.000000,118199.000000,5.960000,
25940.000000,-131639.000000,5.960000,
50450.000000,-238619.000000,5.960000,
60180.000000,279119.000000,5.960000,
20570.000000,-24539.000000,5.960000,
44410.000000,-79859.000000,5.960000,
70900.000000,181979.000000,5.960000,
62130.000000,-139019.000000,5.960000,
68090.000000,122339.000000,5.960000,
62680.000000,-77279.000000,5.960000,
64290.000000,-146879.000000,5.960000,
55720.000000,169979.000000,5.960000,
73850.000000,74219.000000,5.960000,
85190.000000,34859.000000,5.960000,
37400.000000,-14699.000000,5.960000,
7760.000000,292739.000000,5.960000,
64460.000000,-124139.000000,5.960000,
26600.000000,82619.000000,5.960000,
24700.000000,-130439.000000,5.960000,
25390.000000,32939.000000,5.960000,
69700.000000,286619.000000,5.960000,
86230.000000,-226739.000000,5.960000,
37820.000000,231299.000000,5.960000,
32500.000000,100499.000000,5.960000,
7160.000000,44339.000000,5.960000,
38510.000000,-287279.000000,5.960000,
46310.000000,-142919.000000,5.960000,
46900.000000,229079.000000,5.960000,
28260.000000,194939.000000,5.960000,
10570.000000,30239.000000,5.960000,
18440.000000,-44999.000000,5.960000,
45900.000000,141419.000000,5.960000,
26750.000000,-20879.000000,5.960000,
20910.000000,-14759.000000,5.960000,
21400.000000,41519.000000,5.960000,
23820.000000,-137399.000000,5.960000,
30350.000000,-232619.000000,5.960000,
49210.000000,111719.000000,5.960000,
85160.000000,266459.000000,5.960000,
80340.000000,-47939.000000,5.960000,
29900.000000,-45539.000000,5.960000,
45810.000000,-5759.000000,5.960000,
56130.000000,63599.000000,5.960000,
1280.000000,-278819.000000,5.960000,
19840.000000,149339.000000,5.960000,
21370.000000,-82259.000000,5.960000,
26120.000000,-189059.000000,5.960000,
34640.000000,-130019.000000,5.960000,
81610.000000,193919.000000,5.960000,
81710.000000,52319.000000,5.960000,
35360.000000,-133919.000000,5.960000,
65430.000000,195479.000000,5.960000,
62140.000000,85559.000000,5.960000,
81640.000000,-206819.000000,5.960000,
72190.000000,66719.000000,5.960000,
83960.000000,-65099.000000,5.960000,
60310.000000,155639.000000,5.960000,
23800.000000,-47999.000000,5.960000,
43490.000000,-219479.000000,5.960000,
58290.000000,84599.000000,5.960000,
40350.000000,-66659.000000,5.970000,
50970.000000,-185519.000000,5.970000,
9770.000000,192779.000000,5.970000,
67780.000000,-21299.000000,5.970000,
38340.000000,-211799.000000,5.970000,
14790.000000,235859.000000,5.970000,
42550.000000,58559.000000,5.970000,
13460.000000,75419.000000,5.970000,
30350.000000,-53819.000000,5.970000,
76400.000000,292499.000000,5.970000,
3350.000000,98039.000000,5.970000,
14220.000000,83459.000000,5.970000,
27760.000000,122459.000000,5.970000,
520.000000,131879.000000,5.970000,
13980.000000,62459.000000,5.970000,
15890.000000,68639.000000,5.970000,
21030.000000,7379.000000,5.970000,
23010.000000,-187919.000000,5.970000,
41670.000000,-118259.000000,5.970000,
49020.000000,-158999.000000,5.970000,
52270.000000,-140039.000000,5.970000,
60270.000000,-191399.000000,5.970000,
82960.000000,-75179.000000,5.970000,
28310.000000,69659.000000,5.970000,
65710.000000,247559.000000,5.970000,
36630.000000,-150239.000000,5.970000,
58740.000000,-53639.000000,5.970000,
22530.000000,-17759.000000,5.980000,
75600.000000,27119.000000,5.980000,
39870.000000,137759.000000,5.980000,
30290.000000,-154079.000000,5.980000,
39220.000000,-254639.000000,5.980000,
47240.000000,-215579.000000,5.980000,
49420.000000,-151499.000000,5.980000,
71130.000000,130019.000000,5.980000,
47400.000000,138659.000000,5.980000,
15690.000000,-92699.000000,5.980000,
75080.000000,-20339.000000,5.980000,
47180.000000,76199.000000,5.980000,
45670.000000,-46919.000000,5.980000,
46830.000000,-12179.000000,5.980000,
6950.000000,134219.000000,5.980000,
65710.000000,-73439.000000,5.980000,
19160.000000,-98579.000000,5.980000,
48090.000000,-70199.000000,5.980000,
58470.000000,264239.000000,5.980000,
72260.000000,173699.000000,5.980000,
12630.000000,-170639.000000,5.980000,
50480.000000,32039.000000,5.980000,
17330.000000,273479.000000,5.980000,
31820.000000,-151559.000000,5.980000,
79200.000000,24239.000000,5.980000,
17690.000000,1799.000000,5.980000,
28740.000000,-162839.000000,5.980000,
11520.000000,152639.000000,5.980000,
26520.000000,719.000000,5.980000,
77200.000000,190499.000000,5.980000,
21380.000000,34259.000000,5.980000,
45780.000000,-202319.000000,5.980000,
77460.000000,43739.000000,5.980000,
20170.000000,171839.000000,5.980000,
24910.000000,158159.000000,5.980000,
66970.000000,235799.000000,5.980000,
52240.000000,227519.000000,5.980000,
86220.000000,153599.000000,5.980000,
40750.000000,-232559.000000,5.980000,
67690.000000,84719.000000,5.980000,
12570.000000,-24599.000000,5.980000,
25630.000000,-187139.000000,5.980000,
33310.000000,124739.000000,5.980000,
77090.000000,289919.000000,5.980000,
490.000000,-31859.000000,5.980000,
33840.000000,-221999.000000,5.980000,
2840.000000,24359.000000,5.980000,
69270.000000,-162779.000000,5.980000,
6090.000000,108179.000000,5.980000,
37160.000000,174299.000000,5.980000,
49370.000000,-149099.000000,5.980000,
51820.000000,-191459.000000,5.980000,
73760.000000,291959.000000,5.980000,
79910.000000,57839.000000,5.980000,
72480.000000,-2519.000000,5.980000,
54070.000000,-137099.000000,5.980000,
56890.000000,49679.000000,5.980000,
65830.000000,-62579.000000,5.980000,
2560.000000,-217019.000000,5.980000,
58390.000000,-193319.000000,5.980000,
76970.000000,-33599.000000,5.980000,
21160.000000,122159.000000,5.980000,
60440.000000,152099.000000,5.980000,
65030.000000,-87779.000000,5.980000,
61900.000000,179159.000000,5.990000,
77530.000000,-122279.000000,5.990000,
28880.000000,-196319.000000,5.990000,
19390.000000,-30299.000000,5.990000,
7600.000000,92579.000000,5.990000,
30950.000000,23879.000000,5.990000,
61220.000000,-175199.000000,5.990000,
8280.000000,207119.000000,5.990000,
22590.000000,-143399.000000,5.990000,
80580.000000,224759.000000,5.990000,
46450.000000,-41999.000000,5.990000,
37960.000000,-211259.000000,5.990000,
38650.000000,71159.000000,5.990000,
61430.000000,125339.000000,5.990000,
20370.000000,-12899.000000,5.990000,
78180.000000,-51899.000000,5.990000,
45520.000000,-65759.000000,5.990000,
14110.000000,-43619.000000,5.990000,
61970.000000,-116819.000000,5.990000,
27590.000000,-135359.000000,5.990000,
34900.000000,-198779.000000,5.990000,
33100.000000,-141419.000000,5.990000,
13650.000000,201419.000000,5.990000,
30530.000000,-35159.000000,5.990000,
74520.000000,-274319.000000,5.990000,
78270.000000,53219.000000,5.990000,
79810.000000,70679.000000,5.990000,
32050.000000,-19679.000000,5.990000,
32920.000000,95939.000000,5.990000,
9720.000000,-138239.000000,5.990000,
71530.000000,-68639.000000,5.990000,
17200.000000,145199.000000,5.990000,
11120.000000,146159.000000,5.990000,
29580.000000,59519.000000,5.990000,
46720.000000,271739.000000,5.990000,
59380.000000,-207959.000000,5.990000,
79920.000000,89939.000000,5.990000,
85100.000000,-276779.000000,5.990000,
75040.000000,-45239.000000,5.990000,
14760.000000,247319.000000,5.990000,
42200.000000,-133919.000000,5.990000,
73350.000000,112559.000000,5.990000,
3890.000000,20399.000000,5.990000,
79130.000000,225779.000000,5.990000,
73200.000000,248039.000000,5.990000,
270.000000,151560.000000,6.000000,
20230.000000,231000.000000,6.000000,
18580.000000,100980.000000,6.000000,
37150.000000,-45180.000000,6.000000,
6950.000000,6720.000000,6.000000,
81750.000000,-169980.000000,6.000000,
29140.000000,-120900.000000,6.000000,
58940.000000,-158160.000000,6.000000,
7420.000000,-1260.000000,6.000000,
12500.000000,82200.000000,6.000000,
62910.000000,-198660.000000,6.000000,
28260.000000,119760.000000,6.000000,
28900.000000,217260.000000,6.000000,
23130.000000,84060.000000,6.000000,
37640.000000,-236640.000000,6.000000,
38880.000000,-215760.000000,6.000000,
54750.000000,-262020.000000,6.000000,
64120.000000,69360.000000,6.000000,
13120.000000,-100620.000000,6.000000,
27630.000000,-29520.000000,6.000000,
37640.000000,149820.000000,6.000000,
49930.000000,43860.000000,6.000000,
9040.000000,1020.000000,6.000000,
67690.000000,175620.000000,6.000000,
75520.000000,-52200.000000,6.000000,
35470.000000,-15300.000000,6.000000,
26060.000000,-37140.000000,6.000000,
86130.000000,206700.000000,6.000000,
71800.000000,130560.000000,6.000000,
67890.000000,131580.000000,6.000000,
78320.000000,-255720.000000,6.000000,
44840.000000,-229680.000000,6.000000,
17970.000000,-53340.000000,6.000000,
5710.000000,-209340.000000,6.000000,
7880.000000,-36240.000000,6.000000,
30270.000000,-16980.000000,6.000000,
5130.000000,84720.000000,6.000000,
10310.000000,248040.000000,6.000000,
5170.000000,156540.000000,6.000000,
61510.000000,2580.000000,6.000000,
36830.000000,97740.000000,6.000000,
77480.000000,189480.000000,6.000000,
22570.000000,86340.000000,6.000000,
56450.000000,57780.000000,6.000000,
16420.000000,33960.000000,6.000000,
50190.000000,-196980.000000,6.000000,
65810.000000,-10860.000000,6.000000,
72010.000000,-135780.000000,6.000000,
82090.000000,134760.000000,6.000000,
21280.000000,3540.000000,6.000000,
29080.000000,-182160.000000,6.000000,
49820.000000,19800.000000,6.000000,
56150.000000,40560.000000,6.000000,
68400.000000,-240000.000000,6.000000,
69300.000000,72780.000000,6.000000,
79830.000000,-15480.000000,6.000000,
84640.000000,139260.000000,6.000000,
84680.000000,-161520.000000,6.000000,
2390.000000,-161340.000000,6.000000,
31930.000000,163140.000000,6.000000,
53600.000000,69000.000000,6.000000,
57090.000000,-169440.000000,6.000000,
60790.000000,170700.000000,6.000000,
3200.000000,134820.000000,6.000000,
33980.000000,-5280.000000,6.000000,
85950.000000,-51360.000000,6.000000,
25640.000000,122520.000000,6.000000,
47370.000000,134760.000000,6.000000,
65990.000000,106860.000000,6.000000,
76540.000000,277260.000000,6.000000,
29610.000000,-180780.000000,6.000000,
25340.000000,63900.000000,6.000000,
71410.000000,-171240.000000,6.000000,
39570.000000,130020.000000,6.000000,
78370.000000,-33420.000000,6.000000,
15490.000000,-74640.000000,6.000000,
65760.000000,8640.000000,6.000000,
21940.000000,-87180.000000,6.000000,
29790.000000,42300.000000,6.000000,
48780.000000,-25980.000000,6.000000,
49200.000000,-179880.000000,6.000000,
25920.000000,-227520.000000,6.010000,
27600.000000,18900.000000,6.010000,
560.000000,287040.000000,6.010000,
890.000000,31800.000000,6.010000,
14860.000000,54660.000000,6.010000,
81180.000000,251760.000000,6.010000,
80620.000000,75120.000000,6.010000,
56840.000000,-136560.000000,6.010000,
39980.000000,-211260.000000,6.010000,
49120.000000,-207540.000000,6.010000,
38170.000000,-58920.000000,6.010000,
21410.000000,87360.000000,6.010000,
54390.000000,-111360.000000,6.010000,
71610.000000,215040.000000,6.010000,
35530.000000,8880.000000,6.010000,
70250.000000,-76800.000000,6.010000,
20790.000000,202020.000000,6.010000,
2830.000000,70560.000000,6.010000,
76400.000000,131940.000000,6.010000,
48040.000000,-201000.000000,6.010000,
7110.000000,222120.000000,6.010000,
33310.000000,-210240.000000,6.010000,
63100.000000,-94680.000000,6.010000,
77330.000000,199560.000000,6.010000,
25260.000000,-212220.000000,6.010000,
30310.000000,-75840.000000,6.010000,
46830.000000,-120660.000000,6.010000,
3860.000000,106860.000000,6.010000,
9170.000000,54240.000000,6.010000,
86070.000000,-145140.000000,6.010000,
21960.000000,127440.000000,6.010000,
50900.000000,-269460.000000,6.010000,
86130.000000,170520.000000,6.010000,
25980.000000,-40500.000000,6.010000,
68450.000000,121800.000000,6.010000,
31930.000000,151260.000000,6.010000,
25140.000000,137040.000000,6.010000,
17170.000000,67500.000000,6.010000,
52240.000000,17220.000000,6.010000,
74470.000000,52560.000000,6.010000,
46290.000000,11040.000000,6.010000,
82260.000000,307380.000000,6.010000,
22720.000000,-54120.000000,6.010000,
54440.000000,66480.000000,6.020000,
25770.000000,-58500.000000,6.020000,
29550.000000,-166620.000000,6.020000,
28540.000000,-157920.000000,6.020000,
19620.000000,-247080.000000,6.020000,
30850.000000,30480.000000,6.020000,
81570.000000,135360.000000,6.020000,
23540.000000,42120.000000,6.020000,
51800.000000,-182820.000000,6.020000,
41130.000000,-135960.000000,6.020000,
8950.000000,84600.000000,6.020000,
51360.000000,68160.000000,6.020000,
31980.000000,-204000.000000,6.020000,
60200.000000,-242820.000000,6.020000,
79220.000000,-201240.000000,6.020000,
58120.000000,61980.000000,6.020000,
28810.000000,-176340.000000,6.020000,
19410.000000,60180.000000,6.020000,
13240.000000,91200.000000,6.020000,
20840.000000,-37980.000000,6.020000,
69590.000000,41580.000000,6.020000,
46980.000000,-257340.000000,6.020000,
27910.000000,-157620.000000,6.020000,
2770.000000,161520.000000,6.020000,
71950.000000,187440.000000,6.020000,
60330.000000,3720.000000,6.020000,
21130.000000,212340.000000,6.020000,
9920.000000,16980.000000,6.020000,
16400.000000,155100.000000,6.020000,
79940.000000,-51120.000000,6.020000,
25120.000000,93960.000000,6.020000,
16310.000000,57120.000000,6.020000,
28950.000000,227220.000000,6.020000,
15610.000000,150540.000000,6.020000,
18090.000000,-143040.000000,6.020000,
24810.000000,-102780.000000,6.020000,
7980.000000,-75660.000000,6.020000,
4480.000000,25260.000000,6.020000,
54600.000000,-139740.000000,6.020000,
63340.000000,134340.000000,6.020000,
69710.000000,-66000.000000,6.020000,
10330.000000,-226500.000000,6.020000,
15220.000000,259740.000000,6.020000,
80860.000000,114720.000000,6.020000,
11420.000000,96900.000000,6.020000,
25430.000000,45360.000000,6.020000,
10840.000000,39240.000000,6.020000,
58750.000000,176640.000000,6.020000,
44990.000000,-150300.000000,6.020000,
37650.000000,35160.000000,6.030000,
26720.000000,-79200.000000,6.030000,
33360.000000,-161700.000000,6.030000,
68320.000000,146520.000000,6.030000,
65400.000000,59340.000000,6.030000,
26960.000000,-54060.000000,6.030000,
39620.000000,154560.000000,6.030000,
80750.000000,-270120.000000,6.030000,
68580.000000,-69300.000000,6.030000,
77180.000000,69840.000000,6.030000,
890.000000,80220.000000,6.030000,
38330.000000,-44880.000000,6.030000,
44890.000000,-231660.000000,6.030000,
51300.000000,-105480.000000,6.030000,
74560.000000,218220.000000,6.030000,
76060.000000,-62880.000000,6.030000,
12260.000000,74940.000000,6.030000,
840.000000,119580.000000,6.030000,
21670.000000,-91560.000000,6.030000,
70990.000000,110460.000000,6.030000,
43840.000000,98280.000000,6.030000,
61260.000000,-310980.000000,6.030000,
20240.000000,-21420.000000,6.030000,
66470.000000,-64140.000000,6.030000,
57360.000000,-143580.000000,6.030000,
78120.000000,127860.000000,6.030000,
1700.000000,36780.000000,6.030000,
45710.000000,-71160.000000,6.030000,
64370.000000,-128340.000000,6.030000,
52660.000000,-244620.000000,6.030000,
82410.000000,-175020.000000,6.030000,
24890.000000,-10200.000000,6.030000,
82280.000000,-106380.000000,6.030000,
10350.000000,-46080.000000,6.030000,
17150.000000,-141720.000000,6.030000,
28630.000000,31140.000000,6.030000,
82120.000000,226680.000000,6.030000,
17320.000000,13020.000000,6.030000,
62930.000000,-132480.000000,6.030000,
47950.000000,-259380.000000,6.030000,
55440.000000,163020.000000,6.030000,
62350.000000,-214980.000000,6.030000,
35880.000000,29940.000000,6.030000,
76630.000000,200940.000000,6.030000,
64320.000000,144000.000000,6.030000,
7870.000000,93420.000000,6.030000,
50320.000000,52800.000000,6.030000,
71240.000000,172500.000000,6.030000,
63590.000000,112380.000000,6.030000,
12610.000000,213780.000000,6.040000,
23970.000000,-85320.000000,6.040000,
47600.000000,-182580.000000,6.040000,
62390.000000,-63960.000000,6.040000,
3600.000000,160980.000000,6.040000,
56320.000000,-140940.000000,6.040000,
74430.000000,107340.000000,6.040000,
35860.000000,-174360.000000,6.040000,
48170.000000,-259740.000000,6.040000,
70240.000000,130500.000000,6.040000,
57210.000000,57960.000000,6.040000,
64800.000000,288060.000000,6.040000,
71350.000000,-103680.000000,6.040000,
70610.000000,40620.000000,6.040000,
75340.000000,16380.000000,6.040000,
51030.000000,-253140.000000,6.040000,
43340.000000,-308280.000000,6.040000,
42250.000000,90900.000000,6.040000,
49630.000000,-35040.000000,6.040000,
76010.000000,139500.000000,6.040000,
15740.000000,75000.000000,6.040000,
11470.000000,-13740.000000,6.040000,
37720.000000,-13560.000000,6.040000,
70230.000000,12480.000000,6.040000,
68300.000000,-81180.000000,6.040000,
75110.000000,-119520.000000,6.040000,
11870.000000,-240960.000000,6.040000,
34000.000000,-233820.000000,6.040000,
65840.000000,-103200.000000,6.040000,
31390.000000,-284700.000000,6.040000,
40170.000000,241980.000000,6.040000,
67150.000000,-172560.000000,6.040000,
38990.000000,100740.000000,6.040000,
31470.000000,-237060.000000,6.040000,
28300.000000,-154440.000000,6.040000,
15980.000000,31020.000000,6.040000,
18290.000000,-11040.000000,6.040000,
20010.000000,73740.000000,6.040000,
20430.000000,112920.000000,6.040000,
30680.000000,134220.000000,6.040000,
82120.000000,195960.000000,6.040000,
24420.000000,-75660.000000,6.040000,
20130.000000,-283800.000000,6.040000,
71460.000000,-236220.000000,6.040000,
14320.000000,-205620.000000,6.040000,
37900.000000,-101760.000000,6.040000,
82470.000000,-252300.000000,6.040000,
24780.000000,128880.000000,6.040000,
30160.000000,-47040.000000,6.040000,
9700.000000,-11640.000000,6.040000,
14160.000000,-228600.000000,6.040000,
16700.000000,-279600.000000,6.040000,
33630.000000,-135300.000000,6.040000,
44710.000000,86220.000000,6.040000,
61230.000000,-129420.000000,6.040000,
73580.000000,62400.000000,6.040000,
81330.000000,-86400.000000,6.040000,
5780.000000,175500.000000,6.040000,
39370.000000,151320.000000,6.040000,
43150.000000,-186120.000000,6.040000,
10590.000000,169800.000000,6.040000,
40990.000000,540.000000,6.040000,
18830.000000,-187380.000000,6.040000,
45080.000000,27420.000000,6.040000,
83410.000000,-146220.000000,6.040000,
29170.000000,81540.000000,6.040000,
61690.000000,-3960.000000,6.050000,
67780.000000,-262860.000000,6.050000,
2560.000000,-138540.000000,6.050000,
33850.000000,-142020.000000,6.050000,
29650.000000,-115740.000000,6.050000,
71030.000000,123000.000000,6.050000,
21660.000000,99360.000000,6.050000,
7850.000000,140580.000000,6.050000,
26420.000000,-188400.000000,6.050000,
33640.000000,184620.000000,6.050000,
2670.000000,-225060.000000,6.050000,
8040.000000,171000.000000,6.050000,
18090.000000,219960.000000,6.050000,
22620.000000,-81840.000000,6.050000,
29980.000000,14220.000000,6.050000,
54830.000000,-94320.000000,6.050000,
56930.000000,-188880.000000,6.050000,
75430.000000,1740.000000,6.050000,
64890.000000,120000.000000,6.050000,
30040.000000,260700.000000,6.050000,
40630.000000,-244260.000000,6.050000,
18390.000000,-47280.000000,6.050000,
27540.000000,-191880.000000,6.050000,
44220.000000,-236520.000000,6.050000,
58280.000000,60000.000000,6.050000,
60220.000000,-137400.000000,6.050000,
42850.000000,-206700.000000,6.050000,
43830.000000,-136380.000000,6.050000,
8350.000000,167400.000000,6.050000,
51060.000000,-251040.000000,6.050000,
77840.000000,160980.000000,6.050000,
46030.000000,43080.000000,6.050000,
30510.000000,87000.000000,6.050000,
2160.000000,-82320.000000,6.050000,
22540.000000,21900.000000,6.050000,
20820.000000,-103140.000000,6.050000,
61830.000000,188760.000000,6.050000,
6940.000000,-219240.000000,6.050000,
31210.000000,115080.000000,6.050000,
9690.000000,-52440.000000,6.050000,
41590.000000,-58620.000000,6.050000,
62770.000000,27420.000000,6.050000,
11690.000000,153060.000000,6.050000,
76500.000000,-62520.000000,6.050000,
75780.000000,139260.000000,6.050000,
20580.000000,203760.000000,6.050000,
2130.000000,-197400.000000,6.050000,
12250.000000,45540.000000,6.050000,
35320.000000,-203160.000000,6.050000,
56320.000000,124860.000000,6.050000,
73180.000000,-3900.000000,6.050000,
28770.000000,47760.000000,6.050000,
25030.000000,207240.000000,6.050000,
37230.000000,195240.000000,6.050000,
27650.000000,82920.000000,6.050000,
62050.000000,-204840.000000,6.050000,
510.000000,-63360.000000,6.050000,
57780.000000,213960.000000,6.050000,
20440.000000,114960.000000,6.050000,
76230.000000,36180.000000,6.060000,
74370.000000,146160.000000,6.060000,
52190.000000,114480.000000,6.060000,
1120.000000,157680.000000,6.060000,
6460.000000,-288660.000000,6.060000,
17410.000000,-148860.000000,6.060000,
43580.000000,-236580.000000,6.060000,
65460.000000,-171120.000000,6.060000,
2950.000000,-86940.000000,6.060000,
8970.000000,34500.000000,6.060000,
64650.000000,-273780.000000,6.060000,
15510.000000,-82740.000000,6.060000,
28150.000000,-126960.000000,6.060000,
53330.000000,-3120.000000,6.060000,
58550.000000,-53520.000000,6.060000,
62830.000000,-182280.000000,6.060000,
64500.000000,-131340.000000,6.060000,
69080.000000,145620.000000,6.060000,
77420.000000,190680.000000,6.060000,
15300.000000,206880.000000,6.060000,
23270.000000,73800.000000,6.060000,
17780.000000,130320.000000,6.060000,
11240.000000,64440.000000,6.060000,
17050.000000,146880.000000,6.060000,
58490.000000,-91740.000000,6.060000,
67920.000000,50340.000000,6.060000,
17690.000000,158700.000000,6.060000,
25040.000000,42900.000000,6.060000,
60090.000000,-88140.000000,6.060000,
30800.000000,131280.000000,6.060000,
36870.000000,76260.000000,6.060000,
47800.000000,-234540.000000,6.060000,
23230.000000,-93120.000000,6.060000,
39640.000000,-114660.000000,6.060000,
72330.000000,-242400.000000,6.060000,
59210.000000,8520.000000,6.060000,
75280.000000,273360.000000,6.060000,
19650.000000,-77040.000000,6.060000,
11790.000000,115920.000000,6.060000,
42230.000000,-24060.000000,6.060000,
85460.000000,-253860.000000,6.060000,
7950.000000,87120.000000,6.060000,
10440.000000,-183240.000000,6.060000,
11070.000000,6840.000000,6.060000,
52090.000000,130380.000000,6.060000,
52170.000000,-276300.000000,6.060000,
56550.000000,-178200.000000,6.060000,
71720.000000,209760.000000,6.060000,
81360.000000,128160.000000,6.060000,
83380.000000,-101160.000000,6.060000,
1470.000000,-8040.000000,6.060000,
32490.000000,20340.000000,6.060000,
61430.000000,48900.000000,6.060000,
81760.000000,-159360.000000,6.060000,
60060.000000,89520.000000,6.060000,
78160.000000,213420.000000,6.060000,
37380.000000,23640.000000,6.060000,
18140.000000,267420.000000,6.060000,
38350.000000,-268200.000000,6.060000,
54840.000000,114480.000000,6.060000,
27640.000000,205560.000000,6.060000,
53110.000000,-5100.000000,6.060000,
70420.000000,177360.000000,6.060000,
23840.000000,22140.000000,6.060000,
85160.000000,-168000.000000,6.070000,
51750.000000,-174000.000000,6.070000,
20900.000000,75180.000000,6.070000,
57820.000000,18000.000000,6.070000,
22270.000000,-95340.000000,6.070000,
42230.000000,-226380.000000,6.070000,
67170.000000,147360.000000,6.070000,
51440.000000,184740.000000,6.070000,
33210.000000,76680.000000,6.070000,
66120.000000,-102420.000000,6.070000,
67400.000000,194040.000000,6.070000,
54790.000000,-70800.000000,6.070000,
30070.000000,-208740.000000,6.070000,
12350.000000,176820.000000,6.070000,
29470.000000,35400.000000,6.070000,
13790.000000,80160.000000,6.070000,
64050.000000,-53100.000000,6.070000,
35230.000000,284940.000000,6.070000,
43860.000000,-220620.000000,6.070000,
64520.000000,201540.000000,6.070000,
52750.000000,-167760.000000,6.070000,
68870.000000,60720.000000,6.070000,
76390.000000,-131160.000000,6.070000,
58460.000000,-118860.000000,6.070000,
3840.000000,189060.000000,6.070000,
66470.000000,13560.000000,6.070000,
85710.000000,-23040.000000,6.070000,
30280.000000,151320.000000,6.070000,
55650.000000,90420.000000,6.070000,
65730.000000,-67260.000000,6.080000,
64430.000000,-125160.000000,6.080000,
18810.000000,7140.000000,6.080000,
61130.000000,-135480.000000,6.080000,
48620.000000,-23340.000000,6.080000,
41290.000000,-260940.000000,6.080000,
20700.000000,14520.000000,6.080000,
45670.000000,-46920.000000,6.080000,
15520.000000,-190320.000000,6.080000,
53930.000000,-18000.000000,6.080000,
55700.000000,-185820.000000,6.080000,
38110.000000,-157260.000000,6.080000,
19150.000000,72540.000000,6.080000,
27610.000000,-70860.000000,6.080000,
71150.000000,126120.000000,6.080000,
77110.000000,-258540.000000,6.080000,
82330.000000,-227520.000000,6.080000,
17380.000000,57300.000000,6.080000,
70210.000000,10440.000000,6.080000,
14120.000000,111840.000000,6.080000,
14220.000000,21780.000000,6.080000,
25910.000000,20460.000000,6.080000,
42020.000000,208740.000000,6.080000,
50430.000000,-283020.000000,6.080000,
54230.000000,237360.000000,6.080000,
59880.000000,-23580.000000,6.080000,
85060.000000,60600.000000,6.080000,
39930.000000,-39960.000000,6.080000,
9030.000000,71580.000000,6.080000,
72860.000000,-228360.000000,6.080000,
57850.000000,-119640.000000,6.080000,
32420.000000,-155460.000000,6.080000,
53680.000000,-237660.000000,6.080000,
8440.000000,170400.000000,6.080000,
10810.000000,137400.000000,6.080000,
76640.000000,153720.000000,6.080000,
21930.000000,121020.000000,6.080000,
29080.000000,67860.000000,6.080000,
47780.000000,246300.000000,6.080000,
26340.000000,-69480.000000,6.080000,
8030.000000,239520.000000,6.080000,
83170.000000,66720.000000,6.080000,
63210.000000,207300.000000,6.080000,
79860.000000,-76500.000000,6.080000,
16990.000000,86760.000000,6.080000,
20210.000000,144720.000000,6.080000,
8000.000000,266520.000000,6.080000,
72080.000000,-81960.000000,6.080000,
85440.000000,-162360.000000,6.080000,
80130.000000,-160140.000000,6.080000,
19490.000000,-159300.000000,6.080000,
31680.000000,-23640.000000,6.080000,
35510.000000,-59580.000000,6.080000,
36960.000000,-40380.000000,6.080000,
59170.000000,41100.000000,6.080000,
62200.000000,-22560.000000,6.080000,
85810.000000,-36000.000000,6.080000,
68570.000000,70860.000000,6.080000,
14890.000000,135900.000000,6.080000,
490.000000,-8880.000000,6.080000,
16450.000000,-24660.000000,6.080000,
70260.000000,255660.000000,6.080000,
70890.000000,-237120.000000,6.080000,
69860.000000,-157500.000000,6.080000,
84170.000000,-216240.000000,6.080000,
85940.000000,78060.000000,6.080000,
71440.000000,136260.000000,6.080000,
84830.000000,75060.000000,6.080000,
22290.000000,175440.000000,6.090000,
53750.000000,116340.000000,6.090000,
70780.000000,122340.000000,6.090000,
53110.000000,-200220.000000,6.090000,
34000.000000,-103680.000000,6.090000,
22520.000000,-32580.000000,6.090000,
66950.000000,61200.000000,6.090000,
67450.000000,219840.000000,6.090000,
69900.000000,-105540.000000,6.090000,
79970.000000,264000.000000,6.090000,
39280.000000,91800.000000,6.090000,
6770.000000,185460.000000,6.090000,
31550.000000,-91440.000000,6.090000,
31840.000000,67920.000000,6.090000,
37310.000000,54000.000000,6.090000,
78090.000000,146940.000000,6.090000,
36310.000000,188520.000000,6.090000,
71770.000000,204120.000000,6.090000,
25920.000000,-111000.000000,6.090000,
67880.000000,-12000.000000,6.090000,
33840.000000,-186300.000000,6.090000,
25060.000000,-99180.000000,6.090000,
20590.000000,83640.000000,6.090000,
21280.000000,-178740.000000,6.090000,
36780.000000,-215760.000000,6.090000,
83960.000000,125340.000000,6.090000,
54780.000000,-130020.000000,6.090000,
63480.000000,-154440.000000,6.090000,
2550.000000,211560.000000,6.090000,
63180.000000,-148260.000000,6.090000,
27590.000000,115260.000000,6.090000,
60910.000000,49080.000000,6.090000,
30350.000000,61440.000000,6.090000,
24600.000000,-216960.000000,6.090000,
7020.000000,-186420.000000,6.090000,
16020.000000,-169080.000000,6.090000,
53960.000000,-155460.000000,6.090000,
9720.000000,-167580.000000,6.090000,
78150.000000,178560.000000,6.090000,
1090.000000,40380.000000,6.090000,
15150.000000,62280.000000,6.090000,
17690.000000,-142680.000000,6.090000,
18600.000000,-2100.000000,6.090000,
21700.000000,176340.000000,6.090000,
26140.000000,-38160.000000,6.090000,
30300.000000,126120.000000,6.090000,
50350.000000,-181380.000000,6.090000,
84220.000000,-155280.000000,6.090000,
3930.000000,-36000.000000,6.090000,
21790.000000,154560.000000,6.090000,
69510.000000,178500.000000,6.090000,
7180.000000,-237900.000000,6.090000,
49120.000000,-253680.000000,6.090000,
3070.000000,222600.000000,6.090000,
1690.000000,59280.000000,6.090000,
20940.000000,226141.000000,6.100000,
63350.000000,75661.000000,6.100000,
70860.000000,49801.000000,6.100000,
19270.000000,-123721.000000,6.100000,
65850.000000,-122821.000000,6.100000,
17940.000000,52441.000000,6.100000,
61480.000000,70681.000000,6.100000,
57010.000000,-163501.000000,6.100000,
19430.000000,-3181.000000,6.100000,
5610.000000,-282721.000000,6.100000,
60900.000000,92641.000000,6.100000,
50600.000000,-149161.000000,6.100000,
33140.000000,-25681.000000,6.100000,
39300.000000,-152161.000000,6.100000,
46550.000000,-55261.000000,6.100000,
68810.000000,-173941.000000,6.100000,
20220.000000,-42421.000000,6.100000,
48540.000000,-232861.000000,6.100000,
31490.000000,-76261.000000,6.100000,
31790.000000,-261301.000000,6.100000,
55830.000000,-74701.000000,6.100000,
66240.000000,299461.000000,6.100000,
77800.000000,-119041.000000,6.100000,
20230.000000,32281.000000,6.100000,
48130.000000,-187921.000000,6.100000,
72680.000000,78841.000000,6.100000,
61300.000000,-212281.000000,6.100000,
64950.000000,82561.000000,6.100000,
17500.000000,35941.000000,6.100000,
32790.000000,-200941.000000,6.100000,
72460.000000,123961.000000,6.100000,
15170.000000,80701.000000,6.100000,
15480.000000,151801.000000,6.100000,
25200.000000,-72601.000000,6.100000,
25620.000000,17761.000000,6.100000,
29630.000000,-130861.000000,6.100000,
100.000000,152581.000000,6.100000,
19340.000000,-202141.000000,6.100000,
49800.000000,-104761.000000,6.100000,
51220.000000,-196681.000000,6.100000,
57590.000000,-194521.000000,6.100000,
61940.000000,-99961.000000,6.100000,
69390.000000,-120721.000000,6.100000,
27250.000000,-120541.000000,6.100000,
68880.000000,78181.000000,6.100000,
12110.000000,176761.000000,6.100000,
38090.000000,-83521.000000,6.100000,
67480.000000,84961.000000,6.100000,
75600.000000,-130141.000000,6.100000,
44110.000000,-37201.000000,6.100000,
50150.000000,50761.000000,6.100000,
46390.000000,-12901.000000,6.100000,
64350.000000,-22141.000000,6.100000,
25560.000000,-138241.000000,6.100000,
58730.000000,-208501.000000,6.100000,
39460.000000,-215101.000000,6.100000,
57190.000000,47581.000000,6.100000,
44700.000000,-153061.000000,6.100000,
31380.000000,168901.000000,6.100000,
3720.000000,-205261.000000,6.100000,
45000.000000,211621.000000,6.100000,
46620.000000,166321.000000,6.100000,
20160.000000,-170401.000000,6.100000,
33470.000000,-241441.000000,6.100000,
40370.000000,-179101.000000,6.100000,
59480.000000,-95581.000000,6.100000,
6800.000000,-138961.000000,6.100000,
73540.000000,-10141.000000,6.100000,
77850.000000,194641.000000,6.100000,
6430.000000,-150421.000000,6.100000,
24290.000000,-253681.000000,6.100000,
37680.000000,-177961.000000,6.100000,
39370.000000,80521.000000,6.100000,
54780.000000,-222361.000000,6.100000,
74150.000000,-250681.000000,6.100000,
82380.000000,216421.000000,6.100000,
3350.000000,-100021.000000,6.100000,
5800.000000,-209821.000000,6.100000,
9030.000000,-81181.000000,6.100000,
10620.000000,16201.000000,6.100000,
74660.000000,203461.000000,6.100000,
6250.000000,207181.000000,6.110000,
16010.000000,-86761.000000,6.110000,
77720.000000,88081.000000,6.110000,
84040.000000,158881.000000,6.110000,
24070.000000,-145321.000000,6.110000,
11120.000000,90961.000000,6.110000,
23060.000000,-46741.000000,6.110000,
27930.000000,-204301.000000,6.110000,
3820.000000,4981.000000,6.110000,
38330.000000,-153961.000000,6.110000,
49920.000000,-113881.000000,6.110000,
62180.000000,-128761.000000,6.110000,
30020.000000,-82621.000000,6.110000,
48760.000000,87721.000000,6.110000,
52390.000000,-110641.000000,6.110000,
72820.000000,156181.000000,6.110000,
21980.000000,106321.000000,6.110000,
36200.000000,-167941.000000,6.110000,
60560.000000,-56461.000000,6.110000,
55200.000000,-56041.000000,6.110000,
83300.000000,-286201.000000,6.110000,
41060.000000,-153661.000000,6.110000,
26010.000000,-98521.000000,6.110000,
35830.000000,-189601.000000,6.110000,
66910.000000,124081.000000,6.110000,
86110.000000,-115021.000000,6.110000,
1880.000000,239521.000000,6.110000,
30580.000000,-166861.000000,6.110000,
48480.000000,189961.000000,6.110000,
51780.000000,91321.000000,6.110000,
21540.000000,-33781.000000,6.110000,
15620.000000,67501.000000,6.110000,
72320.000000,202861.000000,6.110000,
17690.000000,-210781.000000,6.110000,
57810.000000,-115261.000000,6.110000,
79110.000000,-212461.000000,6.110000,
12610.000000,-148981.000000,6.110000,
2720.000000,-46441.000000,6.110000,
13190.000000,-4141.000000,6.110000,
83640.000000,-225781.000000,6.110000,
31520.000000,110581.000000,6.110000,
54530.000000,47701.000000,6.110000,
990.000000,29701.000000,6.110000,
31180.000000,265141.000000,6.110000,
390.000000,104521.000000,6.110000,
7820.000000,-183061.000000,6.110000,
9400.000000,113821.000000,6.110000,
11420.000000,-175501.000000,6.110000,
16780.000000,-3841.000000,6.110000,
23860.000000,-46801.000000,6.110000,
24190.000000,133801.000000,6.110000,
30060.000000,-230821.000000,6.110000,
30760.000000,-264181.000000,6.110000,
36220.000000,-34501.000000,6.110000,
53090.000000,-210601.000000,6.110000,
73540.000000,-146941.000000,6.110000,
76830.000000,218821.000000,6.110000,
54380.000000,-79381.000000,6.110000,
75980.000000,97021.000000,6.110000,
19610.000000,127741.000000,6.110000,
69540.000000,-56041.000000,6.110000,
51070.000000,116281.000000,6.110000,
52470.000000,131941.000000,6.110000,
53230.000000,-76801.000000,6.110000,
22330.000000,82561.000000,6.110000,
10850.000000,-10441.000000,6.110000,
3590.000000,23341.000000,6.110000,
7350.000000,48601.000000,6.110000,
29130.000000,99181.000000,6.120000,
58830.000000,-142021.000000,6.120000,
50180.000000,-194881.000000,6.120000,
48860.000000,139681.000000,6.120000,
73700.000000,-12121.000000,6.120000,
24160.000000,-80881.000000,6.120000,
25530.000000,-125221.000000,6.120000,
31160.000000,-131821.000000,6.120000,
34360.000000,6721.000000,6.120000,
72750.000000,185341.000000,6.120000,
62750.000000,60961.000000,6.120000,
28820.000000,-176041.000000,6.120000,
73740.000000,301141.000000,6.120000,
24080.000000,59101.000000,6.120000,
37330.000000,-71581.000000,6.120000,
39900.000000,-177841.000000,6.120000,
60500.000000,-53761.000000,6.120000,
76620.000000,194401.000000,6.120000,
78580.000000,-45841.000000,6.120000,
57390.000000,-53461.000000,6.120000,
5020.000000,283441.000000,6.120000,
55590.000000,194521.000000,6.120000,
54640.000000,244081.000000,6.120000,
31500.000000,20521.000000,6.120000,
50470.000000,98641.000000,6.120000,
2000.000000,-256621.000000,6.120000,
57660.000000,-196501.000000,6.120000,
29080.000000,-71041.000000,6.120000,
19160.000000,209281.000000,6.120000,
60710.000000,-235381.000000,6.120000,
71070.000000,47941.000000,6.120000,
26720.000000,292561.000000,6.120000,
28160.000000,-48121.000000,6.120000,
82500.000000,3901.000000,6.120000,
77170.000000,-196861.000000,6.120000,
35070.000000,234001.000000,6.120000,
63800.000000,51481.000000,6.120000,
80630.000000,138961.000000,6.120000,
73150.000000,-171361.000000,6.120000,
31830.000000,119941.000000,6.120000,
290.000000,124861.000000,6.120000,
82710.000000,-127921.000000,6.120000,
5690.000000,-114841.000000,6.120000,
67490.000000,197641.000000,6.120000,
67410.000000,131701.000000,6.120000,
21250.000000,38161.000000,6.120000,
69160.000000,-181801.000000,6.120000,
14680.000000,-73441.000000,6.120000,
21580.000000,196501.000000,6.120000,
23290.000000,37201.000000,6.120000,
28140.000000,48241.000000,6.120000,
28200.000000,-70381.000000,6.120000,
34310.000000,-37321.000000,6.120000,
34380.000000,-30721.000000,6.120000,
42950.000000,-142921.000000,6.120000,
44080.000000,192421.000000,6.120000,
65820.000000,147421.000000,6.120000,
69750.000000,120661.000000,6.120000,
72660.000000,76201.000000,6.120000,
76540.000000,-130441.000000,6.120000,
83900.000000,-242941.000000,6.120000,
9010.000000,121861.000000,6.120000,
37570.000000,-153961.000000,6.120000,
64360.000000,-122941.000000,6.120000,
72980.000000,77761.000000,6.120000,
30010.000000,-19261.000000,6.120000,
39430.000000,-270421.000000,6.120000,
16500.000000,-71761.000000,6.120000,
51260.000000,149521.000000,6.120000,
67600.000000,67381.000000,6.120000,
84600.000000,176941.000000,6.120000,
72300.000000,186661.000000,6.120000,
53310.000000,-131941.000000,6.120000,
22010.000000,-78601.000000,6.120000,
79120.000000,-76321.000000,6.120000,
79510.000000,168361.000000,6.120000,
15770.000000,214681.000000,6.130000,
24780.000000,139981.000000,6.130000,
23470.000000,40561.000000,6.130000,
13700.000000,182761.000000,6.130000,
36210.000000,-222841.000000,6.130000,
57290.000000,-218761.000000,6.130000,
40610.000000,-25741.000000,6.130000,
32270.000000,108901.000000,6.130000,
36570.000000,-129121.000000,6.130000,
28110.000000,83341.000000,6.130000,
39200.000000,-8161.000000,6.130000,
10190.000000,-88441.000000,6.130000,
43540.000000,226621.000000,6.130000,
41510.000000,292141.000000,6.130000,
18880.000000,191641.000000,6.130000,
33130.000000,13981.000000,6.130000,
46310.000000,-96361.000000,6.130000,
19630.000000,55021.000000,6.130000,
18920.000000,80281.000000,6.130000,
68980.000000,237601.000000,6.130000,
34160.000000,-7981.000000,6.130000,
39790.000000,-2761.000000,6.130000,
34290.000000,-37981.000000,6.130000,
66080.000000,19681.000000,6.130000,
65070.000000,6961.000000,6.130000,
57340.000000,67081.000000,6.130000,
55920.000000,57901.000000,6.130000,
28630.000000,-227941.000000,6.130000,
5740.000000,52861.000000,6.130000,
19090.000000,121561.000000,6.130000,
44410.000000,93721.000000,6.130000,
55420.000000,-3721.000000,6.130000,
1790.000000,-53581.000000,6.130000,
11790.000000,-33001.000000,6.130000,
77180.000000,4021.000000,6.130000,
45000.000000,185581.000000,6.130000,
81070.000000,-23641.000000,6.130000,
2430.000000,-85801.000000,6.130000,
10740.000000,-104101.000000,6.130000,
32190.000000,15301.000000,6.130000,
73220.000000,52501.000000,6.130000,
3990.000000,46681.000000,6.130000,
16160.000000,-167521.000000,6.130000,
68180.000000,9001.000000,6.130000,
78920.000000,221581.000000,6.130000,
42610.000000,-57121.000000,6.130000,
49340.000000,150121.000000,6.130000,
50470.000000,-144841.000000,6.130000,
54490.000000,180301.000000,6.130000,
60640.000000,117301.000000,6.130000,
82550.000000,-113941.000000,6.130000,
22420.000000,184261.000000,6.130000,
33130.000000,-276061.000000,6.130000,
61270.000000,218401.000000,6.130000,
70800.000000,-84361.000000,6.130000,
76960.000000,109201.000000,6.130000,
3460.000000,165061.000000,6.130000,
23900.000000,-9181.000000,6.130000,
28480.000000,-125521.000000,6.130000,
58540.000000,98821.000000,6.130000,
65590.000000,78841.000000,6.130000,
34760.000000,242221.000000,6.130000,
71470.000000,-8941.000000,6.130000,
72020.000000,-155041.000000,6.130000,
44260.000000,-129961.000000,6.140000,
71680.000000,25801.000000,6.140000,
73470.000000,3901.000000,6.140000,
24440.000000,65521.000000,6.140000,
61580.000000,-134041.000000,6.140000,
70810.000000,217861.000000,6.140000,
39600.000000,-186601.000000,6.140000,
59900.000000,-156301.000000,6.140000,
35000.000000,-184501.000000,6.140000,
61020.000000,-70441.000000,6.140000,
65300.000000,-164821.000000,6.140000,
39550.000000,-220801.000000,6.140000,
64400.000000,-125041.000000,6.140000,
3010.000000,162061.000000,6.140000,
22260.000000,-24361.000000,6.140000,
22740.000000,62401.000000,6.140000,
28540.000000,127561.000000,6.140000,
32920.000000,-96421.000000,6.140000,
55170.000000,117121.000000,6.140000,
67310.000000,-85861.000000,6.140000,
30270.000000,296761.000000,6.140000,
30380.000000,-190201.000000,6.140000,
51390.000000,-11581.000000,6.140000,
60920.000000,-227821.000000,6.140000,
63130.000000,43021.000000,6.140000,
6280.000000,205561.000000,6.140000,
9850.000000,-189361.000000,6.140000,
10720.000000,-35281.000000,6.140000,
59120.000000,-227341.000000,6.140000,
12240.000000,-250741.000000,6.140000,
18190.000000,149281.000000,6.140000,
30150.000000,-22321.000000,6.140000,
79640.000000,191941.000000,6.140000,
30080.000000,-142681.000000,6.140000,
80190.000000,-5821.000000,6.140000,
70580.000000,-67981.000000,6.140000,
73850.000000,-104881.000000,6.140000,
13480.000000,166021.000000,6.140000,
66330.000000,-226921.000000,6.140000,
17860.000000,-51361.000000,6.140000,
80840.000000,143401.000000,6.140000,
19540.000000,1861.000000,6.140000,
23190.000000,-16621.000000,6.140000,
23470.000000,-222781.000000,6.140000,
24540.000000,3601.000000,6.140000,
57270.000000,-98521.000000,6.140000,
54870.000000,-64021.000000,6.140000,
17770.000000,88621.000000,6.140000,
78700.000000,-67081.000000,6.140000,
8870.000000,182101.000000,6.140000,
18910.000000,-5101.000000,6.140000,
42540.000000,-1201.000000,6.140000,
5080.000000,-56461.000000,6.140000,
5080.000000,-10321.000000,6.140000,
8910.000000,-112021.000000,6.140000,
11260.000000,-249421.000000,6.140000,
63890.000000,-207241.000000,6.140000,
67350.000000,-25501.000000,6.140000,
47180.000000,223441.000000,6.140000,
58340.000000,241801.000000,6.140000,
74510.000000,63181.000000,6.140000,
16080.000000,6721.000000,6.140000,
79910.000000,-274081.000000,6.140000,
28910.000000,127501.000000,6.140000,
41870.000000,182281.000000,6.140000,
52700.000000,-139741.000000,6.140000,
61690.000000,-63481.000000,6.140000,
68300.000000,-111781.000000,6.140000,
80190.000000,-93301.000000,6.140000,
81320.000000,-283621.000000,6.140000,
83310.000000,-265021.000000,6.140000,
13420.000000,70861.000000,6.140000,
28840.000000,71401.000000,6.140000,
6620.000000,-172201.000000,6.140000,
58520.000000,-154501.000000,6.140000,
58040.000000,78661.000000,6.140000,
18300.000000,-195961.000000,6.140000,
76100.000000,25201.000000,6.140000,
2720.000000,-16741.000000,6.140000,
28080.000000,-146401.000000,6.140000,
82950.000000,-23761.000000,6.140000,
31940.000000,101761.000000,6.140000,
980.000000,157021.000000,6.150000,
5490.000000,-164101.000000,6.150000,
22680.000000,51841.000000,6.150000,
70910.000000,144961.000000,6.150000,
84230.000000,-193801.000000,6.150000,
23430.000000,-47401.000000,6.150000,
47570.000000,-215401.000000,6.150000,
44910.000000,-203161.000000,6.150000,
25310.000000,-4921.000000,6.150000,
62120.000000,-52561.000000,6.150000,
13440.000000,174781.000000,6.150000,
7880.000000,113521.000000,6.150000,
18780.000000,222721.000000,6.150000,
50570.000000,183541.000000,6.150000,
43280.000000,-207061.000000,6.150000,
23870.000000,17941.000000,6.150000,
65450.000000,-121741.000000,6.150000,
38000.000000,-209581.000000,6.150000,
76810.000000,79381.000000,6.150000,
31720.000000,240181.000000,6.150000,
32500.000000,142981.000000,6.150000,
82110.000000,-38041.000000,6.150000,
76170.000000,-74041.000000,6.150000,
6950.000000,-282121.000000,6.150000,
49330.000000,30301.000000,6.150000,
38180.000000,130861.000000,6.150000,
45050.000000,191101.000000,6.150000,
2690.000000,-193441.000000,6.150000,
13660.000000,116041.000000,6.150000,
45900.000000,-247861.000000,6.150000,
3250.000000,-31561.000000,6.150000,
11610.000000,-107401.000000,6.150000,
25920.000000,19801.000000,6.150000,
68810.000000,-136141.000000,6.150000,
82690.000000,-8701.000000,6.150000,
84820.000000,162241.000000,6.150000,
54460.000000,19801.000000,6.150000,
39590.000000,280021.000000,6.150000,
40850.000000,241561.000000,6.150000,
23940.000000,79381.000000,6.150000,
52580.000000,-142621.000000,6.150000,
11470.000000,-57721.000000,6.150000,
60580.000000,156421.000000,6.150000,
81070.000000,-10501.000000,6.150000,
84880.000000,-54961.000000,6.150000,
36740.000000,-187861.000000,6.150000,
48720.000000,-138301.000000,6.150000,
38930.000000,105961.000000,6.150000,
5000.000000,73741.000000,6.150000,
43860.000000,294241.000000,6.150000,
73900.000000,204421.000000,6.150000,
34580.000000,-175561.000000,6.160000,
43800.000000,-124981.000000,6.160000,
14380.000000,139801.000000,6.160000,
77040.000000,91201.000000,6.160000,
48150.000000,-219541.000000,6.160000,
11760.000000,-21361.000000,6.160000,
73240.000000,-53281.000000,6.160000,
66290.000000,-5761.000000,6.160000,
6070.000000,92701.000000,6.160000,
9490.000000,135961.000000,6.160000,
85460.000000,-94561.000000,6.160000,
65980.000000,-230041.000000,6.160000,
57760.000000,-104941.000000,6.160000,
23350.000000,9601.000000,6.160000,
30230.000000,38341.000000,6.160000,
61580.000000,-127681.000000,6.160000,
60170.000000,200521.000000,6.160000,
62170.000000,7921.000000,6.160000,
69540.000000,134881.000000,6.160000,
52040.000000,-22081.000000,6.160000,
28900.000000,90361.000000,6.160000,
24800.000000,-68161.000000,6.160000,
42800.000000,-126301.000000,6.160000,
73490.000000,-300001.000000,6.160000,
79570.000000,162961.000000,6.160000,
79970.000000,-94801.000000,6.160000,
81580.000000,70921.000000,6.160000,
50740.000000,-196861.000000,6.160000,
78450.000000,-21361.000000,6.160000,
36910.000000,-198001.000000,6.160000,
64100.000000,-97141.000000,6.160000,
19560.000000,60181.000000,6.160000,
11280.000000,188041.000000,6.160000,
17140.000000,85141.000000,6.160000,
71010.000000,-135181.000000,6.160000,
80570.000000,206281.000000,6.160000,
13870.000000,47041.000000,6.160000,
27240.000000,38101.000000,6.160000,
31820.000000,-103021.000000,6.160000,
75510.000000,151021.000000,6.160000,
22170.000000,-20581.000000,6.160000,
6080.000000,-137341.000000,6.160000,
14960.000000,197461.000000,6.160000,
18410.000000,155461.000000,6.160000,
23870.000000,265321.000000,6.160000,
31980.000000,212701.000000,6.160000,
29320.000000,49201.000000,6.160000,
80450.000000,29521.000000,6.160000,
5160.000000,124561.000000,6.160000,
21770.000000,117541.000000,6.160000,
54390.000000,131281.000000,6.160000,
15650.000000,49981.000000,6.160000,
60050.000000,-217681.000000,6.160000,
18450.000000,34141.000000,6.160000,
84040.000000,-21301.000000,6.160000,
1060.000000,6121.000000,6.160000,
28580.000000,16141.000000,6.160000,
42420.000000,-129301.000000,6.160000,
61040.000000,-39601.000000,6.160000,
55250.000000,-65461.000000,6.160000,
18910.000000,213901.000000,6.160000,
21080.000000,-82621.000000,6.160000,
83230.000000,190201.000000,6.160000,
83500.000000,96661.000000,6.160000,
41880.000000,32041.000000,6.160000,
54470.000000,-235021.000000,6.160000,
67510.000000,-220021.000000,6.160000,
60630.000000,150901.000000,6.160000,
710.000000,173401.000000,6.160000,
47630.000000,-155401.000000,6.160000,
48600.000000,25921.000000,6.160000,
73230.000000,-198241.000000,6.160000,
76730.000000,40381.000000,6.160000,
41540.000000,-96361.000000,6.160000,
73770.000000,-80641.000000,6.160000,
38530.000000,114181.000000,6.160000,
25540.000000,189961.000000,6.170000,
18610.000000,134401.000000,6.170000,
16280.000000,144121.000000,6.170000,
60230.000000,-148021.000000,6.170000,
49910.000000,-118861.000000,6.170000,
22300.000000,-16801.000000,6.170000,
50930.000000,-156601.000000,6.170000,
50580.000000,-114121.000000,6.170000,
23880.000000,-221581.000000,6.170000,
72310.000000,138601.000000,6.170000,
28240.000000,11881.000000,6.170000,
20660.000000,-80761.000000,6.170000,
71650.000000,-86221.000000,6.170000,
22000.000000,-152341.000000,6.170000,
27850.000000,-251461.000000,6.170000,
72510.000000,-36301.000000,6.170000,
80770.000000,-85321.000000,6.170000,
430.000000,-62701.000000,6.170000,
58610.000000,-14281.000000,6.170000,
410.000000,-83281.000000,6.170000,
60990.000000,-147061.000000,6.170000,
82660.000000,141541.000000,6.170000,
61480.000000,-73801.000000,6.170000,
78660.000000,142381.000000,6.170000,
13780.000000,85441.000000,6.170000,
18320.000000,4261.000000,6.170000,
61300.000000,271141.000000,6.170000,
19780.000000,105121.000000,6.170000,
48520.000000,182641.000000,6.170000,
77930.000000,-286021.000000,6.170000,
69350.000000,100621.000000,6.170000,
8670.000000,-147121.000000,6.170000,
30010.000000,-3361.000000,6.170000,
65730.000000,162781.000000,6.170000,
12840.000000,64261.000000,6.170000,
890.000000,-125761.000000,6.170000,
19610.000000,119821.000000,6.170000,
37620.000000,69721.000000,6.170000,
39550.000000,186901.000000,6.170000,
47700.000000,-130981.000000,6.170000,
84540.000000,-33421.000000,6.170000,
23860.000000,9781.000000,6.170000,
32220.000000,61801.000000,6.170000,
27360.000000,-279541.000000,6.170000,
53460.000000,-1021.000000,6.170000,
33680.000000,118501.000000,6.170000,
51850.000000,29221.000000,6.170000,
20830.000000,-195781.000000,6.170000,
32820.000000,5341.000000,6.170000,
43210.000000,291181.000000,6.170000,
48230.000000,133381.000000,6.170000,
81740.000000,-105781.000000,6.170000,
63880.000000,-153901.000000,6.180000,
66290.000000,98641.000000,6.180000,
30780.000000,-88621.000000,6.180000,
19810.000000,-230221.000000,6.180000,
85200.000000,135601.000000,6.180000,
48030.000000,-215281.000000,6.180000,
50090.000000,-29101.000000,6.180000,
27780.000000,781.000000,6.180000,
28090.000000,-203341.000000,6.180000,
71190.000000,118441.000000,6.180000,
66220.000000,191941.000000,6.180000,
20530.000000,-109981.000000,6.180000,
47910.000000,-184741.000000,6.180000,
64100.000000,13741.000000,6.180000,
69460.000000,7441.000000,6.180000,
76630.000000,-47881.000000,6.180000,
39550.000000,-304561.000000,6.180000,
37480.000000,-266341.000000,6.180000,
17180.000000,-101161.000000,6.180000,
51580.000000,1441.000000,6.180000,
61540.000000,-158821.000000,6.180000,
71280.000000,-49381.000000,6.180000,
11270.000000,-100261.000000,6.180000,
36180.000000,-216721.000000,6.180000,
60970.000000,263341.000000,6.180000,
74130.000000,-59521.000000,6.180000,
34150.000000,-138241.000000,6.180000,
75370.000000,204841.000000,6.180000,
37800.000000,-241201.000000,6.180000,
82390.000000,144661.000000,6.180000,
16230.000000,116881.000000,6.180000,
26920.000000,54481.000000,6.180000,
53830.000000,-105001.000000,6.180000,
57350.000000,212161.000000,6.180000,
73190.000000,168661.000000,6.180000,
14190.000000,-35221.000000,6.180000,
43190.000000,122581.000000,6.180000,
52300.000000,216901.000000,6.180000,
1820.000000,-147481.000000,6.180000,
16580.000000,84061.000000,6.180000,
50170.000000,115381.000000,6.180000,
51470.000000,172861.000000,6.180000,
85240.000000,132241.000000,6.180000,
10920.000000,-23461.000000,6.180000,
32380.000000,-69241.000000,6.180000,
73370.000000,52381.000000,6.180000,
76450.000000,107701.000000,6.180000,
1590.000000,-241.000000,6.180000,
2630.000000,-43261.000000,6.180000,
23600.000000,-188461.000000,6.180000,
71960.000000,4981.000000,6.180000,
9300.000000,26941.000000,6.180000,
32260.000000,33841.000000,6.180000,
84240.000000,-67321.000000,6.180000,
45090.000000,-18241.000000,6.180000,
70190.000000,-199621.000000,6.180000,
70700.000000,-208801.000000,6.180000,
18380.000000,220261.000000,6.180000,
19120.000000,145681.000000,6.180000,
24180.000000,10981.000000,6.180000,
31040.000000,-17821.000000,6.180000,
36920.000000,-131521.000000,6.180000,
37510.000000,-153001.000000,6.180000,
77960.000000,-38161.000000,6.180000,
83270.000000,231241.000000,6.180000,
4570.000000,119281.000000,6.180000,
50030.000000,-127201.000000,6.180000,
61490.000000,175801.000000,6.180000,
51920.000000,138301.000000,6.180000,
56360.000000,-280561.000000,6.180000,
82470.000000,-25981.000000,6.180000,
23010.000000,-35581.000000,6.180000,
8820.000000,97261.000000,6.180000,
20380.000000,270241.000000,6.180000,
54950.000000,-173101.000000,6.190000,
77850.000000,-1441.000000,6.190000,
77860.000000,23881.000000,6.190000,
76730.000000,147781.000000,6.190000,
970.000000,277081.000000,6.190000,
6130.000000,211081.000000,6.190000,
80330.000000,136021.000000,6.190000,
12830.000000,-111961.000000,6.190000,
78870.000000,-11941.000000,6.190000,
12190.000000,-28141.000000,6.190000,
13160.000000,59641.000000,6.190000,
73860.000000,-54241.000000,6.190000,
50310.000000,-236941.000000,6.190000,
75790.000000,-99841.000000,6.190000,
43140.000000,1981.000000,6.190000,
30870.000000,-135481.000000,6.190000,
37850.000000,-27541.000000,6.190000,
84880.000000,136921.000000,6.190000,
33320.000000,-54121.000000,6.190000,
44530.000000,89221.000000,6.190000,
67980.000000,-174181.000000,6.190000,
69570.000000,195781.000000,6.190000,
86100.000000,25501.000000,6.190000,
49530.000000,-56821.000000,6.190000,
19810.000000,-305281.000000,6.190000,
5450.000000,238021.000000,6.190000,
29450.000000,52741.000000,6.190000,
77880.000000,-233401.000000,6.190000,
33980.000000,-145861.000000,6.190000,
20270.000000,-17341.000000,6.190000,
35820.000000,-248821.000000,6.190000,
29120.000000,-169141.000000,6.190000,
48520.000000,-250681.000000,6.190000,
56240.000000,-94681.000000,6.190000,
12430.000000,45901.000000,6.190000,
38930.000000,234541.000000,6.190000,
53990.000000,-270181.000000,6.190000,
80030.000000,227461.000000,6.190000,
84420.000000,-180601.000000,6.190000,
84160.000000,75061.000000,6.190000,
45350.000000,-73921.000000,6.190000,
79020.000000,-135961.000000,6.190000,
71470.000000,170701.000000,6.190000,
5220.000000,123841.000000,6.190000,
69920.000000,89761.000000,6.190000,
64370.000000,-151261.000000,6.190000,
50550.000000,34981.000000,6.190000,
78830.000000,24721.000000,6.190000,
21750.000000,-52261.000000,6.190000,
27510.000000,-139681.000000,6.190000,
64300.000000,-164221.000000,6.190000,
77920.000000,91921.000000,6.190000,
55170.000000,-133621.000000,6.190000,
80.000000,179941.000000,6.190000,
60480.000000,48961.000000,6.190000,
76280.000000,-261241.000000,6.190000,
30.000000,214441.000000,6.190000,
9220.000000,-72061.000000,6.190000,
22040.000000,150721.000000,6.190000,
22180.000000,-96181.000000,6.190000,
25480.000000,-79381.000000,6.190000,
53790.000000,-117541.000000,6.190000,
57200.000000,-225421.000000,6.190000,
74240.000000,138001.000000,6.190000,
25710.000000,134881.000000,6.190000,
34600.000000,-190681.000000,6.190000,
62700.000000,-87361.000000,6.190000,
23450.000000,-147361.000000,6.190000,
26000.000000,-81661.000000,6.190000,
68850.000000,-103141.000000,6.190000,
81740.000000,194101.000000,6.190000,
4210.000000,56521.000000,6.190000,
4950.000000,6241.000000,6.190000,
3310.000000,88501.000000,6.190000,
3220.000000,189782.000000,6.200000,
31000.000000,269102.000000,6.200000,
73910.000000,92942.000000,6.200000,
84050.000000,-181142.000000,6.200000,
41990.000000,-52142.000000,6.200000,
57650.000000,-145622.000000,6.200000,
16280.000000,-49202.000000,6.200000,
83240.000000,118202.000000,6.200000,
15460.000000,-227762.000000,6.200000,
75780.000000,5582.000000,6.200000,
73850.000000,133022.000000,6.200000,
71360.000000,139382.000000,6.200000,
70160.000000,-25442.000000,6.200000,
47540.000000,289742.000000,6.200000,
70910.000000,181922.000000,6.200000,
56410.000000,43502.000000,6.200000,
9510.000000,12482.000000,6.200000,
73370.000000,154802.000000,6.200000,
23470.000000,61082.000000,6.200000,
3090.000000,185762.000000,6.200000,
31580.000000,-148082.000000,6.200000,
43020.000000,-120002.000000,6.200000,
61610.000000,-95462.000000,6.200000,
63940.000000,113522.000000,6.200000,
73970.000000,-89882.000000,6.200000,
80160.000000,30842.000000,6.200000,
29230.000000,155822.000000,6.200000,
24830.000000,-88442.000000,6.200000,
26780.000000,38282.000000,6.200000,
55290.000000,-146822.000000,6.200000,
20230.000000,240182.000000,6.200000,
5040.000000,-28922.000000,6.200000,
24880.000000,-6422.000000,6.200000,
20500.000000,-60242.000000,6.200000,
35940.000000,-86282.000000,6.200000,
36100.000000,-192182.000000,6.200000,
13670.000000,-130082.000000,6.200000,
22410.000000,67322.000000,6.200000,
26650.000000,-82562.000000,6.200000,
74250.000000,113702.000000,6.200000,
44420.000000,-237062.000000,6.200000,
65080.000000,86222.000000,6.200000,
81150.000000,72902.000000,6.200000,
18840.000000,-52622.000000,6.200000,
59860.000000,49382.000000,6.200000,
41180.000000,120482.000000,6.200000,
64450.000000,40142.000000,6.200000,
68300.000000,22562.000000,6.200000,
52620.000000,-44402.000000,6.200000,
44360.000000,101402.000000,6.200000,
46460.000000,-210422.000000,6.200000,
75630.000000,-17102.000000,6.200000,
82830.000000,722.000000,6.200000,
29350.000000,-127682.000000,6.200000,
36400.000000,20282.000000,6.200000,
43010.000000,221642.000000,6.200000,
73690.000000,10622.000000,6.200000,
24800.000000,39602.000000,6.200000,
4460.000000,-28562.000000,6.200000,
6230.000000,-17222.000000,6.200000,
27770.000000,-209642.000000,6.200000,
32470.000000,-96062.000000,6.200000,
36110.000000,-206522.000000,6.200000,
44900.000000,-222482.000000,6.200000,
47570.000000,-153782.000000,6.200000,
50770.000000,-155222.000000,6.200000,
65210.000000,183002.000000,6.200000,
70770.000000,165482.000000,6.200000,
73880.000000,188342.000000,6.200000,
74990.000000,19982.000000,6.200000,
76510.000000,-145862.000000,6.200000,
25610.000000,-89882.000000,6.200000,
29750.000000,-129242.000000,6.200000,
72740.000000,-154022.000000,6.200000,
82890.000000,205622.000000,6.200000,
15610.000000,115082.000000,6.200000,
67680.000000,15362.000000,6.200000,
82880.000000,-25502.000000,6.200000,
54850.000000,151922.000000,6.200000,
75740.000000,161342.000000,6.200000,
71970.000000,275402.000000,6.200000,
45510.000000,25202.000000,6.200000,
64490.000000,-89642.000000,6.200000,
63850.000000,51902.000000,6.210000,
16020.000000,207362.000000,6.210000,
64980.000000,174542.000000,6.210000,
7390.000000,265862.000000,6.210000,
36960.000000,-215702.000000,6.210000,
55900.000000,-72662.000000,6.210000,
28640.000000,-172442.000000,6.210000,
31500.000000,-211502.000000,6.210000,
25030.000000,-127862.000000,6.210000,
3140.000000,-250322.000000,6.210000,
41900.000000,-8822.000000,6.210000,
59320.000000,185162.000000,6.210000,
45860.000000,290282.000000,6.210000,
9500.000000,137222.000000,6.210000,
25120.000000,-164822.000000,6.210000,
44180.000000,-261422.000000,6.210000,
56360.000000,-83402.000000,6.210000,
62150.000000,-108842.000000,6.210000,
68180.000000,-6542.000000,6.210000,
9860.000000,-117182.000000,6.210000,
68520.000000,-150962.000000,6.210000,
34070.000000,270422.000000,6.210000,
54810.000000,82802.000000,6.210000,
16760.000000,90902.000000,6.210000,
20430.000000,-10262.000000,6.210000,
27200.000000,-51662.000000,6.210000,
24370.000000,-136022.000000,6.210000,
68770.000000,149162.000000,6.210000,
74230.000000,422.000000,6.210000,
22740.000000,-30902.000000,6.210000,
25640.000000,101522.000000,6.210000,
26280.000000,111542.000000,6.210000,
67920.000000,149042.000000,6.210000,
74350.000000,-8762.000000,6.210000,
21610.000000,-46502.000000,6.210000,
44870.000000,-16682.000000,6.210000,
74090.000000,186782.000000,6.210000,
81000.000000,-46562.000000,6.210000,
13990.000000,-66362.000000,6.210000,
24090.000000,129422.000000,6.210000,
28910.000000,32102.000000,6.210000,
35150.000000,-211742.000000,6.210000,
52910.000000,-211082.000000,6.210000,
55550.000000,70202.000000,6.210000,
82210.000000,182522.000000,6.210000,
16210.000000,-49022.000000,6.210000,
68330.000000,183002.000000,6.210000,
51800.000000,-42182.000000,6.210000,
7370.000000,280562.000000,6.210000,
14240.000000,88082.000000,6.210000,
18260.000000,76682.000000,6.210000,
21490.000000,-3662.000000,6.210000,
27800.000000,80762.000000,6.210000,
61930.000000,-254642.000000,6.210000,
5300.000000,28742.000000,6.210000,
64240.000000,43082.000000,6.210000,
20480.000000,192542.000000,6.210000,
21470.000000,4502.000000,6.210000,
43700.000000,-219062.000000,6.210000,
79130.000000,-15842.000000,6.210000,
19820.000000,15182.000000,6.210000,
47270.000000,99242.000000,6.210000,
40490.000000,-157502.000000,6.210000,
43370.000000,-27662.000000,6.210000,
75780.000000,53102.000000,6.210000,
68690.000000,110702.000000,6.210000,
3760.000000,-235742.000000,6.210000,
25760.000000,-37322.000000,6.210000,
23910.000000,5882.000000,6.210000,
60660.000000,-135062.000000,6.220000,
73210.000000,141902.000000,6.220000,
16410.000000,64922.000000,6.220000,
74920.000000,186902.000000,6.220000,
39740.000000,-96602.000000,6.220000,
52450.000000,117242.000000,6.220000,
46830.000000,66242.000000,6.220000,
81500.000000,-28502.000000,6.220000,
29750.000000,-111362.000000,6.220000,
4380.000000,108302.000000,6.220000,
1340.000000,48602.000000,6.220000,
78190.000000,-70742.000000,6.220000,
71800.000000,183302.000000,6.220000,
73720.000000,-128222.000000,6.220000,
29840.000000,-58742.000000,6.220000,
59400.000000,176342.000000,6.220000,
53820.000000,77642.000000,6.220000,
63670.000000,54662.000000,6.220000,
3500.000000,-218582.000000,6.220000,
13920.000000,112262.000000,6.220000,
61860.000000,87362.000000,6.220000,
74160.000000,93242.000000,6.220000,
30960.000000,55142.000000,6.220000,
67000.000000,155642.000000,6.220000,
61660.000000,145922.000000,6.220000,
19880.000000,-24182.000000,6.220000,
68350.000000,141242.000000,6.220000,
15210.000000,36842.000000,6.220000,
43550.000000,-128522.000000,6.220000,
27490.000000,87782.000000,6.220000,
81350.000000,-208442.000000,6.220000,
17830.000000,-3962.000000,6.220000,
33320.000000,303122.000000,6.220000,
78420.000000,61982.000000,6.220000,
41910.000000,168662.000000,6.220000,
26530.000000,-10802.000000,6.220000,
45860.000000,158822.000000,6.220000,
63530.000000,48062.000000,6.220000,
18170.000000,240602.000000,6.220000,
69330.000000,-87122.000000,6.220000,
45320.000000,-222662.000000,6.220000,
4830.000000,-11702.000000,6.220000,
8570.000000,-66122.000000,6.220000,
13170.000000,-12302.000000,6.220000,
23300.000000,58502.000000,6.220000,
85310.000000,206162.000000,6.220000,
1850.000000,277322.000000,6.220000,
27050.000000,-18902.000000,6.220000,
42120.000000,-73082.000000,6.220000,
43580.000000,-247202.000000,6.220000,
55260.000000,89942.000000,6.220000,
39390.000000,91862.000000,6.220000,
19470.000000,112502.000000,6.220000,
4570.000000,313802.000000,6.220000,
49230.000000,101162.000000,6.220000,
53340.000000,-204062.000000,6.220000,
21680.000000,306722.000000,6.220000,
22980.000000,-229322.000000,6.220000,
78550.000000,220622.000000,6.220000,
70840.000000,155162.000000,6.220000,
64600.000000,163322.000000,6.220000,
71540.000000,67262.000000,6.220000,
18120.000000,5882.000000,6.230000,
26210.000000,-111302.000000,6.230000,
26530.000000,215702.000000,6.230000,
4620.000000,-239102.000000,6.230000,
58310.000000,-70082.000000,6.230000,
66460.000000,-95942.000000,6.230000,
20040.000000,-3782.000000,6.230000,
68500.000000,121142.000000,6.230000,
29180.000000,-33302.000000,6.230000,
62670.000000,56342.000000,6.230000,
25800.000000,-67322.000000,6.230000,
5850.000000,-33902.000000,6.230000,
62660.000000,133082.000000,6.230000,
31560.000000,-39722.000000,6.230000,
73230.000000,192962.000000,6.230000,
46430.000000,44762.000000,6.230000,
46220.000000,-174542.000000,6.230000,
57770.000000,-225182.000000,6.230000,
83650.000000,182282.000000,6.230000,
75570.000000,-68582.000000,6.230000,
30750.000000,36302.000000,6.230000,
35670.000000,-81002.000000,6.230000,
36590.000000,-43622.000000,6.230000,
55730.000000,198722.000000,6.230000,
19710.000000,49322.000000,6.230000,
60070.000000,-3662.000000,6.230000,
72510.000000,38642.000000,6.230000,
21700.000000,80702.000000,6.230000,
27560.000000,-96782.000000,6.230000,
19560.000000,-19982.000000,6.230000,
45770.000000,-201482.000000,6.230000,
58950.000000,-7562.000000,6.230000,
35420.000000,236222.000000,6.230000,
36340.000000,56822.000000,6.230000,
50630.000000,17702.000000,6.230000,
55880.000000,131882.000000,6.230000,
60180.000000,-165962.000000,6.230000,
66780.000000,-143702.000000,6.230000,
9420.000000,118442.000000,6.230000,
35430.000000,15722.000000,6.230000,
41500.000000,-74822.000000,6.230000,
80070.000000,-149042.000000,6.230000,
18370.000000,212522.000000,6.230000,
21170.000000,246542.000000,6.230000,
18250.000000,109862.000000,6.230000,
24250.000000,191942.000000,6.230000,
24320.000000,-84542.000000,6.230000,
24690.000000,-173882.000000,6.230000,
43890.000000,-184982.000000,6.230000,
53120.000000,68042.000000,6.230000,
56800.000000,-22142.000000,6.230000,
61060.000000,87842.000000,6.230000,
9050.000000,63842.000000,6.230000,
16020.000000,7562.000000,6.230000,
22260.000000,65342.000000,6.230000,
38050.000000,-219602.000000,6.230000,
75180.000000,106802.000000,6.230000,
10580.000000,231602.000000,6.230000,
18040.000000,-20762.000000,6.230000,
64210.000000,282002.000000,6.230000,
71340.000000,-39182.000000,6.230000,
63720.000000,-181862.000000,6.230000,
11760.000000,124922.000000,6.240000,
33310.000000,-164042.000000,6.240000,
70780.000000,-84362.000000,6.240000,
910.000000,98282.000000,6.240000,
24580.000000,-86762.000000,6.240000,
67850.000000,-79862.000000,6.240000,
45530.000000,-241982.000000,6.240000,
12560.000000,169082.000000,6.240000,
61690.000000,183062.000000,6.240000,
60850.000000,-5882.000000,6.240000,
36490.000000,113882.000000,6.240000,
44680.000000,-149042.000000,6.240000,
41270.000000,-6182.000000,6.240000,
73610.000000,-134762.000000,6.240000,
77240.000000,215162.000000,6.240000,
22300.000000,189602.000000,6.240000,
36670.000000,-26402.000000,6.240000,
58370.000000,-15242.000000,6.240000,
62190.000000,-268382.000000,6.240000,
62670.000000,-66542.000000,6.240000,
67770.000000,3122.000000,6.240000,
12870.000000,-35582.000000,6.240000,
81350.000000,201902.000000,6.240000,
86000.000000,-87302.000000,6.240000,
10170.000000,205562.000000,6.240000,
24780.000000,161522.000000,6.240000,
70780.000000,-163022.000000,6.240000,
55920.000000,-139142.000000,6.240000,
84700.000000,-76982.000000,6.240000,
44310.000000,108962.000000,6.240000,
44050.000000,-231902.000000,6.240000,
79030.000000,238262.000000,6.240000,
200.000000,229142.000000,6.240000,
24630.000000,-92882.000000,6.240000,
74050.000000,75602.000000,6.240000,
65880.000000,49622.000000,6.240000,
68320.000000,71282.000000,6.240000,
59930.000000,-219602.000000,6.240000,
69060.000000,-140462.000000,6.240000,
70930.000000,43982.000000,6.240000,
68890.000000,-88862.000000,6.240000,
55340.000000,45362.000000,6.240000,
24830.000000,138722.000000,6.240000,
11700.000000,-94022.000000,6.240000,
36790.000000,-97382.000000,6.240000,
9610.000000,22082.000000,6.240000,
51380.000000,143162.000000,6.240000,
6460.000000,166502.000000,6.240000,
84990.000000,118502.000000,6.240000,
4080.000000,115322.000000,6.240000,
170.000000,-72182.000000,6.240000,
70990.000000,208862.000000,6.240000,
74050.000000,-49442.000000,6.240000,
18650.000000,-8162.000000,6.240000,
32350.000000,-103742.000000,6.240000,
84430.000000,4082.000000,6.240000,
23090.000000,57902.000000,6.240000,
73680.000000,30422.000000,6.240000,
530.000000,91682.000000,6.240000,
16400.000000,-38882.000000,6.240000,
22510.000000,-66602.000000,6.240000,
22720.000000,32702.000000,6.240000,
23130.000000,-126302.000000,6.240000,
30750.000000,191282.000000,6.240000,
34400.000000,-25982.000000,6.240000,
44130.000000,-150962.000000,6.240000,
63540.000000,7382.000000,6.240000,
64060.000000,-81002.000000,6.240000,
45220.000000,120242.000000,6.240000,
30810.000000,-169202.000000,6.240000,
38550.000000,-50342.000000,6.240000,
17020.000000,-147902.000000,6.240000,
29890.000000,194942.000000,6.240000,
42100.000000,198662.000000,6.240000,
11760.000000,163262.000000,6.240000,
68390.000000,82142.000000,6.240000,
48040.000000,10622.000000,6.250000,
63870.000000,9302.000000,6.250000,
38770.000000,-218282.000000,6.250000,
38660.000000,-255182.000000,6.250000,
20120.000000,-15962.000000,6.250000,
32120.000000,-162242.000000,6.250000,
69350.000000,98942.000000,6.250000,
22110.000000,-159722.000000,6.250000,
27350.000000,154982.000000,6.250000,
43080.000000,116222.000000,6.250000,
46050.000000,-22742.000000,6.250000,
9800.000000,-240242.000000,6.250000,
73050.000000,105002.000000,6.250000,
5260.000000,-39302.000000,6.250000,
31950.000000,-47702.000000,6.250000,
20760.000000,-15422.000000,6.250000,
290.000000,96002.000000,6.250000,
61430.000000,70982.000000,6.250000,
21080.000000,115742.000000,6.250000,
69860.000000,61082.000000,6.250000,
46120.000000,174542.000000,6.250000,
23040.000000,32042.000000,6.250000,
71470.000000,34742.000000,6.250000,
49220.000000,206042.000000,6.250000,
40630.000000,-136922.000000,6.250000,
45200.000000,-71282.000000,6.250000,
23090.000000,-229862.000000,6.250000,
25170.000000,-77822.000000,6.250000,
13100.000000,205022.000000,6.250000,
27190.000000,-144242.000000,6.250000,
45590.000000,-239522.000000,6.250000,
69070.000000,-106262.000000,6.250000,
17280.000000,200282.000000,6.250000,
62430.000000,173522.000000,6.250000,
20190.000000,93482.000000,6.250000,
69090.000000,96302.000000,6.250000,
24790.000000,138482.000000,6.250000,
72450.000000,-198122.000000,6.250000,
42500.000000,-37202.000000,6.250000,
15630.000000,-22562.000000,6.250000,
34170.000000,-15302.000000,6.250000,
44800.000000,-176102.000000,6.250000,
57090.000000,-50942.000000,6.250000,
64850.000000,54482.000000,6.250000,
10010.000000,129662.000000,6.250000,
21420.000000,176582.000000,6.250000,
70810.000000,-195962.000000,6.250000,
24840.000000,-182222.000000,6.250000,
50610.000000,27182.000000,6.250000,
5080.000000,-160382.000000,6.250000,
10910.000000,19322.000000,6.250000,
15230.000000,45962.000000,6.250000,
29000.000000,-154682.000000,6.250000,
34190.000000,-84062.000000,6.250000,
42310.000000,-176702.000000,6.250000,
49480.000000,-91862.000000,6.250000,
66180.000000,60122.000000,6.250000,
66320.000000,-129662.000000,6.250000,
72020.000000,-177722.000000,6.250000,
80900.000000,230762.000000,6.250000,
86300.000000,-57122.000000,6.250000,
66060.000000,179042.000000,6.250000,
77590.000000,165182.000000,6.250000,
38480.000000,-6362.000000,6.250000,
70150.000000,902.000000,6.250000,
28460.000000,170642.000000,6.250000,
84570.000000,-16382.000000,6.250000,
28610.000000,-212882.000000,6.250000,
36900.000000,216002.000000,6.250000,
79650.000000,64862.000000,6.250000,
36690.000000,-211862.000000,6.250000,
47080.000000,-148322.000000,6.250000,
66090.000000,-89762.000000,6.250000,
72750.000000,3182.000000,6.260000,
23200.000000,-27122.000000,6.260000,
53230.000000,-187982.000000,6.260000,
72280.000000,230042.000000,6.260000,
34140.000000,-4562.000000,6.260000,
47080.000000,262982.000000,6.260000,
26020.000000,-82502.000000,6.260000,
83260.000000,229142.000000,6.260000,
9320.000000,142862.000000,6.260000,
62490.000000,103562.000000,6.260000,
49220.000000,181922.000000,6.260000,
79470.000000,118622.000000,6.260000,
35700.000000,220142.000000,6.260000,
56450.000000,-171962.000000,6.260000,
65310.000000,51482.000000,6.260000,
44350.000000,82982.000000,6.260000,
69380.000000,-249182.000000,6.260000,
18370.000000,-262982.000000,6.260000,
26140.000000,-85562.000000,6.260000,
36510.000000,-56222.000000,6.260000,
40770.000000,-270602.000000,6.260000,
63330.000000,-215522.000000,6.260000,
79820.000000,-14102.000000,6.260000,
27900.000000,73202.000000,6.260000,
22870.000000,106382.000000,6.260000,
20170.000000,-103382.000000,6.260000,
24250.000000,130022.000000,6.260000,
25110.000000,27482.000000,6.260000,
14750.000000,-31982.000000,6.260000,
81380.000000,-146162.000000,6.260000,
46450.000000,120782.000000,6.260000,
83230.000000,215042.000000,6.260000,
8710.000000,203822.000000,6.260000,
19260.000000,100682.000000,6.260000,
67330.000000,-294542.000000,6.260000,
11580.000000,-129482.000000,6.260000,
37390.000000,-108602.000000,6.260000,
17380.000000,-49622.000000,6.260000,
38660.000000,-260822.000000,6.260000,
73300.000000,-180002.000000,6.260000,
6290.000000,72362.000000,6.260000,
13160.000000,272702.000000,6.260000,
44700.000000,229802.000000,6.260000,
7800.000000,193862.000000,6.260000,
59870.000000,284162.000000,6.260000,
2930.000000,-168182.000000,6.260000,
6890.000000,133682.000000,6.260000,
25120.000000,-200642.000000,6.260000,
34290.000000,-240302.000000,6.260000,
37420.000000,-151082.000000,6.260000,
63440.000000,-137102.000000,6.260000,
72070.000000,133622.000000,6.260000,
76240.000000,-33782.000000,6.260000,
32520.000000,-141902.000000,6.260000,
82750.000000,189602.000000,6.260000,
37790.000000,236282.000000,6.260000,
52410.000000,286862.000000,6.260000,
17980.000000,191402.000000,6.260000,
73800.000000,261182.000000,6.260000,
34410.000000,131402.000000,6.260000,
50510.000000,247322.000000,6.260000,
7720.000000,-64082.000000,6.260000,
24070.000000,39662.000000,6.260000,
71080.000000,146582.000000,6.260000,
36720.000000,-103082.000000,6.270000,
65220.000000,179042.000000,6.270000,
47600.000000,-67862.000000,6.270000,
26690.000000,-68522.000000,6.270000,
24130.000000,-138302.000000,6.270000,
33470.000000,41462.000000,6.270000,
76400.000000,57602.000000,6.270000,
35800.000000,-95642.000000,6.270000,
21860.000000,185762.000000,6.270000,
55240.000000,-243002.000000,6.270000,
30680.000000,-140702.000000,6.270000,
52920.000000,220562.000000,6.270000,
8630.000000,199382.000000,6.270000,
4420.000000,27362.000000,6.270000,
15850.000000,-205502.000000,6.270000,
74870.000000,188762.000000,6.270000,
24640.000000,-29042.000000,6.270000,
42670.000000,120242.000000,6.270000,
55080.000000,-147902.000000,6.270000,
83870.000000,163862.000000,6.270000,
12680.000000,177242.000000,6.270000,
21330.000000,-17342.000000,6.270000,
63320.000000,-192122.000000,6.270000,
65460.000000,217562.000000,6.270000,
82040.000000,210602.000000,6.270000,
85980.000000,7562.000000,6.270000,
2970.000000,-84182.000000,6.270000,
20010.000000,125042.000000,6.270000,
66660.000000,-150962.000000,6.270000,
40300.000000,51842.000000,6.270000,
79550.000000,173702.000000,6.270000,
48440.000000,-177842.000000,6.270000,
80510.000000,151502.000000,6.270000,
22610.000000,85502.000000,6.270000,
33570.000000,-198722.000000,6.270000,
29300.000000,-229742.000000,6.270000,
65330.000000,-91742.000000,6.270000,
65820.000000,-183902.000000,6.270000,
32880.000000,117242.000000,6.270000,
43000.000000,-169502.000000,6.270000,
5550.000000,-179042.000000,6.270000,
17580.000000,-260762.000000,6.270000,
51790.000000,4562.000000,6.270000,
30450.000000,164402.000000,6.270000,
66610.000000,-20702.000000,6.270000,
83000.000000,210902.000000,6.270000,
81920.000000,69782.000000,6.270000,
11310.000000,30542.000000,6.270000,
15170.000000,246662.000000,6.270000,
23560.000000,-40262.000000,6.270000,
25000.000000,-127322.000000,6.270000,
31340.000000,-200882.000000,6.270000,
50670.000000,8342.000000,6.270000,
61330.000000,114842.000000,6.270000,
77060.000000,88382.000000,6.270000,
80740.000000,66482.000000,6.270000,
82030.000000,-123002.000000,6.270000,
1180.000000,146642.000000,6.270000,
47590.000000,67442.000000,6.270000,
82650.000000,13742.000000,6.270000,
27370.000000,-29942.000000,6.270000,
50530.000000,164822.000000,6.270000,
54810.000000,137822.000000,6.270000,
54890.000000,-19862.000000,6.270000,
7420.000000,65762.000000,6.270000,
49420.000000,81782.000000,6.270000,
38700.000000,9002.000000,6.270000,
54370.000000,-130622.000000,6.270000,
82770.000000,-47102.000000,6.270000,
34430.000000,84422.000000,6.270000,
11300.000000,67742.000000,6.270000,
74270.000000,65822.000000,6.270000,
29380.000000,-153602.000000,6.280000,
58140.000000,208622.000000,6.280000,
61420.000000,-169862.000000,6.280000,
68240.000000,209642.000000,6.280000,
9830.000000,92342.000000,6.280000,
10020.000000,128042.000000,6.280000,
24490.000000,200582.000000,6.280000,
38160.000000,-96062.000000,6.280000,
10.000000,-159542.000000,6.280000,
68520.000000,188222.000000,6.280000,
18010.000000,-281942.000000,6.280000,
43240.000000,-78662.000000,6.280000,
58300.000000,120122.000000,6.280000,
41380.000000,204302.000000,6.280000,
54560.000000,-229142.000000,6.280000,
57930.000000,29222.000000,6.280000,
24930.000000,30002.000000,6.280000,
39660.000000,228422.000000,6.280000,
62700.000000,-124982.000000,6.280000,
64020.000000,171482.000000,6.280000,
64610.000000,23402.000000,6.280000,
72940.000000,180842.000000,6.280000,
72080.000000,-147002.000000,6.280000,
57280.000000,30902.000000,6.280000,
66480.000000,-96362.000000,6.280000,
85280.000000,178322.000000,6.280000,
42830.000000,2102.000000,6.280000,
81090.000000,106442.000000,6.280000,
63820.000000,-25562.000000,6.280000,
78560.000000,73742.000000,6.280000,
69630.000000,126722.000000,6.280000,
25160.000000,93362.000000,6.280000,
14430.000000,62342.000000,6.280000,
16610.000000,-110642.000000,6.280000,
31680.000000,-190322.000000,6.280000,
69800.000000,181082.000000,6.280000,
72960.000000,140042.000000,6.280000,
58040.000000,-202322.000000,6.280000,
64110.000000,-199502.000000,6.280000,
23400.000000,-236102.000000,6.280000,
31450.000000,132962.000000,6.280000,
44120.000000,315782.000000,6.280000,
4590.000000,287762.000000,6.280000,
52450.000000,205442.000000,6.280000,
41820.000000,-118802.000000,6.280000,
43460.000000,308162.000000,6.280000,
77990.000000,-188582.000000,6.280000,
25210.000000,-19382.000000,6.280000,
53550.000000,-110162.000000,6.280000,
3790.000000,-106382.000000,6.280000,
4810.000000,279362.000000,6.280000,
62570.000000,-8642.000000,6.280000,
71020.000000,205382.000000,6.280000,
50660.000000,-53942.000000,6.280000,
51190.000000,-95882.000000,6.280000,
5010.000000,123362.000000,6.280000,
14960.000000,215702.000000,6.280000,
29850.000000,31982.000000,6.280000,
41450.000000,172622.000000,6.280000,
54210.000000,124502.000000,6.280000,
300.000000,-1862.000000,6.280000,
4690.000000,170822.000000,6.280000,
12990.000000,-282062.000000,6.280000,
28160.000000,-161162.000000,6.280000,
33190.000000,-152282.000000,6.280000,
50240.000000,-82922.000000,6.280000,
57450.000000,142982.000000,6.280000,
57590.000000,-146402.000000,6.280000,
59480.000000,261482.000000,6.280000,
71930.000000,-109982.000000,6.280000,
74570.000000,-142502.000000,6.280000,
77940.000000,-121322.000000,6.280000,
14300.000000,139862.000000,6.280000,
36310.000000,-131042.000000,6.280000,
26250.000000,-24122.000000,6.280000,
33940.000000,230282.000000,6.280000,
41910.000000,121142.000000,6.280000,
49850.000000,246002.000000,6.280000,
53910.000000,-143702.000000,6.280000,
74820.000000,-9002.000000,6.280000,
34890.000000,93362.000000,6.280000,
36650.000000,146402.000000,6.280000,
78380.000000,92102.000000,6.280000,
73050.000000,153902.000000,6.280000,
68020.000000,207062.000000,6.280000,
73130.000000,-171842.000000,6.280000,
86200.000000,81542.000000,6.280000,
60220.000000,-148082.000000,6.290000,
22880.000000,8222.000000,6.290000,
29080.000000,-226262.000000,6.290000,
18870.000000,275402.000000,6.290000,
56170.000000,-119162.000000,6.290000,
11740.000000,118322.000000,6.290000,
2990.000000,99842.000000,6.290000,
33890.000000,185762.000000,6.290000,
35570.000000,-98462.000000,6.290000,
67190.000000,26522.000000,6.290000,
13470.000000,-195422.000000,6.290000,
46960.000000,215102.000000,6.290000,
47450.000000,-189302.000000,6.290000,
20360.000000,78362.000000,6.290000,
40910.000000,205502.000000,6.290000,
59720.000000,61442.000000,6.290000,
45210.000000,87482.000000,6.290000,
67530.000000,287882.000000,6.290000,
65230.000000,-77222.000000,6.290000,
26800.000000,39662.000000,6.290000,
20610.000000,-141902.000000,6.290000,
71200.000000,246422.000000,6.290000,
10390.000000,59402.000000,6.290000,
43780.000000,268862.000000,6.290000,
9230.000000,-184022.000000,6.290000,
77670.000000,82022.000000,6.290000,
54640.000000,-221162.000000,6.290000,
1730.000000,132902.000000,6.290000,
3960.000000,-86462.000000,6.290000,
12770.000000,-219722.000000,6.290000,
40940.000000,-160802.000000,6.290000,
73380.000000,-34802.000000,6.290000,
78260.000000,-138842.000000,6.290000,
39960.000000,-184442.000000,6.290000,
9130.000000,-131162.000000,6.290000,
67020.000000,58382.000000,6.290000,
33930.000000,59762.000000,6.290000,
7580.000000,182.000000,6.290000,
19250.000000,71402.000000,6.290000,
19840.000000,80942.000000,6.290000,
24740.000000,-19202.000000,6.290000,
30820.000000,47762.000000,6.290000,
38120.000000,-274742.000000,6.290000,
44710.000000,-236822.000000,6.290000,
45780.000000,220202.000000,6.290000,
49370.000000,-182882.000000,6.290000,
67950.000000,-105842.000000,6.290000,
70570.000000,51842.000000,6.290000,
74020.000000,150422.000000,6.290000,
53250.000000,-156842.000000,6.290000,
65990.000000,184922.000000,6.290000,
68540.000000,30242.000000,6.290000,
3370.000000,208742.000000,6.290000,
59810.000000,227162.000000,6.290000,
37000.000000,-184382.000000,6.290000,
61290.000000,53823.000000,6.300000,
34530.000000,-70563.000000,6.300000,
30400.000000,97023.000000,6.300000,
30630.000000,-161103.000000,6.300000,
71910.000000,137223.000000,6.300000,
26630.000000,-129123.000000,6.300000,
40580.000000,-165243.000000,6.300000,
51390.000000,72483.000000,6.300000,
800.000000,97143.000000,6.300000,
81640.000000,-12843.000000,6.300000,
1970.000000,101883.000000,6.300000,
81580.000000,-102063.000000,6.300000,
2180.000000,98163.000000,6.300000,
5910.000000,163563.000000,6.300000,
55820.000000,112683.000000,6.300000,
59800.000000,55863.000000,6.300000,
31220.000000,70443.000000,6.300000,
10770.000000,-117063.000000,6.300000,
20210.000000,-239703.000000,6.300000,
22230.000000,-163083.000000,6.300000,
28350.000000,198843.000000,6.300000,
33200.000000,-139083.000000,6.300000,
41800.000000,-134103.000000,6.300000,
61570.000000,-77703.000000,6.300000,
76680.000000,-232923.000000,6.300000,
69920.000000,73083.000000,6.300000,
77060.000000,-167883.000000,6.300000,
10130.000000,250743.000000,6.300000,
24200.000000,-141183.000000,6.300000,
29950.000000,-36723.000000,6.300000,
65840.000000,-35223.000000,6.300000,
79850.000000,110103.000000,6.300000,
45690.000000,37563.000000,6.300000,
40060.000000,84063.000000,6.300000,
8330.000000,83523.000000,6.300000,
85560.000000,-144723.000000,6.300000,
71580.000000,172203.000000,6.300000,
49370.000000,-204423.000000,6.300000,
81350.000000,180303.000000,6.300000,
26740.000000,-114303.000000,6.300000,
70050.000000,51483.000000,6.300000,
28890.000000,-199743.000000,6.300000,
14470.000000,133203.000000,6.300000,
23080.000000,-145083.000000,6.300000,
26840.000000,238863.000000,6.300000,
34780.000000,-38103.000000,6.300000,
77710.000000,101583.000000,6.300000,
43920.000000,102783.000000,6.300000,
50630.000000,-80763.000000,6.300000,
57420.000000,-173463.000000,6.300000,
63140.000000,-123483.000000,6.300000,
61270.000000,97983.000000,6.300000,
62820.000000,-45063.000000,6.300000,
67430.000000,-24603.000000,6.300000,
64630.000000,86463.000000,6.300000,
18230.000000,-150303.000000,6.300000,
51330.000000,-162063.000000,6.300000,
3470.000000,49323.000000,6.300000,
8530.000000,-155583.000000,6.300000,
35130.000000,281403.000000,6.300000,
46650.000000,-82023.000000,6.300000,
82070.000000,-93363.000000,6.300000,
20640.000000,221403.000000,6.300000,
82630.000000,-17403.000000,6.300000,
43260.000000,-6483.000000,6.300000,
69570.000000,134463.000000,6.300000,
67890.000000,103623.000000,6.300000,
62190.000000,218523.000000,6.300000,
4820.000000,-40563.000000,6.300000,
20150.000000,99663.000000,6.300000,
20260.000000,120903.000000,6.300000,
20830.000000,-128463.000000,6.300000,
23250.000000,117303.000000,6.300000,
26030.000000,258603.000000,6.300000,
30770.000000,249603.000000,6.300000,
37110.000000,-132543.000000,6.300000,
52830.000000,-203283.000000,6.300000,
63640.000000,112683.000000,6.300000,
64460.000000,270663.000000,6.300000,
66280.000000,-25503.000000,6.300000,
67520.000000,-204843.000000,6.300000,
70530.000000,-44163.000000,6.300000,
71330.000000,-190443.000000,6.300000,
73560.000000,71583.000000,6.300000,
74780.000000,190863.000000,6.300000,
79910.000000,212763.000000,6.300000,
80180.000000,100143.000000,6.300000,
21050.000000,185523.000000,6.300000,
33800.000000,-217143.000000,6.300000,
20590.000000,-5823.000000,6.300000,
66870.000000,-190503.000000,6.300000,
84210.000000,1083.000000,6.300000,
79720.000000,164703.000000,6.300000,
29360.000000,152763.000000,6.300000,
58450.000000,21303.000000,6.300000,
65130.000000,78003.000000,6.300000,
12020.000000,92463.000000,6.300000,
71530.000000,131223.000000,6.300000,
39150.000000,-783.000000,6.300000,
53110.000000,118143.000000,6.300000,
73160.000000,47643.000000,6.300000,
7570.000000,29763.000000,6.300000,
5370.000000,-168363.000000,6.300000,
4720.000000,134703.000000,6.310000,
48420.000000,-177003.000000,6.310000,
58640.000000,-191163.000000,6.310000,
20130.000000,-15783.000000,6.310000,
58360.000000,96123.000000,6.310000,
63100.000000,-165843.000000,6.310000,
37450.000000,8583.000000,6.310000,
21610.000000,160563.000000,6.310000,
66230.000000,139503.000000,6.310000,
51600.000000,109563.000000,6.310000,
1990.000000,255603.000000,6.310000,
27280.000000,-185343.000000,6.310000,
45480.000000,11883.000000,6.310000,
58460.000000,-76023.000000,6.310000,
32650.000000,100503.000000,6.310000,
12370.000000,-149943.000000,6.310000,
9740.000000,38763.000000,6.310000,
10370.000000,-34023.000000,6.310000,
17590.000000,190263.000000,6.310000,
35810.000000,-98943.000000,6.310000,
140.000000,32283.000000,6.310000,
11010.000000,101883.000000,6.310000,
18030.000000,-7503.000000,6.310000,
76690.000000,-62943.000000,6.310000,
19170.000000,-5163.000000,6.310000,
28280.000000,-155163.000000,6.310000,
26030.000000,-109263.000000,6.310000,
19470.000000,8583.000000,6.310000,
70160.000000,73023.000000,6.310000,
12710.000000,177963.000000,6.310000,
69580.000000,231903.000000,6.310000,
28020.000000,-141663.000000,6.310000,
29330.000000,-40923.000000,6.310000,
49080.000000,51483.000000,6.310000,
2790.000000,249663.000000,6.310000,
23320.000000,-147963.000000,6.310000,
37200.000000,-32703.000000,6.310000,
60620.000000,-9603.000000,6.310000,
49830.000000,-71703.000000,6.310000,
20820.000000,-58503.000000,6.310000,
58020.000000,-50703.000000,6.310000,
20090.000000,-220263.000000,6.310000,
39810.000000,-48423.000000,6.310000,
68490.000000,-55083.000000,6.310000,
46120.000000,89463.000000,6.310000,
6230.000000,115923.000000,6.310000,
7800.000000,-157803.000000,6.310000,
44780.000000,259023.000000,6.310000,
1120.000000,-155703.000000,6.310000,
8150.000000,172203.000000,6.310000,
22880.000000,64023.000000,6.310000,
41470.000000,175683.000000,6.310000,
41700.000000,73623.000000,6.310000,
62390.000000,-21363.000000,6.310000,
69530.000000,34683.000000,6.310000,
6460.000000,-133863.000000,6.310000,
14790.000000,194523.000000,6.310000,
15570.000000,36483.000000,6.310000,
20830.000000,153123.000000,6.310000,
21250.000000,11703.000000,6.310000,
33330.000000,-207363.000000,6.310000,
35870.000000,163503.000000,6.310000,
47350.000000,-34383.000000,6.310000,
55820.000000,132603.000000,6.310000,
56740.000000,3243.000000,6.310000,
58680.000000,246903.000000,6.310000,
67200.000000,111123.000000,6.310000,
69780.000000,-26703.000000,6.310000,
70690.000000,74943.000000,6.310000,
47520.000000,87363.000000,6.310000,
18820.000000,2043.000000,6.310000,
31430.000000,-245643.000000,6.310000,
39980.000000,-183483.000000,6.310000,
60730.000000,-243723.000000,6.310000,
83980.000000,174243.000000,6.310000,
84480.000000,-128043.000000,6.310000,
51970.000000,-152403.000000,6.310000,
64880.000000,-61803.000000,6.310000,
73540.000000,36303.000000,6.310000,
49140.000000,65763.000000,6.310000,
23490.000000,-133023.000000,6.310000,
30190.000000,-137883.000000,6.310000,
28320.000000,11883.000000,6.310000,
82470.000000,61023.000000,6.310000,
48860.000000,-173883.000000,6.320000,
61310.000000,30483.000000,6.320000,
65880.000000,-245703.000000,6.320000,
85710.000000,233583.000000,6.320000,
19480.000000,-188403.000000,6.320000,
11850.000000,236403.000000,6.320000,
48170.000000,-172623.000000,6.320000,
73220.000000,-105123.000000,6.320000,
31940.000000,19263.000000,6.320000,
66670.000000,235683.000000,6.320000,
47380.000000,138783.000000,6.320000,
16560.000000,-13083.000000,6.320000,
82190.000000,-118143.000000,6.320000,
57940.000000,-22683.000000,6.320000,
21900.000000,136743.000000,6.320000,
540.000000,-194523.000000,6.320000,
42060.000000,-299223.000000,6.320000,
55120.000000,-112443.000000,6.320000,
6080.000000,-285003.000000,6.320000,
31120.000000,-71103.000000,6.320000,
10630.000000,-107523.000000,6.320000,
46320.000000,-173223.000000,6.320000,
49820.000000,210783.000000,6.320000,
61930.000000,-90963.000000,6.320000,
62810.000000,-93423.000000,6.320000,
66180.000000,-36843.000000,6.320000,
82720.000000,26463.000000,6.320000,
85730.000000,215943.000000,6.320000,
8690.000000,-10083.000000,6.320000,
17180.000000,-10683.000000,6.320000,
40330.000000,245823.000000,6.320000,
63020.000000,42963.000000,6.320000,
69300.000000,300543.000000,6.320000,
82880.000000,-82143.000000,6.320000,
49780.000000,131943.000000,6.320000,
71680.000000,-220323.000000,6.320000,
62760.000000,96843.000000,6.320000,
48120.000000,158163.000000,6.320000,
19820.000000,-26823.000000,6.320000,
74590.000000,205683.000000,6.320000,
60960.000000,-182523.000000,6.320000,
69540.000000,120303.000000,6.320000,
54970.000000,-156603.000000,6.320000,
13080.000000,153363.000000,6.320000,
13900.000000,246663.000000,6.320000,
28780.000000,-216843.000000,6.320000,
43550.000000,-235983.000000,6.320000,
75370.000000,183903.000000,6.320000,
5260.000000,145263.000000,6.320000,
23270.000000,170763.000000,6.320000,
64900.000000,-130983.000000,6.320000,
70560.000000,81363.000000,6.320000,
23120.000000,53103.000000,6.320000,
24860.000000,-152583.000000,6.320000,
30020.000000,192903.000000,6.320000,
47510.000000,-227943.000000,6.320000,
27980.000000,226263.000000,6.320000,
75820.000000,168783.000000,6.320000,
79090.000000,-19623.000000,6.320000,
18580.000000,233763.000000,6.320000,
49510.000000,201183.000000,6.320000,
15340.000000,55503.000000,6.320000,
33650.000000,-56283.000000,6.320000,
28940.000000,-22863.000000,6.320000,
24320.000000,-187983.000000,6.320000,
52910.000000,76083.000000,6.320000,
63530.000000,117903.000000,6.320000,
67940.000000,-96003.000000,6.320000,
11480.000000,47043.000000,6.320000,
79620.000000,211863.000000,6.320000,
50610.000000,38883.000000,6.320000,
84540.000000,83103.000000,6.320000,
28250.000000,-40143.000000,6.320000,
33460.000000,-196203.000000,6.320000,
61900.000000,28503.000000,6.320000,
73140.000000,-227703.000000,6.320000,
75800.000000,181323.000000,6.320000,
78030.000000,-200703.000000,6.320000,
81160.000000,57183.000000,6.320000,
83230.000000,-178683.000000,6.320000,
83940.000000,-286143.000000,6.320000,
25690.000000,121863.000000,6.320000,
69840.000000,131283.000000,6.320000,
20970.000000,-161643.000000,6.320000,
30680.000000,-195843.000000,6.320000,
39140.000000,-286503.000000,6.320000,
44730.000000,-310203.000000,6.320000,
50250.000000,221463.000000,6.320000,
54750.000000,-173643.000000,6.320000,
70390.000000,216663.000000,6.320000,
59460.000000,126903.000000,6.320000,
67390.000000,141603.000000,6.320000,
81690.000000,111483.000000,6.320000,
48180.000000,-119523.000000,6.320000,
82840.000000,111963.000000,6.330000,
31240.000000,-207183.000000,6.330000,
65470.000000,-71523.000000,6.330000,
27140.000000,-129543.000000,6.330000,
3950.000000,17763.000000,6.330000,
15330.000000,22383.000000,6.330000,
69310.000000,180363.000000,6.330000,
56590.000000,49263.000000,6.330000,
77770.000000,108243.000000,6.330000,
40420.000000,147963.000000,6.330000,
68980.000000,-71403.000000,6.330000,
79820.000000,52683.000000,6.330000,
73760.000000,72363.000000,6.330000,
49150.000000,-272523.000000,6.330000,
79020.000000,175323.000000,6.330000,
81010.000000,-52563.000000,6.330000,
66880.000000,39303.000000,6.330000,
28750.000000,-263763.000000,6.330000,
34980.000000,195783.000000,6.330000,
82150.000000,-253323.000000,6.330000,
74980.000000,28383.000000,6.330000,
50810.000000,268623.000000,6.330000,
67980.000000,-34563.000000,6.330000,
46340.000000,58083.000000,6.330000,
60830.000000,-151263.000000,6.330000,
70720.000000,12243.000000,6.330000,
50930.000000,-213483.000000,6.330000,
68990.000000,-1623.000000,6.330000,
3410.000000,247623.000000,6.330000,
18260.000000,-128643.000000,6.330000,
19220.000000,-124983.000000,6.330000,
75830.000000,149943.000000,6.330000,
44210.000000,311223.000000,6.330000,
25020.000000,-29523.000000,6.330000,
68580.000000,-68763.000000,6.330000,
81820.000000,39423.000000,6.330000,
74390.000000,40563.000000,6.330000,
20660.000000,-72483.000000,6.330000,
49610.000000,22923.000000,6.330000,
8330.000000,-93483.000000,6.330000,
13210.000000,-54903.000000,6.330000,
14740.000000,-73923.000000,6.330000,
65160.000000,-1683.000000,6.330000,
86190.000000,-89163.000000,6.330000,
33240.000000,258003.000000,6.330000,
81130.000000,194583.000000,6.330000,
30920.000000,9903.000000,6.330000,
20530.000000,-63123.000000,6.330000,
30430.000000,-114123.000000,6.330000,
46210.000000,82323.000000,6.330000,
56350.000000,208563.000000,6.330000,
66460.000000,214443.000000,6.330000,
69730.000000,-151323.000000,6.330000,
69840.000000,-246243.000000,6.330000,
70530.000000,-26943.000000,6.330000,
56290.000000,-101643.000000,6.330000,
68460.000000,69543.000000,6.330000,
20520.000000,81663.000000,6.330000,
83740.000000,101763.000000,6.330000,
4620.000000,161763.000000,6.330000,
63360.000000,101463.000000,6.330000,
80460.000000,97023.000000,6.330000,
86060.000000,-97443.000000,6.340000,
17890.000000,-8043.000000,6.340000,
22160.000000,-65283.000000,6.340000,
81190.000000,253383.000000,6.340000,
4860.000000,232803.000000,6.340000,
74990.000000,168003.000000,6.340000,
3500.000000,77103.000000,6.340000,
74790.000000,167583.000000,6.340000,
23800.000000,-81483.000000,6.340000,
42680.000000,-43923.000000,6.340000,
21020.000000,-190023.000000,6.340000,
28630.000000,4143.000000,6.340000,
41500.000000,51783.000000,6.340000,
21860.000000,-162183.000000,6.340000,
23750.000000,-129963.000000,6.340000,
36830.000000,-145203.000000,6.340000,
46340.000000,-193863.000000,6.340000,
45540.000000,81663.000000,6.340000,
46020.000000,21483.000000,6.340000,
60870.000000,-110163.000000,6.340000,
78970.000000,-208503.000000,6.340000,
12130.000000,-92223.000000,6.340000,
12300.000000,148563.000000,6.340000,
19410.000000,19263.000000,6.340000,
20030.000000,-107523.000000,6.340000,
34960.000000,174423.000000,6.340000,
67970.000000,-167763.000000,6.340000,
18360.000000,129423.000000,6.340000,
40710.000000,-286863.000000,6.340000,
66740.000000,-52803.000000,6.340000,
68510.000000,80283.000000,6.340000,
29540.000000,50463.000000,6.340000,
63260.000000,59463.000000,6.340000,
26660.000000,55923.000000,6.340000,
64850.000000,22623.000000,6.340000,
6170.000000,221163.000000,6.340000,
58070.000000,-88083.000000,6.340000,
25160.000000,26403.000000,6.340000,
67030.000000,41163.000000,6.340000,
10240.000000,-143823.000000,6.340000,
17430.000000,255483.000000,6.340000,
25510.000000,172023.000000,6.340000,
34560.000000,267603.000000,6.340000,
52010.000000,-143643.000000,6.340000,
12340.000000,194163.000000,6.340000,
14190.000000,258603.000000,6.340000,
33110.000000,19743.000000,6.340000,
20.000000,96963.000000,6.340000,
12820.000000,208383.000000,6.340000,
59970.000000,-34443.000000,6.340000,
69760.000000,35763.000000,6.340000,
49890.000000,-131223.000000,6.340000,
23140.000000,-14043.000000,6.340000,
53880.000000,-175983.000000,6.340000,
68360.000000,-66903.000000,6.340000,
75880.000000,8223.000000,6.340000,
45180.000000,37143.000000,6.340000,
20330.000000,95883.000000,6.340000,
37430.000000,-208683.000000,6.340000,
21200.000000,-154623.000000,6.340000,
23810.000000,-149643.000000,6.340000,
24910.000000,165003.000000,6.340000,
28690.000000,158403.000000,6.340000,
36480.000000,-134463.000000,6.340000,
39650.000000,-56883.000000,6.340000,
40290.000000,-257223.000000,6.340000,
44710.000000,-99903.000000,6.340000,
55240.000000,-8763.000000,6.340000,
57330.000000,-111963.000000,6.340000,
64310.000000,-4503.000000,6.340000,
83110.000000,-61563.000000,6.340000,
83580.000000,106083.000000,6.340000,
59430.000000,278883.000000,6.340000,
64380.000000,-39303.000000,6.340000,
83670.000000,86883.000000,6.340000,
6190.000000,163143.000000,6.340000,
44030.000000,-282903.000000,6.340000,
65120.000000,-293463.000000,6.340000,
61070.000000,153123.000000,6.340000,
11540.000000,171963.000000,6.340000,
22580.000000,61863.000000,6.340000,
38850.000000,-206943.000000,6.340000,
55760.000000,223623.000000,6.340000,
68490.000000,-81783.000000,6.340000,
80430.000000,-207123.000000,6.340000,
27430.000000,144183.000000,6.340000,
28920.000000,-133443.000000,6.340000,
9800.000000,-145923.000000,6.350000,
31150.000000,-217203.000000,6.350000,
34240.000000,-114843.000000,6.350000,
76260.000000,130743.000000,6.350000,
25080.000000,-97863.000000,6.350000,
15840.000000,87543.000000,6.350000,
44010.000000,-121683.000000,6.350000,
36690.000000,48123.000000,6.350000,
53600.000000,56583.000000,6.350000,
80790.000000,-60303.000000,6.350000,
37130.000000,168423.000000,6.350000,
83680.000000,-38523.000000,6.350000,
29320.000000,-73383.000000,6.350000,
29810.000000,302703.000000,6.350000,
55660.000000,224223.000000,6.350000,
66800.000000,-21363.000000,6.350000,
51940.000000,-238263.000000,6.350000,
65750.000000,-13083.000000,6.350000,
63790.000000,-100443.000000,6.350000,
74250.000000,113523.000000,6.350000,
23490.000000,57303.000000,6.350000,
77090.000000,-12303.000000,6.350000,
69860.000000,101163.000000,6.350000,
5520.000000,125343.000000,6.350000,
68330.000000,250323.000000,6.350000,
8360.000000,176283.000000,6.350000,
21250.000000,-105003.000000,6.350000,
63040.000000,140043.000000,6.350000,
67510.000000,-75663.000000,6.350000,
77060.000000,36663.000000,6.350000,
30570.000000,-198723.000000,6.350000,
44860.000000,-59943.000000,6.350000,
7100.000000,-119103.000000,6.350000,
13160.000000,-37683.000000,6.350000,
70670.000000,177483.000000,6.350000,
28050.000000,-57603.000000,6.350000,
61570.000000,37683.000000,6.350000,
61730.000000,-14043.000000,6.350000,
71920.000000,253383.000000,6.350000,
30780.000000,86763.000000,6.350000,
21080.000000,-230643.000000,6.350000,
26530.000000,140463.000000,6.350000,
31140.000000,190563.000000,6.350000,
52560.000000,83763.000000,6.350000,
74480.000000,-93663.000000,6.350000,
8360.000000,-150723.000000,6.350000,
58350.000000,270843.000000,6.350000,
38780.000000,206583.000000,6.350000,
15380.000000,-219483.000000,6.360000,
72660.000000,-207123.000000,6.360000,
73870.000000,40563.000000,6.360000,
34550.000000,51843.000000,6.360000,
15540.000000,-122163.000000,6.360000,
5240.000000,148023.000000,6.360000,
19150.000000,-66723.000000,6.360000,
19150.000000,-66663.000000,6.360000,
43680.000000,-182763.000000,6.360000,
47850.000000,-2523.000000,6.360000,
65100.000000,151083.000000,6.360000,
65680.000000,203763.000000,6.360000,
53370.000000,184983.000000,6.360000,
22550.000000,4263.000000,6.360000,
45000.000000,-48243.000000,6.360000,
38450.000000,-128703.000000,6.360000,
62980.000000,-21363.000000,6.360000,
4020.000000,192663.000000,6.360000,
83980.000000,-121383.000000,6.360000,
64810.000000,2343.000000,6.360000,
18810.000000,-29403.000000,6.360000,
67660.000000,176763.000000,6.360000,
75680.000000,-245643.000000,6.360000,
83860.000000,-42243.000000,6.360000,
23620.000000,118983.000000,6.360000,
34820.000000,-38823.000000,6.360000,
64640.000000,39783.000000,6.360000,
18810.000000,225723.000000,6.360000,
48810.000000,-236343.000000,6.360000,
67340.000000,-232803.000000,6.360000,
68250.000000,-143403.000000,6.360000,
14280.000000,125403.000000,6.360000,
4030.000000,-86463.000000,6.360000,
41150.000000,13983.000000,6.360000,
35760.000000,-257103.000000,6.360000,
31600.000000,-124683.000000,6.360000,
35780.000000,-184923.000000,6.360000,
9440.000000,143703.000000,6.360000,
79320.000000,39543.000000,6.360000,
20440.000000,-37563.000000,6.360000,
31440.000000,15663.000000,6.360000,
79570.000000,202863.000000,6.360000,
8880.000000,-231543.000000,6.360000,
62880.000000,-226983.000000,6.360000,
27430.000000,-85623.000000,6.360000,
74270.000000,-90423.000000,6.360000,
82700.000000,-5163.000000,6.360000,
7760.000000,62103.000000,6.360000,
2150.000000,47643.000000,6.360000,
23970.000000,88623.000000,6.360000,
83660.000000,107223.000000,6.360000,
6580.000000,-138303.000000,6.360000,
51260.000000,-21483.000000,6.360000,
31660.000000,-150363.000000,6.360000,
62880.000000,-29583.000000,6.360000,
7070.000000,-235623.000000,6.360000,
15210.000000,-145383.000000,6.360000,
41410.000000,195783.000000,6.360000,
80220.000000,-83343.000000,6.360000,
43560.000000,-11283.000000,6.360000,
44860.000000,31083.000000,6.360000,
35530.000000,363.000000,6.360000,
11140.000000,201903.000000,6.360000,
21390.000000,-83643.000000,6.360000,
21990.000000,228483.000000,6.360000,
22100.000000,147843.000000,6.360000,
24210.000000,-263283.000000,6.360000,
30770.000000,-124743.000000,6.360000,
32760.000000,-232263.000000,6.360000,
35390.000000,-130623.000000,6.360000,
36510.000000,302163.000000,6.360000,
37140.000000,89043.000000,6.360000,
37170.000000,-18483.000000,6.360000,
44590.000000,-243543.000000,6.360000,
47720.000000,-250923.000000,6.360000,
48270.000000,44823.000000,6.360000,
54050.000000,79443.000000,6.360000,
61140.000000,249123.000000,6.360000,
65560.000000,148203.000000,6.360000,
82100.000000,-222123.000000,6.360000,
38760.000000,22983.000000,6.360000,
17270.000000,-108123.000000,6.360000,
56140.000000,138183.000000,6.360000,
60950.000000,-120723.000000,6.360000,
63040.000000,208443.000000,6.360000,
70270.000000,200703.000000,6.360000,
70870.000000,80883.000000,6.360000,
74390.000000,-226503.000000,6.360000,
76050.000000,56463.000000,6.360000,
85350.000000,222063.000000,6.360000,
39210.000000,-55683.000000,6.360000,
10610.000000,184563.000000,6.360000,
60350.000000,-299763.000000,6.360000,
61570.000000,35163.000000,6.360000,
81400.000000,128403.000000,6.360000,
37840.000000,-220983.000000,6.360000,
28580.000000,-109083.000000,6.360000,
49180.000000,-143163.000000,6.360000,
16510.000000,-35163.000000,6.370000,
61610.000000,-6003.000000,6.370000,
73580.000000,204003.000000,6.370000,
21030.000000,204963.000000,6.370000,
54030.000000,170223.000000,6.370000,
66400.000000,95343.000000,6.370000,
7880.000000,207543.000000,6.370000,
60980.000000,234183.000000,6.370000,
45240.000000,-179703.000000,6.370000,
62640.000000,138963.000000,6.370000,
12210.000000,17583.000000,6.370000,
75180.000000,-85683.000000,6.370000,
40.000000,162963.000000,6.370000,
12710.000000,-92283.000000,6.370000,
24690.000000,11043.000000,6.370000,
41470.000000,-220683.000000,6.370000,
39130.000000,3723.000000,6.370000,
51580.000000,139683.000000,6.370000,
43830.000000,60603.000000,6.370000,
79830.000000,75543.000000,6.370000,
30750.000000,-54123.000000,6.370000,
45520.000000,147183.000000,6.370000,
6390.000000,62763.000000,6.370000,
51280.000000,78783.000000,6.370000,
19680.000000,4743.000000,6.370000,
70610.000000,138243.000000,6.370000,
77630.000000,-297723.000000,6.370000,
68820.000000,-67563.000000,6.370000,
80810.000000,203283.000000,6.370000,
28500.000000,-189363.000000,6.370000,
2060.000000,240363.000000,6.370000,
17690.000000,70263.000000,6.370000,
35900.000000,99963.000000,6.370000,
66240.000000,-12963.000000,6.370000,
70520.000000,10563.000000,6.370000,
85750.000000,212283.000000,6.370000,
14380.000000,37263.000000,6.370000,
79220.000000,118863.000000,6.370000,
19620.000000,-42903.000000,6.370000,
37210.000000,193683.000000,6.370000,
69480.000000,-192243.000000,6.370000,
81490.000000,162723.000000,6.370000,
67170.000000,18963.000000,6.370000,
36800.000000,-118983.000000,6.370000,
33810.000000,90723.000000,6.370000,
14840.000000,-231303.000000,6.370000,
52170.000000,150543.000000,6.370000,
22420.000000,-85983.000000,6.370000,
27880.000000,-237963.000000,6.370000,
47770.000000,68643.000000,6.370000,
51420.000000,-66963.000000,6.370000,
74410.000000,-85623.000000,6.370000,
3070.000000,12303.000000,6.370000,
11430.000000,-85503.000000,6.370000,
27640.000000,49623.000000,6.370000,
27850.000000,46383.000000,6.370000,
30160.000000,218343.000000,6.370000,
30770.000000,-113463.000000,6.370000,
37710.000000,162783.000000,6.370000,
61050.000000,50043.000000,6.370000,
82240.000000,69003.000000,6.370000,
61310.000000,-68043.000000,6.370000,
23990.000000,158523.000000,6.370000,
58470.000000,-66783.000000,6.370000,
22690.000000,166983.000000,6.370000,
74960.000000,-64983.000000,6.370000,
76870.000000,-179883.000000,6.370000,
21910.000000,272163.000000,6.370000,
76470.000000,423.000000,6.370000,
81420.000000,45363.000000,6.370000,
42910.000000,132423.000000,6.370000,
24120.000000,22923.000000,6.370000,
11830.000000,145803.000000,6.380000,
31960.000000,-187743.000000,6.380000,
60250.000000,-98883.000000,6.380000,
70790.000000,-240183.000000,6.380000,
62960.000000,-138723.000000,6.380000,
71870.000000,152163.000000,6.380000,
82960.000000,158643.000000,6.380000,
62550.000000,-136143.000000,6.380000,
20350.000000,-64323.000000,6.380000,
19220.000000,-19383.000000,6.380000,
19730.000000,-11943.000000,6.380000,
82960.000000,198903.000000,6.380000,
29650.000000,63663.000000,6.380000,
16130.000000,109323.000000,6.380000,
15780.000000,-128043.000000,6.380000,
10400.000000,174903.000000,6.380000,
45800.000000,-212103.000000,6.380000,
57130.000000,-107643.000000,6.380000,
63660.000000,88323.000000,6.380000,
85940.000000,271983.000000,6.380000,
10300.000000,210003.000000,6.380000,
54110.000000,-123783.000000,6.380000,
65510.000000,-104103.000000,6.380000,
60720.000000,54003.000000,6.380000,
1200.000000,175923.000000,6.380000,
20480.000000,-120303.000000,6.380000,
31150.000000,215823.000000,6.380000,
45830.000000,-130923.000000,6.380000,
72840.000000,131823.000000,6.380000,
11260.000000,170343.000000,6.380000,
81390.000000,42183.000000,6.380000,
83830.000000,271143.000000,6.380000,
12350.000000,-129363.000000,6.380000,
23840.000000,88563.000000,6.380000,
32150.000000,-85803.000000,6.380000,
71930.000000,-247623.000000,6.380000,
72290.000000,83583.000000,6.380000,
31790.000000,-140943.000000,6.380000,
32690.000000,116643.000000,6.380000,
25620.000000,-96003.000000,6.380000,
25560.000000,-110403.000000,6.380000,
36800.000000,-222063.000000,6.380000,
71390.000000,102423.000000,6.380000,
30670.000000,-172383.000000,6.380000,
32090.000000,-209703.000000,6.380000,
62300.000000,-117303.000000,6.380000,
64820.000000,70323.000000,6.380000,
33580.000000,-122823.000000,6.380000,
66350.000000,-122283.000000,6.380000,
69690.000000,-69303.000000,6.380000,
28000.000000,-45723.000000,6.380000,
79810.000000,259683.000000,6.380000,
82740.000000,215403.000000,6.380000,
19400.000000,104223.000000,6.380000,
20620.000000,-165063.000000,6.380000,
23340.000000,39723.000000,6.380000,
28700.000000,-185283.000000,6.380000,
6360.000000,-98523.000000,6.380000,
10160.000000,134403.000000,6.380000,
16320.000000,19563.000000,6.380000,
26810.000000,77583.000000,6.380000,
79960.000000,-17043.000000,6.380000,
9480.000000,27783.000000,6.380000,
52400.000000,133143.000000,6.380000,
80280.000000,-903.000000,6.380000,
12040.000000,-95823.000000,6.380000,
15910.000000,-159003.000000,6.380000,
52760.000000,-176643.000000,6.380000,
25240.000000,-102663.000000,6.380000,
2800.000000,214563.000000,6.380000,
23080.000000,-103683.000000,6.380000,
67670.000000,-280383.000000,6.380000,
73320.000000,148083.000000,6.380000,
1370.000000,-44043.000000,6.380000,
31860.000000,55323.000000,6.380000,
27360.000000,-201243.000000,6.380000,
84930.000000,-26943.000000,6.380000,
27280.000000,291303.000000,6.380000,
79330.000000,-64503.000000,6.380000,
47550.000000,67563.000000,6.380000,
19840.000000,143463.000000,6.380000,
39620.000000,185463.000000,6.380000,
83110.000000,4743.000000,6.380000,
16740.000000,-186063.000000,6.380000,
21770.000000,156183.000000,6.380000,
23590.000000,-139143.000000,6.380000,
41420.000000,168003.000000,6.380000,
42170.000000,-285543.000000,6.380000,
46410.000000,-15303.000000,6.380000,
50650.000000,-19443.000000,6.380000,
67440.000000,-132243.000000,6.380000,
68420.000000,-89883.000000,6.380000,
69810.000000,119643.000000,6.380000,
71760.000000,-292923.000000,6.380000,
81000.000000,177783.000000,6.380000,
82510.000000,-131043.000000,6.380000,
84660.000000,-22683.000000,6.380000,
23670.000000,199383.000000,6.380000,
5750.000000,147963.000000,6.380000,
65350.000000,109683.000000,6.380000,
84710.000000,-3963.000000,6.380000,
14640.000000,-59763.000000,6.380000,
27460.000000,-136863.000000,6.380000,
72950.000000,-108123.000000,6.380000,
26930.000000,-232323.000000,6.380000,
36160.000000,-223803.000000,6.380000,
56880.000000,114243.000000,6.380000,
69980.000000,225243.000000,6.380000,
43900.000000,205503.000000,6.380000,
46330.000000,61503.000000,6.380000,
40330.000000,-116823.000000,6.380000,
62240.000000,320583.000000,6.380000,
32350.000000,65343.000000,6.380000,
64670.000000,-140943.000000,6.390000,
82610.000000,42723.000000,6.390000,
5000.000000,209343.000000,6.390000,
53170.000000,-76263.000000,6.390000,
76420.000000,231963.000000,6.390000,
78850.000000,71043.000000,6.390000,
28860.000000,84963.000000,6.390000,
84030.000000,224043.000000,6.390000,
68710.000000,179763.000000,6.390000,
79690.000000,179283.000000,6.390000,
260.000000,-105483.000000,6.390000,
74860.000000,11943.000000,6.390000,
78420.000000,252603.000000,6.390000,
34670.000000,-33963.000000,6.390000,
21390.000000,104283.000000,6.390000,
82830.000000,163383.000000,6.390000,
66850.000000,73743.000000,6.390000,
44610.000000,-141543.000000,6.390000,
81100.000000,-39303.000000,6.390000,
70050.000000,136623.000000,6.390000,
68160.000000,64863.000000,6.390000,
82370.000000,181563.000000,6.390000,
24350.000000,45783.000000,6.390000,
73620.000000,123663.000000,6.390000,
66870.000000,-87243.000000,6.390000,
57370.000000,-51903.000000,6.390000,
50380.000000,-12843.000000,6.390000,
54180.000000,160803.000000,6.390000,
3050.000000,185523.000000,6.390000,
10310.000000,-111003.000000,6.390000,
29480.000000,139503.000000,6.390000,
65840.000000,-101883.000000,6.390000,
85070.000000,166383.000000,6.390000,
4150.000000,288123.000000,6.390000,
74670.000000,251163.000000,6.390000,
8230.000000,85683.000000,6.390000,
1720.000000,-181983.000000,6.390000,
12090.000000,-172083.000000,6.390000,
41630.000000,132603.000000,6.390000,
50890.000000,-227643.000000,6.390000,
52510.000000,-216123.000000,6.390000,
4210.000000,-32103.000000,6.390000,
31200.000000,72123.000000,6.390000,
51320.000000,-192663.000000,6.390000,
52250.000000,-147123.000000,6.390000,
62250.000000,83223.000000,6.390000,
76590.000000,152163.000000,6.390000,
80440.000000,183603.000000,6.390000,
32430.000000,135483.000000,6.390000,
77300.000000,29583.000000,6.390000,
12810.000000,211624.000000,6.400000,
41920.000000,231724.000000,6.400000,
24840.000000,-21124.000000,6.400000,
58970.000000,116464.000000,6.400000,
20130.000000,-11764.000000,6.400000,
70630.000000,105664.000000,6.400000,
58420.000000,-87964.000000,6.400000,
10370.000000,190864.000000,6.400000,
13350.000000,-307024.000000,6.400000,
81780.000000,169864.000000,6.400000,
19750.000000,90604.000000,6.400000,
44660.000000,92164.000000,6.400000,
31520.000000,-9424.000000,6.400000,
49630.000000,-225364.000000,6.400000,
26110.000000,-604.000000,6.400000,
12870.000000,-114844.000000,6.400000,
54690.000000,-163084.000000,6.400000,
57950.000000,-22204.000000,6.400000,
64310.000000,55264.000000,6.400000,
67100.000000,31804.000000,6.400000,
70760.000000,59764.000000,6.400000,
24780.000000,-97084.000000,6.400000,
18270.000000,116404.000000,6.400000,
64200.000000,174244.000000,6.400000,
7480.000000,234424.000000,6.400000,
10650.000000,-137584.000000,6.400000,
38020.000000,192664.000000,6.400000,
61500.000000,157804.000000,6.400000,
64270.000000,-191344.000000,6.400000,
79550.000000,162424.000000,6.400000,
23150.000000,-28504.000000,6.400000,
24760.000000,-213664.000000,6.400000,
39980.000000,-233464.000000,6.400000,
61500.000000,-163804.000000,6.400000,
83940.000000,162544.000000,6.400000,
4920.000000,274504.000000,6.400000,
21150.000000,142564.000000,6.400000,
41650.000000,39784.000000,6.400000,
79310.000000,-279604.000000,6.400000,
18230.000000,-51844.000000,6.400000,
22990.000000,13624.000000,6.400000,
40800.000000,-259264.000000,6.400000,
75120.000000,118324.000000,6.400000,
22850.000000,42364.000000,6.400000,
29310.000000,-135724.000000,6.400000,
5840.000000,267544.000000,6.400000,
22410.000000,-105904.000000,6.400000,
69820.000000,73024.000000,6.400000,
32580.000000,-192844.000000,6.400000,
34960.000000,-127864.000000,6.400000,
81790.000000,-25144.000000,6.400000,
56030.000000,61804.000000,6.400000,
34330.000000,-103084.000000,6.400000,
34180.000000,200764.000000,6.400000,
83040.000000,23824.000000,6.400000,
71080.000000,105364.000000,6.400000,
39580.000000,42184.000000,6.400000,
65080.000000,144364.000000,6.400000,
66710.000000,-68944.000000,6.400000,
52350.000000,-204904.000000,6.400000,
2380.000000,297004.000000,6.400000,
19950.000000,206044.000000,6.400000,
28950.000000,206224.000000,6.400000,
40350.000000,128944.000000,6.400000,
75180.000000,-41704.000000,6.400000,
27360.000000,-79804.000000,6.400000,
41940.000000,-89044.000000,6.400000,
51530.000000,139624.000000,6.400000,
61390.000000,52324.000000,6.400000,
78950.000000,-110284.000000,6.400000,
77710.000000,-84484.000000,6.400000,
7710.000000,160084.000000,6.400000,
16200.000000,37024.000000,6.400000,
76730.000000,-103624.000000,6.400000,
2230.000000,-195904.000000,6.400000,
69530.000000,1264.000000,6.400000,
5180.000000,-1504.000000,6.400000,
18640.000000,-93304.000000,6.400000,
22670.000000,-189904.000000,6.400000,
25560.000000,215344.000000,6.400000,
29140.000000,-2104.000000,6.400000,
40350.000000,-78364.000000,6.400000,
44260.000000,54604.000000,6.400000,
48550.000000,-4984.000000,6.400000,
57170.000000,62764.000000,6.400000,
57680.000000,-114844.000000,6.400000,
64320.000000,168004.000000,6.400000,
77650.000000,-154564.000000,6.400000,
82300.000000,-215644.000000,6.400000,
86220.000000,-95944.000000,6.400000,
23020.000000,-54304.000000,6.400000,
65260.000000,-232444.000000,6.400000,
65370.000000,138484.000000,6.400000,
65650.000000,-229384.000000,6.400000,
83530.000000,-291304.000000,6.400000,
17610.000000,-240064.000000,6.400000,
71810.000000,-208564.000000,6.400000,
35760.000000,-147064.000000,6.400000,
84950.000000,88444.000000,6.400000,
10070.000000,-44944.000000,6.400000,
46070.000000,12904.000000,6.400000,
38470.000000,-214864.000000,6.400000,
66800.000000,29824.000000,6.410000,
45070.000000,-205564.000000,6.410000,
85790.000000,-91264.000000,6.410000,
18330.000000,71344.000000,6.410000,
72980.000000,-44524.000000,6.410000,
25270.000000,116764.000000,6.410000,
31950.000000,-131644.000000,6.410000,
46280.000000,-37324.000000,6.410000,
49080.000000,-210364.000000,6.410000,
20500.000000,-10504.000000,6.410000,
78370.000000,155104.000000,6.410000,
19000.000000,7084.000000,6.410000,
47610.000000,262144.000000,6.410000,
83390.000000,-52324.000000,6.410000,
84700.000000,102304.000000,6.410000,
31370.000000,-129484.000000,6.410000,
7340.000000,-106864.000000,6.410000,
29620.000000,83404.000000,6.410000,
3630.000000,255604.000000,6.410000,
50780.000000,-215044.000000,6.410000,
12750.000000,161524.000000,6.410000,
66800.000000,111304.000000,6.410000,
15210.000000,-4204.000000,6.410000,
51860.000000,-298324.000000,6.410000,
19590.000000,24784.000000,6.410000,
27820.000000,-137584.000000,6.410000,
28680.000000,26044.000000,6.410000,
66730.000000,187684.000000,6.410000,
82950.000000,114424.000000,6.410000,
70230.000000,-198484.000000,6.410000,
29870.000000,-213064.000000,6.410000,
64270.000000,144304.000000,6.410000,
74430.000000,-96004.000000,6.410000,
36900.000000,113344.000000,6.410000,
57510.000000,-135064.000000,6.410000,
37420.000000,106684.000000,6.410000,
43340.000000,-257404.000000,6.410000,
48500.000000,146704.000000,6.410000,
73720.000000,-56704.000000,6.410000,
75880.000000,10684.000000,6.410000,
85770.000000,-57184.000000,6.410000,
2190.000000,-234544.000000,6.410000,
29620.000000,-120904.000000,6.410000,
29720.000000,-181624.000000,6.410000,
67390.000000,254884.000000,6.410000,
73800.000000,165364.000000,6.410000,
63780.000000,158764.000000,6.410000,
820.000000,-94744.000000,6.410000,
8720.000000,-239464.000000,6.410000,
54280.000000,-147184.000000,6.410000,
25590.000000,-44644.000000,6.410000,
43130.000000,-93304.000000,6.420000,
42650.000000,44284.000000,6.420000,
35150.000000,229204.000000,6.420000,
76630.000000,211024.000000,6.420000,
24950.000000,-114544.000000,6.420000,
64020.000000,-137224.000000,6.420000,
30500.000000,-9124.000000,6.420000,
72470.000000,33844.000000,6.420000,
44140.000000,-84124.000000,6.420000,
20020.000000,-197704.000000,6.420000,
1700.000000,-73264.000000,6.420000,
30870.000000,-117424.000000,6.420000,
64430.000000,-125404.000000,6.420000,
66720.000000,13204.000000,6.420000,
77540.000000,84304.000000,6.420000,
11400.000000,100264.000000,6.420000,
25330.000000,-156304.000000,6.420000,
64990.000000,70684.000000,6.420000,
53890.000000,-40204.000000,6.420000,
40910.000000,-279484.000000,6.420000,
78580.000000,148204.000000,6.420000,
86180.000000,299524.000000,6.420000,
17020.000000,118384.000000,6.420000,
29570.000000,-136564.000000,6.420000,
71820.000000,75664.000000,6.420000,
33860.000000,131764.000000,6.420000,
26260.000000,-96544.000000,6.420000,
71420.000000,-219904.000000,6.420000,
23500.000000,42544.000000,6.420000,
25120.000000,-111664.000000,6.420000,
31680.000000,-152944.000000,6.420000,
27680.000000,-160744.000000,6.420000,
29970.000000,-124624.000000,6.420000,
32980.000000,41704.000000,6.420000,
34380.000000,-140944.000000,6.420000,
17160.000000,275824.000000,6.420000,
23330.000000,97144.000000,6.420000,
85910.000000,279424.000000,6.420000,
35480.000000,-22324.000000,6.420000,
63400.000000,250504.000000,6.420000,
53270.000000,-46264.000000,6.420000,
56840.000000,-144784.000000,6.420000,
24080.000000,101524.000000,6.420000,
69140.000000,-78004.000000,6.420000,
6550.000000,-111904.000000,6.420000,
36260.000000,-143944.000000,6.420000,
57830.000000,-89104.000000,6.420000,
59700.000000,-162964.000000,6.420000,
63950.000000,140044.000000,6.420000,
68970.000000,-143464.000000,6.420000,
84540.000000,-160264.000000,6.420000,
4020.000000,205024.000000,6.420000,
57170.000000,-182284.000000,6.420000,
79790.000000,-173284.000000,6.420000,
900.000000,113584.000000,6.420000,
65390.000000,-212584.000000,6.420000,
77590.000000,-189964.000000,6.420000,
47130.000000,-187684.000000,6.420000,
62490.000000,60304.000000,6.420000,
63220.000000,53524.000000,6.420000,
26520.000000,-32344.000000,6.420000,
28260.000000,-88384.000000,6.430000,
73500.000000,214624.000000,6.430000,
32680.000000,-208324.000000,6.430000,
28750.000000,-179944.000000,6.430000,
20480.000000,106204.000000,6.430000,
12900.000000,216184.000000,6.430000,
82710.000000,33784.000000,6.430000,
370.000000,210424.000000,6.430000,
71030.000000,97744.000000,6.430000,
29660.000000,47104.000000,6.430000,
45800.000000,-144724.000000,6.430000,
32800.000000,213724.000000,6.430000,
84270.000000,148084.000000,6.430000,
26400.000000,54604.000000,6.430000,
76960.000000,139144.000000,6.430000,
51380.000000,-23884.000000,6.430000,
69480.000000,111724.000000,6.430000,
56410.000000,-252904.000000,6.430000,
47790.000000,71284.000000,6.430000,
77550.000000,-88564.000000,6.430000,
81770.000000,136144.000000,6.430000,
46070.000000,-89524.000000,6.430000,
73470.000000,192904.000000,6.430000,
13560.000000,88384.000000,6.430000,
37080.000000,263104.000000,6.430000,
75230.000000,-24844.000000,6.430000,
83750.000000,89284.000000,6.430000,
51090.000000,4984.000000,6.430000,
62750.000000,-6004.000000,6.430000,
71310.000000,38524.000000,6.430000,
76860.000000,145264.000000,6.430000,
62550.000000,-129364.000000,6.430000,
42060.000000,-105184.000000,6.430000,
15040.000000,-127024.000000,6.430000,
66800.000000,-211444.000000,6.430000,
48360.000000,227764.000000,6.430000,
25800.000000,76564.000000,6.430000,
15230.000000,136744.000000,6.430000,
26350.000000,-121504.000000,6.430000,
30500.000000,-31804.000000,6.430000,
43420.000000,-267184.000000,6.430000,
65400.000000,-117844.000000,6.430000,
83830.000000,162664.000000,6.430000,
49000.000000,178204.000000,6.430000,
65920.000000,-92284.000000,6.430000,
3300.000000,175384.000000,6.430000,
27680.000000,-80464.000000,6.430000,
58110.000000,-140824.000000,6.440000,
23680.000000,27304.000000,6.440000,
21270.000000,42424.000000,6.440000,
81780.000000,-30004.000000,6.440000,
61300.000000,-184144.000000,6.440000,
29460.000000,-134344.000000,6.440000,
17450.000000,-192544.000000,6.440000,
16710.000000,97024.000000,6.440000,
4950.000000,-68764.000000,6.440000,
62450.000000,-38584.000000,6.440000,
3190.000000,-89224.000000,6.440000,
22570.000000,-213244.000000,6.440000,
8880.000000,7144.000000,6.440000,
31220.000000,70864.000000,6.440000,
13440.000000,-146404.000000,6.440000,
21430.000000,-192364.000000,6.440000,
49060.000000,182584.000000,6.440000,
64730.000000,163744.000000,6.440000,
460.000000,-9244.000000,6.440000,
52120.000000,-213184.000000,6.440000,
53790.000000,-141964.000000,6.440000,
32300.000000,128944.000000,6.440000,
5620.000000,320524.000000,6.440000,
27110.000000,140044.000000,6.440000,
31330.000000,-43084.000000,6.440000,
50710.000000,-58864.000000,6.440000,
79720.000000,-119344.000000,6.440000,
20750.000000,145924.000000,6.440000,
75260.000000,102724.000000,6.440000,
27730.000000,-211144.000000,6.440000,
25430.000000,-36484.000000,6.440000,
27540.000000,-67324.000000,6.440000,
66350.000000,53944.000000,6.440000,
68270.000000,277444.000000,6.440000,
40650.000000,-125104.000000,6.440000,
25110.000000,-203044.000000,6.440000,
76190.000000,10624.000000,6.440000,
36240.000000,11584.000000,6.440000,
1050.000000,-68704.000000,6.440000,
64890.000000,-306844.000000,6.440000,
81850.000000,-217864.000000,6.440000,
84220.000000,117184.000000,6.440000,
36750.000000,-69004.000000,6.440000,
48750.000000,-106504.000000,6.440000,
72220.000000,-81424.000000,6.440000,
24290.000000,-98524.000000,6.440000,
74440.000000,71824.000000,6.440000,
54800.000000,-91204.000000,6.440000,
22990.000000,-114484.000000,6.440000,
23600.000000,-75424.000000,6.440000,
49880.000000,-87844.000000,6.440000,
22390.000000,38344.000000,6.440000,
29870.000000,-108124.000000,6.440000,
83100.000000,59704.000000,6.440000,
2160.000000,-54004.000000,6.440000,
8400.000000,108784.000000,6.440000,
21120.000000,-106084.000000,6.440000,
21400.000000,-115144.000000,6.440000,
26460.000000,153604.000000,6.440000,
30340.000000,-62884.000000,6.440000,
35070.000000,67984.000000,6.440000,
39310.000000,-74464.000000,6.440000,
49810.000000,-143704.000000,6.440000,
56600.000000,-54184.000000,6.440000,
58160.000000,201004.000000,6.440000,
78310.000000,-178264.000000,6.440000,
84420.000000,-239764.000000,6.440000,
72710.000000,-44644.000000,6.440000,
2220.000000,86524.000000,6.440000,
18570.000000,250744.000000,6.440000,
31160.000000,28924.000000,6.440000,
62700.000000,242344.000000,6.440000,
82820.000000,-92344.000000,6.440000,
39150.000000,189064.000000,6.440000,
71390.000000,-240544.000000,6.440000,
77520.000000,-305344.000000,6.440000,
72500.000000,-238984.000000,6.440000,
77020.000000,134524.000000,6.440000,
78480.000000,131764.000000,6.440000,
84010.000000,223204.000000,6.440000,
16080.000000,-151144.000000,6.440000,
230.000000,240184.000000,6.440000,
51290.000000,12004.000000,6.440000,
63610.000000,-7804.000000,6.440000,
72820.000000,87304.000000,6.450000,
65140.000000,43264.000000,6.450000,
68350.000000,-142384.000000,6.450000,
14070.000000,-189784.000000,6.450000,
3780.000000,170584.000000,6.450000,
38670.000000,-255184.000000,6.450000,
29750.000000,217444.000000,6.450000,
60630.000000,-180244.000000,6.450000,
81350.000000,142744.000000,6.450000,
80800.000000,134884.000000,6.450000,
71530.000000,37324.000000,6.450000,
12500.000000,216964.000000,6.450000,
24760.000000,-158344.000000,6.450000,
67080.000000,-50524.000000,6.450000,
25960.000000,98104.000000,6.450000,
42860.000000,-135964.000000,6.450000,
37680.000000,175684.000000,6.450000,
9780.000000,173884.000000,6.450000,
24400.000000,-196984.000000,6.450000,
68230.000000,224704.000000,6.450000,
21580.000000,199204.000000,6.450000,
61840.000000,44944.000000,6.450000,
67210.000000,138184.000000,6.450000,
64370.000000,-126184.000000,6.450000,
77150.000000,1984.000000,6.450000,
25940.000000,-98944.000000,6.450000,
74090.000000,-137164.000000,6.450000,
8020.000000,210904.000000,6.450000,
21370.000000,186544.000000,6.450000,
45120.000000,-117184.000000,6.450000,
35240.000000,41704.000000,6.450000,
74950.000000,230584.000000,6.450000,
35120.000000,-108844.000000,6.450000,
71410.000000,28504.000000,6.450000,
14600.000000,-72544.000000,6.450000,
72980.000000,133504.000000,6.450000,
67300.000000,113884.000000,6.450000,
52040.000000,147724.000000,6.450000,
74340.000000,201664.000000,6.450000,
76300.000000,-52144.000000,6.450000,
85720.000000,7984.000000,6.450000,
56210.000000,108004.000000,6.450000,
58190.000000,-66064.000000,6.450000,
2870.000000,75424.000000,6.450000,
77000.000000,134704.000000,6.450000,
23060.000000,-228424.000000,6.450000,
1120.000000,-29044.000000,6.450000,
42770.000000,135844.000000,6.450000,
17090.000000,-227704.000000,6.450000,
28240.000000,-160564.000000,6.450000,
32030.000000,-145684.000000,6.450000,
51140.000000,-87724.000000,6.450000,
61930.000000,-139804.000000,6.450000,
62290.000000,-58744.000000,6.450000,
68740.000000,107764.000000,6.450000,
310.000000,162844.000000,6.460000,
77600.000000,-288244.000000,6.460000,
59090.000000,-163324.000000,6.460000,
85820.000000,185884.000000,6.460000,
67320.000000,125164.000000,6.460000,
76230.000000,171724.000000,6.460000,
31120.000000,-191164.000000,6.460000,
2740.000000,-59164.000000,6.460000,
15930.000000,57484.000000,6.460000,
67720.000000,-66964.000000,6.460000,
63950.000000,141664.000000,6.460000,
6820.000000,200224.000000,6.460000,
44340.000000,93724.000000,6.460000,
49450.000000,-183724.000000,6.460000,
13760.000000,205684.000000,6.460000,
21230.000000,-70804.000000,6.460000,
48690.000000,-101224.000000,6.460000,
54890.000000,248284.000000,6.460000,
66530.000000,-95764.000000,6.460000,
3170.000000,138904.000000,6.460000,
75030.000000,64984.000000,6.460000,
72430.000000,180844.000000,6.460000,
31780.000000,-75844.000000,6.460000,
70410.000000,139684.000000,6.460000,
79800.000000,-101944.000000,6.460000,
71330.000000,120424.000000,6.460000,
73120.000000,166804.000000,6.460000,
76530.000000,172744.000000,6.460000,
48180.000000,-174844.000000,6.460000,
35140.000000,-205924.000000,6.460000,
55910.000000,-118444.000000,6.460000,
62810.000000,-187084.000000,6.460000,
54790.000000,-86524.000000,6.460000,
56060.000000,-141664.000000,6.460000,
60210.000000,-115624.000000,6.460000,
75270.000000,-182644.000000,6.460000,
27840.000000,8764.000000,6.460000,
10030.000000,-81064.000000,6.460000,
24420.000000,-313324.000000,6.460000,
68620.000000,76624.000000,6.460000,
28300.000000,-46204.000000,6.460000,
72300.000000,-41824.000000,6.460000,
30910.000000,-144004.000000,6.460000,
50940.000000,-37264.000000,6.460000,
33590.000000,266524.000000,6.460000,
51480.000000,-27184.000000,6.460000,
78340.000000,129184.000000,6.460000,
60030.000000,-73564.000000,6.460000,
21450.000000,238024.000000,6.460000,
23850.000000,39124.000000,6.460000,
25570.000000,-247924.000000,6.460000,
50920.000000,213724.000000,6.460000,
51410.000000,-279664.000000,6.460000,
71700.000000,-118984.000000,6.460000,
72370.000000,-14764.000000,6.460000,
75200.000000,-110644.000000,6.460000,
81520.000000,-103564.000000,6.460000,
83410.000000,-240724.000000,6.460000,
9850.000000,63964.000000,6.460000,
11080.000000,57124.000000,6.460000,
58740.000000,-72844.000000,6.460000,
75040.000000,-115444.000000,6.460000,
77340.000000,64504.000000,6.460000,
79460.000000,-107764.000000,6.460000,
39790.000000,-115084.000000,6.460000,
4440.000000,102784.000000,6.460000,
75240.000000,-100564.000000,6.460000,
31050.000000,-121504.000000,6.470000,
19980.000000,-6304.000000,6.470000,
52910.000000,-111424.000000,6.470000,
62370.000000,-180304.000000,6.470000,
13270.000000,-42544.000000,6.470000,
59320.000000,-29344.000000,6.470000,
16540.000000,71644.000000,6.470000,
41920.000000,162484.000000,6.470000,
8410.000000,231664.000000,6.470000,
5140.000000,255544.000000,6.470000,
47390.000000,224104.000000,6.470000,
60880.000000,-42544.000000,6.470000,
79160.000000,207664.000000,6.470000,
2770.000000,199144.000000,6.470000,
23020.000000,-210784.000000,6.470000,
33820.000000,-136024.000000,6.470000,
51530.000000,197524.000000,6.470000,
32980.000000,-178024.000000,6.470000,
25720.000000,-86644.000000,6.470000,
71150.000000,-10384.000000,6.470000,
1000.000000,-72844.000000,6.470000,
20510.000000,84004.000000,6.470000,
630.000000,205804.000000,6.470000,
86250.000000,216124.000000,6.470000,
23090.000000,107044.000000,6.470000,
23290.000000,6904.000000,6.470000,
3000.000000,-156244.000000,6.470000,
61120.000000,-53524.000000,6.470000,
56630.000000,-217084.000000,6.470000,
38160.000000,289804.000000,6.470000,
4200.000000,-207724.000000,6.470000,
69690.000000,-126004.000000,6.470000,
70550.000000,180904.000000,6.470000,
18930.000000,-187924.000000,6.470000,
25550.000000,254704.000000,6.470000,
50140.000000,-112684.000000,6.470000,
76590.000000,-5884.000000,6.470000,
78610.000000,-60724.000000,6.470000,
83810.000000,-148324.000000,6.470000,
64150.000000,7144.000000,6.470000,
6260.000000,166204.000000,6.470000,
4350.000000,163264.000000,6.470000,
24050.000000,-171664.000000,6.470000,
63780.000000,-119044.000000,6.470000,
78120.000000,164824.000000,6.470000,
70560.000000,40144.000000,6.480000,
16990.000000,214324.000000,6.480000,
56870.000000,-235684.000000,6.480000,
19160.000000,122404.000000,6.480000,
25540.000000,-38404.000000,6.480000,
71670.000000,-29704.000000,6.480000,
72590.000000,75364.000000,6.480000,
56320.000000,-31744.000000,6.480000,
72980.000000,-131344.000000,6.480000,
20000.000000,118144.000000,6.480000,
38130.000000,-66904.000000,6.480000,
40090.000000,-108004.000000,6.480000,
52490.000000,-73624.000000,6.480000,
63340.000000,-134824.000000,6.480000,
67610.000000,166804.000000,6.480000,
80980.000000,128704.000000,6.480000,
40700.000000,43204.000000,6.480000,
69220.000000,19924.000000,6.480000,
69780.000000,53824.000000,6.480000,
41740.000000,39364.000000,6.480000,
18270.000000,99724.000000,6.480000,
65920.000000,-152344.000000,6.480000,
8210.000000,205444.000000,6.480000,
25230.000000,-33184.000000,6.480000,
35580.000000,-199384.000000,6.480000,
72670.000000,-31924.000000,6.480000,
30800.000000,-138244.000000,6.480000,
20370.000000,-35044.000000,6.480000,
4580.000000,173164.000000,6.480000,
67990.000000,-187024.000000,6.480000,
67780.000000,113944.000000,6.480000,
80620.000000,281764.000000,6.480000,
55700.000000,-317344.000000,6.480000,
22650.000000,167164.000000,6.480000,
74770.000000,-130084.000000,6.480000,
12880.000000,23164.000000,6.480000,
34510.000000,-129064.000000,6.480000,
19390.000000,-96184.000000,6.480000,
9500.000000,-136804.000000,6.480000,
22160.000000,-178504.000000,6.480000,
84480.000000,-41284.000000,6.480000,
84690.000000,-14764.000000,6.480000,
42430.000000,-109084.000000,6.480000,
51940.000000,-96724.000000,6.480000,
950.000000,-273364.000000,6.480000,
2090.000000,48184.000000,6.480000,
20870.000000,-146404.000000,6.480000,
42630.000000,-98224.000000,6.480000,
64390.000000,-235864.000000,6.480000,
64800.000000,-73264.000000,6.480000,
66050.000000,-135004.000000,6.480000,
66960.000000,-106984.000000,6.480000,
77040.000000,-81964.000000,6.480000,
81980.000000,-178924.000000,6.480000,
4950.000000,-1684.000000,6.480000,
68930.000000,-200644.000000,6.480000,
48880.000000,-120004.000000,6.480000,
77340.000000,-193384.000000,6.480000,
67290.000000,-173224.000000,6.480000,
64610.000000,-145144.000000,6.480000,
79070.000000,270064.000000,6.480000,
82580.000000,-113704.000000,6.480000,
41990.000000,-59884.000000,6.480000,
60730.000000,-150724.000000,6.480000,
30080.000000,-5824.000000,6.490000,
12490.000000,-129124.000000,6.490000,
79240.000000,225004.000000,6.490000,
75760.000000,165124.000000,6.490000,
45550.000000,-271384.000000,6.490000,
54240.000000,19804.000000,6.490000,
51880.000000,-42064.000000,6.490000,
63860.000000,-260044.000000,6.490000,
67100.000000,-11584.000000,6.490000,
60960.000000,-60604.000000,6.490000,
67840.000000,39604.000000,6.490000,
19910.000000,309484.000000,6.490000,
45550.000000,129484.000000,6.490000,
1950.000000,99364.000000,6.490000,
17750.000000,19504.000000,6.490000,
28580.000000,203464.000000,6.490000,
33670.000000,55444.000000,6.490000,
8380.000000,-15664.000000,6.490000,
34380.000000,178084.000000,6.490000,
37280.000000,-85384.000000,6.490000,
34460.000000,168904.000000,6.490000,
40550.000000,46264.000000,6.490000,
59430.000000,-27064.000000,6.490000,
70820.000000,73804.000000,6.490000,
8370.000000,143524.000000,6.490000,
53950.000000,-136444.000000,6.490000,
75770.000000,-3364.000000,6.490000,
76450.000000,-38224.000000,6.490000,
50410.000000,-221404.000000,6.490000,
70960.000000,105604.000000,6.490000,
36980.000000,103324.000000,6.490000,
85480.000000,200944.000000,6.490000,
2420.000000,-59524.000000,6.490000,
36360.000000,-187924.000000,6.490000,
13490.000000,-173044.000000,6.490000,
25510.000000,-181324.000000,6.490000,
48230.000000,-179404.000000,6.490000,
78100.000000,-90424.000000,6.490000,
20100.000000,-211984.000000,6.490000,
41270.000000,-127264.000000,6.490000,
56410.000000,-112444.000000,6.490000,
53820.000000,-185284.000000,6.490000,
67370.000000,-69484.000000,6.490000,
71550.000000,-198005.000000,6.500000,
15210.000000,32045.000000,6.500000,
47490.000000,-95645.000000,6.500000,
78810.000000,-37205.000000,6.500000,
56170.000000,-236225.000000,6.500000,
36970.000000,63905.000000,6.500000,
40560.000000,190025.000000,6.500000,
56770.000000,-101105.000000,6.500000,
71720.000000,-24305.000000,6.500000,
55470.000000,134525.000000,6.500000,
62430.000000,-69665.000000,6.500000,
82950.000000,-131165.000000,6.500000,
24050.000000,-258425.000000,6.500000,
33130.000000,54065.000000,6.500000,
41200.000000,10865.000000,6.500000,
19030.000000,192965.000000,6.500000,
37090.000000,98765.000000,6.500000,
67530.000000,79205.000000,6.500000,
49430.000000,-19865.000000,6.500000,
77340.000000,-112505.000000,6.500000,
26800.000000,-85445.000000,6.500000,
30510.000000,-83105.000000,6.500000,
31100.000000,-24065.000000,6.500000,
56160.000000,187505.000000,6.500000,
9010.000000,-90725.000000,6.500000,
60850.000000,-150725.000000,6.500000,
74540.000000,127745.000000,6.500000,
19270.000000,14525.000000,6.500000,
24030.000000,23045.000000,6.500000,
69520.000000,70685.000000,6.500000,
23140.000000,8285.000000,6.500000,
62330.000000,21965.000000,6.500000,
83440.000000,-106385.000000,6.500000,
37260.000000,-64805.000000,6.500000,
37850.000000,-95405.000000,6.500000,
67300.000000,-52505.000000,6.500000,
77290.000000,-41705.000000,6.500000,
56190.000000,-2105.000000,6.500000,
71580.000000,-52625.000000,6.500000,
74600.000000,128225.000000,6.500000,
56060.000000,-20525.000000,6.500000,
9600.000000,-110345.000000,6.500000,
18740.000000,-293645.000000,6.500000,
36030.000000,-205085.000000,6.500000,
74710.000000,-98165.000000,6.500000,
66640.000000,75005.000000,6.500000,
12220.000000,-117845.000000,6.500000,
23080.000000,-190145.000000,6.500000,
24760.000000,-194765.000000,6.500000,
48590.000000,21725.000000,6.500000,
63100.000000,-121445.000000,6.500000,
65380.000000,-50225.000000,6.500000,
66550.000000,-157865.000000,6.500000,
68210.000000,-226085.000000,6.500000,
48930.000000,36785.000000,6.500000,
22020.000000,-162425.000000,6.500000,
31940.000000,-117125.000000,6.500000,
69680.000000,208025.000000,6.500000,
6010.000000,193985.000000,6.500000,
21720.000000,-216425.000000,6.500000,
72480.000000,60005.000000,6.500000,
25640.000000,81845.000000,6.500000,
120.000000,-52925.000000,6.500000,
37290.000000,-81125.000000,6.510000,
26930.000000,-114725.000000,6.510000,
83000.000000,217625.000000,6.510000,
25210.000000,-79685.000000,6.510000,
48790.000000,-279305.000000,6.510000,
85020.000000,-114785.000000,6.510000,
24010.000000,286625.000000,6.510000,
80300.000000,275405.000000,6.510000,
72320.000000,-45665.000000,6.510000,
29560.000000,-107705.000000,6.510000,
13140.000000,75365.000000,6.510000,
27900.000000,-136505.000000,6.510000,
76160.000000,227885.000000,6.510000,
86320.000000,116585.000000,6.510000,
74460.000000,140705.000000,6.510000,
20000.000000,151625.000000,6.510000,
27450.000000,-52085.000000,6.510000,
23220.000000,-136505.000000,6.510000,
38230.000000,-42365.000000,6.510000,
69900.000000,-17645.000000,6.510000,
7770.000000,-87725.000000,6.510000,
24760.000000,-153065.000000,6.510000,
84110.000000,95885.000000,6.510000,
4340.000000,-110945.000000,6.510000,
18490.000000,-128645.000000,6.510000,
10050.000000,-128045.000000,6.510000,
73250.000000,-128465.000000,6.510000,
54420.000000,-258905.000000,6.510000,
78980.000000,76565.000000,6.510000,
86120.000000,93485.000000,6.510000,
14410.000000,-185705.000000,6.510000,
33770.000000,-35465.000000,6.520000,
8960.000000,199985.000000,6.520000,
58290.000000,34985.000000,6.520000,
24300.000000,-110165.000000,6.520000,
44550.000000,19205.000000,6.520000,
62410.000000,-252245.000000,6.520000,
16810.000000,-212225.000000,6.520000,
48430.000000,-144665.000000,6.520000,
74840.000000,164165.000000,6.520000,
65840.000000,-66545.000000,6.520000,
33020.000000,-83465.000000,6.520000,
36520.000000,-39245.000000,6.520000,
64550.000000,-67745.000000,6.520000,
71600.000000,15965.000000,6.520000,
15640.000000,33245.000000,6.520000,
66920.000000,-75065.000000,6.520000,
22360.000000,-64025.000000,6.520000,
86320.000000,167105.000000,6.520000,
19310.000000,-49565.000000,6.520000,
61800.000000,-222125.000000,6.520000,
74080.000000,-109805.000000,6.520000,
51500.000000,-119645.000000,6.520000,
68710.000000,-5525.000000,6.520000,
34590.000000,-88985.000000,6.520000,
43030.000000,145265.000000,6.520000,
28130.000000,15665.000000,6.520000,
25250.000000,-120545.000000,6.520000,
20860.000000,-261785.000000,6.520000,
27190.000000,-155165.000000,6.520000,
28510.000000,-111365.000000,6.520000,
33750.000000,-143285.000000,6.520000,
8580.000000,-135365.000000,6.520000,
81880.000000,189125.000000,6.520000,
48880.000000,275645.000000,6.520000,
26570.000000,199085.000000,6.530000,
34030.000000,-33245.000000,6.530000,
34390.000000,102185.000000,6.530000,
19510.000000,125525.000000,6.530000,
44910.000000,94505.000000,6.530000,
30440.000000,-198125.000000,6.530000,
30710.000000,35405.000000,6.530000,
67750.000000,90245.000000,6.530000,
83290.000000,160445.000000,6.530000,
15500.000000,34265.000000,6.530000,
57170.000000,-234605.000000,6.530000,
3880.000000,183725.000000,6.530000,
83780.000000,223145.000000,6.530000,
7070.000000,150125.000000,6.530000,
82170.000000,37805.000000,6.530000,
37390.000000,20585.000000,6.530000,
72980.000000,-126785.000000,6.530000,
57370.000000,-114545.000000,6.530000,
40070.000000,-108725.000000,6.530000,
81050.000000,-93905.000000,6.530000,
21250.000000,-181385.000000,6.530000,
71070.000000,123905.000000,6.530000,
47170.000000,104585.000000,6.540000,
42900.000000,167405.000000,6.540000,
13670.000000,121085.000000,6.540000,
71700.000000,108785.000000,6.540000,
37910.000000,-162305.000000,6.540000,
19240.000000,169145.000000,6.540000,
15890.000000,-125165.000000,6.540000,
27170.000000,82445.000000,6.540000,
24590.000000,-163685.000000,6.540000,
31080.000000,34505.000000,6.540000,
31880.000000,-153065.000000,6.540000,
3980.000000,226025.000000,6.540000,
12420.000000,67565.000000,6.540000,
19760.000000,280805.000000,6.540000,
20170.000000,-20405.000000,6.540000,
23760.000000,16265.000000,6.540000,
27710.000000,-138785.000000,6.540000,
9570.000000,-231485.000000,6.540000,
21190.000000,73145.000000,6.540000,
22120.000000,31265.000000,6.540000,
75300.000000,-4985.000000,6.540000,
42120.000000,80045.000000,6.540000,
77400.000000,-69005.000000,6.540000,
26470.000000,-32045.000000,6.540000,
71860.000000,-137045.000000,6.540000,
13630.000000,-107705.000000,6.540000,
31040.000000,-144605.000000,6.540000,
180.000000,-87005.000000,6.540000,
72140.000000,232745.000000,6.540000,
36160.000000,-110165.000000,6.540000,
63630.000000,156545.000000,6.540000,
79840.000000,-273245.000000,6.540000,
85330.000000,162005.000000,6.540000,
1250.000000,39545.000000,6.550000,
27810.000000,-91865.000000,6.550000,
72330.000000,-118865.000000,6.550000,
82000.000000,-169025.000000,6.550000,
28180.000000,-72785.000000,6.550000,
74500.000000,-271325.000000,6.550000,
62060.000000,-143225.000000,6.550000,
76780.000000,-94925.000000,6.550000,
8120.000000,-34145.000000,6.550000,
12910.000000,264065.000000,6.550000,
74030.000000,36305.000000,6.550000,
34560.000000,-233885.000000,6.550000,
56100.000000,6065.000000,6.550000,
38170.000000,-38165.000000,6.550000,
20120.000000,-16265.000000,6.550000,
21270.000000,-14705.000000,6.550000,
68480.000000,75125.000000,6.550000,
27640.000000,-100685.000000,6.550000,
72720.000000,171905.000000,6.550000,
1390.000000,-111845.000000,6.550000,
16180.000000,37925.000000,6.550000,
68820.000000,2345.000000,6.550000,
63120.000000,123485.000000,6.550000,
61050.000000,91325.000000,6.550000,
10460.000000,-232085.000000,6.550000,
28820.000000,-163745.000000,6.550000,
35460.000000,47105.000000,6.550000,
67560.000000,-70685.000000,6.550000,
37000.000000,-74465.000000,6.560000,
21880.000000,-174545.000000,6.560000,
27280.000000,9845.000000,6.560000,
23400.000000,32585.000000,6.560000,
46090.000000,48845.000000,6.560000,
30450.000000,-75125.000000,6.560000,
40360.000000,197645.000000,6.560000,
81920.000000,-319805.000000,6.560000,
19000.000000,-61745.000000,6.560000,
27990.000000,-144305.000000,6.560000,
28840.000000,-10385.000000,6.560000,
23930.000000,16985.000000,6.560000,
22610.000000,25445.000000,6.560000,
69940.000000,208985.000000,6.560000,
77690.000000,-106925.000000,6.560000,
22650.000000,50705.000000,6.560000,
25460.000000,5405.000000,6.560000,
75370.000000,-12905.000000,6.560000,
51370.000000,-119765.000000,6.560000,
67620.000000,-180425.000000,6.560000,
55850.000000,30905.000000,6.560000,
65680.000000,105185.000000,6.560000,
69130.000000,-135365.000000,6.560000,
62160.000000,-315305.000000,6.560000,
28570.000000,289025.000000,6.560000,
67750.000000,-125165.000000,6.560000,
18690.000000,-134705.000000,6.560000,
18020.000000,142805.000000,6.560000,
60960.000000,180305.000000,6.560000,
31600.000000,103625.000000,6.570000,
5210.000000,12785.000000,6.570000,
19530.000000,-2045.000000,6.570000,
9420.000000,88805.000000,6.570000,
80790.000000,-60365.000000,6.570000,
69120.000000,179525.000000,6.570000,
63310.000000,-79445.000000,6.570000,
26900.000000,-136145.000000,6.570000,
3870.000000,144005.000000,6.570000,
66560.000000,-90965.000000,6.570000,
82850.000000,139385.000000,6.570000,
30410.000000,-105245.000000,6.570000,
5320.000000,-121625.000000,6.570000,
60410.000000,-91985.000000,6.570000,
1780.000000,-115685.000000,6.570000,
35830.000000,-232265.000000,6.570000,
43100.000000,221345.000000,6.570000,
76120.000000,-274445.000000,6.570000,
65880.000000,83885.000000,6.570000,
69620.000000,-114605.000000,6.570000,
32280.000000,5645.000000,6.580000,
49290.000000,-84485.000000,6.580000,
47030.000000,-13265.000000,6.580000,
14910.000000,-165185.000000,6.580000,
86370.000000,121445.000000,6.580000,
55750.000000,289685.000000,6.580000,
49730.000000,-128585.000000,6.580000,
65590.000000,-14525.000000,6.580000,
1940.000000,156665.000000,6.580000,
5580.000000,-32465.000000,6.580000,
13280.000000,-70565.000000,6.580000,
20620.000000,308465.000000,6.580000,
21730.000000,6185.000000,6.580000,
27500.000000,-144005.000000,6.580000,
27780.000000,-180005.000000,6.580000,
61230.000000,23765.000000,6.580000,
65360.000000,-132065.000000,6.580000,
20030.000000,5105.000000,6.580000,
25310.000000,20045.000000,6.580000,
68970.000000,-130205.000000,6.580000,
40020.000000,-117425.000000,6.580000,
75590.000000,60605.000000,6.580000,
30430.000000,-23165.000000,6.580000,
30920.000000,70565.000000,6.580000,
14840.000000,-154565.000000,6.580000,
8660.000000,-93125.000000,6.580000,
23990.000000,-137465.000000,6.580000,
49200.000000,-254945.000000,6.580000,
85780.000000,-226325.000000,6.580000,
19750.000000,-224405.000000,6.580000,
2250.000000,11345.000000,6.580000,
77090.000000,177665.000000,6.590000,
75090.000000,-224825.000000,6.590000,
45300.000000,66245.000000,6.590000,
29810.000000,-76745.000000,6.590000,
17630.000000,5765.000000,6.590000,
51310.000000,189185.000000,6.590000,
3730.000000,183785.000000,6.590000,
26630.000000,-108845.000000,6.590000,
25030.000000,-79985.000000,6.590000,
21570.000000,-5285.000000,6.590000,
70210.000000,-115625.000000,6.590000,
36240.000000,-293705.000000,6.590000,
19200.000000,159965.000000,6.590000,
27460.000000,-127085.000000,6.590000,
85260.000000,-87065.000000,6.590000,
68010.000000,272886.000000,6.600000,
38950.000000,-14586.000000,6.600000,
70830.000000,85446.000000,6.600000,
23020.000000,-71286.000000,6.600000,
21360.000000,50226.000000,6.600000,
53150.000000,-55686.000000,6.600000,
68300.000000,-89646.000000,6.600000,
52440.000000,-151626.000000,6.600000,
54160.000000,-10986.000000,6.600000,
70790.000000,-142026.000000,6.600000,
26020.000000,-111966.000000,6.600000,
26450.000000,-82326.000000,6.600000,
24360.000000,-142386.000000,6.600000,
70590.000000,73266.000000,6.600000,
22800.000000,-175506.000000,6.600000,
68410.000000,146526.000000,6.600000,
83590.000000,-178686.000000,6.610000,
85340.000000,232326.000000,6.610000,
22360.000000,-9066.000000,6.610000,
47930.000000,13326.000000,6.610000,
13060.000000,55626.000000,6.610000,
74360.000000,164466.000000,6.610000,
27650.000000,-114066.000000,6.610000,
68460.000000,-133506.000000,6.620000,
43860.000000,-163566.000000,6.620000,
80560.000000,-165486.000000,6.620000,
3980.000000,-128466.000000,6.620000,
25300.000000,17406.000000,6.620000,
31260.000000,-32646.000000,6.620000,
76690.000000,-271326.000000,6.620000,
30470.000000,-94146.000000,6.620000,
33570.000000,-40746.000000,6.620000,
68070.000000,-179646.000000,6.620000,
22580.000000,3966.000000,6.620000,
66540.000000,-139926.000000,6.620000,
56310.000000,-141066.000000,6.620000,
58610.000000,-76746.000000,6.620000,
48430.000000,-268926.000000,6.620000,
65820.000000,3666.000000,6.620000,
71190.000000,90546.000000,6.620000,
21250.000000,-232206.000000,6.620000,
46590.000000,-95346.000000,6.620000,
81960.000000,-176406.000000,6.620000,
49010.000000,-124146.000000,6.620000,
39150.000000,189306.000000,6.620000,
27230.000000,-143706.000000,6.620000,
630.000000,-263706.000000,6.630000,
44920.000000,93306.000000,6.630000,
65260.000000,47106.000000,6.630000,
65920.000000,-67086.000000,6.630000,
18030.000000,13086.000000,6.630000,
75730.000000,-154866.000000,6.630000,
27100.000000,-129246.000000,6.630000,
73180.000000,133746.000000,6.630000,
6100.000000,-180246.000000,6.630000,
48910.000000,159186.000000,6.630000,
49860.000000,125226.000000,6.630000,
70480.000000,173466.000000,6.630000,
73970.000000,155526.000000,6.630000,
22540.000000,14946.000000,6.630000,
67960.000000,-110706.000000,6.630000,
22500.000000,-258186.000000,6.630000,
18250.000000,265626.000000,6.630000,
73220.000000,-22926.000000,6.630000,
61410.000000,127566.000000,6.630000,
62360.000000,-159246.000000,6.640000,
63870.000000,9306.000000,6.640000,
4390.000000,222186.000000,6.640000,
60860.000000,-150606.000000,6.640000,
81540.000000,-189786.000000,6.640000,
29340.000000,-109266.000000,6.640000,
27260.000000,-94086.000000,6.640000,
69980.000000,-52446.000000,6.640000,
34050.000000,-126066.000000,6.640000,
83230.000000,165906.000000,6.640000,
11770.000000,-111066.000000,6.640000,
26230.000000,24066.000000,6.640000,
32120.000000,62106.000000,6.640000,
68920.000000,60726.000000,6.640000,
61970.000000,1386.000000,6.640000,
27040.000000,-134526.000000,6.640000,
61230.000000,-163686.000000,6.640000,
43990.000000,-122886.000000,6.640000,
23110.000000,5466.000000,6.650000,
28750.000000,-179946.000000,6.650000,
71320.000000,127206.000000,6.650000,
44290.000000,-14286.000000,6.650000,
18940.000000,-125766.000000,6.650000,
84740.000000,125886.000000,6.650000,
76190.000000,163866.000000,6.650000,
37260.000000,8346.000000,6.650000,
22010.000000,-40326.000000,6.650000,
54340.000000,-92886.000000,6.650000,
67090.000000,-4086.000000,6.650000,
37070.000000,255906.000000,6.660000,
38850.000000,-55026.000000,6.660000,
64270.000000,-110106.000000,6.660000,
66600.000000,14706.000000,6.660000,
18690.000000,1926.000000,6.660000,
69740.000000,-29586.000000,6.660000,
30530.000000,-75486.000000,6.660000,
23000.000000,-16986.000000,6.660000,
48420.000000,233106.000000,6.660000,
22550.000000,-107286.000000,6.660000,
68490.000000,90186.000000,6.660000,
12620.000000,258786.000000,6.660000,
32130.000000,-28746.000000,6.670000,
47780.000000,-5106.000000,6.670000,
13890.000000,79386.000000,6.670000,
30370.000000,-140706.000000,6.680000,
76230.000000,80886.000000,6.680000,
54760.000000,69486.000000,6.680000,
75200.000000,152766.000000,6.680000,
27080.000000,-130206.000000,6.680000,
26060.000000,89046.000000,6.680000,
83030.000000,-17346.000000,6.680000,
81690.000000,149586.000000,6.680000,
40660.000000,-131586.000000,6.680000,
29890.000000,-134646.000000,6.690000,
34720.000000,-142686.000000,6.690000,
35980.000000,12246.000000,6.690000,
2390.000000,-122286.000000,6.690000,
36220.000000,-91207.000000,6.700000,
75260.000000,146587.000000,6.700000,
51200.000000,186487.000000,6.700000,
39550.000000,-293647.000000,6.700000,
23210.000000,3067.000000,6.700000,
30560.000000,-98467.000000,6.700000,
68660.000000,-20527.000000,6.700000,
82060.000000,-137647.000000,6.700000,
4640.000000,114367.000000,6.700000,
15150.000000,-159787.000000,6.700000,
30620.000000,-132247.000000,6.700000,
59140.000000,68047.000000,6.700000,
7850.000000,140587.000000,6.710000,
72860.000000,151627.000000,6.710000,
5930.000000,-90127.000000,6.710000,
17010.000000,-31747.000000,6.710000,
72240.000000,-26947.000000,6.710000,
6120.000000,219787.000000,6.710000,
17730.000000,-92647.000000,6.710000,
17310.000000,-158347.000000,6.710000,
28190.000000,-216247.000000,6.710000,
63630.000000,206407.000000,6.710000,
55290.000000,-137647.000000,6.720000,
68650.000000,12067.000000,6.720000,
82180.000000,-277447.000000,6.720000,
770.000000,135727.000000,6.720000,
65660.000000,-254767.000000,6.720000,
32830.000000,-184447.000000,6.720000,
69150.000000,60727.000000,6.730000,
64980.000000,-81847.000000,6.730000,
32580.000000,-91927.000000,6.730000,
27780.000000,-139987.000000,6.730000,
73790.000000,-66967.000000,6.740000,
68940.000000,124627.000000,6.740000,
58170.000000,-117607.000000,6.740000,
21160.000000,-138787.000000,6.740000,
67770.000000,-68947.000000,6.740000,
12860.000000,-236827.000000,6.740000,
48490.000000,182167.000000,6.740000,
68350.000000,36547.000000,6.740000,
66300.000000,18367.000000,6.740000,
22650.000000,-38647.000000,6.740000,
15770.000000,-298507.000000,6.750000,
64960.000000,-19327.000000,6.750000,
26760.000000,-16387.000000,6.750000,
19740.000000,-108487.000000,6.750000,
32480.000000,116227.000000,6.760000,
8990.000000,-81727.000000,6.760000,
34520.000000,143887.000000,6.760000,
39990.000000,-103447.000000,6.760000,
9210.000000,-225427.000000,6.760000,
52820.000000,79147.000000,6.760000,
1000.000000,-283687.000000,6.760000,
32840.000000,82807.000000,6.770000,
43100.000000,-147427.000000,6.770000,
24600.000000,-98467.000000,6.770000,
28060.000000,-57727.000000,6.770000,
46210.000000,-217507.000000,6.780000,
28580.000000,-146707.000000,6.780000,
25430.000000,-157028.000000,6.800000,
33640.000000,-114368.000000,6.810000,
42910.000000,167408.000000,6.810000,
35050.000000,-142568.000000,6.810000,
19410.000000,-134468.000000,6.810000,
86110.000000,-114908.000000,6.820000,
29400.000000,209768.000000,6.820000,
5920.000000,-192488.000000,6.830000,
3600.000000,160988.000000,6.840000,
68460.000000,-133508.000000,6.840000,
2320.000000,-263348.000000,6.840000,
9910.000000,-166688.000000,6.840000,
78730.000000,76628.000000,6.840000,
13830.000000,-131228.000000,6.850000,
17150.000000,-122468.000000,6.850000,
78690.000000,236768.000000,6.860000,
51800.000000,30488.000000,6.860000,
40250.000000,-210548.000000,6.870000,
85640.000000,-246308.000000,6.880000,
3110.000000,-157388.000000,6.890000,
60080.000000,-175628.000000,6.890000,
24850.000000,-86229.000000,6.900000,
22530.000000,130209.000000,6.920000,
60030.000000,15189.000000,6.930000,
15320.000000,22389.000000,6.930000,
20730.000000,74589.000000,6.930000,
22130.000000,9069.000000,6.940000,
21900.000000,213909.000000,6.940000,
52110.000000,101889.000000,6.950000,
18030.000000,13089.000000,6.950000,
44290.000000,-14229.000000,6.970000,
18820.000000,-129009.000000,6.970000,
55980.000000,-88209.000000,6.980000,
51930.000000,-71949.000000,6.980000,
79090.000000,298389.000000,6.980000,
79390.000000,-107709.000000,6.980000,
26680.000000,-134349.000000,6.990000,
67820.000000,-28510.000000,7.000000,
44440.000000,97510.000000,7.000000,
22310.000000,78850.000000,7.000000,
48430.000000,232990.000000,7.010000,
22720.000000,-181390.000000,7.030000,
14870.000000,224470.000000,7.040000,
59030.000000,-119590.000000,7.060000,
37910.000000,-294970.000000,7.060000,
54690.000000,-163090.000000,7.060000,
26680.000000,-134350.000000,7.070000,
55500.000000,-137470.000000,7.090000,
82140.000000,246910.000000,7.090000,
30400.000000,88391.000000,7.100000,
79340.000000,-61151.000000,7.150000,
67910.000000,-300011.000000,7.150000,
27320.000000,-267491.000000,7.160000,
27320.000000,-267491.000000,7.160000
};

